import { Http } from '@angular/http';
import 'rxjs/add/operator/map';
import 'rxjs/add/operator/catch';
import { Router } from '@angular/router';
import { CustomStoreOptions } from '../model/custom-store-options';
import { AppConfigService } from '../app-config/app-config.service';
import { Common } from './common.service';
import { B2bService } from './b2b.service';
import { ModalSpellCheckComponent } from '../modal-spell-check/modal-spell-check.component';
import { HttpClient } from '@angular/common/http';
export declare class Request {
    private appConfigService;
    httpClient: HttpClient;
    http: Http;
    private router;
    private common;
    private b2bService;
    config: any;
    api: any;
    system_id: any;
    constructor(appConfigService: AppConfigService, httpClient: HttpClient, http: Http, router: Router, common: Common, b2bService: B2bService);
    /**
     * fn. get data สำหรับดึงข้อมูลสำหรับ Datagrid เท่านั้น
     * @param customStoreOptions โยนค่าต่าง ๆ มาในนี้
     */
    getCustomStore(customStoreOptions: CustomStoreOptions): Promise<any[] | {
        data: any[];
        totalCount: number;
    } | {
        data: any[];
        totalCount: number;
    }>;
    /**
     * fn. post data สำหรับดึงข้อมูลสำหรับ Datagrid เท่านั้น
     * @param customStoreOptions โยนค่าต่าง ๆ มาในนี้
     */
    postCustomStore(customStoreOptions: CustomStoreOptions): Promise<any[] | {
        data: any[];
        totalCount: number;
    } | {
        data: any[];
        totalCount: number;
    }>;
    /**
     * fn. post data สำหรับดึงข้อมูลสำหรับ Datagrid เท่านั้น
     * @param customStoreOptions โยนค่าต่าง ๆ มาในนี้
     */
    postCustomStore31(customStoreOptions: CustomStoreOptions): Promise<any[] | {
        data: any[];
        totalCount: number;
    } | {
        data: any[];
        totalCount: number;
    }>;
    /**
     * ถ้า getCustomStore แล้ว error กรณี loadMode = 'processed'
     * @param error
     */
    fnHandleErrorProcessedMode(error: any): {
        data: any[];
        totalCount: number;
    };
    /**
     * ถ้า getCustomStore แล้ว error กรณี loadMode = 'raw'
     * @param error
     */
    fnHandleErrorRawMode(error: any): any[];
    /**
     * fn. get data สำหรับดึงข้อมูลทั่วไป
     * @param url ex /test
     * @param data ค่าต่างที่ต้องการแนบไปกับ API
     */
    get(url: any, data?: any): Promise<any[]>;
    /**
     * fn. get data สำหรับดึงข้อมูลทั่วไป
     * @param url ex /test
     * @param data ค่าต่างที่ต้องการแนบไปกับ API
     */
    get31(url: any, data?: any): Promise<any[]>;
    /**
     * fn. get data สำหรับดึงข้อมูลทั่วไป
     * @param url ex /test
     * @param data ค่าต่างที่ต้องการแนบไปกับ API
     */
    getCustom(url: any, headers?: any): Promise<any[]>;
    /**
     * fn. get data สำหรับดึงข้อมูลทั่วไป
     * @param url ex /test
     * @param data ค่าต่างที่ต้องการแนบไปกับ API
     */
    getRawResponse(url: any, headers?: any): Promise<any>;
    /**
     * fn. delete data สำหรับลบข้อมูลทั่วไป
     * @param url ex /test
     * @param data ค่าต่างที่ต้องการแนบไปกับ API
     */
    delete(url: any, data?: any): Promise<any>;
    /**
     * fn. post data สำหรับสร้างข้อมูลทั่วไป
     * @param url ex /test
     * @param data ค่าต่างที่ต้องการแนบไปกับ API
     */
    post(url: any, data: any): Promise<any>;
    /**
     * fn. post data สำหรับสร้างข้อมูลทั่วไป
     * @param url ex /test
     * @param data ค่าต่างที่ต้องการแนบไปกับ API
     */
    post31(url: any, data: any): Promise<any>;
    /**
     * fn. post data สำหรับสร้างข้อมูลทั่วไป
     * @param url ex /test
     * @param data ค่าต่างที่ต้องการแนบไปกับ API
     */
    post14(url: any, data: any): Promise<any>;
    /**
     * fn. post data สำหรับสร้างข้อมูลทั่วไป
     * @param url ex /test
     * @param data ค่าต่างที่ต้องการแนบไปกับ API
     */
    postCustom(url: any, data: any, headers?: any): Promise<any>;
    /**
     * fn. put data สำหรับอัพเดตข้อมูลทั่วไป
     * @param url ex /test
     * @param data ค่าต่างที่ต้องการแนบไปกับ API
     */
    put(url: any, data: any): Promise<any>;
    /**
     * ถ้า getCustomStore แล้ว success กรณี loadMode = 'processed'
     * @param resData
     */
    fnHandleResponseProcessedMode(resData: any): {
        data: any[];
        totalCount: number;
    };
    /**
     * ถ้า getCustomStore แล้ว success กรณี loadMode = 'raw'
     * @param resData
     */
    fnHandleResponseRawMode(resData: any): any[];
    fnHandleResponse(resData: any): any[];
    /**
     * fn ดึงข้อมูลเพื่อใช้ใน Dropdown List
     * @param systemId เลขรหัสระบบที่ต้องการดึง
     * @param dropDownType ประเภทข้อมูล dropdown ที่ต้องการดึง
     */
    getDropDown(systemId: number, dropDownType: String, code?: String): Promise<any>;
    getDepartment(parentId?: number): Promise<any>;
    getExtDepartment(): Promise<any>;
    getCategory(system_id: any): Promise<any[]>;
    getStepName(category_id: any): Promise<any[]>;
    getAttachment(url: any): Promise<any>;
    postAttachment(url: any, data: any): Promise<any>;
    getUserLevel(): Promise<any>;
    multipleDeleteMain(table: any, idList: any): Promise<any>;
    getAttachmentLinkToken(url: any): Promise<string>;
    checkSpell(data: any, fieldList: any, modal: ModalSpellCheckComponent): Promise<boolean>;
    getQualification(url: any, headers?: any): Promise<any>;
    verifyUserName(): Promise<any>;
    utoa(str: any): string;
    downloadImgToBase64(api: any): Promise<{}>;
    downloadView(api: any): Promise<void>;
    download(api: any): Promise<void>;
}
