import 'rxjs/add/operator/catch';
import { array } from 'is_js';
import { UUID } from 'angular2-uuid';
import { Observable } from 'rxjs/Observable';
import { BehaviorSubject } from 'rxjs/BehaviorSubject';
import 'rxjs/add/operator/map';
import QrCode from 'qrcode-reader';
import { DxDateBoxModule } from 'devextreme-angular/ui/date-box';
import { baseZIndex } from 'devextreme/ui/overlay';
import moment from 'moment-es6';
import 'moment/locale/th';
import DataSource from 'devextreme/data/data_source';
import CustomStore from 'devextreme/data/custom_store';
import ArrayStore from 'devextreme/data/array_store';
import { DxDataGridModule as DxDataGridModule$1 } from 'devextreme-angular/ui/data-grid';
import { CustomValidators } from 'ng2-validation';
import { find, map, uniqBy, get, intersection, cloneDeep, merge, isObject, xorBy, filter, unionBy, includes, size } from 'lodash';
import { HttpClient, HttpHeaders, HttpRequest, HttpEventType, HttpResponse } from '@angular/common/http';
import { ModalModule } from 'ngx-bootstrap';
import { DxButtonModule, DxFileUploaderModule, DxTabPanelModule, DxTemplateModule, DxDataGridComponent, DxDataGridModule, DxSelectBoxModule } from 'devextreme-angular';
import { formatDate, locale } from 'devextreme/localization';
import 'devextreme-intl';
import { NgZorroAntdModule, NZ_I18N, th_TH } from 'ng-zorro-antd';
import { Headers, Http, RequestOptions, URLSearchParams, HttpModule } from '@angular/http';
import { Router, ActivatedRoute } from '@angular/router';
import { __awaiter, __generator, __values, __extends, __spread } from 'tslib';
import { trigger, state, style, transition, animate } from '@angular/animations';
import { AutoCompleteModule, TabViewModule, SharedModule, ButtonModule, DomHandler, PrimeTemplate } from 'primeng/primeng';
import { FormsModule, NG_VALUE_ACCESSOR, FormBuilder, Validators, NgControl, ReactiveFormsModule, FormControl } from '@angular/forms';
import { of, Observable as Observable$1, Subject } from 'rxjs';
import { Injectable, Component, NgModule, Directive, Input, TemplateRef, ViewContainerRef, EventEmitter, Output, ViewChild, forwardRef, defineInjectable, inject, ElementRef, Renderer2, ChangeDetectorRef, ContentChildren } from '@angular/core';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var SocAppLibraryService = /** @class */ (function () {
    function SocAppLibraryService() {
    }
    SocAppLibraryService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    SocAppLibraryService.ctorParameters = function () { return []; };
    /** @nocollapse */ SocAppLibraryService.ngInjectableDef = defineInjectable({ factory: function SocAppLibraryService_Factory() { return new SocAppLibraryService(); }, token: SocAppLibraryService, providedIn: "root" });
    return SocAppLibraryService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var SocAppLibraryComponent = /** @class */ (function () {
    function SocAppLibraryComponent() {
    }
    /**
     * @return {?}
     */
    SocAppLibraryComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        console.log("lib version 1.11.21");
    };
    SocAppLibraryComponent.decorators = [
        { type: Component, args: [{
                    selector: 'lib-soc-app-library',
                    template: "\n    <p>\n      soc-app-library works!\n    </p>\n  "
                }] }
    ];
    /** @nocollapse */
    SocAppLibraryComponent.ctorParameters = function () { return []; };
    return SocAppLibraryComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var AppConfigService = /** @class */ (function () {
    function AppConfigService(http) {
        this.http = http;
        this.appConfig = {
            env: 'local',
            // local | dev | prod
            title: 'Default',
            googleTagManagerId: 'GTM-KWJ6FF4'
        };
    }
    /**
     * @param {?} appConfigPath
     * @return {?}
     */
    AppConfigService.prototype.loadAppConfig = /**
     * @param {?} appConfigPath
     * @return {?}
     */
    function (appConfigPath) {
        var _this = this;
        return this.http.get(appConfigPath)
            .toPromise()
            .then(function (data) {
            _this.appConfig = data;
        })
            .catch(function (err) {
            console.error(err.message);
        });
    };
    /**
     * @return {?}
     */
    AppConfigService.prototype.getConfig = /**
     * @return {?}
     */
    function () {
        return this.appConfig;
    };
    AppConfigService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root',
                },] }
    ];
    /** @nocollapse */
    AppConfigService.ctorParameters = function () { return [
        { type: HttpClient }
    ]; };
    /** @nocollapse */ AppConfigService.ngInjectableDef = defineInjectable({ factory: function AppConfigService_Factory() { return new AppConfigService(inject(HttpClient)); }, token: AppConfigService, providedIn: "root" });
    return AppConfigService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var ResultCode = /** @class */ (function () {
    function ResultCode() {
    }
    ResultCode.SUCCESS = '20000';
    ResultCode.NOT_FOUND = '40400';
    ResultCode.ERROR = '50000';
    return ResultCode;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
// # Calendar TH
locale('th');
var Common = /** @class */ (function () {
    function Common() {
        this.DATE_FORMAT = 'YYYY-MM-DD HH:mm:ss';
        console.log("lib common version 1.11.21");
    }
    /**
     * fn. เช็ค data ทุกประเภท จะ Return กลับไปเป็น true|false
     * @param data
     */
    /**
     * fn. เช็ค data ทุกประเภท จะ Return กลับไปเป็น true|false
     * @param {?} data
     * @return {?}
     */
    Common.prototype.isNotEmpty = /**
     * fn. เช็ค data ทุกประเภท จะ Return กลับไปเป็น true|false
     * @param {?} data
     * @return {?}
     */
    function (data) {
        /** @type {?} */
        var haveData = false;
        /** @type {?} */
        var type = typeof data;
        // //console.tag('type:').log(type)
        switch (type) {
            // array|object
            case 'object':
                if (!data || data == null) {
                    haveData = false;
                }
                else if (typeof data[0] !== 'undefined') {
                    haveData = data.length !== 0 ? true : false;
                }
                else if (data instanceof Date) {
                    haveData = true;
                }
                else {
                    haveData = Object.keys(data).length ? true : false;
                }
                break;
            // string
            case 'string':
                if (data) {
                    haveData = true;
                }
                break;
            // number
            case 'number':
            // boolean
            case 'boolean':
            // function
            case 'function':
                haveData = true;
                break;
            default:
                haveData = false;
                break;
        }
        return haveData;
    };
    /**
     * fn. ปั้น filter สำหรับ Custom Store แบบมี field,filter,orderby
     * @param filterOptions : {}
     */
    /**
     * fn. ปั้น filter สำหรับ Custom Store แบบมี field,filter,orderby
     * @param {?} filterOptions : {}
     * @return {?}
     */
    Common.prototype.fnGenFilter = /**
     * fn. ปั้น filter สำหรับ Custom Store แบบมี field,filter,orderby
     * @param {?} filterOptions : {}
     * @return {?}
     */
    function (filterOptions) {
        var _this = this;
        /** @type {?} */
        var loadOptions = filterOptions.loadOptions || {};
        /** @type {?} */
        var filterList = filterOptions.filterList || {};
        /** @type {?} */
        var exceptionList = filterOptions.exceptionList || [];
        /** @type {?} */
        var options = filterOptions.options || {};
        /** @type {?} */
        var filter$$1 = new Observable(function (observer) {
            /** @type {?} */
            var data1 = _this.fnCheckLoadOptions(loadOptions);
            observer.next(data1);
            /** @type {?} */
            var data2 = _this.fnCheckFilterData(filterList, exceptionList);
            observer.next(data2);
            /** @type {?} */
            var data3 = _this.fnCheckOptions(data1, data2, options);
            observer.next(data3);
            observer.complete();
        });
        /** @type {?} */
        var obj = {};
        /** @type {?} */
        var observerStep = {
            next: function (data) { return (obj = data); },
            error: function (err) { return console.error('Observer got an error: ' + err); },
            complete: function () { return console.log('obj :', obj); }
        };
        filter$$1.subscribe(observerStep);
        // return filter กลับไป
        return obj;
    };
    /**
     * @param {?} loadOptions
     * @return {?}
     */
    Common.prototype.fnCheckLoadOptions = /**
     * @param {?} loadOptions
     * @return {?}
     */
    function (loadOptions) {
        /** @type {?} */
        var options = {
            limit: '',
            offset: '',
            order_by: []
        };
        if (this.isNotEmpty(loadOptions)) {
            options.offset = this.isNotEmpty(loadOptions.skip)
                ? loadOptions.skip
                : '';
            options.limit = this.isNotEmpty(loadOptions.take) ? loadOptions.take : '';
            if (this.isNotEmpty(loadOptions.sort)) {
                console.log("​Common -> fnCheckLoadOptions -> loadOptions.sort", loadOptions.sort);
                for (var index = 0; index < loadOptions.sort.length; index++) {
                    /** @type {?} */
                    var sort = loadOptions.sort[index];
                    /** @type {?} */
                    var orderbySelector = sort.selector || '';
                    if (orderbySelector) {
                        if (sort.desc) {
                            options.order_by.push(orderbySelector + ' desc');
                        }
                        else {
                            options.order_by.push(orderbySelector + ' asc');
                        }
                    }
                }
            }
            // options.orderby = this.isNotEmpty(loadOptions.sort) ? loadOptions.sort[0].selector : '';
            // options.orderby = this.isNotEmpty(loadOptions.sort) && loadOptions.sort[0].desc ? options.orderby + '|DESC' : options.orderby + '|ASC';
        }
        this.fnRemoveEmptyKey(options);
        return options;
    };
    /**
     * @param {?} filterList
     * @param {?} exceptionList
     * @return {?}
     */
    Common.prototype.fnCheckFilterData = /**
     * @param {?} filterList
     * @param {?} exceptionList
     * @return {?}
     */
    function (filterList, exceptionList) {
        /** @type {?} */
        var filter$$1 = {
            fields: '',
            filter: '',
            offset: '',
            limit: '',
            orderby: ''
        };
        if (this.isNotEmpty(filterList)) {
            filter$$1.fields = this.isNotEmpty(filterList.fields)
                ? filterList.fields
                : '';
            if (filterList.filter) {
                filter$$1.filter = this.fnConverstFilterDate(filterList.filter, exceptionList);
            }
            else {
                filter$$1.filter = '';
            }
            // filter.filter = this.isNotEmpty(filterList.filter)
            //   ? filterList.filter
            //   : '';
            filter$$1.offset = this.isNotEmpty(filterList.offset)
                ? filterList.offset
                : '';
            filter$$1.limit = this.isNotEmpty(filterList.limit) ? filterList.limit : '';
            filter$$1.orderby = this.isNotEmpty(filterList.orderby)
                ? filterList.orderby
                : '';
        }
        this.fnRemoveEmptyKey(filter$$1);
        return filter$$1;
    };
    /**
     * @param {?} data1
     * @param {?} data2
     * @param {?} options
     * @return {?}
     */
    Common.prototype.fnCheckOptions = /**
     * @param {?} data1
     * @param {?} data2
     * @param {?} options
     * @return {?}
     */
    function (data1, data2, options) {
        /** @type {?} */
        var mergeData = merge(data1, data2);
        options = options || {};
        /** @type {?} */
        var removeFilterEmpty = options.removeFilterEmpty || false; // if empty string will remove parameter
        if (removeFilterEmpty) {
            mergeData.filter = this.fnRemoveEmptyKey(mergeData.filter);
        }
        return mergeData;
    };
    /**
     * @param {?} obj
     * @return {?}
     */
    Common.prototype.fnRemoveEmptyKey = /**
     * @param {?} obj
     * @return {?}
     */
    function (obj) {
        for (var key in obj) {
            if (!this.isNotEmpty(obj[key])) {
                delete obj[key];
            }
            else if (isObject(obj[key])) {
                obj[key] = this.fnRemoveEmptyKey(obj[key]);
            }
        }
        return obj;
    };
    /**
     * @param {?} filter
     * @param {?} exceptionList
     * @return {?}
     */
    Common.prototype.fnConverstFilterDate = /**
     * @param {?} filter
     * @param {?} exceptionList
     * @return {?}
     */
    function (filter$$1, exceptionList) {
        for (var key in filter$$1) {
            /** @type {?} */
            var element = filter$$1[key];
            if (isObject(element)) {
                for (var dateKey in element) {
                    if (element[dateKey] && (dateKey === 'from' || dateKey === 'to')) {
                        if (exceptionList.includes(key)) {
                            element[dateKey] = moment(element[dateKey]).format('YYYY-MM-DD HH:mm:ss');
                        }
                        else {
                            if (dateKey === 'from') {
                                element[dateKey] = moment(element[dateKey]).format('YYYY-MM-DD 00:00:00');
                            }
                            else if (dateKey === 'to') {
                                element[dateKey] = moment(element[dateKey]).format('YYYY-MM-DD 23:59:59');
                            }
                        }
                    }
                }
            }
        }
        return filter$$1;
    };
    /**
     * fn. ปั้น filter สำหรับ Custom Store แบบ basic
     * @param loadOptions
     */
    /**
     * fn. ปั้น filter สำหรับ Custom Store แบบ basic
     * @param {?} loadOptions
     * @return {?}
     */
    Common.prototype.fnGenFilterBasic = /**
     * fn. ปั้น filter สำหรับ Custom Store แบบ basic
     * @param {?} loadOptions
     * @return {?}
     */
    function (loadOptions) {
        console.log('​Common -> fnGenFilterBasic -> loadOptions', loadOptions);
        /** @type {?} */
        var params = '?';
        params += 'skip=' + loadOptions.skip || 0;
        params += '&take=' + loadOptions.take || 10;
        if (loadOptions.sort) {
            params += '&orderby=' + loadOptions.sort[0].selector;
            if (loadOptions.sort[0].desc) {
                params += ' desc';
            }
        }
        return params;
    };
    /**
     * แปลงวันที่ จาก String เป็น Type Date
     * @param date วันที่ ที่ต้องการแปลง
     * @param formatOfDate ถ้ารู้ format ของ date ที่ส่งเข้ามาให้ระบุด้วย
     */
    /**
     * แปลงวันที่ จาก String เป็น Type Date
     * @param {?} date วันที่ ที่ต้องการแปลง
     * @param {?=} formatOfDate ถ้ารู้ format ของ date ที่ส่งเข้ามาให้ระบุด้วย
     * @return {?}
     */
    Common.prototype.fnToDate = /**
     * แปลงวันที่ จาก String เป็น Type Date
     * @param {?} date วันที่ ที่ต้องการแปลง
     * @param {?=} formatOfDate ถ้ารู้ format ของ date ที่ส่งเข้ามาให้ระบุด้วย
     * @return {?}
     */
    function (date, formatOfDate) {
        if (date) {
            if (formatOfDate) {
                return moment(date, formatOfDate).toDate();
            }
            else {
                return moment(date).toDate();
            }
        }
        else {
            return null;
        }
    };
    /**
     * แปลงวันที่ จาก String เป็น Type Date โดยมีอิง format จาก DB 'YYYY-MM-DD'
     * @param date วันที่ ที่ต้องการแปลง
     */
    /**
     * แปลงวันที่ จาก String เป็น Type Date โดยมีอิง format จาก DB 'YYYY-MM-DD'
     * @param {?} date วันที่ ที่ต้องการแปลง
     * @return {?}
     */
    Common.prototype.fnLToDateFromDB = /**
     * แปลงวันที่ จาก String เป็น Type Date โดยมีอิง format จาก DB 'YYYY-MM-DD'
     * @param {?} date วันที่ ที่ต้องการแปลง
     * @return {?}
     */
    function (date) {
        return moment(date, 'YYYY-MM-DD').toDate();
    };
    /**
     * เปลี่ยนภาษา Date Picker ของ Prime NG
     * @param local ภาษา
     */
    /**
     * เปลี่ยนภาษา Date Picker ของ Prime NG
     * @param {?} local ภาษา
     * @return {?}
     */
    Common.prototype.fnLocalPCalendar = /**
     * เปลี่ยนภาษา Date Picker ของ Prime NG
     * @param {?} local ภาษา
     * @return {?}
     */
    function (local) {
        switch (local) {
            case 'th':
                return {
                    firstDayOfWeek: 1,
                    dayNames: [
                        'อาทิตย์',
                        'จันทร์',
                        'อังคาร',
                        'พุธ',
                        'พฤหัส',
                        'ศุกร์',
                        'เสาร์'
                    ],
                    dayNamesShort: ['อา', 'จ', 'อ', 'พ', 'พฤ', 'ศ', 'ส'],
                    dayNamesMin: ['อา', 'จ', 'อ', 'พ', 'พฤ', 'ศ', 'ส'],
                    monthNames: [
                        'มกราคม',
                        'กุมภาพันธ์',
                        'มีนาคม',
                        'เมษายน',
                        'พฤษภาคม',
                        'มิถุนายน',
                        'กรกฎาคม',
                        'สิงหาคม',
                        'กันยายน',
                        'ตุลาคม',
                        'พฤศจิกายน',
                        'ธันวาคม'
                    ],
                    monthNamesShort: [
                        'ม.ค.',
                        'ก.พ.',
                        'มี.ค.',
                        'เม.ย.',
                        'พ.ค.',
                        'มิ.ย.',
                        'ก.ค.',
                        'ส.ค.',
                        'ก.ย.',
                        'ต.ค.',
                        'พ.ย.',
                        'ธ.ค.'
                    ],
                    today: 'วันนี้',
                    clear: 'เคลีย'
                };
            default:
                return {
                    firstDayOfWeek: 0,
                    dayNames: [
                        'Sunday',
                        'Monday',
                        'Tuesday',
                        'Wednesday',
                        'Thursday',
                        'Friday',
                        'Saturday'
                    ],
                    dayNamesShort: ['Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat'],
                    dayNamesMin: ['Su', 'Mo', 'Tu', 'We', 'Th', 'Fr', 'Sa'],
                    monthNames: [
                        'January',
                        'February',
                        'March',
                        'April',
                        'May',
                        'June',
                        'July',
                        'August',
                        'September',
                        'October',
                        'November',
                        'December'
                    ],
                    monthNamesShort: [
                        'Jan',
                        'Feb',
                        'Mar',
                        'Apr',
                        'May',
                        'Jun',
                        'Jul',
                        'Aug',
                        'Sep',
                        'Oct',
                        'Nov',
                        'Dec'
                    ],
                    today: 'Today',
                    clear: 'Clear'
                };
        }
    };
    /**
     * @param {?} id
     * @return {?}
     */
    Common.prototype.collapseFn = /**
     * @param {?} id
     * @return {?}
     */
    function (id) {
        /** @type {?} */
        var ibox = $('#' + id + ' div.collapse-link').closest('div.ibox');
        /** @type {?} */
        var button = $('#' + id + ' div.collapse-link').find('i');
        /** @type {?} */
        var button1 = $('#' + id + ' div.collapse-link').find('svg');
        /** @type {?} */
        var body = ibox.find('div.ibox-body');
        /** @type {?} */
        var content = ibox.find('div.ibox-content');
        /** @type {?} */
        var footer = ibox.find('div.ibox-footer');
        body.slideToggle();
        content.slideToggle();
        footer.slideToggle();
        button.toggleClass('far fa-chevron-up').toggleClass('far fa-chevron-down');
        button1.toggleClass('far fa-chevron-up').toggleClass('far fa-chevron-down');
        ibox.toggleClass('').toggleClass('border-bottom');
        setTimeout(function () {
            ibox.resize();
            ibox.find('[id^=map-]').resize();
        }, 50);
    };
    /**
     * เซ็ต action delete สำหรับส่ง post ไป api
     * @param idList id ที่ลบ
     * @param dataList array data ที่ต้องการจัดการ
     */
    /**
     * เซ็ต action delete สำหรับส่ง post ไป api
     * @param {?} idList id ที่ลบ
     * @param {?} dataList array data ที่ต้องการจัดการ
     * @return {?}
     */
    Common.prototype.fnFlagDelete = /**
     * เซ็ต action delete สำหรับส่ง post ไป api
     * @param {?} idList id ที่ลบ
     * @param {?} dataList array data ที่ต้องการจัดการ
     * @return {?}
     */
    function (idList, dataList) {
        /** @type {?} */
        var resultList = [];
        var _loop_1 = function (indexDs) {
            /** @type {?} */
            var obj = dataList[indexDs];
            /** @type {?} */
            var id = find(idList, function (value) { return value === obj.id; });
            if (obj.id != id) {
                resultList.push(obj);
            }
        };
        for (var indexDs = 0; indexDs < dataList.length; indexDs++) {
            _loop_1(indexDs);
        }
        return resultList;
    };
    /**
     *  เซ็ต action edit สำหรับส่ง post ไป api
     * @param dataList array data ที่ต้องการจัดการ
     * @param nameId ชื่อ ref id ของ table
     * @param mainId ค่า ref id ของ table
     */
    /**
     *  เซ็ต action edit สำหรับส่ง post ไป api
     * @param {?} dataList array data ที่ต้องการจัดการ
     * @return {?}
     */
    Common.prototype.fnFlagEdit = /**
     *  เซ็ต action edit สำหรับส่ง post ไป api
     * @param {?} dataList array data ที่ต้องการจัดการ
     * @return {?}
     */
    function (dataList) {
        /** @type {?} */
        var resultList = [];
        for (var index = 0; index < dataList.length; index++) {
            /** @type {?} */
            var obj = dataList[index];
            if (obj.id > 0) {
                obj.action = 'edit';
            }
            resultList.push(obj);
        }
        return resultList;
    };
    /**
     * เซ็ตค่าเมื่อกด edit
     * @param dataList array data ที่ต้องการจัดการ
     * @param data data ของ row ปัจจุบัน หรือ data ที่ต้องการเอาค่าไปอัพเดตให้ array data
     * @param nameId ชื่อ ref id ของ table
     * @param mainId ค่า ref id ของ table
     */
    /**
     * เซ็ตค่าเมื่อกด edit
     * @param {?} dataList array data ที่ต้องการจัดการ
     * @param {?} data data ของ row ปัจจุบัน หรือ data ที่ต้องการเอาค่าไปอัพเดตให้ array data
     * @return {?}
     */
    Common.prototype.fnSetValueEdit = /**
     * เซ็ตค่าเมื่อกด edit
     * @param {?} dataList array data ที่ต้องการจัดการ
     * @param {?} data data ของ row ปัจจุบัน หรือ data ที่ต้องการเอาค่าไปอัพเดตให้ array data
     * @return {?}
     */
    function (dataList, data) {
        for (var index = 0; index < dataList.length; index++) {
            /** @type {?} */
            var obj = dataList[index];
            if (obj.id === data.id) {
                dataList[index] = data;
            }
        }
        return dataList;
    };
    /**
     * ลบ id ชั่วคราวที่สร้างขึ้นมาใช้สำหรับ datagrid
     * @param dataList array data ที่ต้องการจัดการ
     */
    /**
     * ลบ id ชั่วคราวที่สร้างขึ้นมาใช้สำหรับ datagrid
     * @param {?} dataList array data ที่ต้องการจัดการ
     * @return {?}
     */
    Common.prototype.fnRemoveFakeId = /**
     * ลบ id ชั่วคราวที่สร้างขึ้นมาใช้สำหรับ datagrid
     * @param {?} dataList array data ที่ต้องการจัดการ
     * @return {?}
     */
    function (dataList) {
        /** @type {?} */
        var resultList = [];
        for (var index = 0; index < dataList.length; index++) {
            /** @type {?} */
            var obj = dataList[index];
            if (obj.id < 0) {
                delete obj.id;
            }
            resultList.push(obj);
        }
        return resultList;
    };
    /**
     * check response และแสดง modal ตาม result code
     * @param response data ที่ส่งมาจาก api
     * @param modal modal ที่ผูกกับ UI นั้น ๆ
     */
    /**
     * check response และแสดง modal ตาม result code
     * @param {?} response data ที่ส่งมาจาก api
     * @param {?} modal modal ที่ผูกกับ UI นั้น ๆ
     * @return {?}
     */
    Common.prototype.fnCheckResponse = /**
     * check response และแสดง modal ตาม result code
     * @param {?} response data ที่ส่งมาจาก api
     * @param {?} modal modal ที่ผูกกับ UI นั้น ๆ
     * @return {?}
     */
    function (response, modal) {
        if (+response.resultCode === 20000) {
            /** @type {?} */
            var dataAlert = {
                'modalId': 'myModalSuccess',
                'userTitle': 'Success',
                'userMessage': 'ดำเนินการสำเร็จ'
            };
            modal.openModal(dataAlert);
        }
        else {
            /** @type {?} */
            var dataAlert = {
                'modalId': 'myModalError',
                'userTitle': 'Error',
                'userMessage': 'ดำเนินการไม่สำเร็จ'
            };
            modal.openModal(dataAlert);
        }
    };
    /**
     * fn จัดการ action ของ data CRUD
     * @param a datalist ที่เก็บไว้ตอน Get
     * @param b datalist ปัจจุบันที่เปลี่ยนแปลง
     * @param idName key key หลักที่ต้องการใช้เปรียบเทียบ
     */
    /**
     * fn จัดการ action ของ data CRUD
     * @param {?} a datalist ที่เก็บไว้ตอน Get
     * @param {?} b datalist ปัจจุบันที่เปลี่ยนแปลง
     * @param {?=} idName key key หลักที่ต้องการใช้เปรียบเทียบ
     * @return {?}
     */
    Common.prototype.fnBuildArrayAction = /**
     * fn จัดการ action ของ data CRUD
     * @param {?} a datalist ที่เก็บไว้ตอน Get
     * @param {?} b datalist ปัจจุบันที่เปลี่ยนแปลง
     * @param {?=} idName key key หลักที่ต้องการใช้เปรียบเทียบ
     * @return {?}
     */
    function (a, b, idName) {
        if (idName === void 0) { idName = 'id'; }
        var e_1, _a;
        /** @type {?} */
        var aClone = cloneDeep(a);
        /** @type {?} */
        var bClone = cloneDeep(b);
        /** @type {?} */
        var deleted_added = xorBy(aClone, bClone, idName);
        /** @type {?} */
        var deleted = filter(deleted_added, function (o) { return o[idName] > 0; });
        /** @type {?} */
        var combine = unionBy(deleted, bClone, idName);
        try {
            // console.log('combine', combine);
            // console.log('----');
            for (var combine_1 = __values(combine), combine_1_1 = combine_1.next(); !combine_1_1.done; combine_1_1 = combine_1.next()) {
                var item = combine_1_1.value;
                if (includes(deleted_added, item)) {
                    if (item[idName] < 0) {
                        item['action'] = 'add';
                    }
                    else {
                        for (var field in item) {
                            if (field !== idName) {
                                delete item[field];
                            }
                        }
                        item.action = "delete";
                    }
                }
                else {
                    item['action'] = 'edit';
                }
                if (item.row_number) {
                    delete item['row_number'];
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (combine_1_1 && !combine_1_1.done && (_a = combine_1.return)) _a.call(combine_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return combine;
    };
    /**
     * fn ปั้นข้อความหัว Table
     * @param result ผลลัพ data ที่ได้จาก custom store
     */
    /**
     * fn ปั้นข้อความหัว Table
     * @param {?} result ผลลัพ data ที่ได้จาก custom store
     * @return {?}
     */
    Common.prototype.fnGenTextTotal = /**
     * fn ปั้นข้อความหัว Table
     * @param {?} result ผลลัพ data ที่ได้จาก custom store
     * @return {?}
     */
    function (result) {
        /** @type {?} */
        var resultCount = result.data.length || 0;
        /** @type {?} */
        var totalCount = result.totalCount || 0;
        /** @type {?} */
        var textTotal = "\u0E1C\u0E25\u0E25\u0E31\u0E1E\u0E18\u0E4C " + resultCount + " \u0E23\u0E32\u0E22\u0E01\u0E32\u0E23 \u0E08\u0E32\u0E01\u0E17\u0E31\u0E49\u0E07\u0E2B\u0E21\u0E14 " + totalCount + " \u0E23\u0E32\u0E22\u0E01\u0E32\u0E23";
        return textTotal;
    };
    /**
     * fn ปั้นข้อความหัว Table สำหรับ datasource แบบ get ครั้งเดียว
     * @param event event ที่ได้จาก event onOptionChanged
     */
    /**
     * fn ปั้นข้อความหัว Table สำหรับ datasource แบบ get ครั้งเดียว
     * @param {?} event event ที่ได้จาก event onOptionChanged
     * @return {?}
     */
    Common.prototype.fnGenTextTotalRaw = /**
     * fn ปั้นข้อความหัว Table สำหรับ datasource แบบ get ครั้งเดียว
     * @param {?} event event ที่ได้จาก event onOptionChanged
     * @return {?}
     */
    function (event) {
        /** @type {?} */
        var promise = new Promise(function (resolve, reject) {
            setTimeout(function () {
                if (event.name === 'paging' || event.name === 'dataSource') {
                    /** @type {?} */
                    var getVisibleRows = event.component ? event.component.getVisibleRows() : [];
                    /** @type {?} */
                    var totalCount = event.component ? event.component.totalCount() : 0;
                    /** @type {?} */
                    var resultCount = getVisibleRows.length || 0;
                    resolve("\u0E1C\u0E25\u0E25\u0E31\u0E1E\u0E18\u0E4C " + resultCount + " \u0E23\u0E32\u0E22\u0E01\u0E32\u0E23 \u0E08\u0E32\u0E01\u0E17\u0E31\u0E49\u0E07\u0E2B\u0E21\u0E14 " + totalCount + " \u0E23\u0E32\u0E22\u0E01\u0E32\u0E23");
                }
            }, 100);
        });
        return promise;
    };
    /** fn เปลี่ยน calendar devextreme ให้ปี เป็นแบบ พ.ศ. */
    /**
     * fn เปลี่ยน calendar devextreme ให้ปี เป็นแบบ พ.ศ.
     * @return {?}
     */
    Common.prototype.fnChangeCalendarYear = /**
     * fn เปลี่ยน calendar devextreme ให้ปี เป็นแบบ พ.ศ.
     * @return {?}
     */
    function () {
        try {
            /** @type {?} */
            var yearRegex_1 = /^[0-9]{4}-[0-9]{4}$/g;
            /** @type {?} */
            var yearRegex2_1 = /^[0-9]{4}\s-\s[0-9]{4}$/g;
            /** @type {?} */
            var btnList = document.querySelectorAll('.dx-popup-content .dx-calendar');
            for (var indexBtn = 0; indexBtn < btnList.length; indexBtn++) {
                /** @type {?} */
                var btn = btnList[indexBtn];
                btn.removeEventListener('click', function (e) { });
                btn.addEventListener('click', function () {
                    /** *
                     * เปลี่ยนปีในส่วนของ cell ด้านใน
                      @type {?} */
                    var dxCalendarCell = document.querySelectorAll('.dx-calendar-cell');
                    for (var index = 0; index < dxCalendarCell.length; index++) {
                        /** @type {?} */
                        var cell = dxCalendarCell[index];
                        /** @type {?} */
                        var text = cell.getAttribute('aria-label');
                        /** @type {?} */
                        var num = parseInt(text);
                        if (text.length === 4 && num !== NaN) {
                            /** @type {?} */
                            var num2 = num + 543;
                            cell.textContent = num2.toString();
                        }
                        else if (text.match(yearRegex2_1)) {
                            /** @type {?} */
                            var arr = text.split('-');
                            /** @type {?} */
                            var year1 = parseInt(arr[0]);
                            /** @type {?} */
                            var year2 = parseInt(arr[1]);
                            /** @type {?} */
                            var str = (year1 + 543).toString() + '-' + (year2 + 543).toString();
                            cell.textContent = str;
                        }
                    }
                    /** *
                     * เปลี่ยนปีในส่วนของ nav ด้านบน
                      @type {?} */
                    var dxCalendarTop = document.querySelectorAll('.dx-calendar-caption-button');
                    for (var indexTop = 0; indexTop < dxCalendarTop.length; indexTop++) {
                        /** @type {?} */
                        var cell = dxCalendarTop[indexTop];
                        /** @type {?} */
                        var text = cell.getAttribute('aria-label');
                        /** @type {?} */
                        var num = parseInt(text);
                        if (text.length === 4 && num !== NaN) {
                            /** @type {?} */
                            var num2 = num + 543;
                            /** @type {?} */
                            var fisrt = cell.children;
                            /** @type {?} */
                            var target = fisrt.item(0).children;
                            target.item(0).textContent = num2.toString();
                        }
                        else if (text.match(yearRegex_1)) {
                            /** @type {?} */
                            var arr = text.split('-');
                            /** @type {?} */
                            var year1 = parseInt(arr[0]);
                            /** @type {?} */
                            var year2 = parseInt(arr[1]);
                            /** @type {?} */
                            var str = (year1 + 543).toString() + '-' + (year2 + 543).toString();
                            /** @type {?} */
                            var fisrt = cell.children;
                            /** @type {?} */
                            var target = fisrt.item(0).children;
                            target.item(0).textContent = str;
                        }
                    }
                });
            }
        }
        catch (error) {
            console.log("fnChangeCalendarYear -> error", error);
        }
    };
    /**
     * @return {?}
     */
    Common.prototype.fnChangeCalendarYearOnce = /**
     * @return {?}
     */
    function () {
        try {
            /** @type {?} */
            var yearRegex = /^[0-9]{4}-[0-9]{4}$/g;
            /** *
             * เปลี่ยนปีในส่วนของ cell ด้านใน
              @type {?} */
            var dxCalendarCell = document.querySelectorAll('.dx-calendar-cell');
            for (var index = 0; index < dxCalendarCell.length; index++) {
                /** @type {?} */
                var cell = dxCalendarCell[index];
                /** @type {?} */
                var text = cell.getAttribute('aria-label');
                /** @type {?} */
                var num = parseInt(text);
                if (text.length === 4 && num !== NaN) {
                    /** @type {?} */
                    var num2 = num + 543;
                    cell.textContent = num2.toString();
                }
            }
            /** *
             * เปลี่ยนปีในส่วนของ nav ด้านบน
              @type {?} */
            var dxCalendarTop = document.querySelectorAll('.dx-calendar-caption-button');
            for (var indexTop = 0; indexTop < dxCalendarTop.length; indexTop++) {
                /** @type {?} */
                var cell = dxCalendarTop[indexTop];
                /** @type {?} */
                var text = cell.getAttribute('aria-label');
                /** @type {?} */
                var num = parseInt(text);
                if (text.length === 4 && num !== NaN) {
                    /** @type {?} */
                    var num2 = num + 543;
                    /** @type {?} */
                    var fisrt = cell.children;
                    /** @type {?} */
                    var target = fisrt.item(0).children;
                    target.item(0).textContent = num2.toString();
                }
                else if (text.match(yearRegex)) {
                    /** @type {?} */
                    var arr = text.split('-');
                    /** @type {?} */
                    var year1 = parseInt(arr[0]);
                    /** @type {?} */
                    var year2 = parseInt(arr[1]);
                    /** @type {?} */
                    var str = (year1 + 543).toString() + '-' + (year2 + 543).toString();
                    /** @type {?} */
                    var fisrt = cell.children;
                    /** @type {?} */
                    var target = fisrt.item(0).children;
                    target.item(0).textContent = str;
                }
            }
        }
        catch (error) {
            console.log("fnChangeCalendarYear -> error", error);
        }
    };
    // gen uuid
    /**
     * @return {?}
     */
    Common.prototype.fnGenUuid = /**
     * @return {?}
     */
    function () {
        return UUID.UUID();
    };
    /**
     * fn แปลง date ก่อนส่งไปให้ API
     * @param dataList data ที่ต้องการจัดการหรือ model ที่ผูก
     * @param fieldList list รายชื่อ field ที่ต้องการแปลง date
     */
    /**
     * fn แปลง date ก่อนส่งไปให้ API
     * @param {?} dataList data ที่ต้องการจัดการหรือ model ที่ผูก
     * @param {?} fieldList list รายชื่อ field ที่ต้องการแปลง date
     * @return {?}
     */
    Common.prototype.fnFormatDateList = /**
     * fn แปลง date ก่อนส่งไปให้ API
     * @param {?} dataList data ที่ต้องการจัดการหรือ model ที่ผูก
     * @param {?} fieldList list รายชื่อ field ที่ต้องการแปลง date
     * @return {?}
     */
    function (dataList, fieldList) {
        /** @type {?} */
        var cloneDataList = cloneDeep(dataList);
        for (var index = 0; index < fieldList.length; index++) {
            /** @type {?} */
            var field = fieldList[index];
            if (cloneDataList[field]) {
                cloneDataList[field] = moment(cloneDataList[field]).format(this.DATE_FORMAT);
            }
        }
        return cloneDataList;
    };
    /**
       * fn. แปลง string date จาก db เป็น วัน เวลา ประเทศไทย
       * @param value String date ที่ต้องการแปลง
       */
    /**
     * fn. แปลง string date จาก db เป็น วัน เวลา ประเทศไทย
     * @param {?} value String date ที่ต้องการแปลง
     * @return {?}
     */
    Common.prototype.fnDisplayFormatDate = /**
     * fn. แปลง string date จาก db เป็น วัน เวลา ประเทศไทย
     * @param {?} value String date ที่ต้องการแปลง
     * @return {?}
     */
    function (value) {
        /** @type {?} */
        var dateString = formatDate(value, "shortDate");
        /** @type {?} */
        var timeString = formatDate(value, "HH:mm:ss");
        return dateString + ' ' + timeString;
    };
    /**
     * @param {?} key
     * @param {?} value
     * @return {?}
     */
    Common.prototype.replacer = /**
     * @param {?} key
     * @param {?} value
     * @return {?}
     */
    function (key, value) {
        // Filtering out properties
        // console.log("key",key);
        // console.log("value",value);
        // console.log("type",typeof value);
        // const type = typeof value;
        // switch (type) {
        //     case 'string':
        //         return value.trim();
        //     case 'Date':
        //         return moment(value).format('YYYY-MM-dd HH:mm:ss');
        //     default:
        // }
        if (typeof value === "string") {
            if (/^\d{4}-\d{2}-\d{2}T\d{2}:\d{2}:\d{2}.\d{3}Z$/.test(value)) {
                return moment(value).format('YYYY-MM-DD HH:mm:ss');
            }
            else {
                return value.trim();
            }
        }
        return value;
    };
    /**
     * @param {?} key
     * @param {?} value
     * @return {?}
     */
    Common.prototype.replacernotrim = /**
     * @param {?} key
     * @param {?} value
     * @return {?}
     */
    function (key, value) {
        // Filtering out properties
        // console.log("key",key);
        // console.log("value",value);
        // console.log("type",typeof value);
        // const type = typeof value;
        // switch (type) {
        //     case 'string':
        //         return value.trim();
        //     case 'Date':
        //         return moment(value).format('YYYY-MM-dd HH:mm:ss');
        //     default:
        // }
        if (typeof value === "string") {
            if (/^\d{4}-\d{2}-\d{2}T\d{2}:\d{2}:\d{2}.\d{3}Z$/.test(value)) {
                return moment(value).format('YYYY-MM-DD HH:mm:ss');
            }
            else {
                return value;
            }
        }
        return value;
    };
    /**
     * @param {?} date
     * @return {?}
     */
    Common.prototype.convertTHShortDate = /**
     * @param {?} date
     * @return {?}
     */
    function (date) {
        date = moment(date);
        /** @type {?} */
        var iMonth = parseInt(moment(date).format('MM'));
        /** @type {?} */
        var iYear = moment(date).format('YYYY');
        iYear = iYear.substr(2, 4);
        /** @type {?} */
        var thShortMonth = ['', 'ม.ค.', 'ก.พ.', 'มี.ค.', 'เม.ย.', 'พ.ค.', 'มิ.ย.', 'ก.ค.', 'ส.ค.', 'ก.ย.', 'ต.ค.', 'พ.ย.', 'ธ.ค.'];
        return this.NumberToThaiNumber(date.format('DD')) + ' ' + thShortMonth[iMonth] + ' ' + this.NumberToThaiNumber(iYear);
    };
    /**
     * @param {?} Number
     * @return {?}
     */
    Common.prototype.NumberToThaiNumber = /**
     * @param {?} Number
     * @return {?}
     */
    function (Number) {
        Number = Number.toString();
        Number = Number.replace(/0/gi, '๐');
        Number = Number.replace(/1/gi, '๑');
        Number = Number.replace(/2/gi, '๒');
        Number = Number.replace(/3/gi, '๓');
        Number = Number.replace(/4/gi, '๔');
        Number = Number.replace(/5/gi, '๕');
        Number = Number.replace(/6/gi, '๖');
        Number = Number.replace(/7/gi, '๗');
        Number = Number.replace(/8/gi, '๘');
        Number = Number.replace(/9/gi, '๙');
        return Number;
    };
    /**
     * @param {?} month
     * @param {?} short
     * @return {?}
     */
    Common.prototype.fnGetMonthTH = /**
     * @param {?} month
     * @param {?} short
     * @return {?}
     */
    function (month, short) {
        month = month - 1;
        /** @type {?} */
        var thMonth = ["มกราคม", "กุมภาพันธ์", "มีนาคม",
            "เมษายน", "พฤษภาคม", "มิถุนายน", "กรกฎาคม", "สิงหาคม", "กันยายน",
            "ตุลาคม", "พฤศจิกายน", "ธันวาคม"];
        /** @type {?} */
        var thShortMonth = ["ม.ค.", "ก.พ.", "มี.ค.", "เม.ย.", "พ.ค.", "มิ.ย.", "ก.ค.", "ส.ค.", "ก.ย.", "ต.ค.", "พ.ย.", "ธ.ค."];
        return short === true ? thShortMonth[month] : thMonth[month];
    };
    /**
     * @param {?} date
     * @param {?} format
     * @param {?} typeTH
     * @return {?}
     */
    Common.prototype.convertTHDate = /**
     * @param {?} date
     * @param {?} format
     * @param {?} typeTH
     * @return {?}
     */
    function (date, format, typeTH) {
        moment.locale('th');
        console.log(moment(date).add(543, "years").format("DD MMMM YYYY"));
        if (typeTH) {
            return this.NumberToThaiNumber(moment(date).add(543, "years").format(format));
        }
        else {
            return moment(date).add(543, "years").format(format);
        }
    };
    Common.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    Common.ctorParameters = function () { return []; };
    return Common;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var B2bService = /** @class */ (function () {
    function B2bService(http, appConfigService) {
        this.http = http;
        this.appConfigService = appConfigService;
        this.verifyTokenUrl = '';
        this.downloadTokenUrl = '';
        this._verifyToken = new BehaviorSubject({});
        this.verifyToken = {
            'username': '$username',
            'sessionId': '$sessionId',
            'groupIntegrationNames': ['groupName1', 'groupName2', 'groupName3'],
            'menus': ['menu1', 'menu2'],
            'menuPermissions': [
                { 'menuName': 'menu1', 'permissions': ['add', 'edit', 'delete'] },
                { 'menuName': 'menu2', 'permissions': ['view', 'add', 'edit'] }
            ],
            'attachmentToken': {
                'token': 'DOWNLOADS_AEB496F6DED34FFF93F668412E3CDD38',
                'expire': '2018-09-21 09:00:00'
            }
        };
        this.config = appConfigService.getConfig();
        // console.log('b2b config',this.config);
        this.verifyTokenUrl = get(this.config, 'apiServers.portal-backend.verifyToken');
        this.downloadTokenUrl = get(this.config, 'apiServers.portal-backend.downloadToken');
    }
    /**
     * @return {?}
     */
    B2bService.prototype.verify = /**
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var body = {
            'microIntegrationName': get(this.config, 'microIntegrationName')
        };
        return this.http.post(this.verifyTokenUrl, body, this.jwt()).map(function (res) {
            // console.log(res.json());
            // console.log(res);
            res = res.json();
            if (+res['resultCode'] === 20000) {
                _this.verifyToken = res['resultData'];
                _this._verifyToken.next(res['resultData']);
            }
            // else if(+res['resultCode'] === 40100){
            //   let __resultData = res['resultData'];
            //   this.checkSession(__resultData.userMessage);
            // }
            // console.log(this.verifyToken);
            return res;
        }).catch(function (error) { return Observable.throw(error.json().error || 'Server error'); }).toPromise();
    };
    /**
     * @return {?}
     */
    B2bService.prototype.subscribeVerifyToken = /**
     * @return {?}
     */
    function () {
        return this._verifyToken.asObservable();
    };
    /**
     * @return {?}
     */
    B2bService.prototype.getVerifyToken = /**
     * @return {?}
     */
    function () {
        return this._verifyToken.getValue();
    };
    /**
     * @param {?} userMessage
     * @return {?}
     */
    B2bService.prototype.checkSession = /**
     * @param {?} userMessage
     * @return {?}
     */
    function (userMessage) {
        console.log('checkSession');
        /** @type {?} */
        var token = sessionStorage.getItem('token');
        window.parent.postMessage(JSON.stringify({
            command: "checkSession",
            message: token,
            userMessage: userMessage || 'Unknow'
        }), '*');
        console.log('checkSession', JSON.stringify({
            command: "checkSession",
            message: token,
            userMessage: userMessage || 'Unknow'
        }));
    };
    /** รับค่า role ที่มีสิทธิ์ */
    // isCheckGroup(rolePermission) {
    //     console.log("rolePermission",rolePermission);
    //     /** mockup response*/
    //     let verify = [];
    //     this.verifyToken.menuPermissions.forEach(menuPermissions => {
    //         if (menuPermissions.menuName === rolePermission.role) {
    //             verify = menuPermissions.permissions;
    //         }
    //     });
    //     console.log("verify",verify);
    //     const checkArrary = _.intersection(verify, rolePermission.component);
    //     console.log("checkArrary",checkArrary);
    //     if (checkArrary.length !== 0) {
    //         return true;
    //     } else {
    //         return false;
    //     }
    // }
    /**
     * รับค่า role ที่มีสิทธิ์
     * @param {?} route
     * @return {?}
     */
    B2bService.prototype.isCheckGroup = /**
     * รับค่า role ที่มีสิทธิ์
     * @param {?} route
     * @return {?}
     */
    function (route) {
        var e_1, _a;
        /** @type {?} */
        var verify = [];
        try {
            for (var _b = __values(this.verifyToken.menuPermissions), _c = _b.next(); !_c.done; _c = _b.next()) {
                var menuPermissions = _c.value;
                /** @type {?} */
                var url = menuPermissions.url || "";
                /** @type {?} */
                var splitPath = url.split('?');
                splitPath = splitPath.length > 0 ? splitPath[0].split('/') : [];
                /** @type {?} */
                var path = void 0; // ดึง path สุดท้าย
                for (var i = 0; i <= splitPath.length; i++) {
                    // console.log('isCheckGroup splitPath[i]', splitPath[i]);
                    if (splitPath[i] === '#') {
                        path = splitPath[i + 1]; // ดึง path หลัง #
                        break;
                    }
                }
                // console.log("isCheckGroup path", path);
                if (path === route.route) {
                    verify = menuPermissions.permissions;
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
        /** @type {?} */
        var checkArrary = intersection(verify, route.component);
        // console.log("isCheckGroup checkArrary", checkArrary);
        if (checkArrary.length !== 0) {
            return true;
        }
        else {
            return false;
        }
    };
    /** รับค่า guard ที่มีสิทธิ์ */
    /**
     * รับค่า guard ที่มีสิทธิ์
     * @param {?} role
     * @return {?}
     */
    B2bService.prototype.isCheckGuard = /**
     * รับค่า guard ที่มีสิทธิ์
     * @param {?} role
     * @return {?}
     */
    function (role) {
        /** *
         * mockup response
          @type {?} */
        var checkArrary = intersection(this.verifyToken.menus, [role]);
        // console.log("checkArrary",checkArrary);
        if (checkArrary.length !== 0) {
            return true;
        }
        else {
            return false;
        }
    };
    /**
     * @return {?}
     */
    B2bService.prototype.verifyDemo = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var token = sessionStorage.getItem('token');
        // console.log('token', token);
        if (token && token === 'demo') {
            return of({
                'resultCode': '20000',
                'resultDescription': 'Success',
                'resultData': {
                    'b2bToken': '$b2bToken'
                }
            }).toPromise();
        }
        return of({
            'resultCode': '40000',
            'resultDescription': '',
        }).toPromise();
    };
    /**
     * @return {?}
     */
    B2bService.prototype.jwt = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var token = sessionStorage.getItem('token');
        if (token) {
            /** @type {?} */
            var headers = new Headers({ 'Authorization': 'Bearer ' + token, 'Content-Type': 'application/json', 'x-token': '1' });
            return new RequestOptions({ headers: headers });
        }
    };
    /**
     * @return {?}
     */
    B2bService.prototype.getAttachmentToken = /**
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            var now, expireDate, checkDateValid, response, e_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        now = new Date();
                        expireDate = new Date(this.verifyToken.attachmentToken.expire);
                        checkDateValid = now <= expireDate;
                        if (!checkDateValid) return [3 /*break*/, 1];
                        return [2 /*return*/, this.verifyToken.attachmentToken.token];
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.http.post(this.downloadTokenUrl, {}, this.jwt()).map(function (res) {
                                return res.json();
                            }).catch(function (error) { return Observable.throw(error.json().error || 'Server error'); }).toPromise()];
                    case 2:
                        response = _a.sent();
                        // console.log('response ',response);
                        if (+response['resultCode'] === 20000) {
                            this.verifyToken.attachmentToken = response['resultData'];
                            return [2 /*return*/, response['resultData'].token];
                        }
                        // else if(+response['resultCode'] === 40100){
                        //   let __resultData = response['resultData'];
                        //   this.checkSession(__resultData.userMessage);
                        //   return '';
                        // }
                        else {
                            return [2 /*return*/, ''];
                        }
                        return [3 /*break*/, 4];
                    case 3:
                        e_2 = _a.sent();
                        console.log('error ', e_2);
                        return [2 /*return*/, ''];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    /** รับค่า guard ที่มีสิทธิ์ */
    /**
     * รับค่า guard ที่มีสิทธิ์
     * @param {?} route
     * @return {?}
     */
    B2bService.prototype.isCheckGuardRoutePath = /**
     * รับค่า guard ที่มีสิทธิ์
     * @param {?} route
     * @return {?}
     */
    function (route) {
        var e_3, _a;
        try {
            // console.log("route",route);
            // console.log("this.verifyToken",this.verifyToken);
            for (var _b = __values(this.verifyToken.menuPermissions), _c = _b.next(); !_c.done; _c = _b.next()) {
                var menuPermissions = _c.value;
                /** @type {?} */
                var url = menuPermissions.url || "";
                /** @type {?} */
                var splitPath = url.split('?');
                splitPath = splitPath.length > 0 ? splitPath[0].split('/') : [];
                /** @type {?} */
                var path = void 0; // ดึง path สุดท้าย
                for (var i = 0; i <= splitPath.length; i++) {
                    // console.log('splitPath[i]', splitPath[i]);
                    if (splitPath[i] === '#') {
                        path = splitPath[i + 1]; // ดึง path หลัง #
                        break;
                    }
                }
                // console.log("path",path);
                if (path === route) {
                    return true;
                }
            }
        }
        catch (e_3_1) { e_3 = { error: e_3_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_3) throw e_3.error; }
        }
        return false;
    };
    B2bService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    B2bService.ctorParameters = function () { return [
        { type: Http },
        { type: AppConfigService }
    ]; };
    return B2bService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var Request = /** @class */ (function () {
    function Request(appConfigService, httpClient, http, router, common, b2bService) {
        this.appConfigService = appConfigService;
        this.httpClient = httpClient;
        this.http = http;
        this.router = router;
        this.common = common;
        this.b2bService = b2bService;
        this.config = appConfigService.getConfig();
        this.api = get(this.config, 'apiServers.tomcat.url');
        this.system_id = get(this.config, 'system_id');
        // this.api = 'https://d.gaizers.com/RestAPI';
    }
    /**
     * fn. get data สำหรับดึงข้อมูลสำหรับ Datagrid เท่านั้น
     * @param customStoreOptions โยนค่าต่าง ๆ มาในนี้
     */
    /**
     * fn. get data สำหรับดึงข้อมูลสำหรับ Datagrid เท่านั้น
     * @param {?} customStoreOptions โยนค่าต่าง ๆ มาในนี้
     * @return {?}
     */
    Request.prototype.getCustomStore = /**
     * fn. get data สำหรับดึงข้อมูลสำหรับ Datagrid เท่านั้น
     * @param {?} customStoreOptions โยนค่าต่าง ๆ มาในนี้
     * @return {?}
     */
    function (customStoreOptions) {
        var _this = this;
        /** @type {?} */
        var url = customStoreOptions.url || '';
        /** @type {?} */
        var data = customStoreOptions.filter || {};
        /** @type {?} */
        var loadMode = customStoreOptions.loadMode || 'processed';
        /** @type {?} */
        var params = new URLSearchParams();
        for (var key in data) {
            if (key === 'filter') {
                if (data[key] !== '{}') {
                    params.set(key, data[key]);
                }
            }
            else {
                params.set(key, data[key]);
            }
        }
        console.log('​Request -> getCustomStore -> params', params);
        /** @type {?} */
        var userData = this.b2bService.getVerifyToken();
        /** @type {?} */
        var headerData = {
            system_id: this.system_id,
            department: userData.phoneBookData && userData.phoneBookData.length > 0 ? userData.phoneBookData[0].dept : "",
            username: userData.username
        };
        /** @type {?} */
        var headers = new Headers();
        headers.append('x-Token', '1');
        headers.append('x-user-data', this.utoa(JSON.stringify(headerData)));
        /** @type {?} */
        var options = new RequestOptions({ headers: headers, withCredentials: true });
        options.search = params;
        return this.http.get(this.api + url, options)
            .map(function (res) {
            /** @type {?} */
            var resData = res.json();
            console.log('​Request -> getCustomStore -> resData', resData);
            if (loadMode === 'processed') {
                return _this.fnHandleResponseProcessedMode(resData);
            }
            else {
                return _this.fnHandleResponseRawMode(resData);
            }
        })
            .toPromise()
            .catch(function (error) {
            console.log('​Request -> getCustomStore -> error', error);
            if (loadMode === 'processed') {
                return _this.fnHandleErrorProcessedMode(error);
            }
            else {
                return _this.fnHandleErrorRawMode(error);
            }
        });
    };
    /**
     * fn. post data สำหรับดึงข้อมูลสำหรับ Datagrid เท่านั้น
     * @param customStoreOptions โยนค่าต่าง ๆ มาในนี้
     */
    /**
     * fn. post data สำหรับดึงข้อมูลสำหรับ Datagrid เท่านั้น
     * @param {?} customStoreOptions โยนค่าต่าง ๆ มาในนี้
     * @return {?}
     */
    Request.prototype.postCustomStore = /**
     * fn. post data สำหรับดึงข้อมูลสำหรับ Datagrid เท่านั้น
     * @param {?} customStoreOptions โยนค่าต่าง ๆ มาในนี้
     * @return {?}
     */
    function (customStoreOptions) {
        return __awaiter(this, void 0, void 0, function () {
            var url, data, loadMode, userData, headerData, headers, options;
            var _this = this;
            return __generator(this, function (_a) {
                url = customStoreOptions.url || '';
                data = JSON.parse(JSON.stringify(customStoreOptions.filter, this.common.replacer)) || {};
                loadMode = customStoreOptions.loadMode || 'processed';
                userData = this.b2bService.getVerifyToken();
                headerData = {
                    system_id: this.system_id,
                    department: userData.phoneBookData && userData.phoneBookData.length > 0 ? userData.phoneBookData[0].dept : "",
                    username: userData.username
                };
                headers = new Headers();
                headers.append('x-Token', '1');
                headers.append('x-user-data', this.utoa(JSON.stringify(headerData)));
                options = new RequestOptions({ headers: headers, withCredentials: true });
                return [2 /*return*/, this.http.post(this.api + url, data, options)
                        .map(function (res) {
                        /** @type {?} */
                        var resData = res.json();
                        console.log('​Request -> getCustomStore -> resData', resData);
                        if (loadMode === 'processed') {
                            return _this.fnHandleResponseProcessedMode(resData);
                        }
                        else {
                            return _this.fnHandleResponseRawMode(resData);
                        }
                    })
                        .toPromise()
                        .catch(function (error) {
                        console.log('​Request -> getCustomStore -> error', error);
                        if (loadMode === 'processed') {
                            return _this.fnHandleErrorProcessedMode(error);
                        }
                        else {
                            return _this.fnHandleErrorRawMode(error);
                        }
                    })];
            });
        });
    };
    /**
     * fn. post data สำหรับดึงข้อมูลสำหรับ Datagrid เท่านั้น
     * @param customStoreOptions โยนค่าต่าง ๆ มาในนี้
     */
    /**
     * fn. post data สำหรับดึงข้อมูลสำหรับ Datagrid เท่านั้น
     * @param {?} customStoreOptions โยนค่าต่าง ๆ มาในนี้
     * @return {?}
     */
    Request.prototype.postCustomStore31 = /**
     * fn. post data สำหรับดึงข้อมูลสำหรับ Datagrid เท่านั้น
     * @param {?} customStoreOptions โยนค่าต่าง ๆ มาในนี้
     * @return {?}
     */
    function (customStoreOptions) {
        return __awaiter(this, void 0, void 0, function () {
            var url, data, loadMode, userData, headerData, headers, options;
            var _this = this;
            return __generator(this, function (_a) {
                url = customStoreOptions.url || '';
                data = JSON.parse(JSON.stringify(customStoreOptions.filter, this.common.replacer)) || {};
                loadMode = customStoreOptions.loadMode || 'processed';
                userData = this.b2bService.getVerifyToken();
                headerData = {
                    system_id: 31,
                    department: userData.phoneBookData && userData.phoneBookData.length > 0 ? userData.phoneBookData[0].dept : "",
                    username: userData.username
                };
                headers = new Headers();
                headers.append('x-Token', '1');
                headers.append('x-user-data', this.utoa(JSON.stringify(headerData)));
                options = new RequestOptions({ headers: headers, withCredentials: true });
                return [2 /*return*/, this.http.post(this.api + url, data, options)
                        .map(function (res) {
                        /** @type {?} */
                        var resData = res.json();
                        console.log('​Request -> getCustomStore -> resData', resData);
                        if (loadMode === 'processed') {
                            return _this.fnHandleResponseProcessedMode(resData);
                        }
                        else {
                            return _this.fnHandleResponseRawMode(resData);
                        }
                    })
                        .toPromise()
                        .catch(function (error) {
                        console.log('​Request -> getCustomStore -> error', error);
                        if (loadMode === 'processed') {
                            return _this.fnHandleErrorProcessedMode(error);
                        }
                        else {
                            return _this.fnHandleErrorRawMode(error);
                        }
                    })];
            });
        });
    };
    /**
     * ถ้า getCustomStore แล้ว error กรณี loadMode = 'processed'
     * @param error
     */
    /**
     * ถ้า getCustomStore แล้ว error กรณี loadMode = 'processed'
     * @param {?} error
     * @return {?}
     */
    Request.prototype.fnHandleErrorProcessedMode = /**
     * ถ้า getCustomStore แล้ว error กรณี loadMode = 'processed'
     * @param {?} error
     * @return {?}
     */
    function (error) {
        // alert('ERROR ' + error);
        console.error('ERROR ' + error);
        return {
            data: [],
            totalCount: 0
        };
    };
    /**
     * ถ้า getCustomStore แล้ว error กรณี loadMode = 'raw'
     * @param error
     */
    /**
     * ถ้า getCustomStore แล้ว error กรณี loadMode = 'raw'
     * @param {?} error
     * @return {?}
     */
    Request.prototype.fnHandleErrorRawMode = /**
     * ถ้า getCustomStore แล้ว error กรณี loadMode = 'raw'
     * @param {?} error
     * @return {?}
     */
    function (error) {
        // alert('ERROR ' + error);
        console.error('ERROR ' + error);
        return [];
    };
    /**
     * fn. get data สำหรับดึงข้อมูลทั่วไป
     * @param url ex /test
     * @param data ค่าต่างที่ต้องการแนบไปกับ API
     */
    /**
     * fn. get data สำหรับดึงข้อมูลทั่วไป
     * @param {?} url ex /test
     * @param {?=} data ค่าต่างที่ต้องการแนบไปกับ API
     * @return {?}
     */
    Request.prototype.get = /**
     * fn. get data สำหรับดึงข้อมูลทั่วไป
     * @param {?} url ex /test
     * @param {?=} data ค่าต่างที่ต้องการแนบไปกับ API
     * @return {?}
     */
    function (url, data) {
        var _this = this;
        /** @type {?} */
        var params = new URLSearchParams();
        for (var key in data) {
            if (key === 'filter') {
                if (data[key] !== '{}') {
                    params.set(key, data[key]);
                }
            }
            else {
                params.set(key, data[key]);
            }
        }
        console.log('​Request -> getCustomStore -> params', params);
        /** @type {?} */
        var userData = this.b2bService.getVerifyToken();
        /** @type {?} */
        var headerData = {
            system_id: this.system_id,
            department: userData.phoneBookData && userData.phoneBookData.length > 0 ? userData.phoneBookData[0].dept : "",
            username: userData.username
        };
        /** @type {?} */
        var headers = new Headers();
        headers.append('x-Token', '1');
        headers.append('x-user-data', this.utoa(JSON.stringify(headerData)));
        headers.append('Authorization', 'Bearer eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJ1c2VybmFtZSI6IlRlc3QiLCJzZXNzaW9uSWQiOiJjNzQwNDdiZi1jNGUwLTQxOTMtOTRiNy1jOGI4M2ViYjhlMGMiLCJpYXQiOjE1NDM5NDYyNDYsImV4cCI6MTU0NDU1MTA0Nn0.5y9f2ZYieRZHhGIMTryxuvsAjJYzvFnWnpcYLk1hSXw');
        /** @type {?} */
        var options = new RequestOptions({ headers: headers, withCredentials: true });
        options.search = params;
        return this.http.get(this.api + url, options)
            .map(function (res) {
            /** @type {?} */
            var resData = res.json();
            return _this.fnHandleResponse(resData);
        })
            .catch(function (error) { return Observable$1.throw(error.json().error || 'Server error'); }).toPromise();
    };
    /**
     * fn. get data สำหรับดึงข้อมูลทั่วไป
     * @param url ex /test
     * @param data ค่าต่างที่ต้องการแนบไปกับ API
     */
    /**
     * fn. get data สำหรับดึงข้อมูลทั่วไป
     * @param {?} url ex /test
     * @param {?=} data ค่าต่างที่ต้องการแนบไปกับ API
     * @return {?}
     */
    Request.prototype.get31 = /**
     * fn. get data สำหรับดึงข้อมูลทั่วไป
     * @param {?} url ex /test
     * @param {?=} data ค่าต่างที่ต้องการแนบไปกับ API
     * @return {?}
     */
    function (url, data) {
        var _this = this;
        /** @type {?} */
        var params = new URLSearchParams();
        for (var key in data) {
            if (key === 'filter') {
                if (data[key] !== '{}') {
                    params.set(key, data[key]);
                }
            }
            else {
                params.set(key, data[key]);
            }
        }
        console.log('​Request -> getCustomStore -> params', params);
        /** @type {?} */
        var userData = this.b2bService.getVerifyToken();
        /** @type {?} */
        var headerData = {
            system_id: 31,
            department: userData.phoneBookData && userData.phoneBookData.length > 0 ? userData.phoneBookData[0].dept : "",
            username: userData.username
        };
        /** @type {?} */
        var headers = new Headers();
        headers.append('x-Token', '1');
        headers.append('x-user-data', this.utoa(JSON.stringify(headerData)));
        headers.append('Authorization', 'Bearer eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJ1c2VybmFtZSI6IlRlc3QiLCJzZXNzaW9uSWQiOiJjNzQwNDdiZi1jNGUwLTQxOTMtOTRiNy1jOGI4M2ViYjhlMGMiLCJpYXQiOjE1NDM5NDYyNDYsImV4cCI6MTU0NDU1MTA0Nn0.5y9f2ZYieRZHhGIMTryxuvsAjJYzvFnWnpcYLk1hSXw');
        /** @type {?} */
        var options = new RequestOptions({ headers: headers, withCredentials: true });
        options.search = params;
        return this.http.get(this.api + url, options)
            .map(function (res) {
            /** @type {?} */
            var resData = res.json();
            return _this.fnHandleResponse(resData);
        })
            .catch(function (error) { return Observable$1.throw(error.json().error || 'Server error'); }).toPromise();
    };
    /**
     * fn. get data สำหรับดึงข้อมูลทั่วไป
     * @param url ex /test
     * @param data ค่าต่างที่ต้องการแนบไปกับ API
     */
    /**
     * fn. get data สำหรับดึงข้อมูลทั่วไป
     * @param {?} url ex /test
     * @param {?=} headers
     * @return {?}
     */
    Request.prototype.getCustom = /**
     * fn. get data สำหรับดึงข้อมูลทั่วไป
     * @param {?} url ex /test
     * @param {?=} headers
     * @return {?}
     */
    function (url, headers) {
        var _this = this;
        if (!headers) {
            headers = new Headers();
        }
        /** @type {?} */
        var options = new RequestOptions({ headers: headers });
        return this.http.get(url, options)
            .map(function (res) {
            /** @type {?} */
            var resData = res.json();
            return _this.fnHandleResponse(resData);
        })
            .catch(function (error) { return Observable$1.throw(error.json().error || 'Server error'); }).toPromise();
    };
    /**
     * fn. get data สำหรับดึงข้อมูลทั่วไป
     * @param url ex /test
     * @param data ค่าต่างที่ต้องการแนบไปกับ API
     */
    /**
     * fn. get data สำหรับดึงข้อมูลทั่วไป
     * @param {?} url ex /test
     * @param {?=} headers
     * @return {?}
     */
    Request.prototype.getRawResponse = /**
     * fn. get data สำหรับดึงข้อมูลทั่วไป
     * @param {?} url ex /test
     * @param {?=} headers
     * @return {?}
     */
    function (url, headers) {
        if (!headers) {
            headers = new Headers();
        }
        /** @type {?} */
        var options = new RequestOptions({ headers: headers });
        return this.http.get(url, options)
            .map(function (res) {
            return res.json();
        })
            .catch(function (error) { return Observable$1.throw(error.json().error || 'Server error'); }).toPromise();
    };
    /**
     * fn. delete data สำหรับลบข้อมูลทั่วไป
     * @param url ex /test
     * @param data ค่าต่างที่ต้องการแนบไปกับ API
     */
    /**
     * fn. delete data สำหรับลบข้อมูลทั่วไป
     * @param {?} url ex /test
     * @param {?=} data ค่าต่างที่ต้องการแนบไปกับ API
     * @return {?}
     */
    Request.prototype.delete = /**
     * fn. delete data สำหรับลบข้อมูลทั่วไป
     * @param {?} url ex /test
     * @param {?=} data ค่าต่างที่ต้องการแนบไปกับ API
     * @return {?}
     */
    function (url, data) {
        /** @type {?} */
        var params = new URLSearchParams();
        for (var key in data) {
            if (key === 'filter') {
                if (data[key] !== '{}') {
                    params.set(key, data[key]);
                }
            }
            else {
                params.set(key, data[key]);
            }
        }
        console.log('​Request -> getCustomStore -> params', params);
        /** @type {?} */
        var userData = this.b2bService.getVerifyToken();
        /** @type {?} */
        var headerData = {
            system_id: this.system_id,
            department: userData.phoneBookData && userData.phoneBookData.length > 0 ? userData.phoneBookData[0].dept : "",
            username: userData.username
        };
        /** @type {?} */
        var headers = new Headers();
        headers.append('x-Token', '1');
        headers.append('x-user-data', this.utoa(JSON.stringify(headerData)));
        /** @type {?} */
        var options = new RequestOptions({ headers: headers, withCredentials: true });
        options.search = params;
        return this.http.delete(this.api + url, options)
            .map(function (res) {
            return res.json();
        })
            .catch(function (error) { return Observable$1.throw(error.json().error || 'Server error'); }).toPromise();
    };
    /**
     * fn. post data สำหรับสร้างข้อมูลทั่วไป
     * @param url ex /test
     * @param data ค่าต่างที่ต้องการแนบไปกับ API
     */
    /**
     * fn. post data สำหรับสร้างข้อมูลทั่วไป
     * @param {?} url ex /test
     * @param {?} data ค่าต่างที่ต้องการแนบไปกับ API
     * @return {?}
     */
    Request.prototype.post = /**
     * fn. post data สำหรับสร้างข้อมูลทั่วไป
     * @param {?} url ex /test
     * @param {?} data ค่าต่างที่ต้องการแนบไปกับ API
     * @return {?}
     */
    function (url, data) {
        data = JSON.parse(JSON.stringify(data, this.common.replacer));
        console.log('​post -> data', data);
        console.log('​post -> data', typeof data);
        /** @type {?} */
        var params = new URLSearchParams();
        /** @type {?} */
        var userData = this.b2bService.getVerifyToken();
        /** @type {?} */
        var headerData = {
            system_id: this.system_id,
            department: userData.phoneBookData && userData.phoneBookData.length > 0 ? userData.phoneBookData[0].dept : "",
            username: userData.username
        };
        /** @type {?} */
        var headers = new Headers();
        headers.append('x-Token', '1');
        headers.append('x-user-data', this.utoa(JSON.stringify(headerData)));
        headers.append('Content-Type', 'application/json');
        /** @type {?} */
        var options = new RequestOptions({ headers: headers, withCredentials: true });
        return this.http.post(this.api + url, data, options)
            .map(function (res) {
            return res.json();
        })
            .catch(function (error) { return Observable$1.throw(error.json().error || 'Server error'); }).toPromise();
    };
    /**
     * fn. post data สำหรับสร้างข้อมูลทั่วไป
     * @param url ex /test
     * @param data ค่าต่างที่ต้องการแนบไปกับ API
     */
    /**
     * fn. post data สำหรับสร้างข้อมูลทั่วไป
     * @param {?} url ex /test
     * @param {?} data ค่าต่างที่ต้องการแนบไปกับ API
     * @return {?}
     */
    Request.prototype.post31 = /**
     * fn. post data สำหรับสร้างข้อมูลทั่วไป
     * @param {?} url ex /test
     * @param {?} data ค่าต่างที่ต้องการแนบไปกับ API
     * @return {?}
     */
    function (url, data) {
        data = JSON.parse(JSON.stringify(data, this.common.replacer));
        console.log('​post -> data', data);
        console.log('​post -> data', typeof data);
        /** @type {?} */
        var params = new URLSearchParams();
        /** @type {?} */
        var userData = this.b2bService.getVerifyToken();
        /** @type {?} */
        var headerData = {
            system_id: 31,
            department: userData.phoneBookData && userData.phoneBookData.length > 0 ? userData.phoneBookData[0].dept : "",
            username: userData.username
        };
        /** @type {?} */
        var headers = new Headers();
        headers.append('x-Token', '1');
        headers.append('x-user-data', this.utoa(JSON.stringify(headerData)));
        headers.append('Content-Type', 'application/json');
        /** @type {?} */
        var options = new RequestOptions({ headers: headers, withCredentials: true });
        return this.http.post(this.api + url, data, options)
            .map(function (res) {
            return res.json();
        })
            .catch(function (error) { return Observable$1.throw(error.json().error || 'Server error'); }).toPromise();
    };
    /**
     * fn. post data สำหรับสร้างข้อมูลทั่วไป
     * @param url ex /test
     * @param data ค่าต่างที่ต้องการแนบไปกับ API
     */
    /**
     * fn. post data สำหรับสร้างข้อมูลทั่วไป
     * @param {?} url ex /test
     * @param {?} data ค่าต่างที่ต้องการแนบไปกับ API
     * @return {?}
     */
    Request.prototype.post14 = /**
     * fn. post data สำหรับสร้างข้อมูลทั่วไป
     * @param {?} url ex /test
     * @param {?} data ค่าต่างที่ต้องการแนบไปกับ API
     * @return {?}
     */
    function (url, data) {
        data = JSON.parse(JSON.stringify(data, this.common.replacernotrim));
        console.log('​post -> data', data);
        console.log('​post -> data', typeof data);
        /** @type {?} */
        var params = new URLSearchParams();
        /** @type {?} */
        var userData = this.b2bService.getVerifyToken();
        /** @type {?} */
        var headerData = {
            system_id: this.system_id,
            department: userData.phoneBookData && userData.phoneBookData.length > 0 ? userData.phoneBookData[0].dept : "",
            username: userData.username
        };
        /** @type {?} */
        var headers = new Headers();
        headers.append('x-Token', '1');
        headers.append('x-user-data', this.utoa(JSON.stringify(headerData)));
        headers.append('Content-Type', 'application/json');
        /** @type {?} */
        var options = new RequestOptions({ headers: headers, withCredentials: true });
        return this.http.post(this.api + url, data, options)
            .map(function (res) {
            return res.json();
        })
            .catch(function (error) { return Observable$1.throw(error.json().error || 'Server error'); }).toPromise();
    };
    /**
     * fn. post data สำหรับสร้างข้อมูลทั่วไป
     * @param url ex /test
     * @param data ค่าต่างที่ต้องการแนบไปกับ API
     */
    /**
     * fn. post data สำหรับสร้างข้อมูลทั่วไป
     * @param {?} url ex /test
     * @param {?} data ค่าต่างที่ต้องการแนบไปกับ API
     * @param {?=} headers
     * @return {?}
     */
    Request.prototype.postCustom = /**
     * fn. post data สำหรับสร้างข้อมูลทั่วไป
     * @param {?} url ex /test
     * @param {?} data ค่าต่างที่ต้องการแนบไปกับ API
     * @param {?=} headers
     * @return {?}
     */
    function (url, data, headers) {
        console.log('​post -> data', data);
        console.log('​post -> data', typeof data);
        if (!headers) {
            headers = new Headers();
            headers.append('Content-Type', 'application/json');
        }
        /** @type {?} */
        var options = new RequestOptions({ headers: headers, withCredentials: true });
        return this.http.post(url, data, options)
            .map(function (res) {
            return res.json();
        })
            .catch(function (error) { return Observable$1.throw(error.json().error || 'Server error'); }).toPromise();
    };
    /**
     * fn. put data สำหรับอัพเดตข้อมูลทั่วไป
     * @param url ex /test
     * @param data ค่าต่างที่ต้องการแนบไปกับ API
     */
    /**
     * fn. put data สำหรับอัพเดตข้อมูลทั่วไป
     * @param {?} url ex /test
     * @param {?} data ค่าต่างที่ต้องการแนบไปกับ API
     * @return {?}
     */
    Request.prototype.put = /**
     * fn. put data สำหรับอัพเดตข้อมูลทั่วไป
     * @param {?} url ex /test
     * @param {?} data ค่าต่างที่ต้องการแนบไปกับ API
     * @return {?}
     */
    function (url, data) {
        /** @type {?} */
        var params = new URLSearchParams();
        /** @type {?} */
        var userData = this.b2bService.getVerifyToken();
        /** @type {?} */
        var headerData = {
            system_id: this.system_id,
            department: userData.phoneBookData && userData.phoneBookData.length > 0 ? userData.phoneBookData[0].dept : "",
            username: userData.username
        };
        /** @type {?} */
        var headers = new Headers();
        headers.append('x-Token', '1');
        headers.append('x-user-data', this.utoa(JSON.stringify(headerData)));
        headers.append('Content-Type', 'application/json');
        /** @type {?} */
        var options = new RequestOptions({ headers: headers, withCredentials: true });
        return this.http.put(this.api + url, data, options)
            .map(function (res) {
            return res.json();
        })
            .catch(function (error) { return Observable$1.throw(error.json().error || 'Server error'); }).toPromise();
    };
    /**
     * ถ้า getCustomStore แล้ว success กรณี loadMode = 'processed'
     * @param resData
     */
    /**
     * ถ้า getCustomStore แล้ว success กรณี loadMode = 'processed'
     * @param {?} resData
     * @return {?}
     */
    Request.prototype.fnHandleResponseProcessedMode = /**
     * ถ้า getCustomStore แล้ว success กรณี loadMode = 'processed'
     * @param {?} resData
     * @return {?}
     */
    function (resData) {
        /** @type {?} */
        var customStoreData = {
            data: [],
            totalCount: 0
        };
        /** @type {?} */
        var code = '';
        /** @type {?} */
        var description = '';
        /** @type {?} */
        var data = [];
        /** @type {?} */
        var rowCount = 0;
        if (array(resData)) {
            data = resData;
            rowCount = size(data);
        }
        else {
            /** เปลี่ยนไปตามรูปแบบ response */
            code = resData.resultCode || '';
            description = resData.resultDescription || '';
            data = resData.resultData || [];
            rowCount = resData.rowCount || 0; // เปลี่ยนไปตาม Response
            /** */
        }
        if (code === ResultCode.ERROR) {
            console.log('​fnHandleResponseProcessedMode -> RESULT_CODE.ERROR', ResultCode.ERROR);
        }
        else if (code === ResultCode.NOT_FOUND) {
            console.log('​fnHandleResponseProcessedMode -> RESULT_CODE.NOT_FOUND', ResultCode.NOT_FOUND);
        }
        else {
            customStoreData.data = data;
            customStoreData.totalCount = rowCount;
        }
        return customStoreData;
    };
    /**
     * ถ้า getCustomStore แล้ว success กรณี loadMode = 'raw'
     * @param resData
     */
    /**
     * ถ้า getCustomStore แล้ว success กรณี loadMode = 'raw'
     * @param {?} resData
     * @return {?}
     */
    Request.prototype.fnHandleResponseRawMode = /**
     * ถ้า getCustomStore แล้ว success กรณี loadMode = 'raw'
     * @param {?} resData
     * @return {?}
     */
    function (resData) {
        /** @type {?} */
        var code = '';
        /** @type {?} */
        var description = '';
        /** @type {?} */
        var data = [];
        if (array(resData)) {
            data = resData;
        }
        else {
            /** เปลี่ยนไปตามรูปแบบ response */
            code = resData.resultCode || '';
            description = resData.resultDescription || '';
            data = resData.resultData || [];
            /** */
        }
        if (code === ResultCode.ERROR) {
            alert('ERROR:' + ResultCode.ERROR);
            return [];
        }
        else if (code === ResultCode.NOT_FOUND) {
            alert('ERROR:' + ResultCode.NOT_FOUND);
            return [];
        }
        else {
            return data;
        }
    };
    /**
     * @param {?} resData
     * @return {?}
     */
    Request.prototype.fnHandleResponse = /**
     * @param {?} resData
     * @return {?}
     */
    function (resData) {
        /** @type {?} */
        var code = '';
        /** @type {?} */
        var description = '';
        /** @type {?} */
        var data = [];
        if (array(resData)) {
            data = resData;
        }
        else if (resData.data && array(resData.data)) {
            data = resData.data;
        }
        else {
            /** เปลี่ยนไปตามรูปแบบ response */
            code = resData.resultCode || '';
            description = resData.resultDescription || '';
            data = resData.resultData || [];
            /** */
        }
        if (code === ResultCode.ERROR) {
            console.log('​fnHandleResponse -> RESULT_CODE.ERROR', ResultCode.ERROR);
            return [];
        }
        else if (code === ResultCode.NOT_FOUND) {
            console.log('​fnHandleResponse -> RESULT_CODE.NOT_FOUND', ResultCode.NOT_FOUND);
            return [];
        }
        else {
            return data;
        }
    };
    /**
     * fn ดึงข้อมูลเพื่อใช้ใน Dropdown List
     * @param systemId เลขรหัสระบบที่ต้องการดึง
     * @param dropDownType ประเภทข้อมูล dropdown ที่ต้องการดึง
     */
    /**
     * fn ดึงข้อมูลเพื่อใช้ใน Dropdown List
     * @param {?} systemId เลขรหัสระบบที่ต้องการดึง
     * @param {?} dropDownType ประเภทข้อมูล dropdown ที่ต้องการดึง
     * @param {?=} code
     * @return {?}
     */
    Request.prototype.getDropDown = /**
     * fn ดึงข้อมูลเพื่อใช้ใน Dropdown List
     * @param {?} systemId เลขรหัสระบบที่ต้องการดึง
     * @param {?} dropDownType ประเภทข้อมูล dropdown ที่ต้องการดึง
     * @param {?=} code
     * @return {?}
     */
    function (systemId, dropDownType, code) {
        return __awaiter(this, void 0, void 0, function () {
            var data, urlDropdown, resData, resData, error_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 5, , 6]);
                        data = {
                            filter: {
                                system_id: systemId,
                                dropdown_type: dropDownType,
                                code: code
                            },
                            limit: 1000,
                            offset: 0,
                            order_by: ['id asc']
                        };
                        urlDropdown = get(this.config, 'apiServers.tomcat.api.ct_dropdown_search');
                        if (!(systemId === 31)) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.post31(urlDropdown, data)];
                    case 1:
                        resData = _a.sent();
                        return [2 /*return*/, resData.resultData];
                    case 2: return [4 /*yield*/, this.post(urlDropdown, data)];
                    case 3:
                        resData = _a.sent();
                        return [2 /*return*/, resData.resultData];
                    case 4: return [3 /*break*/, 6];
                    case 5:
                        error_1 = _a.sent();
                        console.log('catch -> error', error_1);
                        return [2 /*return*/, []];
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @param {?=} parentId
     * @return {?}
     */
    Request.prototype.getDepartment = /**
     * @param {?=} parentId
     * @return {?}
     */
    function (parentId) {
        if (parentId === void 0) { parentId = 0; }
        return __awaiter(this, void 0, void 0, function () {
            var data, urlDropdown, resData, error_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        data = {
                            filter: { ref_department_id: parentId },
                            limit: 1000,
                            offset: 0,
                            order_by: ['name asc']
                        };
                        urlDropdown = get(this.config, 'apiServers.tomcat.api.ct_department_search');
                        return [4 /*yield*/, this.post(urlDropdown, data)];
                    case 1:
                        resData = _a.sent();
                        return [2 /*return*/, resData.resultData];
                    case 2:
                        error_2 = _a.sent();
                        console.log('catch -> error', error_2);
                        return [2 /*return*/, []];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @return {?}
     */
    Request.prototype.getExtDepartment = /**
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            var data, urlDropdown, resData, error_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        data = {
                            filter: {},
                            limit: 1000,
                            offset: 0,
                            order_by: ['name asc']
                        };
                        urlDropdown = get(this.config, 'apiServers.tomcat.api.ct_ext_department_search');
                        return [4 /*yield*/, this.post(urlDropdown, data)];
                    case 1:
                        resData = _a.sent();
                        return [2 /*return*/, resData.resultData];
                    case 2:
                        error_3 = _a.sent();
                        console.log('catch -> error', error_3);
                        return [2 /*return*/, []];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @param {?} system_id
     * @return {?}
     */
    Request.prototype.getCategory = /**
     * @param {?} system_id
     * @return {?}
     */
    function (system_id) {
        return __awaiter(this, void 0, void 0, function () {
            var urlStep, params, resData, error_4;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        urlStep = get(this.config, 'apiServers.tomcat.api.ct_category');
                        params = "?_where=(system_id,eq," + system_id + ")&_sort=seq_no";
                        return [4 /*yield*/, this.get(urlStep + params)];
                    case 1:
                        resData = _a.sent();
                        return [2 /*return*/, resData];
                    case 2:
                        error_4 = _a.sent();
                        console.log('catch -> error', error_4);
                        return [2 /*return*/, []];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @param {?} category_id
     * @return {?}
     */
    Request.prototype.getStepName = /**
     * @param {?} category_id
     * @return {?}
     */
    function (category_id) {
        return __awaiter(this, void 0, void 0, function () {
            var urlStep, params, resData, error_5;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        urlStep = get(this.config, 'apiServers.tomcat.api.ct_step');
                        params = "?_where=(category_id,eq," + category_id + ")&_sort=seq_no";
                        return [4 /*yield*/, this.get(urlStep + params)];
                    case 1:
                        resData = _a.sent();
                        return [2 /*return*/, resData];
                    case 2:
                        error_5 = _a.sent();
                        console.log('catch -> error', error_5);
                        return [2 /*return*/, []];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @param {?} url
     * @return {?}
     */
    Request.prototype.getAttachment = /**
     * @param {?} url
     * @return {?}
     */
    function (url) {
        return __awaiter(this, void 0, void 0, function () {
            var headers, resData, error_6;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        headers = new Headers();
                        headers.append('Authorization', 'Basic ' + btoa('APPSOC:123456'));
                        return [4 /*yield*/, this.getCustom(url, headers)];
                    case 1:
                        resData = _a.sent();
                        return [2 /*return*/, resData];
                    case 2:
                        error_6 = _a.sent();
                        console.log('catch -> error', error_6);
                        return [2 /*return*/, error_6];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @param {?} url
     * @param {?} data
     * @return {?}
     */
    Request.prototype.postAttachment = /**
     * @param {?} url
     * @param {?} data
     * @return {?}
     */
    function (url, data) {
        return __awaiter(this, void 0, void 0, function () {
            var headers, resData, error_7;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        headers = new Headers();
                        headers.append('Authorization', 'Basic ' + btoa('APPSOC:123456'));
                        headers.append('test', 'test');
                        return [4 /*yield*/, this.postCustom(url, data, headers)];
                    case 1:
                        resData = _a.sent();
                        return [2 /*return*/, resData];
                    case 2:
                        error_7 = _a.sent();
                        console.log('catch -> error', error_7);
                        return [2 /*return*/, error_7];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @return {?}
     */
    Request.prototype.getUserLevel = /**
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            var data, urlDropdown, resData, error_8;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        data = {
                            filter: {},
                            limit: 1000,
                            offset: 0,
                            order_by: ['level asc']
                        };
                        urlDropdown = get(this.config, 'apiServers.tomcat.api.ct_user_level_search');
                        return [4 /*yield*/, this.post(urlDropdown, data)];
                    case 1:
                        resData = _a.sent();
                        return [2 /*return*/, resData];
                    case 2:
                        error_8 = _a.sent();
                        console.log('catch -> error', error_8);
                        return [2 /*return*/, []];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @param {?} table
     * @param {?} idList
     * @return {?}
     */
    Request.prototype.multipleDeleteMain = /**
     * @param {?} table
     * @param {?} idList
     * @return {?}
     */
    function (table, idList) {
        return __awaiter(this, void 0, void 0, function () {
            var e_1, _a, url, deleteObj, idList_1, idList_1_1, id, tmp, resData, error_9;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _b.trys.push([0, 2, , 3]);
                        url = "/" + table.split("_")[0] + "/main";
                        deleteObj = {};
                        deleteObj[table] = [];
                        try {
                            for (idList_1 = __values(idList), idList_1_1 = idList_1.next(); !idList_1_1.done; idList_1_1 = idList_1.next()) {
                                id = idList_1_1.value;
                                tmp = {
                                    id: id,
                                    action: "delete"
                                };
                                deleteObj[table].push(tmp);
                            }
                        }
                        catch (e_1_1) { e_1 = { error: e_1_1 }; }
                        finally {
                            try {
                                if (idList_1_1 && !idList_1_1.done && (_a = idList_1.return)) _a.call(idList_1);
                            }
                            finally { if (e_1) throw e_1.error; }
                        }
                        return [4 /*yield*/, this.post(url, [deleteObj])];
                    case 1:
                        resData = _b.sent();
                        if (resData.resultCode === 20000) {
                            idList = [];
                        }
                        return [2 /*return*/, resData];
                    case 2:
                        error_9 = _b.sent();
                        console.log('catch -> error', error_9);
                        return [2 /*return*/, []];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @param {?} url
     * @return {?}
     */
    Request.prototype.getAttachmentLinkToken = /**
     * @param {?} url
     * @return {?}
     */
    function (url) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, url + '?downloadToken=' + this.b2bService.getAttachmentToken() + '&inline=true'];
            });
        });
    };
    /**
     * @param {?} data
     * @param {?} fieldList
     * @param {?} modal
     * @return {?}
     */
    Request.prototype.checkSpell = /**
     * @param {?} data
     * @param {?} fieldList
     * @param {?} modal
     * @return {?}
     */
    function (data, fieldList, modal) {
        return __awaiter(this, void 0, void 0, function () {
            var e_2, _a, url, body, fieldList_1, fieldList_1_1, field, resData, spellCheck;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        url = "/spellCheck";
                        body = {};
                        try {
                            for (fieldList_1 = __values(fieldList), fieldList_1_1 = fieldList_1.next(); !fieldList_1_1.done; fieldList_1_1 = fieldList_1.next()) {
                                field = fieldList_1_1.value;
                                if (data[field.field]) {
                                    body[field.field] = {
                                        value: data[field.field],
                                        display: field.display
                                    };
                                }
                            }
                        }
                        catch (e_2_1) { e_2 = { error: e_2_1 }; }
                        finally {
                            try {
                                if (fieldList_1_1 && !fieldList_1_1.done && (_a = fieldList_1.return)) _a.call(fieldList_1);
                            }
                            finally { if (e_2) throw e_2.error; }
                        }
                        return [4 /*yield*/, this.post(url, body)];
                    case 1:
                        resData = _b.sent();
                        spellCheck = JSON.parse(resData.resultData);
                        if (size(spellCheck) === 0) {
                            return [2 /*return*/, true];
                        }
                        else {
                            modal.open(spellCheck);
                            return [2 /*return*/, false];
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @param {?} url
     * @param {?=} headers
     * @return {?}
     */
    Request.prototype.getQualification = /**
     * @param {?} url
     * @param {?=} headers
     * @return {?}
     */
    function (url, headers) {
        return __awaiter(this, void 0, void 0, function () {
            var options;
            return __generator(this, function (_a) {
                if (!headers) {
                    headers = new Headers();
                }
                options = new RequestOptions({ headers: headers, withCredentials: true });
                return [2 /*return*/, this.http.get(url, options)
                        .map(function (res) {
                        return res.json();
                    })
                        .catch(function (error) { return Observable$1.throw(error.json().error || 'Server error'); }).toPromise()];
            });
        });
    };
    /**
     * @return {?}
     */
    Request.prototype.verifyUserName = /**
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            var verifyToken, data, phoneBookData;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.b2bService.verify()];
                    case 1:
                        verifyToken = _a.sent();
                        if (+verifyToken.resultCode === 20000) {
                            data = verifyToken.resultData;
                            phoneBookData = data.phoneBookData && data.phoneBookData.length > 0 ? data.phoneBookData[0] : {};
                            return [2 /*return*/, phoneBookData.name];
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @param {?} str
     * @return {?}
     */
    Request.prototype.utoa = /**
     * @param {?} str
     * @return {?}
     */
    function (str) {
        return window.btoa(unescape(encodeURIComponent(str)));
    };
    /**
     * @param {?} api
     * @return {?}
     */
    Request.prototype.downloadImgToBase64 = /**
     * @param {?} api
     * @return {?}
     */
    function (api) {
        var _this = this;
        return new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
            var httpOptions, blob, reader_1, err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        httpOptions = {
                            headers: new HttpHeaders({ "Authorization": "Basic " + btoa('APPSOC:123456') })
                        };
                        return [4 /*yield*/, this.httpClient.get(api, { headers: httpOptions.headers, responseType: "blob" }).toPromise()];
                    case 1:
                        blob = _a.sent();
                        reader_1 = new FileReader();
                        reader_1.readAsDataURL(blob);
                        reader_1.onloadend = function () {
                            /** @type {?} */
                            var base64data = reader_1.result;
                            resolve(base64data);
                        };
                        return [3 /*break*/, 3];
                    case 2:
                        err_1 = _a.sent();
                        console.log(err_1);
                        resolve(false);
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/];
                }
            });
        }); });
    };
    /**
     * @param {?} api
     * @return {?}
     */
    Request.prototype.downloadView = /**
     * @param {?} api
     * @return {?}
     */
    function (api) {
        return __awaiter(this, void 0, void 0, function () {
            var httpOptions, blob, url, err_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        httpOptions = {
                            headers: new HttpHeaders({ "Authorization": "Basic " + btoa('APPSOC:123456') })
                        };
                        return [4 /*yield*/, this.httpClient.get(api, { headers: httpOptions.headers, responseType: "blob" }).toPromise()];
                    case 1:
                        blob = _a.sent();
                        url = window.URL.createObjectURL(blob, { oneTimeOnly: true });
                        window.open(url, '_blank');
                        return [3 /*break*/, 3];
                    case 2:
                        err_2 = _a.sent();
                        console.log(err_2);
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @param {?} api
     * @return {?}
     */
    Request.prototype.download = /**
     * @param {?} api
     * @return {?}
     */
    function (api) {
        return __awaiter(this, void 0, void 0, function () {
            var w, httpOptions, blob, url, err_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        w = window.open();
                        w.document.writeln("");
                        httpOptions = {
                            headers: new HttpHeaders({ "Authorization": "Basic " + btoa('APPSOC:123456') })
                        };
                        return [4 /*yield*/, this.httpClient.get(api, { headers: httpOptions.headers, responseType: "blob" }).toPromise()];
                    case 1:
                        blob = _a.sent();
                        url = window.URL.createObjectURL(blob);
                        w.location.href = url;
                        return [3 /*break*/, 3];
                    case 2:
                        err_3 = _a.sent();
                        console.log(err_3);
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    Request.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    Request.ctorParameters = function () { return [
        { type: AppConfigService },
        { type: HttpClient },
        { type: Http },
        { type: Router },
        { type: Common },
        { type: B2bService }
    ]; };
    return Request;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var UploadAttachmentComponent = /** @class */ (function () {
    function UploadAttachmentComponent(appConfigService, request, common, http, _http) {
        var _this = this;
        this.appConfigService = appConfigService;
        this.request = request;
        this.common = common;
        this.http = http;
        this._http = _http;
        this.upLoadType = [
            { title: "File", type: 1 },
            // {title:"Scan",type:2},
            { title: "Link", type: 3 },
            { title: "QR Code", type: 4 }
        ];
        this.systemId = '0';
        this.RelatedAgency = 'SOC';
        this.RecordId = '0';
        this.Subject = '-';
        this.TypeId = '0';
        this.onlyImage = false;
        this.uploaded = new EventEmitter();
        // @ViewChild('myModal') myModal;
        this.fileList = [];
        this.fileNameLink = '';
        this.fileNameLinkError = '';
        this.QrCodeFileName = '';
        this.fileNameQr = '';
        this.fileNameLinkQr = '';
        this.fileNameQrError = '';
        this.filter = {};
        this.uploadHeaders = {
            "Authorization": "Basic " + btoa("APPSOC:123456")
        };
        this.isLoading = false;
        this.isDisabled = false;
        this.createAuthorizationHeader = function (headers) {
        };
        this.beforeUpload = function (file, _fileList) {
            return new Observable$1(function (observer) {
                /** @type {?} */
                var whitelist = [
                    'application/pdf',
                    'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet',
                    'application/vnd.ms-excel',
                    'application/vnd.msexcel',
                    'application/csv',
                    'text/csv',
                    'application/msword',
                    'application/vnd.openxmlformats-officedocument.wordprocessingml.document',
                    'application/vnd.ms-powerpoint',
                    'application/vnd.openxmlformats-officedocument.presentationml.slideshow',
                    'application/vnd.openxmlformats-officedocument.presentationml.presentation',
                    'text/plain',
                    'text/comma-separated-values',
                    'text/anytext',
                    'image/png',
                    'image/jpeg',
                    'image/gif',
                    'image/bmp'
                ];
                /** @type {?} */
                var isWhitelist = (file && whitelist.indexOf(file.type) > -1);
                if (!isWhitelist) {
                    setTimeout(function () {
                        _this.fileList = [{
                                uid: '999',
                                name: 'สามารถอัพโหลดได้เฉพาะไฟล์  pdf , png  , jpeg  ,gif , text , word , excel , powerpoint',
                                status: 'error',
                                response: 'สามารถอัพโหลดได้เฉพาะไฟล์  pdf , png  , jpeg  ,gif , text , word , excel , powerpoint',
                                url: null
                            }];
                    }, 50);
                    observer.complete();
                    return;
                }
                /** @type {?} */
                var isLt30M = /** @type {?} */ ((file.size)) / 1024 / 1024 < 30;
                if (!isLt30M) {
                    _this.fileList = [{
                            uid: '999',
                            name: 'File must smaller than 30MB!',
                            status: 'error',
                            response: 'File must smaller than 30MB!',
                            url: null
                        }];
                    observer.complete();
                    return;
                }
                observer.next(isWhitelist && isLt30M);
                observer.complete();
            });
        };
        this.customReq = function (item) {
            /** @type {?} */
            var formData = new FormData();
            // tslint:disable-next-line:no-any
            formData.append('FileData', /** @type {?} */ (item.file));
            formData.append('SystemId', '' + _this.systemId);
            formData.append('RelatedAgency', _this.RelatedAgency);
            formData.append('RecordId', _this.RecordId);
            formData.append('Subject', _this.Subject);
            formData.append('TypeId', _this.TypeId);
            /** @type {?} */
            var headers = new HttpHeaders();
            headers = headers.set('Authorization', 'Basic ' + btoa('APPSOC:123456'));
            /** @type {?} */
            var req = new HttpRequest('POST', item.action, formData, {
                reportProgress: true,
                headers: headers
            });
            // req.headers.set('Authorization', 'Basic ' + btoa('APPSOC:123456'));
            return _this.http.request(req).subscribe(function (event) {
                if (event.type === HttpEventType.UploadProgress) {
                    if (event.total > 0) {
                        (/** @type {?} */ (event)).percent = event.loaded / event.total * 100;
                    }
                    // console.log("onProgress", event , this.fileList);
                    item.onProgress(event, item.file);
                }
                else if (event instanceof HttpResponse) {
                    // console.log("event.body", event.body , this.fileList);
                    if (_this.fileList && _this.fileList.length > 1) {
                        _this.fileList = [_this.fileList[_this.fileList.length - 1]];
                    }
                    // let res = JSON.parse(event.body);
                    // this.isDisabled = true;
                    // let res = JSON.parse(event.body);
                    // this.isDisabled = true;
                    _this.isDisabled = false;
                    _this.uploaded.emit(event.body);
                    item.onSuccess(event.body, item.file, event);
                }
            }, function (err) {
                console.log(err);
                item.onError(err, item.file);
            });
        };
        this.config = appConfigService.getConfig();
        this.url = get(this.config, 'apiServers.alfresco.url') || "https://portal-uat.soc.go.th/api/mfec/Alfresco";
        this.uploadUrl = get(this.config, 'apiServers.alfresco.uploadUrl') || 'https://portal-uat.soc.go.th/microservice-api/gen-processed-file/upload-link-server';
        // || "http://127.0.0.1:5500/microservice-api/gen-processed-file/upload-link-server";
    }
    /**
     * @return {?}
     */
    UploadAttachmentComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        console.log('form', this.form);
        this.qr = new QrCode();
        this.qr.callback = function (err, result) {
            console.log('callback');
            _this.fileNameQrError = '';
            /** @type {?} */
            var span = document.querySelector('span') || document.createElement('span');
            if (result) {
                console.log(result.result);
                if (result.result) {
                    _this.fileNameLinkQr = result.result;
                    _this.uploadLinkQr();
                }
                // span.textContent = 'view console';
            }
            else {
                // span.textContent = 'Error! See error message in console!';
                console.error(err);
                _this.fileNameQrError = _this.QrCodeFileName;
                _this.QrCodeFileName = '';
            }
            // preview.appendChild(span);
        };
    };
    /**
     * @return {?}
     */
    UploadAttachmentComponent.prototype.uploadLinkQr = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.isLoading = true;
        this.fileNameQrError = '';
        this._http.post(this.uploadUrl, {
            SystemId: '' + this.systemId,
            RelatedAgency: this.RelatedAgency,
            RecordId: this.RecordId,
            Subject: this.Subject,
            TypeId: this.TypeId,
            link: this.fileNameLinkQr
        }).map(function (res) {
            return res.json();
        })
            .toPromise().then(function (res) {
            console.log(res);
            _this.isLoading = false;
            if (res.resultCode === 20000 && res.data && res.data.file) {
                _this.fileNameLinkQr = '';
                // this.isDisabled = true;
                // this.isDisabled = true;
                _this.isDisabled = false;
                console.log('res.data', res.data.file);
                _this.fileNameQr = res.data.file.fileName;
                _this.uploaded.emit(res.data.file);
                _this.fileNameLink = '';
                _this.fileNameLinkError = '';
            }
            else {
                _this.fileNameQrError = _this.fileNameLinkQr;
            }
        }).catch(function (err) {
            _this.uploaded.emit({});
            _this.isLoading = false;
            _this.fileNameQrError = _this.fileNameLinkQr;
            console.log(err);
        });
    };
    /**
     * @return {?}
     */
    UploadAttachmentComponent.prototype.btnUpload = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.isLoading = true;
        this.fileNameLinkError = '';
        this._http.post(this.uploadUrl, {
            SystemId: '' + this.systemId,
            RelatedAgency: this.RelatedAgency,
            RecordId: this.RecordId,
            Subject: this.Subject,
            TypeId: this.TypeId,
            link: this.filter.link
        }).map(function (res) {
            return res.json();
        })
            .toPromise().then(function (res) {
            console.log(res);
            _this.isLoading = false;
            if (res.resultCode === 20000 && res.data && res.data.file) {
                _this.filter = {};
                // this.isDisabled = true;
                // this.isDisabled = true;
                _this.isDisabled = false;
                console.log('res.data', res.data.file);
                _this.fileNameLink = res.data.file.fileName;
                _this.uploaded.emit(res.data.file);
                _this.QrCodeFileName = '';
                _this.fileNameQr = '';
                _this.fileNameLinkQr = '';
                _this.fileNameQrError = '';
            }
            else {
                _this.fileNameLinkError = _this.filter.link;
            }
        }).catch(function (err) {
            _this.uploaded.emit({});
            _this.isLoading = false;
            _this.fileNameLinkError = _this.filter.link;
            console.log(err);
        });
    };
    /**
     * @return {?}
     */
    UploadAttachmentComponent.prototype.onQrCodeChange = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var fullPath = document.getElementById('file-upload')['value'];
        if (fullPath) {
            /** @type {?} */
            var startIndex = (fullPath.indexOf('\\') >= 0 ? fullPath.lastIndexOf('\\') : fullPath.lastIndexOf('/'));
            /** @type {?} */
            var filename = fullPath.substring(startIndex);
            if (filename.indexOf('\\') === 0 || filename.indexOf('/') === 0) {
                filename = filename.substring(1);
            }
            this.QrCodeFileName = filename;
        }
        else {
            this.QrCodeFileName = '';
        }
        this.fileNameLinkQr = '';
        /** @type {?} */
        var upload = document.getElementById('file-upload');
        /** @type {?} */
        var preview = document.getElementById('preview');
        /** @type {?} */
        var files_ = document.getElementById('file-upload')['files'];
        // console.log('files_',files_)
        if (files_) {
            var _loop_1 = function () {
                file = files_[i];
                imageType = /^image\//;
                if (!imageType.test(file.type)) {
                    this_1.QrCodeFileName = '';
                    this_1.fileNameQrError = 'File type not valid';
                    console.log('File type not valid');
                }
                else {
                    // Read file
                    reader = new FileReader();
                    /** @type {?} */
                    var self_1 = this_1;
                    reader.addEventListener('load', function () {
                        /** @type {?} */
                        var img = document.querySelector('img') || document.createElement('img');
                        img.src = this.result;
                        // preview.appendChild(img);
                        // Analyse code
                        // preview.appendChild(img);
                        // Analyse code
                        self_1.qr.decode(this.result);
                    }.bind(reader), false);
                    reader.readAsDataURL(file);
                }
            };
            var this_1 = this, file, imageType, reader;
            for (var i = 0; i < files_.length; i++) {
                _loop_1();
            }
        }
        // console.log("onQrCodeChange",jsqrcode)
    };
    /**
     * @param {?} file
     * @return {?}
     */
    UploadAttachmentComponent.prototype.onUploaded = /**
     * @param {?} file
     * @return {?}
     */
    function (file) {
        console.log("file", file);
        /** @type {?} */
        var res = JSON.parse(file.request.response);
        this.uploaded.emit(res);
    };
    /**
     * @param {?} e
     * @return {?}
     */
    UploadAttachmentComponent.prototype.onSelected = /**
     * @param {?} e
     * @return {?}
     */
    function (e) {
        console.log("e", e);
        console.log('form', this.form);
        this.form.ngSubmit.emit();
    };
    /**
     * @param {?} data
     * @return {?}
     */
    UploadAttachmentComponent.prototype.onChange = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        data.fileList = [data.file];
        // console.log("onChange",data);
        if (data.fileList === 0) {
            this.isDisabled = false;
        }
    };
    /**
     * @return {?}
     */
    UploadAttachmentComponent.prototype.clearValue = /**
     * @return {?}
     */
    function () {
        this.isDisabled = false;
        console.log("clearValue");
        this.fileList = [];
        this.fileNameLink = '';
        this.fileNameLinkError = '';
        this.QrCodeFileName = '';
        this.fileNameQr = '';
        this.fileNameLinkQr = '';
        this.fileNameQrError = '';
    };
    UploadAttachmentComponent.decorators = [
        { type: Component, args: [{
                    selector: 'upload-attachment',
                    template: "<!--<p-tabView>-->\n    <!--<p-tabPanel header=\"File\">-->\n        <!--<dx-file-uploader selectButtonText=\"\u0E40\u0E25\u0E37\u0E2D\u0E01\u0E44\u0E1F\u0E25\u0E4C\" labelText=\"\" accept=\"*\" uploadMode=\"useForm\" uploadMethod=\"POST\"-->\n                          <!--multiple=\"true\" uploadMode=\"instantly\" labelText=\"\u0E2B\u0E23\u0E37\u0E2D\u0E27\u0E32\u0E07\u0E44\u0E1F\u0E25\u0E4C\u0E17\u0E35\u0E48\u0E19\u0E35\u0E48\" uploadUrl=\"https://filemanager-dot-smartrms-api.appspot.com/api/http/upload\"-->\n        <!--&gt;-->\n        <!--</dx-file-uploader>-->\n    <!--</p-tabPanel>-->\n    <!--<p-tabPanel header=\"Link\">-->\n        <!--Content 2-->\n    <!--</p-tabPanel>-->\n    <!--<p-tabPanel header=\"QR Code\">-->\n        <!--Content 3-->\n    <!--</p-tabPanel>-->\n<!--</p-tabView>-->\n<!-- [disabled]=\"isDisabled\" -->\n<dx-tab-panel\n        #tabPanel\n        [items]=\"upLoadType\"\n        [selectedIndex]=\"0\"\n        [loop]=\"false\"\n        [animationEnabled]=\"false\"\n        [swipeEnabled]=\"false\"\n        itemTemplate=\"itemTemplate\"\n>\n    <!--<div *dxTemplate=\"let type of upLoadType\">-->\n        <!--<span>{{type.name.toUpperCase()}}</span>-->\n    <!--</div>-->\n    <div *dxTemplate=\"let item of 'itemTemplate'\">\n        <div class=\"tabpanel-item\">\n            <div *ngIf=\"item.type === 1\">\n                <div class=\"col-sm-12\" style=\"text-align: center\">\n                    <br>\n                    <!--<form #f=\"ngForm\" action=\"https://203.154.32.126:2585/api/mfec/Alfresco\" method=\"post\" enctype=\"multipart/form-data\">-->\n                        <!--<input type=\"hidden\" name=\"SystemId\" [value]=\"11\">-->\n                        <!--<input type=\"hidden\" name=\"RelatedAgency\" [value]=\"11\">-->\n                        <!--<input type=\"hidden\" name=\"RecordId\" [value]=\"11\">-->\n                        <!--<input type=\"hidden\" name=\"Subject\" [value]=\"11\">-->\n                        <!--<input type=\"hidden\" name=\"TypeId\" [value]=\"11\">-->\n                        <!--<dx-file-uploader [uploadHeaders]=\"uploadHeaders\" selectButtonText=\"\u0E40\u0E25\u0E37\u0E2D\u0E01\u0E44\u0E1F\u0E25\u0E4C\" labelText=\"\" accept=\"*\" uploadMode=\"useForm\" (onValueChanged)=\"onSelected($event)\"-->\n                                          <!--labelText=\"\u0E2B\u0E23\u0E37\u0E2D\u0E27\u0E32\u0E07\u0E44\u0E1F\u0E25\u0E4C\u0E17\u0E35\u0E48\u0E19\u0E35\u0E48\">-->\n                        <!--</dx-file-uploader>-->\n                        <!--<input type=\"submit\">-->\n                    <!--</form>-->\n                    <nz-upload *ngIf=\"!onlyImage\" nzType=\"drag\"\n                        [nzAction]=\"url\"\n                        [nzCustomRequest]=\"customReq\"\n                        [nzMultiple]=\"false\"\n                        [(nzFileList)]=\"fileList\"\n                        (nzChange)=\"onChange($event)\"\n                        [nzShowButton]=\"fileList.length === 0\"\n                        [nzBeforeUpload]=\"beforeUpload\">\n                    <!--<nz-upload nzType=\"drag\"-->\n                               <!--nzAction=\"https://203.154.32.126:2585/api/mfec/Alfresco\"-->\n                               <!--&gt;-->\n                        <a nz-button>\n                            <i nz-icon type=\"upload\"></i><span>Click to Upload</span>\n                        </a>\n                    </nz-upload>\n                    <nz-upload *ngIf=\"onlyImage\" nzType=\"drag\"\n                           [nzAction]=\"url\"\n                           [nzCustomRequest]=\"customReq\"\n                           [nzMultiple]=\"false\"\n                           nzFileType=\"image/png,image/jpeg,image/gif,image/bmp\"\n                           [(nzFileList)]=\"fileList\"\n                           (nzChange)=\"onChange($event)\"\n                           [nzBeforeUpload]=\"beforeUpload\">\n                        <!--<nz-upload nzType=\"drag\"-->\n                        <!--nzAction=\"https://203.154.32.126:2585/api/mfec/Alfresco\"-->\n                        <!--&gt;-->\n                        <a nz-button>\n                            <i nz-icon type=\"upload\"></i><span>Click to Upload</span>\n                        </a>\n                    </nz-upload>\n                    <br>\n                </div>\n            </div>\n            <div *ngIf=\"item.type === 2\">\n                <div class=\"col-sm-10\" style=\"text-align: center\">\n                    <br>\n                    <br>\n                </div>\n            </div>\n            <div *ngIf=\"item.type === 3\">\n                <div class=\"col-sm-12\" style=\"text-align: center\">\n                  <div class=\"row\" *ngIf=\"!uploadUrl\" >\n                    <br>\n                    <br>\n                  </div>\n                    <div class=\"row\" *ngIf=\"uploadUrl\" style=\"height: 100px;\">\n                      <div class=\"col-sm-12\" style=\"padding: 50px;\">\n                        <div class=\"input-group\">\n                        <input type=\"text\" class=\"form-control m-input\" placeholder=\"\" [(ngModel)]=\"filter.link\">\n                        <span class=\"input-group-btn add-bt\">\n                          <button type=\"button\" class=\"btn btn-success btn-md\"  (click)=\"btnUpload()\" style=\"margin: 0px 0px;\" [disabled]=\"isLoading\">\n                              Upload\n                          </button>\n                        </span>\n                      </div>\n\n                      <div class=\"ant-upload-list-item ant-upload-list-item-done\" *ngIf=\"fileNameLink\">\n                      <div class=\"ant-upload-list-item-info\">\n                          <i nz-icon=\"\" class=\"anticon ng-tns-c8-0 anticon-paper-clip\" style=\"position: absolute;left: 0px;\"></i>\n                          <span class=\"ant-upload-list-item-name ng-tns-c8-0 \" >{{fileNameLink}}</span>\n                          <!-- <i  type=\"close\" class=\"anticon ng-tns-c8-0 anticon-close ng-star-inserted\" ></i> -->\n                        </div>\n                      </div>\n                      <div class=\"ant-upload-list-item ant-upload-list-item-done ant-upload-list-item-error\" *ngIf=\"fileNameLinkError\">\n                      <div class=\"ant-upload-list-item-info\">\n                          <i nz-icon=\"\" class=\"anticon ng-tns-c8-0 anticon-paper-clip\" style=\"position: absolute;left: 0px;\"></i>\n                          <span class=\"ant-upload-list-item-name ng-tns-c8-0 \" >{{fileNameLinkError}}</span>\n                          <i  type=\"close\" class=\"anticon ng-tns-c8-0 anticon-close\" (click)=\"fileNameLinkError = ''\" ></i>\n                        </div>\n                      </div>\n\n\n                  </div>\n                  </div>\n                </div>\n            </div>\n            <div *ngIf=\"item.type === 4\">\n              <div class=\"col-sm-12\" style=\"text-align: center\">\n                <div class=\"row\" *ngIf=\"!uploadUrl\" >\n                  <br>\n                  <br>\n                </div>\n\n                  <div class=\"row\" *ngIf=\"uploadUrl\" style=\"height: 100px;\">\n                    <div class=\"col-sm-12\" style=\"padding: 50px;\">\n                      <div id=\"preview\"></div>\n                      <div class=\"input-group\">\n                            <label for=\"file-upload\" class=\"custom-file-upload\"\n                            style=\"background-color: #2b3a4a !important;display: inline-block;color: #f5f9e2 !important;padding: 7px 14px;cursor: pointer;\">\n                                 Upload\n                            </label>\n                            <!-- -->\n                            <span style=\"padding: 10px;\"> <i  *ngIf=\"isLoading\" class=\"fa fa-spinner fa-spin\" aria-hidden=\"true\" ></i> {{QrCodeFileName}}</span>\n                            <input id=\"file-upload\" type=\"file\" style=\" display: none;\" (change)=\"onQrCodeChange()\" accept=\"image/*\"/>\n                      </div>\n\n                      <div class=\"ant-upload-list-item ant-upload-list-item-done\" *ngIf=\"fileNameQr\">\n                      <div class=\"ant-upload-list-item-info\">\n                          <i nz-icon=\"\" class=\"anticon ng-tns-c8-0 anticon-paper-clip\" style=\"position: absolute;left: 0px;\"></i>\n                          <span class=\"ant-upload-list-item-name ng-tns-c8-0 \" >{{fileNameQr}}</span>\n                          <!-- <i  type=\"close\" class=\"anticon ng-tns-c8-0 anticon-close ng-star-inserted\" ></i> -->\n                        </div>\n                      </div>\n                      <div class=\"ant-upload-list-item ant-upload-list-item-done ant-upload-list-item-error\" *ngIf=\"fileNameQrError\">\n                      <div class=\"ant-upload-list-item-info\">\n                          <i nz-icon=\"\" class=\"anticon ng-tns-c8-0 anticon-paper-clip\" style=\"position: absolute;left: 0px;\"></i>\n                          <span class=\"ant-upload-list-item-name ng-tns-c8-0 \" >{{fileNameQrError}}</span>\n                          <i  type=\"close\" class=\"anticon ng-tns-c8-0 anticon-close\" (click)=\"fileNameQrError = ''\" ></i>\n                        </div>\n                      </div>\n                    </div>\n                  </div>\n                </div>\n            </div>\n        </div>\n    </div>\n</dx-tab-panel>\n"
                }] }
    ];
    /** @nocollapse */
    UploadAttachmentComponent.ctorParameters = function () { return [
        { type: AppConfigService },
        { type: Request },
        { type: Common },
        { type: HttpClient },
        { type: Http }
    ]; };
    UploadAttachmentComponent.propDecorators = {
        form: [{ type: ViewChild, args: ['f',] }],
        upLoadType: [{ type: Input }],
        systemId: [{ type: Input }],
        RelatedAgency: [{ type: Input }],
        RecordId: [{ type: Input }],
        Subject: [{ type: Input }],
        TypeId: [{ type: Input }],
        onlyImage: [{ type: Input }],
        uploaded: [{ type: Output }]
    };
    return UploadAttachmentComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
// # Calendar TH
locale('th');
var UploadAttachmentModule = /** @class */ (function () {
    function UploadAttachmentModule() {
    }
    UploadAttachmentModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule,
                        DxFileUploaderModule,
                        DxTemplateModule,
                        DxTabPanelModule,
                        AutoCompleteModule,
                        TabViewModule,
                        FormsModule,
                        DxButtonModule,
                        NgZorroAntdModule,
                    ], exports: [
                        UploadAttachmentComponent
                    ], providers: [], declarations: [
                        UploadAttachmentComponent,
                    ],
                },] }
    ];
    return UploadAttachmentModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var ModalStepViewComponent = /** @class */ (function () {
    function ModalStepViewComponent(request, common) {
        this.request = request;
        this.common = common;
        this.onUpdateModal = new EventEmitter();
        this.submitted = false;
        this.title = 'สถานะขั้นตอน';
        this.selectList = [];
        this.list = [];
        this.modalConfig = {
            ignoreBackdropClick: true
        };
        this.selectedStep = {};
        this.isMore = false;
        this.moreField = [];
        this.stepData = {};
        this.lastStep = '';
        this.stepName = '';
        this.isSend = false;
        this.isRecieve = false;
        this.sendList = [];
        this.recieveList = [];
    }
    /**
     * @return {?}
     */
    ModalStepViewComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    /**
     * @param {?=} options
     * @return {?}
     */
    ModalStepViewComponent.prototype.open = /**
     * @param {?=} options
     * @return {?}
     */
    function (options) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, step, i, flag, ct_step_flag, newField, filter$$1, sendDataList, filter$$1, recieveDataList;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        console.log(options);
                        this.stepData = {};
                        if (!options) return [3 /*break*/, 11];
                        this.title = options.option.title || 'สถานะขั้นตอน';
                        this.stepName = options.data.step_name || '';
                        this.stepData = JSON.parse(JSON.stringify(options.data));
                        this.downloadToken = options.downloadToken;
                        if (!this.stepData.step_id) return [3 /*break*/, 11];
                        _a = this;
                        return [4 /*yield*/, this.request.get('/db/ct_step?_where=(id,eq,' + this.stepData.step_id + ')')];
                    case 1:
                        _a.selectList = _b.sent();
                        step = this.selectList[0];
                        if (!step.flag) return [3 /*break*/, 6];
                        i = 0;
                        _b.label = 2;
                    case 2:
                        if (!(i < step.flag.length)) return [3 /*break*/, 5];
                        flag = step.flag.charAt(i);
                        return [4 /*yield*/, this.request.get('/db/ct_step_flag?_where=(flag,eq,' + flag + ')')];
                    case 3:
                        ct_step_flag = _b.sent();
                        newField = ct_step_flag[0];
                        this.moreField.push(newField);
                        _b.label = 4;
                    case 4:
                        i++;
                        return [3 /*break*/, 2];
                    case 5:
                        this.isMore = true;
                        return [3 /*break*/, 11];
                    case 6:
                        this.isMore = false;
                        if (!(step.type_id === 8 || step.type_id === 13)) return [3 /*break*/, 8];
                        filter$$1 = {
                            filter: {
                                ct_step_data_id: this.stepData.id
                            },
                            order_by: ["is_important", "send_book_no", "created_at"]
                        };
                        return [4 /*yield*/, this.request.post('/search/v_ct_step_sent', filter$$1)];
                    case 7:
                        sendDataList = _b.sent();
                        this.sendList = sendDataList.resultData;
                        this.isSend = true;
                        this.isRecieve = false;
                        return [3 /*break*/, 11];
                    case 8:
                        if (!(step.type_id === 9 || step.type_id === 14)) return [3 /*break*/, 10];
                        filter$$1 = {
                            filter: {
                                ct_step_data_id: this.stepData.id
                            },
                            order_by: ["is_important", "send_book_no", "created_at"]
                        };
                        return [4 /*yield*/, this.request.post('/search/v_ct_step_sent', filter$$1)];
                    case 9:
                        recieveDataList = _b.sent();
                        this.recieveList = recieveDataList.resultData;
                        this.isRecieve = true;
                        this.isSend = false;
                        return [3 /*break*/, 11];
                    case 10:
                        this.isRecieve = false;
                        this.isSend = false;
                        _b.label = 11;
                    case 11:
                        this.modal.show();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @return {?}
     */
    ModalStepViewComponent.prototype.closeModal = /**
     * @return {?}
     */
    function () {
        this.submitted = false;
        this.selectList = [];
        this.list = [];
        this.selectedStep = {};
        this.isMore = false;
        this.isSend = false;
        this.isRecieve = false;
        this.moreField = [];
        this.stepData = {};
        this.lastStep = '';
        this.modal.hide();
    };
    /**
     * @param {?} data
     * @return {?}
     */
    ModalStepViewComponent.prototype.getFieldId = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        /** @type {?} */
        var id = '';
        if (data.type === 'text') {
            id += 'txtView';
        }
        else if (data.type === 'datetime') {
            id += 'txtView';
        }
        /** @type {?} */
        var field = data.field_name.charAt(0).toLocaleUpperCase() + data.field_name.substring(1);
        id += field;
        return id;
    };
    /**
     * @param {?} data
     * @return {?}
     */
    ModalStepViewComponent.prototype.getRowIndex = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        if (!data.data) {
            return '';
        }
        /** @type {?} */
        var no = data.row.dataIndex + 1;
        return no;
    };
    /**
     * @param {?} e
     * @return {?}
     */
    ModalStepViewComponent.prototype.onCellPrepared = /**
     * @param {?} e
     * @return {?}
     */
    function (e) {
        if (e.rowType === 'data') {
            for (var i in e.component.columns) {
                if (e.column.dataField === e.component.columns[i]) {
                    e.cellElement.accessKey = e.component.columns[i];
                }
            }
        }
    };
    /**
     * @param {?} data
     * @return {?}
     */
    ModalStepViewComponent.prototype.isImportant = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        return data.is_important ? "สำคัญ" : "";
    };
    /**
     * @param {?} data
     * @return {?}
     */
    ModalStepViewComponent.prototype.getImageLink = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        return data.url + '?downloadToken=' + this.downloadToken;
    };
    ModalStepViewComponent.decorators = [
        { type: Component, args: [{
                    selector: 'modal-step-view',
                    template: "<div class=\"modal fade\" bsModal #modal=\"bs-modal\" [config]=\"{backdrop: 'static'}\"\n     tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"dialog-static-name\">\n    <div class=\"modal-dialog modal-lg\">\n        <div class=\"modal-content\">\n            <div class=\"modal-header\">\n                <h4 id=\"dialog-static-name\" class=\"modal-title pull-left\"><label>{{title}}</label></h4>\n                <button type=\"button\" class=\"close pull-right\" aria-label=\"Close\" (click)=\"closeModal()\">\n                    <span aria-hidden=\"true\">&times;</span>\n                </button>\n            </div>\n            <div class=\"modal-body\">\n                <div class=\"row\">\n                    <div class=\"col-lg-12\">\n                        <div class=\"m-portlet__body\">\n                            <div class=\"row\">\n                                <!-- \u0E2A\u0E16\u0E32\u0E19\u0E30\u0E43\u0E2B\u0E21\u0E48 -->\n                                <!--<div class=\"col-sm-2\">-->\n                                    <!--<span>\u0E2A\u0E16\u0E32\u0E19\u0E30 :</span>-->\n                                <!--</div>-->\n                                <div class=\"col-sm-6\">\n                                    <label class=\"control-label\">\u0E2A\u0E16\u0E32\u0E19\u0E30\u0E01\u0E32\u0E23\u0E15\u0E34\u0E14\u0E15\u0E32\u0E21</label>\n                                    <input type=\"text\" class=\"form-control m-input\" id=\"txtViewStepName\" [(ngModel)]=\"stepName\" disabled>\n                                </div>\n                                <!-- \u0E27\u0E31\u0E19\u0E14\u0E33\u0E40\u0E19\u0E34\u0E19\u0E01\u0E32\u0E23 -->\n                                <!--<div class=\"col-sm-2\">-->\n                                    <!--<span>\u0E27\u0E31\u0E19\u0E14\u0E33\u0E40\u0E19\u0E34\u0E19\u0E01\u0E32\u0E23 :</span>-->\n                                <!--</div>-->\n                                <div class=\"col-sm-6\">\n                                    <label class=\"control-label\">\u0E27\u0E31\u0E19\u0E14\u0E33\u0E40\u0E19\u0E34\u0E19\u0E01\u0E32\u0E23</label>\n                                    <soc-date-box [id]=\"'txtStepDate'\" [(value)]=\"stepData.step_date\" [disabled]=\"true\"></soc-date-box>\n                                </div>\n                            </div>\n                            <div class=\"row\" *ngIf=\"stepData.system_id === 23\">\n                                <div class=\"col-sm-6\">\n                                    <label class=\"control-label\">\u0E40\u0E25\u0E02\u0E17\u0E35\u0E48\u0E23\u0E31\u0E1A \u0E2A\u0E25\u0E04.</label>\n                                    <input type=\"text\" class=\"form-control m-input\" id=\"soc_recv_no\" [(ngModel)]=\"stepData.soc_recv_no\" [disabled]=\"true\">\n                                </div>\n                                <div class=\"col-sm-6\">\n                                    <label class=\"control-label\">\u0E27\u0E31\u0E19\u0E17\u0E35\u0E48\u0E23\u0E31\u0E1A \u0E2A\u0E25\u0E04.</label>\n                                    <soc-date-box [id]=\"'soc_recv_date'\" [(value)]=\"stepData.soc_recv_date\"[disabled]=\"true\" ></soc-date-box>\n                                </div>\n                                <br>\n                            </div>\n                            <div class=\"row\" *ngIf=\"stepData.system_id === 23\">\n                                <div class=\"col-sm-6\">\n                                    <label class=\"control-label\">\u0E40\u0E25\u0E02\u0E17\u0E35\u0E48\u0E23\u0E31\u0E1A \u0E01\u0E2D\u0E04.</label>\n                                    <input type=\"text\" class=\"form-control m-input\" id=\"gtc_recv_no\" [(ngModel)]=\"stepData.gtc_recv_no\" [disabled]=\"true\">\n                                </div>\n                                <div class=\"col-sm-6\">\n                                    <label class=\"control-label\">\u0E27\u0E31\u0E19\u0E17\u0E35\u0E48\u0E23\u0E31\u0E1A \u0E01\u0E2D\u0E04.</label>\n                                    <soc-date-box [id]=\"'gtc_recv_date'\" [(value)]=\"stepData.gtc_recv_date\" [disabled]=\"true\" ></soc-date-box>\n                                </div>\n                                <br>\n                            </div>\n\n                            <div class=\"row\" *ngIf=\"stepData.system_id === 23\">\n                              <div class=\"col-sm-6\">\n                                  <label class=\"control-label\">\u0E40\u0E25\u0E02\u0E17\u0E35\u0E48\u0E2B\u0E19\u0E31\u0E07\u0E2A\u0E37\u0E2D</label>\n                                  <input type=\"text\" class=\"form-control m-input\" id=\"book_no\" [(ngModel)]=\"stepData.book_no\" [disabled]=\"true\">\n                              </div>\n                              <div class=\"col-sm-6\">\n                                  <label class=\"control-label\">\u0E25\u0E07\u0E27\u0E31\u0E19\u0E17\u0E35\u0E48</label>\n                                  <!-- <input type=\"text\" class=\"form-control m-input\" id=\"book_date\" [(ngModel)]=\"stepData.book_date\" [disabled]=\"true\"> -->\n                                  <soc-date-box [id]=\"'book_date'\"  [(value)]=\"stepData.book_date\" [disabled]=\"true\"></soc-date-box>\n                              </div>\n                                <br>\n                            </div>\n\n                            <div class=\"row\" *ngIf=\"stepData.system_id === 23\">\n                                <div class=\"col-sm-6\">\n                                    <label class=\"control-label\">\u0E40\u0E23\u0E35\u0E22\u0E19</label>\n                                    <input type=\"text\" class=\"form-control m-input\" id=\"for\" [(ngModel)]=\"stepData.for\" [disabled]=\"true\">\n                                </div>\n                                <br>\n                            </div>\n                            <div class=\"row\" *ngIf=\"stepData.system_id === 23\">\n                                <div class=\"col-sm-6\">\n                                    <label class=\"control-label\">\u0E01\u0E23\u0E30\u0E17\u0E23\u0E27\u0E07</label>\n                                    <input type=\"text\" class=\"form-control m-input\" id=\"for\" [(ngModel)]=\"stepData.ministry\" [disabled]=\"true\">\n                                    <!-- <soc-auto-complete-2 [id]=\"'ministry'\"  mode=\"local\"\n                                      [api]=\"'/db/ct_ext_department'\" [acceptCustomValue]=\"false\" field=\"name\" fieldApi=\"id,name,code,type\"\n                                      [filter]=\"'&_where=(type,in,1,9)'\" (valueSelete)=\"valueSeleteMinistry($event)\"\n                                      [(value)]=\"stepData.ministry\" [(ngModel)]=\"stepData.ministry\" [disabled]=\"true\">\n                                    </soc-auto-complete-2> -->\n                                </div>\n                                <div class=\"col-sm-6\">\n                                    <label class=\"control-label\">\u0E01\u0E23\u0E21</label>\n                                    <div>\n                                      <input type=\"text\" class=\"form-control m-input\" id=\"for\" [(ngModel)]=\"stepData.dept_name\" [disabled]=\"true\">\n                                    <!-- <soc-auto-complete-2 [acceptCustomValue]=\"false\" [id]=\"'dept_name'\"\n                                      mode=\"local\" [filter]=\"filter_ref_ext_department_id\"\n                                       [api]=\"'/db/ct_ext_department'\" field=\"name\"\n                                      fieldApi=\"id,name,code,type\" [(value)]=\"stepData.dept_name\" (valueSelete)=\"valueSeleteDeptName($event)\"\n                                      [(ngModel)]=\"stepData.dept_name\"  [disabled]=\"true\">\n                                    </soc-auto-complete-2> -->\n                                    </div>\n                                </div>\n                            </div>\n\n                            <br>\n                            <div class=\"row\">\n                                <!--<div class=\"col-sm-2\">-->\n                                <!--<span>\u0E40\u0E2D\u0E01\u0E2A\u0E32\u0E23\u0E41\u0E19\u0E1A :</span>-->\n                                <!--</div>-->\n                                <div class=\"col-sm-12\">\n                                    <label class=\"control-label\">\u0E40\u0E2D\u0E01\u0E2A\u0E32\u0E23\u0E41\u0E19\u0E1A</label>\n                                    <br>\n                                    <a [href]=\"getImageLink(stepData)\" target=\"_blank\">{{stepData.url}}</a>\n                                </div>\n                            </div>\n                            <br>\n                            <!-- \u0E2B\u0E21\u0E32\u0E22\u0E40\u0E2B\u0E15\u0E38 -->\n                            <div class=\"row\">\n                                <!--<div class=\"col-sm-2\">-->\n                                    <!--<span>\u0E2B\u0E21\u0E32\u0E22\u0E40\u0E2B\u0E15\u0E38 :</span>-->\n                                <!--</div>-->\n                                <div class=\"col-sm-12\">\n                                    <label class=\"control-label\">\u0E2B\u0E21\u0E32\u0E22\u0E40\u0E2B\u0E15\u0E38</label>\n                                    <textarea class=\"form-control m-input\" id=\"txtViewRemark\" rows=\"3\" [(ngModel)]=\"stepData.remark\" disabled></textarea>\n                                </div>\n                            </div>\n                            <br>\n                            <div *ngIf=\"isMore\">\n                                <div *ngFor=\"let field of moreField; let i=index\">\n                                    <div class=\"row\">\n                                        <!--<div class=\"col-sm-2\">-->\n                                            <!--<span>{{field.display_name}} :</span>-->\n                                        <!--</div>-->\n                                        <div *ngIf=\"field.type === 'text'\">\n                                            <div class=\"col-sm-12\">\n                                                <label class=\"control-label\">{{field.display_name}}</label>\n                                                <input type=\"text\" class=\"form-control m-input\" [id]=\"getFieldId(field)\" [(ngModel)]=\"stepData[field.field_name]\" disabled>\n                                            </div>\n                                        </div>\n                                        <!-- field \u0E40\u0E1E\u0E34\u0E48\u0E21\u0E40\u0E15\u0E34\u0E21 type datetime -->\n                                        <div *ngIf=\"field.type === 'datetime'\">\n                                            <div class=\"col-sm-6\">\n                                                <label class=\"control-label\">{{field.display_name}}</label>\n                                                <soc-date-box  [id]=\"getFieldId(field)\" [(value)]=\"stepData[field.field_name]\" [disabled]=\"true\"></soc-date-box>\n                                            </div>\n                                        </div>\n                                        <div *ngIf=\"field.type === 'number'\">\n                                            <div *ngIf=\"field.field_name === 'remind_date'\">\n                                                <div class=\"col-sm-6\">\n                                                    <label class=\"control-label\">{{field.display_name}}</label>\n                                                    <soc-date-box  [id]=\"getFieldId(field)\" [(value)]=\"stepData[field.field_name]\" [disabled]=\"true\"></soc-date-box>\n                                                </div>\n                                            </div>\n                                            <div *ngIf=\"field.field_name !== 'remind_date'\">\n                                                <div class=\"col-sm-6\">\n                                                    <label class=\"control-label\">{{field.display_name}}</label>\n                                                    <input type=\"number\" class=\"form-control m-input\" [id]=\"getFieldId(field)\" [(ngModel)]=\"stepData[field.field_name]\" disabled>\n                                                </div>\n                                            </div>\n                                        </div>\n                                        <div *ngIf=\"field.type === 'special'\">\n                                            <div *ngIf=\"field.field_name === 'term'\">\n\n                                            </div>\n                                            <div *ngIf=\"field.field_name === 'amount'\">\n                                                <div  class=\"col-sm-6\">\n                                                    <label class=\"control-label\">{{field.display_name}}</label>\n                                                    <input type=\"text\" class=\"form-control m-input\" [id]=\"getFieldId(field)\" [(ngModel)]=\"stepData[field.field_name]\" disabled>\n                                                </div>\n                                                <div class=\"col-sm-6\">\n                                                    <div class=\"m-radio-inline\">\n                                                        <label class=\"m-radio\">\n                                                            <input type=\"radio\" id=\"rdlAmountType1\" [value]=\"0\" [(ngModel)]=\"stepData['amount_type']\" disabled>\n                                                            \u0E19\u0E31\u0E1A\u0E41\u0E15\u0E48<span></span>\n                                                        </label>\n                                                        <label class=\"m-radio\">\n                                                            <input type=\"radio\" id=\"rdlAmountType2\" [value]=\"1\" [(ngModel)]=\"stepData['amount_type']\" disabled>\n                                                            \u0E19\u0E31\u0E1A\u0E16\u0E31\u0E14<span></span>\n                                                        </label>\n                                                    </div>\n                                                </div>\n                                            </div>\n                                            <div *ngIf=\"field.field_name === 'follow'\">\n                                                <div class=\"col-sm-6\">\n                                                    <label class=\"control-label\">{{field.display_name}}</label>\n                                                    <div class=\"m-radio-inline\">\n                                                        <label class=\"m-radio\">\n                                                            <input type=\"radio\" [id]=\"getFieldId(field) + '1'\" value=\"\u0E17\u0E32\u0E07\u0E01\u0E32\u0E23\" [(ngModel)]=\"stepData[field.field_name]\" disabled>\n                                                            \u0E17\u0E32\u0E07\u0E01\u0E32\u0E23<span></span>\n                                                        </label>\n                                                        <label class=\"m-radio\">\n                                                            <input type=\"radio\" [id]=\"getFieldId(field) + '2'\" value=\"\u0E44\u0E21\u0E48\u0E17\u0E32\u0E07\u0E01\u0E32\u0E23\" [(ngModel)]=\"stepData[field.field_name]\" disabled>\n                                                            \u0E44\u0E21\u0E48\u0E17\u0E32\u0E07\u0E01\u0E32\u0E23<span></span>\n                                                        </label>\n                                                    </div>\n                                                </div>\n                                                <!--<div class=\"col-sm-2\">-->\n                                                    <!--<span>\u0E2B\u0E21\u0E32\u0E22\u0E40\u0E2B\u0E15\u0E38 :</span>-->\n                                                <!--</div>-->\n                                                <div class=\"col-sm-6\">\n                                                    <label class=\"control-label\">\u0E2B\u0E21\u0E32\u0E22\u0E40\u0E2B\u0E15\u0E38</label>\n                                                    <input type=\"text\" class=\"form-control m-input\" id=\"txtFollowRemark\" [(ngModel)]=\"stepData['follow_remark']\" disabled>\n                                                </div>\n                                            </div>\n                                            <div *ngIf=\"field.field_name === 'cause'\">\n                                                <div  class=\"col-sm-6\">\n                                                    <label class=\"control-label\">{{field.display_name}}</label>\n                                                    <input type=\"text\" class=\"form-control m-input\" [id]=\"getFieldId(field)\" [(ngModel)]=\"stepData[field.field_name]\" disabled>\n                                                </div>\n                                            </div>\n                                        </div>\n                                    </div>\n                                    <br>\n                                </div>\n                                <br>\n                            </div>\n                            <div *ngIf=\"isSend\">\n                                <div class=\"row\">\n                                    <div class=\"col-sm-2\">\n                                        <span>\u0E23\u0E32\u0E22\u0E01\u0E32\u0E23\u0E2A\u0E48\u0E07 :</span>\n                                    </div>\n                                </div>\n                                <br>\n                                <dx-data-grid #dxDataGridStepSendListView class=\"card-list-table\"\n                                              id=\"gridStepSendListView\" noDataText=\"\"\n                                              (onCellPrepared)=\"onCellPrepared($event)\" [dataSource]=\"sendList\"\n                                              [wordWrapEnabled]=\"true\"\n                                              [showBorders]=\"true\">\n                                    <dxi-column caption=\"\u0E23\u0E32\u0E22\u0E01\u0E32\u0E23\u0E17\u0E35\u0E48\" [allowSorting]=\"false\" cellTemplate=\"cellTemplate\" alignment=\"center\"></dxi-column>\n                                    <dxi-column dataField=\"send_to\" caption=\"\u0E2B\u0E19\u0E48\u0E27\u0E22\u0E07\u0E32\u0E19\"></dxi-column>\n                                    <dxi-column dataField=\"send_book_no\" caption=\"\u0E40\u0E25\u0E02\u0E17\u0E35\u0E48\u0E2B\u0E19\u0E31\u0E07\u0E2A\u0E37\u0E2D\u0E2A\u0E48\u0E07\u0E2D\u0E2D\u0E01\"></dxi-column>\n                                    <dxi-column dataField=\"send_date\" caption=\"\u0E27\u0E31\u0E19\u0E17\u0E35\u0E48\u0E2A\u0E48\u0E07\u0E2D\u0E2D\u0E01\" dataType=\"date\" alignment=\"center\"></dxi-column>\n                                    <dxi-column [calculateCellValue]=\"isImportant\" caption=\"\u0E04\u0E27\u0E32\u0E21\u0E2A\u0E33\u0E04\u0E31\u0E0D\"></dxi-column>\n                                    <div *dxTemplate=\"let data of 'cellTemplate'\">\n                                        {{getRowIndex(data)}}\n                                    </div>\n                                </dx-data-grid>\n                                <br>\n                            </div>\n                            <div *ngIf=\"isRecieve\">\n                                <div class=\"row\">\n                                    <div class=\"col-sm-2\">\n                                        <span>\u0E23\u0E32\u0E22\u0E01\u0E32\u0E23\u0E23\u0E31\u0E1A :</span>\n                                    </div>\n                                </div>\n                                <br>\n                                <dx-data-grid #dxDataGridStepRecieveListView class=\"card-list-table\"\n                                              id=\"gridStepRecieveListView\" noDataText=\"\"\n                                              (onCellPrepared)=\"onCellPrepared($event)\" [dataSource]=\"recieveList\"\n                                              [wordWrapEnabled]=\"true\"\n                                              [showBorders]=\"true\">\n                                    <dxi-column caption=\"\u0E23\u0E32\u0E22\u0E01\u0E32\u0E23\u0E17\u0E35\u0E48\" [allowSorting]=\"false\" cellTemplate=\"cellTemplate\" alignment=\"center\"></dxi-column>\n                                    <dxi-column dataField=\"recv_from\" caption=\"\u0E2B\u0E19\u0E48\u0E27\u0E22\u0E07\u0E32\u0E19\"></dxi-column>\n                                    <dxi-column dataField=\"send_book_no\" caption=\"\u0E40\u0E25\u0E02\u0E17\u0E35\u0E48\u0E2B\u0E19\u0E31\u0E07\u0E2A\u0E37\u0E2D\u0E2A\u0E48\u0E07\u0E2D\u0E2D\u0E01\"></dxi-column>\n                                    <dxi-column dataField=\"send_date\" caption=\"\u0E27\u0E31\u0E19\u0E17\u0E35\u0E48\u0E2A\u0E48\u0E07\u0E2D\u0E2D\u0E01\" dataType=\"date\" alignment=\"center\"></dxi-column>\n                                    <dxi-column dataField=\"recv_no\" caption=\"\u0E40\u0E25\u0E02\u0E17\u0E35\u0E48\u0E23\u0E31\u0E1A\u0E2B\u0E19\u0E31\u0E07\u0E2A\u0E37\u0E2D\"></dxi-column>\n                                    <dxi-column dataField=\"recv_date\" caption=\"\u0E27\u0E31\u0E19\u0E17\u0E35\u0E48\u0E23\u0E31\u0E1A\" dataType=\"date\" alignment=\"center\"></dxi-column>\n                                    <div *dxTemplate=\"let data of 'cellTemplate'\">\n                                        {{getRowIndex(data)}}\n                                    </div>\n                                </dx-data-grid>\n                                <br>\n                            </div>\n                        </div>\n                    </div>\n                </div>\n            </div>\n        </div>\n    </div>\n</div>"
                }] }
    ];
    /** @nocollapse */
    ModalStepViewComponent.ctorParameters = function () { return [
        { type: Request },
        { type: Common }
    ]; };
    ModalStepViewComponent.propDecorators = {
        onUpdateModal: [{ type: Output }],
        modal: [{ type: ViewChild, args: ['modal',] }]
    };
    return ModalStepViewComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var StepListComponent = /** @class */ (function () {
    function StepListComponent(appConfigService, request, common, b2b) {
        this.appConfigService = appConfigService;
        this.request = request;
        this.common = common;
        this.b2b = b2b;
        this.mode = 'CREATE';
        this.columns = ['ลำดับที่', 'ผู้แก้ไข', 'วันที่', 'สถานะการติดตาม', 'หมายเหตุ'];
        this.stepList = [];
        this.dxgridPageSize = 10;
        this.allowedPageSizes1 = 10;
        this.allowedPageSizes2 = 25;
        this.allowedPageSizes3 = 50;
        this.allowedPageSizes4 = 100;
        this.customers = [];
        this.lastStep = '';
        this.config = appConfigService.getConfig();
    }
    /**
     * @return {?}
     */
    StepListComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        setTimeout(function () { return __awaiter(_this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this;
                        return [4 /*yield*/, this.b2b.getAttachmentToken()];
                    case 1:
                        _a.downloadToken = _b.sent();
                        return [2 /*return*/];
                }
            });
        }); }, 500);
        if (this.mode !== "CREATE") {
            this.getStepList();
        }
    };
    /**
     * @return {?}
     */
    StepListComponent.prototype.getStepList = /**
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            var filter$$1, data;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        console.log('getStepList', this.stepList);
                        filter$$1 = {
                            filter: {
                                ref_table: "=" + this.option.data.ref_table,
                                ref_id: this.option.data.ref_id,
                                system_id: this.option.data.system_id
                            },
                            order_by: ["step_date desc"]
                        };
                        return [4 /*yield*/, this.request.post('/search/ct_step_data', filter$$1)];
                    case 1:
                        data = _a.sent();
                        this.stepList = data.resultData;
                        if (this.stepList && this.stepList.length > 0) {
                            this.lastStep = this.stepList[0].name;
                        }
                        console.log('getStepList', this.stepList);
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @param {?} data
     * @return {?}
     */
    StepListComponent.prototype.addStepList = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        /** @type {?} */
        var userData = this.b2b.getVerifyToken();
        data.username = userData.username;
        this.stepList.push(data);
        console.log('getStepList', this.stepList);
    };
    /**
     * @param {?} data
     * @return {?}
     */
    StepListComponent.prototype.getRowIndex = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        if (!data.data) {
            return '';
        }
        /** @type {?} */
        var page = this.dxDataGridStepList.instance.option('paging.pageIndex') || 0;
        /** @type {?} */
        var pageSize = this.dxDataGridStepList.instance.option('paging.pageSize');
        /** @type {?} */
        var no = data.row.dataIndex + 1;
        return page * pageSize + no;
    };
    /**
     * @param {?} data
     * @return {?}
     */
    StepListComponent.prototype.view = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        /** @type {?} */
        var viewData = {
            option: this.option,
            data: data,
            downloadToken: this.downloadToken
        };
        this.modalStepView.open(viewData);
    };
    /**
     * @return {?}
     */
    StepListComponent.prototype.getLastStep = /**
     * @return {?}
     */
    function () {
        return this.lastStep;
    };
    /**
     * @param {?} e
     * @return {?}
     */
    StepListComponent.prototype.onCellPrepared = /**
     * @param {?} e
     * @return {?}
     */
    function (e) {
        if (e.rowType === 'data') {
            e.cellElement.accessKey = e.column.caption;
        }
    };
    StepListComponent.decorators = [
        { type: Component, args: [{
                    selector: 'soc-step-list',
                    template: "<div class=\"col-sm-12\">\n    <!--[selectedRowKeys]=\"selectRowKeyId\" (onInitialized)=\"onInitialized($event)\" (onSelectionChanged)=\"selectRow($event)\"-->\n    <div class=\"table-responsive table-wrapper\">\n      <!--<dx-data-grid #dxDataGridStepList id=\"dxDataGridStepList\" [dataSource]=\"ds\" [hoverStateEnabled]=\"true\" noDataText=\"\"-->\n                    <!--showBorders=\"true\" [rowAlternationEnabled]=\"true\" [columnAutoWidth]=\"true\"-->\n                    <!--[columns]=\"columns\"-->\n                    <!--class=\"card-list-table\"-->\n                    <!--[allowColumnResizing]=\"true\"-->\n                    <!--[allowColumnReordering]=\"true\"-->\n                    <!--[wordWrapEnabled]=\"true\"-->\n                    <!--[columnMinWidth]=\"'100%'\" class=\"card-list-table\">-->\n        <!--<dxo-paging [pageSize]=\"dxgridPageSize\"></dxo-paging>-->\n        <!--<dxo-pager [showPageSizeSelector]=\"true\" [allowedPageSizes]=\"[allowedPageSizes1, allowedPageSizes2, allowedPageSizes3, allowedPageSizes4]\"-->\n                   <!--[showInfo]=\"false\" [visible]=\"true\" [showNavigationButtons]=\"true\">-->\n        <!--</dxo-pager>-->\n        <!--<dxo-scrolling showScrollbar=\"always\"></dxo-scrolling>-->\n        <!--<dxo-remote-operations [sorting]=\"true\" [paging]=\"true\">-->\n        <!--</dxo-remote-operations>-->\n      <!--</dx-data-grid>-->\n      <dx-data-grid #dxDataGridStepList\n            id=\"gridContainer\" noDataText=\"\" showBorders=\"true\" class=\"card-list-table\"\n            (onCellPrepared)=\"onCellPrepared($event)\" [dataSource]=\"stepList\"\n            [hoverStateEnabled]=\"true\" [rowAlternationEnabled]=\"true\" [columnAutoWidth]=\"false\"\n            [allowColumnResizing]=\"true\" [allowColumnReordering]=\"true\" [wordWrapEnabled]=\"false\"\n            [showBorders]=\"true\">\n            <dxi-column caption=\"\u0E25\u0E33\u0E14\u0E31\u0E1A\u0E17\u0E35\u0E48\" [allowSorting]=\"false\" cellTemplate=\"cellTemplate\" alignment=\"center\" [width]=\"70\"></dxi-column>\n            <dxi-column caption=\"\u0E08\u0E31\u0E14\u0E01\u0E32\u0E23\" [allowSorting]=\"false\" cellTemplate=\"cellTemplateAction\" alignment=\"center\" [width]=\"70\"></dxi-column>\n            <dxi-column dataField=\"username\" caption=\"\u0E1C\u0E39\u0E49\u0E14\u0E33\u0E40\u0E19\u0E34\u0E19\u0E01\u0E32\u0E23\"></dxi-column>\n            <dxi-column dataField=\"step_date\" [caption]=\"option.data.system_id === 161?'\u0E27\u0E31\u0E19\u0E17\u0E35\u0E48':'\u0E27\u0E31\u0E19\u0E17\u0E35\u0E48\u0E14\u0E33\u0E40\u0E19\u0E34\u0E19\u0E01\u0E32\u0E23'\" dataType=\"date\" alignment=\"center\" [width]=\"100\"></dxi-column>\n            <dxi-column dataField=\"step_name\" caption=\"\u0E2A\u0E16\u0E32\u0E19\u0E30\u0E01\u0E32\u0E23\u0E15\u0E34\u0E14\u0E15\u0E32\u0E21\"></dxi-column>\n            <dxi-column dataField=\"remark\" caption=\"\u0E2B\u0E21\u0E32\u0E22\u0E40\u0E2B\u0E15\u0E38\"></dxi-column>\n            <dxo-paging [pageSize]=\"dxgridPageSize\"></dxo-paging>\n            <dxo-pager [showPageSizeSelector]=\"true\" [allowedPageSizes]=\"[allowedPageSizes1, allowedPageSizes2, allowedPageSizes3, allowedPageSizes4]\"\n            [showInfo]=\"false\" [visible]=\"true\" [showNavigationButtons]=\"true\">\n            </dxo-pager>\n            <dxo-state-storing [enabled]=\"true\" type=\"localStorage\" storageKey=\"stepListDataGrid\"></dxo-state-storing>\n            <div *dxTemplate=\"let data of 'cellTemplate'\">\n              {{getRowIndex(data)}}\n            </div>\n            <div *dxTemplate=\"let data of 'cellTemplateAction'\">\n              <a id=\"btnView\" (click)=\"view(data.data)\" class=\"btn btn-default btn-sm icon\" data-toggle=\"tooltip\" data-placement=\"top\" title=\"\u0E14\u0E39\u0E02\u0E49\u0E2D\u0E21\u0E39\u0E25\"><i class=\"fal fa-eye\"></i></a>\n            </div>\n      </dx-data-grid>\n    </div>\n</div><!--End col-sm-12-->\n<!--<modal-step #modalStep (onUpdateModal)='getStepList()' (onCreateModal)=\"addStepList($event)\" [mode]=\"mode\"></modal-step>-->\n<modal-step-view #modalStepView ></modal-step-view>\n"
                }] }
    ];
    /** @nocollapse */
    StepListComponent.ctorParameters = function () { return [
        { type: AppConfigService },
        { type: Request },
        { type: Common },
        { type: B2bService }
    ]; };
    StepListComponent.propDecorators = {
        mode: [{ type: Input }],
        option: [{ type: Input }],
        dxDataGridStepList: [{ type: ViewChild, args: ['dxDataGridStepList',] }],
        modalStepView: [{ type: ViewChild, args: ['modalStepView',] }]
    };
    return StepListComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
// # Calendar TH
locale('th'); // # Calendar TH
baseZIndex(9999);
var SocDateBoxComponent = /** @class */ (function () {
    function SocDateBoxComponent(common) {
        var _this = this;
        this.common = common;
        this.id = '';
        this.width = '100%';
        this.type = 'date';
        this.max = undefined;
        this.min = undefined;
        this.acceptCustomValue = true;
        this.maxZoomLevel = 'month';
        this.minZoomLevel = 'century';
        this.valueChange = new EventEmitter();
        this.openOnFieldClick = true;
        this.disabled = false;
        this.interval = 30;
        this.showAnalogClock = false;
        this.format = {
            formatter: function (date) {
                if (_this.type === 'datetime') {
                    return formatDate(date, 'shortDateShortTime');
                }
                else if (_this.type === 'time') {
                    return formatDate(date, 'shortTime');
                }
                else {
                    return formatDate(date, 'shortDate');
                }
            },
            parser: function (date) {
                /** @type {?} */
                var format = 'D/M/YYYY';
                if (_this.type === 'datetime') {
                    format = 'D/M/YYYY HH:mm';
                }
                else if (_this.type === 'time') {
                    format = 'HH:mm';
                }
                /** @type {?} */
                var dateFormated = moment(date, format, true).subtract(543, 'year').toDate();
                return dateFormated;
            }
        };
        /**
         * START Bind Value
         */
        this.onModelChange = function () { };
        this.onModelTouched = function () { };
    }
    /**
     * @return {?}
     */
    SocDateBoxComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/];
            });
        });
    };
    /**
     * @return {?}
     */
    SocDateBoxComponent.prototype.ngAfterViewInit = /**
     * @return {?}
     */
    function () {
    };
    /**
     * @return {?}
     */
    SocDateBoxComponent.prototype.onOpened = /**
     * @return {?}
     */
    function () {
        this.common.fnChangeCalendarYear(); // # Calendar TH
        if (this.maxZoomLevel === 'year' || this.maxZoomLevel === 'decade') {
            this.common.fnChangeCalendarYearOnce(); // # Calendar TH
        }
        /** *
         * SECTION แก้ปัญหา ปฏิทินไม่แสดงใน modal ที่ prod
          @type {?} */
        var element = document.querySelector('.dx-overlay-wrapper.dx-dropdowneditor-overlay.dx-popup-wrapper.dx-datebox-wrapper.dx-datebox-wrapper-date.dx-datebox-wrapper-calendar');
        /** @type {?} */
        var subElement = document.querySelector('.dx-overlay-wrapper.dx-dropdowneditor-overlay.dx-popup-wrapper.dx-datebox-wrapper.dx-datebox-wrapper-date.dx-datebox-wrapper-calendar > .dx-overlay-content.dx-popup-normal');
        if (element) {
            /** @type {?} */
            var style$$1 = element.getAttribute('style');
            /** @type {?} */
            var newStyle = style$$1.replace('z-index: 1501;', 'z-index: 2050;');
            console.log('LOG: SocDateBoxComponent -> onOpened -> newStyle element', newStyle);
            element.setAttribute('style', newStyle);
        }
        if (subElement) {
            /** @type {?} */
            var style$$1 = subElement.getAttribute('style');
            /** @type {?} */
            var newStyle = style$$1.replace('z-index: 1501;', 'z-index: 2050;');
            console.log('LOG: SocDateBoxComponent -> onOpened -> newStyle subElement', newStyle);
            subElement.setAttribute('style', newStyle);
        }
        /** !SECTION */
    };
    /**
     * @param {?} e
     * @return {?}
     */
    SocDateBoxComponent.prototype.onValueChanged = /**
     * @param {?} e
     * @return {?}
     */
    function (e) {
        console.log("​SocDateBoxComponent -> onValueChanged -> e", e);
        this.valueChange.emit(e.value);
    };
    /**
     * @param {?} value
     * @return {?}
     */
    SocDateBoxComponent.prototype.writeValue = /**
     * @param {?} value
     * @return {?}
     */
    function (value) { };
    /**
     * @param {?} fn
     * @return {?}
     */
    SocDateBoxComponent.prototype.registerOnChange = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) { };
    /**
     * @param {?} fn
     * @return {?}
     */
    SocDateBoxComponent.prototype.registerOnTouched = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) { };
    SocDateBoxComponent.decorators = [
        { type: Component, args: [{
                    selector: 'soc-date-box',
                    providers: [{
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: forwardRef(function () { return SocDateBoxComponent; }),
                            multi: true
                        }],
                    template: "\n    <dx-date-box [showAnalogClock]=\"showAnalogClock\" [id]=\"id\" [(value)]=\"value\" [type]=\"type\" [disabled]=\"disabled\" [width]=\"width\" [interval]=\"interval\" [acceptCustomValue]=\"true\" [displayFormat]=\"format\" invalidDateMessage=\"\u0E27\u0E31\u0E19\u0E17\u0E35\u0E48\u0E44\u0E21\u0E48\u0E16\u0E39\u0E01\u0E15\u0E49\u0E2D\u0E07 \u0E01\u0E23\u0E38\u0E13\u0E32\u0E01\u0E23\u0E2D\u0E01\u0E40\u0E1B\u0E47\u0E19 \u0E27\u0E31\u0E19/\u0E40\u0E14\u0E37\u0E2D\u0E19/\u0E1B\u0E35\"\n    [openOnFieldClick]=\"openOnFieldClick\" (onOpened)=\"onOpened()\" (onValueChanged)=\"onValueChanged($event)\" [max]=\"max\" [min]=\"min\" [maxZoomLevel]=\"maxZoomLevel\" [minZoomLevel]=\"minZoomLevel\"></dx-date-box>\n\n"
                }] }
    ];
    /** @nocollapse */
    SocDateBoxComponent.ctorParameters = function () { return [
        { type: Common }
    ]; };
    SocDateBoxComponent.propDecorators = {
        id: [{ type: Input }],
        width: [{ type: Input }],
        type: [{ type: Input }],
        value: [{ type: Input }],
        max: [{ type: Input }],
        min: [{ type: Input }],
        acceptCustomValue: [{ type: Input }],
        maxZoomLevel: [{ type: Input }],
        minZoomLevel: [{ type: Input }],
        valueChange: [{ type: Output }],
        openOnFieldClick: [{ type: Input }],
        disabled: [{ type: Input }],
        interval: [{ type: Input }],
        showAnalogClock: [{ type: Input }]
    };
    return SocDateBoxComponent;
}());
var SharedDateBoxModule = /** @class */ (function () {
    function SharedDateBoxModule() {
    }
    SharedDateBoxModule.decorators = [
        { type: NgModule, args: [{
                    imports: [CommonModule, FormsModule, SharedModule, DxDateBoxModule],
                    exports: [SocDateBoxComponent, SharedModule],
                    declarations: [SocDateBoxComponent],
                },] }
    ];
    return SharedDateBoxModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
// # Calendar TH
locale('th');
var ModalStepViewModule = /** @class */ (function () {
    function ModalStepViewModule() {
    }
    ModalStepViewModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule,
                        FormsModule,
                        ModalModule.forRoot(),
                        DxDataGridModule,
                        DxTemplateModule,
                        SharedDateBoxModule
                    ], exports: [
                        ModalStepViewComponent
                    ], providers: [], declarations: [
                        ModalStepViewComponent,
                    ],
                },] }
    ];
    return ModalStepViewModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
moment.locale('th');
var DateService = /** @class */ (function () {
    function DateService() {
    }
    /**
     * @param {?} startDate
     * @return {?}
     */
    DateService.prototype.fromNow = /**
     * @param {?} startDate
     * @return {?}
     */
    function (startDate) {
        return moment(startDate).fromNow();
    };
    /**
     * @return {?}
     */
    DateService.prototype.getNow = /**
     * @return {?}
     */
    function () {
        return moment();
    };
    /**
     * @param {?} date
     * @return {?}
     */
    DateService.prototype.convertToTH = /**
     * @param {?} date
     * @return {?}
     */
    function (date) {
        if (date) {
            /** @type {?} */
            var day = date.format('DD');
            /** @type {?} */
            var month = date.format('MM');
            /** @type {?} */
            var year = +date.format('YYYY') + 543;
            /** @type {?} */
            var _date = day + '/' + month + '/' + year;
            return _date;
        }
        else {
            return '';
        }
    };
    DateService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root',
                },] }
    ];
    /** @nocollapse */
    DateService.ctorParameters = function () { return []; };
    /** @nocollapse */ DateService.ngInjectableDef = defineInjectable({ factory: function DateService_Factory() { return new DateService(); }, token: DateService, providedIn: "root" });
    return DateService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var Options = /** @class */ (function () {
    function Options() {
    }
    return Options;
}());
var ModalStepComponent = /** @class */ (function (_super) {
    __extends(ModalStepComponent, _super);
    function ModalStepComponent(appConfigService, request, formBuilder, common, date, b2bService) {
        var _this = _super.call(this) || this;
        _this.appConfigService = appConfigService;
        _this.request = request;
        _this.formBuilder = formBuilder;
        _this.common = common;
        _this.date = date;
        _this.b2bService = b2bService;
        _this.onUpdateModal = new EventEmitter();
        _this.submitted = false;
        _this.submittedSend = false;
        _this.submittedRecieve = false;
        _this.title = '';
        _this.selectList = [];
        _this.sendList = [];
        _this.recieveList = [];
        _this.modalConfig = {
            ignoreBackdropClick: true
        };
        _this.selectedStep = null;
        _this.isMore = false;
        _this.stepData = {};
        _this.sendData = {};
        _this.recieveData = {};
        _this.lastStep = '';
        _this.isSend = false;
        _this.isRecieve = false;
        _this.isEditSend = false;
        _this.isEditRecieve = false;
        _this.tmpData = {};
        _this.filteredDepartments = [];
        _this.departmentList = [];
        _this.departmentUrl = "/db/ct_ext_department";
        _this.causeUrl = "/db/ct_dropdown";
        _this.causeFilter = "system_id,eq,23)$and(dropdown_type,like,เรื่องส่งคืน";
        _this.tempId = -1;
        _this.filter_ref_ext_department_id = false;
        _this.filter_ref_ext_department_id_show = true;
        _this.config = appConfigService.getConfig();
        _this.attachmentUrl = get(_this.config, 'apiServers.alfresco.url') || "https://203.154.32.126:2585/api/mfec/Alfresco";
        _this.system_id = get(_this.config, 'system_id');
        return _this;
    }
    /**
     * @return {?}
     */
    ModalStepComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.th = this.common.fnLocalPCalendar('th');
        this.recieveForm = this.formBuilder.group({
            book_no: ['', [Validators.required]],
            recv_date: [''],
        });
        this.sendForm = this.formBuilder.group({
            send_to: [''],
            book_no: [''],
            send_date: [''],
            is_important: [''],
        });
        this.registerForm = this.formBuilder.group({
            name: [''],
            step_id: ['', Validators.required],
            step_date: [''],
            remark: [''],
            lastStep: [''],
            moreField: this.formBuilder.array([]),
            soc_recv_no: [''],
            soc_recv_date: [''],
            gtc_recv_no: [''],
            gtc_recv_date: [''],
            book_no: [''],
            book_date: [''],
            'for': [''],
            dept_name: [''],
            ministry: ['']
        });
    };
    /**
     * @param {?=} options
     * @return {?}
     */
    ModalStepComponent.prototype.open = /**
     * @param {?=} options
     * @return {?}
     */
    function (options) {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        console.log(options);
                        this.stepData = {};
                        if (!options) return [3 /*break*/, 2];
                        this.title = options.title || '';
                        this.lastStep = options.data.lastStep;
                        this.stepData = JSON.parse(JSON.stringify(options.data));
                        this.stepData.step_date = this.date.getNow();
                        delete this.stepData['lastStep'];
                        _a = this;
                        return [4 /*yield*/, this.request.get('/db/ct_step?_where=(category_id,eq,' + options.data.category_id + ')&_sort=seq_no')];
                    case 1:
                        _a.selectList = _b.sent();
                        _b.label = 2;
                    case 2:
                        this.uploadAttachment.clearValue();
                        this.modal.show();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @return {?}
     */
    ModalStepComponent.prototype.f = /**
     * @return {?}
     */
    function () { return this.registerForm.controls; };
    /**
     * @return {?}
     */
    ModalStepComponent.prototype.fs = /**
     * @return {?}
     */
    function () { return this.sendForm.controls; };
    /**
     * @return {?}
     */
    ModalStepComponent.prototype.fr = /**
     * @return {?}
     */
    function () { return this.recieveForm.controls; };
    /**
     * @return {?}
     */
    ModalStepComponent.prototype.closeModal = /**
     * @return {?}
     */
    function () {
        this.submitted = false;
        this.selectList = [];
        this.sendList = [];
        this.selectedStep = null;
        this.isMore = false;
        this.isSend = false;
        this.moreField = [];
        this.stepData = {};
        this.lastStep = '';
        this.modal.hide();
    };
    /**
     * @return {?}
     */
    ModalStepComponent.prototype.closeSendModal = /**
     * @return {?}
     */
    function () {
        this.submittedSend = false;
        this.sendData = {};
        this.isEditSend = false;
        this.tmpData = {};
        this.sendModal.hide();
    };
    /**
     * @return {?}
     */
    ModalStepComponent.prototype.closeRecieveModal = /**
     * @return {?}
     */
    function () {
        this.submittedRecieve = false;
        this.recieveData = {};
        this.isEditRecieve = false;
        this.tmpData = {};
        this.recieveModal.hide();
    };
    /**
     * @param {?} modal
     * @return {?}
     */
    ModalStepComponent.prototype.onYesClick = /**
     * @param {?} modal
     * @return {?}
     */
    function (modal) {
        modal.hide();
    };
    /**
     * @param {?} modal
     * @return {?}
     */
    ModalStepComponent.prototype.onNoClick = /**
     * @param {?} modal
     * @return {?}
     */
    function (modal) {
        modal.hide();
    };
    /**
     * @param {?} $event
     * @return {?}
     */
    ModalStepComponent.prototype.onHidden = /**
     * @param {?} $event
     * @return {?}
     */
    function ($event) {
        console.log('LOG MESSAGE: ModalConfirm -> onHidden -> $event', $event);
    };
    /**
     * @param {?} value
     * @return {?}
     */
    ModalStepComponent.prototype.valueSeleteMinistry = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        var _this = this;
        this.filter_ref_ext_department_id_show = false;
        console.log('value', value);
        // this.stepData.ministry_id = value && value.id ? value.id : null
        if (value && value.id) {
            this.stepData.dept_name = null;
            this.filter_ref_ext_department_id = "&_where=(ref_ext_department_id,eq," + value.id + ")$and(type,in,2,3,4,5)";
        }
        else {
            this.filter_ref_ext_department_id = false;
        }
        setTimeout(function () {
            _this.filter_ref_ext_department_id_show = true;
        }, 50);
    };
    /**
     * @param {?} value
     * @return {?}
     */
    ModalStepComponent.prototype.valueSeleteDeptName = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        console.log('value', value);
        this.stepData.code_dept = value && value.id ? value.id : null;
    };
    /**
     * @return {?}
     */
    ModalStepComponent.prototype.checkExtraField = /**
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            var i, flag, requireFlag, ct_step_flag, newField, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        this.stepData.step_id = this.selectedStep.id;
                        this.stepData.step_name = this.selectedStep.name;
                        console.log(this.isMore);
                        this.moreField = [];
                        if (!(this.selectedStep.flag && this.selectedStep.flag !== '')) return [3 /*break*/, 6];
                        i = 0;
                        _b.label = 1;
                    case 1:
                        if (!(i < this.selectedStep.flag.length)) return [3 /*break*/, 5];
                        flag = this.selectedStep.flag.charAt(i);
                        requireFlag = this.selectedStep.require_flag ? this.selectedStep.require_flag.charAt(i) : 0;
                        return [4 /*yield*/, this.request.get('/db/ct_step_flag?_where=(flag,eq,' + flag + ')')];
                    case 2:
                        ct_step_flag = _b.sent();
                        newField = ct_step_flag[0];
                        return [4 /*yield*/, this.addField(newField, +requireFlag)];
                    case 3:
                        _b.sent();
                        this.moreField.push(newField);
                        console.log(this.f);
                        _b.label = 4;
                    case 4:
                        i++;
                        return [3 /*break*/, 1];
                    case 5:
                        this.isMore = true;
                        this.isSend = false;
                        this.isRecieve = false;
                        return [3 /*break*/, 9];
                    case 6:
                        this.isMore = false;
                        if (!(this.selectedStep.type_id === 8 || this.selectedStep.type_id === 13)) return [3 /*break*/, 8];
                        _a = this;
                        return [4 /*yield*/, this.request.get('/db/ct_ext_department?_sort=name')];
                    case 7:
                        _a.departmentList = _b.sent();
                        this.departmentList = this.departmentList.map(function (a) { return a.name; });
                        this.isSend = true;
                        this.isRecieve = false;
                        // } else if (this.selectedStep.type_id === 9 || this.selectedStep.type_id === 14) {
                        //     const data = await this.request.post('/sql/getLastSend', this.stepData);
                        //     if (data.resultData && data.resultData.length > 0) {
                        //         const ct_step_data_id = data.resultData[0].id;
                        //         const ct_sendList = await this.request.get('/db/ct_send?_where=(ct_step_data_id,eq,' + ct_step_data_id + ')');
                        //         for (const ct_send of ct_sendList) {
                        //             const recvData: any = {
                        //                 ct_send_id: ct_send.id,
                        //                 send_book_no: ct_send.book_no,
                        //                 send_date: ct_send.send_date,
                        //                 recv_from: ct_send.send_to,
                        //                 name: ct_send.name
                        //             };
                        //             this.recieveList.push(recvData);
                        //         }
                        //     }
                        //     this.isRecieve = true;
                        //     this.isSend = false;
                        return [3 /*break*/, 9];
                    case 8:
                        this.isSend = false;
                        this.isRecieve = false;
                        _b.label = 9;
                    case 9: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @param {?} data
     * @return {?}
     */
    ModalStepComponent.prototype.getFieldId = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        /** @type {?} */
        var id = '';
        if (data.type === 'text') {
            id += 'txt';
        }
        else if (data.type === 'datetime') {
            id += 'txt';
        }
        else {
            id += 'txt';
        }
        /** @type {?} */
        var field = data.field_name.charAt(0).toLocaleUpperCase() + data.field_name.substring(1);
        id += field;
        return id;
    };
    /**
     * @param {?} data
     * @param {?} required
     * @return {?}
     */
    ModalStepComponent.prototype.addField = /**
     * @param {?} data
     * @param {?} required
     * @return {?}
     */
    function (data, required) {
        /** @type {?} */
        var control = /** @type {?} */ (this.registerForm.controls['moreField']);
        /** @type {?} */
        var newgroup;
        this.stepData[data.field_name] = null;
        if (data.type === 'text') {
            if (required) {
                /** @type {?} */
                var group = {};
                group[data.field_name] = ['', Validators.required];
                newgroup = this.formBuilder.group(group);
            }
            else {
                /** @type {?} */
                var group = {};
                group[data.field_name] = [''];
                newgroup = this.formBuilder.group(group);
            }
        }
        else if (data.type === 'datetime') {
            if (required) {
                /** @type {?} */
                var group = {};
                group[data.field_name] = ['', Validators.required, CustomValidators.date];
                newgroup = this.formBuilder.group(group);
            }
            else {
                /** @type {?} */
                var group = {};
                group[data.field_name] = [''];
                newgroup = this.formBuilder.group(group);
            }
            this.stepData[data.field_name] = this.date.getNow();
        }
        else if (data.type === 'number') {
            if (required) {
                /** @type {?} */
                var group = {};
                group[data.field_name] = [Validators.required];
                newgroup = this.formBuilder.group(group);
            }
            else {
                /** @type {?} */
                var group = {};
                group[data.field_name] = [''];
                newgroup = this.formBuilder.group(group);
            }
        }
        else if (data.type === 'special') {
            if (data.field_name === 'amount') {
                if (required) {
                    /** @type {?} */
                    var group = {};
                    group[data.field_name] = ['', Validators.required];
                    group['amount_type'] = ['', Validators.required];
                    newgroup = this.formBuilder.group(group);
                }
                else {
                    /** @type {?} */
                    var group = {};
                    group[data.field_name] = [''];
                    group['amount_type'] = [''];
                    newgroup = this.formBuilder.group(group);
                }
            }
            else if (data.field_name === 'follow') {
                if (required) {
                    /** @type {?} */
                    var group = {};
                    group[data.field_name] = ['', Validators.required];
                    group['follow_remark'] = ['', Validators.required];
                    newgroup = this.formBuilder.group(group);
                }
                else {
                    /** @type {?} */
                    var group = {};
                    group[data.field_name] = [''];
                    group['follow_remark'] = [''];
                    newgroup = this.formBuilder.group(group);
                }
            }
            else {
                if (required) {
                    /** @type {?} */
                    var group = {};
                    group[data.field_name] = ['', Validators.required];
                    newgroup = this.formBuilder.group(group);
                }
                else {
                    /** @type {?} */
                    var group = {};
                    group[data.field_name] = [''];
                    newgroup = this.formBuilder.group(group);
                }
            }
        }
        control.push(newgroup);
    };
    /**
     * @param {?} i
     * @param {?} field
     * @param {?=} validateType
     * @return {?}
     */
    ModalStepComponent.prototype.getValidateMoreField = /**
     * @param {?} i
     * @param {?} field
     * @param {?=} validateType
     * @return {?}
     */
    function (i, field, validateType) {
        /** @type {?} */
        var formMoreField = this.f()['moreField'];
        if (validateType) {
            formMoreField = formMoreField.controls[i];
            formMoreField = formMoreField.controls[field];
            if (formMoreField.errors) {
                return formMoreField.errors[validateType];
            }
            else {
                return formMoreField.errors;
            }
        }
        else {
            return formMoreField.errors;
        }
    };
    /**
     * @param {?} data
     * @return {?}
     */
    ModalStepComponent.prototype.getRowIndex = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        if (!data.data) {
            return '';
        }
        /** @type {?} */
        var no = data.row.dataIndex + 1;
        return no;
    };
    /**
     * @param {?} e
     * @return {?}
     */
    ModalStepComponent.prototype.onCellPrepared = /**
     * @param {?} e
     * @return {?}
     */
    function (e) {
        if (e.rowType === 'data') {
            for (var i in e.component.columns) {
                if (e.column.dataField === e.component.columns[i]) {
                    e.cellElement.accessKey = e.component.columns[i];
                }
            }
        }
    };
    /**
     * @return {?}
     */
    ModalStepComponent.prototype.addSend = /**
     * @return {?}
     */
    function () {
        this.sendData.send_date = this.date.getNow();
        this.sendModal.show();
    };
    /**
     * @param {?} data
     * @return {?}
     */
    ModalStepComponent.prototype.editSend = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        this.tmpData = data;
        this.sendData = JSON.parse(JSON.stringify(data));
        // this.sendData.send_date = new Date(this.sendData.send_date);
        this.isEditSend = true;
        this.sendModal.show();
    };
    /**
     * @param {?} data
     * @return {?}
     */
    ModalStepComponent.prototype.editRecieve = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        this.tmpData = data;
        this.recieveData = JSON.parse(JSON.stringify(data));
        this.recieveData.recv_date = this.recieveData.recv_date ? new Date(this.recieveData.recv_date) : this.recieveData.recv_date;
        this.isEditRecieve = true;
        this.recieveModal.show();
    };
    /**
     * @param {?} event
     * @return {?}
     */
    ModalStepComponent.prototype.filterDepartments = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        this.filteredDepartments = [];
        for (var i = 0; i < this.departmentList.length; i++) {
            /** @type {?} */
            var department = this.departmentList[i];
            if (department.toLowerCase().indexOf(event.query.toLowerCase()) == 0) {
                this.filteredDepartments.push(department);
            }
        }
    };
    /**
     * @return {?}
     */
    ModalStepComponent.prototype.onSubmit = /**
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            var e_1, _a, e_2, _b, postData, data, userData, main, ct_send, ct_recieve, _c, _d, data_1, ct_recieve, _e, _f, data_2, postResponse, stepList;
            return __generator(this, function (_g) {
                switch (_g.label) {
                    case 0:
                        this.submitted = true;
                        // ถ้า form ไม่ครบหรือผิดตามเงื่อนไขที่ตั้งไว้จะจบที่ตรงนี้
                        console.log('this.registerForm.invalid: ', this.registerForm.invalid);
                        if (this.registerForm.invalid) {
                            return [2 /*return*/];
                        }
                        postData = [];
                        data = cloneDeep(this.stepData);
                        data.action = "add";
                        userData = this.b2bService.getVerifyToken();
                        data.username = userData.username;
                        if (data.remind_date)
                            data.remind_date = this.date.getNow().add(data.remind_date, 'd').toDate();
                        delete data["ct_main_id"];
                        delete data["update_date"];
                        main = {
                            "ct_step_data": [data]
                        };
                        postData.push(main);
                        if (this.sendList && this.sendList.length > 0) {
                            ct_send = {
                                "ct_send": []
                            };
                            ct_recieve = {
                                "ct_recieve": []
                            };
                            try {
                                for (_c = __values(this.sendList), _d = _c.next(); !_d.done; _d = _c.next()) {
                                    data_1 = _d.value;
                                    data_1.name = data_1.name;
                                    data_1.action = "add";
                                    delete data_1.id;
                                    ct_send.ct_send.push(data_1);
                                }
                            }
                            catch (e_1_1) { e_1 = { error: e_1_1 }; }
                            finally {
                                try {
                                    if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
                                }
                                finally { if (e_1) throw e_1.error; }
                            }
                            postData.push(ct_send);
                        }
                        if (this.recieveList && this.recieveList.length > 0) {
                            ct_recieve = {
                                "ct_recieve": []
                            };
                            try {
                                for (_e = __values(this.recieveList), _f = _e.next(); !_f.done; _f = _e.next()) {
                                    data_2 = _f.value;
                                    delete data_2['send_book_no'];
                                    delete data_2['send_date'];
                                    data_2.name = data_2.name;
                                    data_2.action = "add";
                                    ct_recieve.ct_recieve.push(data_2);
                                }
                            }
                            catch (e_2_1) { e_2 = { error: e_2_1 }; }
                            finally {
                                try {
                                    if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
                                }
                                finally { if (e_2) throw e_2.error; }
                            }
                            postData.push(ct_recieve);
                        }
                        console.log('postData', postData);
                        return [4 /*yield*/, this.request.post("/ct/main", postData)];
                    case 1:
                        postResponse = _g.sent();
                        if (!this.stepData.update_date) return [3 /*break*/, 5];
                        return [4 /*yield*/, this.getStepList()];
                    case 2:
                        stepList = _g.sent();
                        console.log("stepList", stepList);
                        if (!(stepList.length > 0)) return [3 /*break*/, 4];
                        return [4 /*yield*/, this.request.put("/db/" + this.stepData.ref_table + "/" + this.stepData.ref_id, { status: stepList[0].step_name, status_date: stepList[0].step_date })];
                    case 3:
                        _g.sent();
                        this.common.fnCheckResponse(postResponse, this.myModal);
                        _g.label = 4;
                    case 4: return [3 /*break*/, 7];
                    case 5: return [4 /*yield*/, this.request.put("/db/" + this.stepData.ref_table + "/" + this.stepData.ref_id, { status: this.stepData.step_name })];
                    case 6:
                        _g.sent();
                        this.common.fnCheckResponse(postResponse, this.myModal);
                        _g.label = 7;
                    case 7:
                        // }else{
                        //     this.onCreateModal.emit(postData);
                        // }
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @return {?}
     */
    ModalStepComponent.prototype.getStepList = /**
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            var filter$$1, data;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        console.log('getStepList');
                        filter$$1 = {
                            filter: {
                                ref_table: "=" + this.stepData.ref_table,
                                ref_id: this.stepData.ref_id,
                                system_id: this.stepData.system_id
                            },
                            order_by: ["step_date desc"]
                        };
                        return [4 /*yield*/, this.request.post('/search/ct_step_data', filter$$1)];
                    case 1:
                        data = _a.sent();
                        return [2 /*return*/, data.resultData || []];
                }
            });
        });
    };
    /**
     * @return {?}
     */
    ModalStepComponent.prototype.onClickBack = /**
     * @return {?}
     */
    function () {
        this.onUpdateModal.emit();
        this.closeModal();
    };
    /**
     * @return {?}
     */
    ModalStepComponent.prototype.onSubmitSend = /**
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            var e_3, _a, tmpList, _b, _c, tmpSend;
            return __generator(this, function (_d) {
                this.submittedSend = true;
                // ถ้า form ไม่ครบหรือผิดตามเงื่อนไขที่ตั้งไว้จะจบที่ตรงนี้
                if (this.sendForm.invalid) {
                    return [2 /*return*/];
                }
                if (this.isEditSend) {
                    tmpList = [];
                    try {
                        for (_b = __values(this.sendList), _c = _b.next(); !_c.done; _c = _b.next()) {
                            tmpSend = _c.value;
                            if (tmpSend.id === this.tmpData.id) {
                                tmpList.push(this.sendData);
                            }
                            else {
                                tmpList.push(tmpSend);
                            }
                        }
                    }
                    catch (e_3_1) { e_3 = { error: e_3_1 }; }
                    finally {
                        try {
                            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                        }
                        finally { if (e_3) throw e_3.error; }
                    }
                    this.sendList = tmpList;
                }
                else {
                    this.sendData.id = this.tempId;
                    this.tempId--;
                    this.sendList.push(this.sendData);
                }
                this.closeSendModal();
                return [2 /*return*/];
            });
        });
    };
    /**
     * @return {?}
     */
    ModalStepComponent.prototype.onSubmitRecieve = /**
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            var e_4, _a, tmpList, _b, _c, tmpSend;
            return __generator(this, function (_d) {
                this.submittedSend = true;
                // ถ้า form ไม่ครบหรือผิดตามเงื่อนไขที่ตั้งไว้จะจบที่ตรงนี้
                if (this.recieveForm.invalid) {
                    return [2 /*return*/];
                }
                if (this.isEditRecieve) {
                    tmpList = [];
                    try {
                        for (_b = __values(this.recieveList), _c = _b.next(); !_c.done; _c = _b.next()) {
                            tmpSend = _c.value;
                            if (tmpSend.recv_from === this.tmpData.recv_from) {
                                tmpList.push(this.recieveData);
                            }
                            else {
                                tmpList.push(tmpSend);
                            }
                        }
                    }
                    catch (e_4_1) { e_4 = { error: e_4_1 }; }
                    finally {
                        try {
                            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                        }
                        finally { if (e_4) throw e_4.error; }
                    }
                    this.recieveList = tmpList;
                }
                else {
                    this.recieveList.push(this.recieveData);
                }
                this.closeRecieveModal();
                return [2 /*return*/];
            });
        });
    };
    /**
     * @param {?} data
     * @return {?}
     */
    ModalStepComponent.prototype.isImportant = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        return data.is_important ? "สำคัญ" : "";
    };
    /**
     * @param {?} data
     * @return {?}
     */
    ModalStepComponent.prototype.onUploaded = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        this.stepData.url = this.attachmentUrl + '/' + data.uuid;
        this.stepData.uuid = data.uuid;
    };
    /**
     * @param {?} field
     * @return {?}
     */
    ModalStepComponent.prototype.checkDisable = /**
     * @param {?} field
     * @return {?}
     */
    function (field) {
        if (this.stepData[field.field_name] !== 'ไม่ทางการ') {
            return true;
        }
        else {
            return false;
        }
    };
    /**
     * @param {?} data
     * @return {?}
     */
    ModalStepComponent.prototype.getImageLink = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var url;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.request.getAttachmentLinkToken(data.url)];
                    case 1:
                        url = _a.sent();
                        return [2 /*return*/, url];
                }
            });
        });
    };
    ModalStepComponent.decorators = [
        { type: Component, args: [{
                    selector: 'modal-step',
                    template: "<div class=\"modal fade\" bsModal #modal=\"bs-modal\" [config]=\"{backdrop: 'static'}\"\n     tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"dialog-static-name1\">\n    <div class=\"modal-dialog modal-lg\">\n        <div class=\"modal-content\">\n            <div class=\"modal-header\">\n                <h4 id=\"dialog-static-name\" class=\"modal-title pull-left\"><label>{{title}}</label></h4>\n                <button type=\"button\" class=\"close pull-right\" aria-label=\"Close\" (click)=\"closeModal()\">\n                    <span aria-hidden=\"true\">&times;</span>\n                </button>\n            </div>\n            <div class=\"modal-body\">\n                <div class=\"row\">\n                    <div class=\"col-lg-12\">\n                        <form class=\"m-form m-form--state m-form--fit m-form--label-align-right\" [formGroup]=\"registerForm\" (ngSubmit)=\"onSubmit()\">\n                            <div class=\"m-portlet__body\">\n\n                                <!-- \u0E2A\u0E16\u0E32\u0E19\u0E30\u0E25\u0E48\u0E32\u0E2A\u0E38\u0E14 -->\n                                <div class=\"row\">\n                                    <!--<div class=\"col-sm-3\">-->\n                                        <!--<span>\u0E2A\u0E16\u0E32\u0E19\u0E30\u0E1B\u0E31\u0E08\u0E08\u0E38\u0E1A\u0E31\u0E19 :</span>-->\n                                    <!--</div>-->\n                                    <div class=\"col-sm-6\">\n                                        <div class=\"form-group m-form__group\" [ngClass]=\"{ 'has-error': submitted && f().lastStep.errors }\">\n                                            <label class=\"control-label\">\u0E2A\u0E16\u0E32\u0E19\u0E30\u0E1B\u0E31\u0E08\u0E08\u0E38\u0E1A\u0E31\u0E19</label>\n                                            <input type=\"text\" formControlName=\"lastStep\" class=\"form-control m-input\" id=\"txtLastStatus\" [(ngModel)]=\"lastStep\" disabled>\n                                        </div>\n                                    </div>\n                                    <div class=\"col-sm-6\">\n                                        <!--<select id=\"selNewStatus\" style=\"width: 100%\">-->\n                                        <div class=\"form-group m-form__group\" [ngClass]=\"{ 'has-error': submitted && f().step_id.errors }\">\n                                            <label class=\"control-label\">\u0E2A\u0E16\u0E32\u0E19\u0E30\u0E43\u0E2B\u0E21\u0E48<span class=\"color-red\">&nbsp;*</span></label>\n                                            <select id=\"selNewStatus\" class=\"form-control\" style=\"width: 100%\" [(ngModel)]=\"selectedStep\" formControlName=\"step_id\" (change)=\"checkExtraField()\">\n                                                <option value=\"null\">\u0E01\u0E23\u0E38\u0E13\u0E32\u0E40\u0E25\u0E37\u0E2D\u0E01\u0E23\u0E32\u0E22\u0E01\u0E32\u0E23</option>\n                                                <option *ngFor=\"let step of selectList\" [ngValue]=\"step\">{{step.name}}</option>\n                                            </select>\n                                            <!-- <div *ngIf=\"submitted && f().step_id.errors\" class=\"invalid-feedback\">\n                                                <div *ngIf=\"f().step_id.errors.required\"><font color=\"red\"> * \u0E01\u0E23\u0E38\u0E13\u0E32\u0E01\u0E23\u0E2D\u0E01</font></div>\n                                            </div> -->\n                                        </div>\n                                    </div>\n                                </div>\n                                <br>\n                                <!--<div class=\"row\">-->\n                                    <!-- \u0E2A\u0E16\u0E32\u0E19\u0E30\u0E43\u0E2B\u0E21\u0E48 -->\n                                    <!--<div class=\"col-sm-3\">-->\n                                        <!--<span>\u0E2A\u0E16\u0E32\u0E19\u0E30\u0E43\u0E2B\u0E21\u0E48 :</span>-->\n                                    <!--</div>-->\n                                <!--</div>-->\n                                <!--<br>-->\n                                <div class=\"row\">\n                                    <!-- \u0E27\u0E31\u0E19\u0E14\u0E33\u0E40\u0E19\u0E34\u0E19\u0E01\u0E32\u0E23 -->\n                                    <!--<div class=\"col-sm-3\">-->\n                                        <!--<span>\u0E27\u0E31\u0E19\u0E17\u0E35\u0E48\u0E14\u0E33\u0E40\u0E19\u0E34\u0E19\u0E01\u0E32\u0E23 :</span>-->\n                                    <!--</div>-->\n                                    <div class=\"col-sm-6\">\n                                        <div class=\"form-group m-form__group\" [ngClass]=\"{ 'has-error': submitted && f().step_date.errors }\">\n                                            <label class=\"control-label\" *ngIf=\"stepData.system_id === 161\">\u0E27\u0E31\u0E19\u0E17\u0E35\u0E48</label>\n                                            <label class=\"control-label\" *ngIf=\"stepData.system_id !== 161\">\u0E27\u0E31\u0E19\u0E17\u0E35\u0E48\u0E14\u0E33\u0E40\u0E19\u0E34\u0E19\u0E01\u0E32\u0E23</label>\n                                            <soc-date-box [id]=\"'txtDate'\" [(value)]=\"stepData.step_date\"></soc-date-box>\n                                            <div *ngIf=\"submitted && f().step_date.errors\" >\n                                                <div *ngIf=\"f().step_date.errors.required\" class=\"lable-error\">Date is required</div>\n                                                <div *ngIf=\"f().step_date.errors.date\" class=\"lable-error\">Date is invalid</div>\n                                            </div>\n                                        </div>\n                                    </div>\n                                </div>\n                                <br>\n                                \n                                \n                                \n                                <!--<div class=\"row\" *ngIf=\"stepData.system_id === 23\">-->\n                                    <!-- \u0E27\u0E31\u0E19\u0E14\u0E33\u0E40\u0E19\u0E34\u0E19\u0E01\u0E32\u0E23 -->\n                                    <!--<div class=\"col-sm-3\">-->\n                                        <!--<span>\u0E27\u0E31\u0E19\u0E17\u0E35\u0E48\u0E14\u0E33\u0E40\u0E19\u0E34\u0E19\u0E01\u0E32\u0E23 :</span>-->\n                                    <!--</div>-->\n                                <!--    <div class=\"col-sm-6\">-->\n                                <!--      <label class=\"control-label\">\u0E40\u0E25\u0E02\u0E17\u0E35\u0E48\u0E2B\u0E19\u0E31\u0E07\u0E2A\u0E37\u0E2D</label>-->\n                                <!--      <input type=\"text\" class=\"form-control m-input\" id=\"book_no\" [(ngModel)]=\"stepData.book_no\"-->\n                                <!--      formControlName=\"book_no\">-->\n                                <!--  </div>-->\n                                <!--  <div class=\"col-sm-6\">-->\n                                <!--      <label class=\"control-label\">\u0E25\u0E07\u0E27\u0E31\u0E19\u0E17\u0E35\u0E48</label>-->\n                                <!--      <soc-date-box [id]=\"'book_date'\" [(value)]=\"stepData.book_date\" formControlName=\"book_date\"></soc-date-box>-->\n                                      <!-- <input type=\"text\" class=\"form-control m-input\" id=\"book_date\" [(ngModel)]=\"stepData.book_date\"-->\n                                <!--      formControlName=\"book_date\"> -->\n                                <!--  </div>-->\n\n                                <!--</div>-->\n                                <!--<br>-->\n                                <!--<div class=\"row\" *ngIf=\"stepData.system_id === 23\">-->\n                                    <!-- \u0E27\u0E31\u0E19\u0E14\u0E33\u0E40\u0E19\u0E34\u0E19\u0E01\u0E32\u0E23 -->\n                                    <!--<div class=\"col-sm-3\">-->\n                                        <!--<span>\u0E27\u0E31\u0E19\u0E17\u0E35\u0E48\u0E14\u0E33\u0E40\u0E19\u0E34\u0E19\u0E01\u0E32\u0E23 :</span>-->\n                                    <!--</div>-->\n                                <!--     <div class=\"col-sm-6\">-->\n                                <!--        <label class=\"control-label\">\u0E40\u0E25\u0E02\u0E17\u0E35\u0E48\u0E23\u0E31\u0E1A \u0E2A\u0E25\u0E04.</label>-->\n                                <!--        <input type=\"text\" class=\"form-control m-input\" id=\"soc_recv_no\" formControlName=\"soc_recv_no\" [(ngModel)]=\"stepData.soc_recv_no\">-->\n                                <!--    </div>-->\n                                <!--    <div class=\"col-sm-6\">-->\n                                <!--        <label class=\"control-label\">\u0E27\u0E31\u0E19\u0E17\u0E35\u0E48\u0E23\u0E31\u0E1A \u0E2A\u0E25\u0E04.</label>-->\n                                <!--        <soc-date-box [id]=\"'soc_recv_date'\" [(value)]=\"stepData.soc_recv_date\" formControlName=\"soc_recv_date\"></soc-date-box>-->\n                                <!--    </div>-->\n                                <!--</div>-->\n                                <!--<br>-->\n                                <!--<div class=\"row\" *ngIf=\"stepData.system_id === 23\">-->\n                                    <!-- \u0E27\u0E31\u0E19\u0E14\u0E33\u0E40\u0E19\u0E34\u0E19\u0E01\u0E32\u0E23 -->\n                                    <!--<div class=\"col-sm-3\">-->\n                                        <!--<span>\u0E27\u0E31\u0E19\u0E17\u0E35\u0E48\u0E14\u0E33\u0E40\u0E19\u0E34\u0E19\u0E01\u0E32\u0E23 :</span>-->\n                                    <!--</div>-->\n                                <!--     <div class=\"col-sm-6\">-->\n                                <!--      <label class=\"control-label\">\u0E2B\u0E19\u0E48\u0E27\u0E22\u0E07\u0E32\u0E19\u0E17\u0E35\u0E48\u0E23\u0E31\u0E1A-\u0E2A\u0E48\u0E07</label>-->\n                                <!--      <input type=\"text\" class=\"form-control m-input\" id=\"dept_name\" [(ngModel)]=\"stepData.dept_name\" formControlName=\"dept_name\">-->\n                                <!--  </div>-->\n                                <!--</div>-->\n                                <!--<br>-->\n                                \n                                \n                                \n                                <div class=\"row\" *ngIf=\"stepData.system_id === 23\">\n                                    <div class=\"col-sm-6\">\n                                        <label class=\"control-label\">\u0E40\u0E25\u0E02\u0E17\u0E35\u0E48\u0E23\u0E31\u0E1A \u0E2A\u0E25\u0E04.</label>\n                                        <input type=\"text\" class=\"form-control m-input\" id=\"soc_recv_no\" formControlName=\"soc_recv_no\" [(ngModel)]=\"stepData.soc_recv_no\">\n                                    </div>\n                                    <div class=\"col-sm-6\">\n                                        <label class=\"control-label\">\u0E27\u0E31\u0E19\u0E17\u0E35\u0E48\u0E23\u0E31\u0E1A \u0E2A\u0E25\u0E04.</label>\n                                        <soc-date-box [id]=\"'soc_recv_date'\" [(value)]=\"stepData.soc_recv_date\" formControlName=\"soc_recv_date\"></soc-date-box>\n                                    </div>\n                                </div>\n                                <br>\n                                <div class=\"row\" *ngIf=\"stepData.system_id === 23\">\n                                    <div class=\"col-sm-6\">\n                                        <label class=\"control-label\">\u0E40\u0E25\u0E02\u0E17\u0E35\u0E48\u0E23\u0E31\u0E1A \u0E01\u0E2D\u0E04.</label>\n                                        <input type=\"text\" class=\"form-control m-input\" id=\"gtc_recv_no\" [(ngModel)]=\"stepData.gtc_recv_no\" formControlName=\"gtc_recv_no\">\n                                    </div>\n                                    <div class=\"col-sm-6\">\n                                        <label class=\"control-label\">\u0E27\u0E31\u0E19\u0E17\u0E35\u0E48\u0E23\u0E31\u0E1A \u0E01\u0E2D\u0E04.</label>\n                                        <soc-date-box [id]=\"'gtc_recv_date'\" [(value)]=\"stepData.gtc_recv_date\" formControlName=\"gtc_recv_date\"></soc-date-box>\n                                    </div>\n                                </div>\n                                <br>\n                                <div class=\"row\" *ngIf=\"stepData.system_id === 23\">\n                                  <div class=\"col-sm-6\">\n                                      <label class=\"control-label\">\u0E40\u0E25\u0E02\u0E17\u0E35\u0E48\u0E2B\u0E19\u0E31\u0E07\u0E2A\u0E37\u0E2D</label>\n                                      <input type=\"text\" class=\"form-control m-input\" id=\"book_no\" [(ngModel)]=\"stepData.book_no\"\n                                      formControlName=\"book_no\">\n                                  </div>\n                                  <div class=\"col-sm-6\">\n                                      <label class=\"control-label\">\u0E25\u0E07\u0E27\u0E31\u0E19\u0E17\u0E35\u0E48</label>\n                                      <soc-date-box [id]=\"'book_date'\" [(value)]=\"stepData.book_date\" formControlName=\"book_date\"></soc-date-box>\n                                      <!-- <input type=\"text\" class=\"form-control m-input\" id=\"book_date\" [(ngModel)]=\"stepData.book_date\"\n                                      formControlName=\"book_date\"> -->\n                                  </div>\n                                </div>\n                                <br>\n                                <div class=\"row\" *ngIf=\"stepData.system_id === 23\">\n                                    <div class=\"col-sm-6\">\n                                        <label class=\"control-label\">\u0E40\u0E23\u0E35\u0E22\u0E19</label>\n                                        <input type=\"text\" class=\"form-control m-input\" id=\"for\" [(ngModel)]=\"stepData.for\" formControlName=\"for\">\n                                    </div>\n\n                                </div>\n                                <br>\n                                <div class=\"row\" *ngIf=\"stepData.system_id === 23\">\n                                    <div class=\"col-sm-6\">\n                                        <label class=\"control-label\">\u0E01\u0E23\u0E30\u0E17\u0E23\u0E27\u0E07</label>\n                                        <soc-auto-complete-2 [id]=\"'ministry'\"  mode=\"local\"\n                                          [api]=\"'/db/ct_ext_department'\" [acceptCustomValue]=\"false\" field=\"name\" fieldApi=\"id,name,code,type\"\n                                          [filter]=\"'&_where=(type,in,1,9)'\" (valueSelete)=\"valueSeleteMinistry($event)\"\n                                          [(value)]=\"stepData.ministry\" [(ngModel)]=\"stepData.ministry\"\n                                          formControlName=\"ministry\">\n                                        </soc-auto-complete-2>\n                                    </div>\n                                    <div class=\"col-sm-6\">\n                                        <label class=\"control-label\">\u0E01\u0E23\u0E21</label>\n                                        <div *ngIf=\"filter_ref_ext_department_id_show\">\n                                        <soc-auto-complete-2 [acceptCustomValue]=\"false\" [id]=\"'dept_name'\"\n                                          mode=\"local\" [filter]=\"filter_ref_ext_department_id\"\n                                           [api]=\"'/db/ct_ext_department'\" field=\"name\"\n                                          fieldApi=\"id,name,code,type\" [(value)]=\"stepData.dept_name\" (valueSelete)=\"valueSeleteDeptName($event)\"\n                                          [(ngModel)]=\"stepData.dept_name\" [disabled]=\"!filter_ref_ext_department_id\"\n                                          formControlName=\"dept_name\">\n                                        </soc-auto-complete-2>\n                                        </div>\n                                    </div>\n\n                                </div>\n                                <br>\n                                \n                                <!-- \u0E2B\u0E21\u0E32\u0E22\u0E40\u0E2B\u0E15\u0E38 -->\n                                <div class=\"row\">\n                                    <!--<div class=\"col-sm-3\">-->\n                                        <!--<span>\u0E2B\u0E21\u0E32\u0E22\u0E40\u0E2B\u0E15\u0E38 :</span>-->\n                                    <!--</div>-->\n                                    <div class=\"col-sm-12\">\n                                        <div class=\"form-group m-form__group\" [ngClass]=\"{ 'has-error': submitted && f().remark.errors }\">\n                                            <label class=\"control-label\">\u0E2B\u0E21\u0E32\u0E22\u0E40\u0E2B\u0E15\u0E38</label>\n                                            <textarea class=\"form-control m-input\" id=\"txtRemark\" rows=\"5\" formControlName=\"remark\" [(ngModel)]=\"stepData.remark\"></textarea>\n                                        </div>\n                                    </div>\n                                </div>\n                                <br>\n                                <!-- \u0E40\u0E2D\u0E01\u0E2A\u0E32\u0E23\u0E41\u0E19\u0E1A -->\n                                <div class=\"row\">\n                                    <!--<div class=\"col-sm-3\">-->\n                                        <!--<span>\u0E40\u0E2D\u0E01\u0E2A\u0E32\u0E23\u0E41\u0E19\u0E1A :</span>-->\n                                    <!--</div>-->\n                                    <div class=\"col-sm-12\">\n                                        <label class=\"control-label\">\u0E40\u0E2D\u0E01\u0E2A\u0E32\u0E23\u0E41\u0E19\u0E1A</label>\n                                        <upload-attachment #uploadAttachment [systemId]=\"stepData.system_id\" (uploaded)=\"onUploaded($event)\"></upload-attachment>\n                                        <!--<dx-tab-panel-->\n                                                <!--#tabPanel-->\n                                                <!--[items]=\"upLoadType\"-->\n                                                <!--[selectedIndex]=\"0\"-->\n                                                <!--[loop]=\"false\"-->\n                                                <!--[animationEnabled]=\"false\"-->\n                                                <!--[swipeEnabled]=\"false\"-->\n                                                <!--itemTemplate=\"itemTemplate\"-->\n                                        <!--&gt;-->\n                                            <!--&lt;!&ndash;<div *dxTemplate=\"let type of upLoadType\">&ndash;&gt;-->\n                                                <!--&lt;!&ndash;<span>{{type.name.toUpperCase()}}</span>&ndash;&gt;-->\n                                            <!--&lt;!&ndash;</div>&ndash;&gt;-->\n                                            <!--<div *dxTemplate=\"let item of 'itemTemplate'\">-->\n                                                <!--<div class=\"tabpanel-item\">-->\n                                                    <!--<div *ngIf=\"item.type === 1\">-->\n                                                        <!--<div class=\"col-sm-10\" style=\"text-align: center\">-->\n                                                            <!--<dx-file-uploader selectButtonText=\"\u0E40\u0E25\u0E37\u0E2D\u0E01\u0E44\u0E1F\u0E25\u0E4C\" labelText=\"\" accept=\"*\" uploadMode=\"useForm\" uploadMethod=\"POST\"-->\n                                                                              <!--multiple=\"true\" uploadMode=\"instantly\" labelText=\"\u0E2B\u0E23\u0E37\u0E2D\u0E27\u0E32\u0E07\u0E44\u0E1F\u0E25\u0E4C\u0E17\u0E35\u0E48\u0E19\u0E35\u0E48\" uploadUrl=\"https://filemanager-dot-smartrms-api.appspot.com/api/http/upload\"-->\n                                                            <!--&gt;-->\n                                                            <!--</dx-file-uploader>-->\n                                                        <!--</div>-->\n                                                    <!--</div>-->\n                                                <!--</div>-->\n                                            <!--</div>-->\n                                        <!--</dx-tab-panel>-->\n                                    </div>\n                                </div>\n                                <br>\n                                <!-- field \u0E40\u0E1E\u0E34\u0E48\u0E21\u0E40\u0E15\u0E34\u0E21 -->\n                                <div *ngIf=\"isMore\">\n                                    <div formArrayName=\"moreField\">\n                                        <div *ngFor=\"let field of moreField; let i=index\">\n                                            <div [formGroupName]=\"i\">\n                                                <div class=\"row\">\n                                                    <!--<div class=\"col-sm-3\">-->\n                                                        <!--<span>field.display_name :</span>-->\n                                                    <!--</div>-->\n                                                    <!-- field \u0E40\u0E1E\u0E34\u0E48\u0E21\u0E40\u0E15\u0E34\u0E21 type text -->\n                                                    <div *ngIf=\"field.type === 'text'\">\n                                                        <div class=\"col-sm-12\">\n                                                            <div class=\"form-group m-form__group\" [ngClass]=\"{ 'has-error': submitted && getValidateMoreField(i,field.field_name) }\">\n                                                                <label class=\"control-label\">{{field.display_name}}</label>\n                                                                <input type=\"text\" class=\"form-control m-input\" [id]=\"getFieldId(field)\" [formControlName]=\"field.field_name\" [(ngModel)]=\"stepData[field.field_name]\">\n                                                                <div *ngIf=\"submitted && getValidateMoreField(i,field.field_name)\" class=\"invalid-feedback\">\n                                                                    <div *ngIf=\"getValidateMoreField(i,field.field_name,'required')\"><font color=\"red\"> * \u0E01\u0E23\u0E38\u0E13\u0E32\u0E01\u0E23\u0E2D\u0E01</font></div>\n                                                                </div>\n                                                            </div>\n                                                        </div>\n                                                    </div>\n                                                    <!-- field \u0E40\u0E1E\u0E34\u0E48\u0E21\u0E40\u0E15\u0E34\u0E21 type datetime -->\n                                                    <div *ngIf=\"field.type === 'datetime'\">\n\n                                                        <div class=\"col-sm-6\">\n                                                            <div class=\"form-group m-form__group\" [ngClass]=\"{ 'has-error': submitted && getValidateMoreField(i,field.field_name) }\">\n                                                                <label class=\"control-label\">{{field.display_name}}</label>\n                                                                <soc-date-box  [id]=\"getFieldId(field)\" [(value)]=\"stepData[field.field_name]\"></soc-date-box>\n                                                                <!--<div *ngIf=\"getValidateMoreField(i,field.field_name,'required')\" class=\"lable-error\">Date is required</div>-->\n                                                                <!--<div *ngIf=\"getValidateMoreField(i,field.field_name,'date')\" class=\"lable-error\">Date is invalid</div>-->\n                                                            </div>\n                                                        </div>\n                                                    </div>\n                                                    <div *ngIf=\"field.type === 'number'\">\n                                                        <div class=\"col-sm-4\">\n                                                            <div class=\"form-group m-form__group\" [ngClass]=\"{ 'has-error': submitted && getValidateMoreField(i,field.field_name) }\">\n                                                                <label class=\"control-label\">{{field.display_name}}</label>\n                                                                <div class=\"input-group\">\n                                                                    <input type=\"number\" class=\"form-control m-input\" [id]=\"getFieldId(field)\" [formControlName]=\"field.field_name\" [(ngModel)]=\"stepData[field.field_name]\">\n                                                                    <div *ngIf=\"field.field_name === 'remind_date'\" class=\"input-group-addon\"><span>\u0E27\u0E31\u0E19</span></div>\n                                                                </div>\n                                                                <div *ngIf=\"submitted && getValidateMoreField(i,field.field_name)\" class=\"invalid-feedback\">\n                                                                    <div *ngIf=\"getValidateMoreField(i,field.field_name,'required')\"><font color=\"red\"> * \u0E01\u0E23\u0E38\u0E13\u0E32\u0E01\u0E23\u0E2D\u0E01</font></div>\n                                                                </div>\n                                                            </div>\n                                                        </div>\n                                                        <!--<div class=\"col-sm-2\" *ngIf=\"field.field_name === 'remind_date'\">-->\n                                                            <!--<span>\u0E27\u0E31\u0E19</span>-->\n                                                        <!--</div>-->\n                                                    </div>\n                                                    <div *ngIf=\"field.type === 'special'\">\n                                                        <div *ngIf=\"field.field_name === 'term'\">\n\n                                                        </div>\n                                                        <div *ngIf=\"field.field_name === 'amount'\">\n                                                            <div class=\"col-sm-6\">\n                                                                <div class=\"form-group m-form__group\" [ngClass]=\"{ 'has-error': submitted && getValidateMoreField(i,field.field_name) }\">\n                                                                    <label class=\"control-label\">{{field.display_name}}</label>\n                                                                    <input type=\"number\" class=\"form-control m-input\" [id]=\"getFieldId(field)\" [formControlName]=\"field.field_name\" [(ngModel)]=\"stepData[field.field_name]\">\n                                                                    <div *ngIf=\"submitted && getValidateMoreField(i,field.field_name)\" class=\"invalid-feedback\">\n                                                                        <div *ngIf=\"getValidateMoreField(i,field.field_name,'required')\"><font color=\"red\"> * \u0E01\u0E23\u0E38\u0E13\u0E32\u0E01\u0E23\u0E2D\u0E01</font></div>\n                                                                    </div>\n                                                                </div>\n                                                            </div>\n                                                            <div class=\"col-sm-6\">\n                                                                <div class=\"form-group m-form__group\" [ngClass]=\"{ 'has-error': submitted && getValidateMoreField(i,'amount_type') }\">\n                                                                    <div class=\"m-radio-inline\">\n                                                                        <label class=\"m-radio\">\n                                                                            <input type=\"radio\" id=\"rdlAmountType1\" name=\"amount_type\" value=\"0\" [formControlName]=\"'amount_type'\" [(ngModel)]=\"stepData['amount_type']\" checked>\n                                                                            \u0E19\u0E31\u0E1A\u0E41\u0E15\u0E48<span></span>\n                                                                        </label>\n                                                                        <label class=\"m-radio\">\n                                                                            <input type=\"radio\" id=\"rdlAmountType2\" name=\"amount_type\" value=\"1\" [formControlName]=\"'amount_type'\" [(ngModel)]=\"stepData['amount_type']\">\n                                                                            \u0E19\u0E31\u0E1A\u0E16\u0E31\u0E14<span></span>\n                                                                        </label>\n                                                                    </div>\n                                                                </div>\n                                                            </div>\n                                                        </div>\n                                                        <div *ngIf=\"field.field_name === 'follow'\">\n                                                            <div class=\"col-sm-6\">\n                                                                <div class=\"form-group m-form__group\" [ngClass]=\"{ 'has-error': submitted && getValidateMoreField(i,'amount_type') }\">\n                                                                    <label class=\"control-label\">{{field.display_name}}</label>\n                                                                    <div class=\"m-radio-inline\">\n                                                                        <label class=\"m-radio\">\n                                                                            <input type=\"radio\" [id]=\"getFieldId(field) + '1'\" [name]=\"field.field_name\" value=\"\u0E17\u0E32\u0E07\u0E01\u0E32\u0E23\" [formControlName]=\"field.field_name\" [(ngModel)]=\"stepData[field.field_name]\" checked>\n                                                                            \u0E17\u0E32\u0E07\u0E01\u0E32\u0E23<span></span>\n                                                                        </label>\n                                                                        <label class=\"m-radio\">\n                                                                            <input type=\"radio\" [id]=\"getFieldId(field) + '2'\" [name]=\"field.field_name\" value=\"\u0E44\u0E21\u0E48\u0E17\u0E32\u0E07\u0E01\u0E32\u0E23\" [formControlName]=\"field.field_name\" [(ngModel)]=\"stepData[field.field_name]\">\n                                                                            \u0E44\u0E21\u0E48\u0E17\u0E32\u0E07\u0E01\u0E32\u0E23<span></span>\n                                                                        </label>\n                                                                    </div>\n                                                                </div>\n                                                            </div>\n                                                            <!--<div class=\"col-sm-3\">-->\n                                                                <!--<span>\u0E2B\u0E21\u0E32\u0E22\u0E40\u0E2B\u0E15\u0E38 :</span>-->\n                                                            <!--</div>-->\n                                                            <div class=\"col-sm-6\">\n                                                                <div class=\"form-group m-form__group\" [ngClass]=\"{ 'has-error': submitted && getValidateMoreField(i,'follow_remark') }\">\n                                                                    <label class=\"control-label\">\u0E2B\u0E21\u0E32\u0E22\u0E40\u0E2B\u0E15\u0E38</label>\n                                                                    <input type=\"text\" class=\"form-control m-input\" id=\"txtFollowRemark\" [formControlName]=\"'follow_remark'\" [(ngModel)]=\"stepData['follow_remark']\" [disableControl]=\"checkDisable(field)\">\n                                                                    <!--<div *ngIf=\"submitted && getValidateMoreField(i,'follow_remark')\" class=\"invalid-feedback\">-->\n                                                                        <!--<div *ngIf=\"getValidateMoreField(i,'follow_remark','required')\">First Name is required</div>-->\n                                                                    <!--</div>-->\n                                                                </div>\n                                                            </div>\n                                                        </div>\n                                                        <div *ngIf=\"field.field_name === 'cause'\">\n                                                            <div class=\"col-sm-6\">\n                                                                <div class=\"form-group m-form__group\" [ngClass]=\"{ 'has-error': submitted && getValidateMoreField(i,field.field_name) }\">\n                                                                    <label class=\"control-label\">{{field.display_name}}</label>\n                                                                    <soc-auto-complete id=\"'txtCause'\" mode=\"local\" [orderBy]=\"'name'\" [filter]=\"causeFilter\"\n                                                                                       [api]=\"causeUrl\" field=\"name\" [(value)]=\"stepData['cause']\"></soc-auto-complete>\n                                                                    <div *ngIf=\"submitted && getValidateMoreField(i,field.field_name)\" class=\"invalid-feedback\">\n                                                                        <div *ngIf=\"getValidateMoreField(i,field.field_name,'required')\"><font color=\"red\"> * \u0E01\u0E23\u0E38\u0E13\u0E32\u0E01\u0E23\u0E2D\u0E01</font></div>\n                                                                    </div>\n                                                                </div>\n                                                            </div>\n                                                        </div>\n                                                    </div>\n                                                </div>\n                                            </div>\n                                        </div>\n                                        <br>\n                                    </div>\n                                </div>\n                                <div *ngIf=\"isSend\">\n                                    <div class=\"row\">\n                                        <div class=\"col-sm-3\">\n                                            <span>\u0E23\u0E32\u0E22\u0E01\u0E32\u0E23\u0E2A\u0E48\u0E07 :</span>\n                                        </div>\n                                        <div class=\"col-sm-9\">\n                                            <!--<a id=\"btnSendAdd\" (click)=\"sendModal.show()\" class=\"btn btn-default btn-sm icon\" data-toggle=\"tooltip\" data-placement=\"top\" title=\"Add\"><i class=\"fal fa-plus\"></i></a>-->\n                                            <a id=\"btnSendAdd\" class=\"btn btn-default btn-md btn-md-search\" (click)=\"addSend()\">\u0E40\u0E1E\u0E34\u0E48\u0E21\u0E23\u0E32\u0E22\u0E01\u0E32\u0E23\u0E2A\u0E48\u0E07</a>\n                                        </div>\n                                    </div>\n                                    <br>\n                                    <dx-data-grid #dxDataGridStepSendList class=\"card-list-table\"\n                                                  id=\"gridStepSendList\" noDataText=\"\"\n                                                  (onCellPrepared)=\"onCellPrepared($event)\" [dataSource]=\"sendList\"\n                                                  [wordWrapEnabled]=\"true\"\n                                                  [showBorders]=\"true\">\n                                        <dxi-column caption=\"\u0E23\u0E32\u0E22\u0E01\u0E32\u0E23\u0E17\u0E35\u0E48\" [allowSorting]=\"false\" cellTemplate=\"cellTemplate\" alignment=\"center\"></dxi-column>\n                                        <dxi-column caption=\"\u0E08\u0E31\u0E14\u0E01\u0E32\u0E23\" [allowSorting]=\"false\" cellTemplate=\"cellTemplateAction\" alignment=\"center\"></dxi-column>\n                                        <dxi-column dataField=\"send_to\" caption=\"\u0E2B\u0E19\u0E48\u0E27\u0E22\u0E07\u0E32\u0E19\"></dxi-column>\n                                        <dxi-column dataField=\"book_no\" caption=\"\u0E40\u0E25\u0E02\u0E17\u0E35\u0E48\u0E2B\u0E19\u0E31\u0E07\u0E2A\u0E37\u0E2D\u0E2A\u0E48\u0E07\u0E2D\u0E2D\u0E01\"></dxi-column>\n                                        <dxi-column dataField=\"send_date\" caption=\"\u0E27\u0E31\u0E19\u0E17\u0E35\u0E48\u0E2A\u0E48\u0E07\u0E2D\u0E2D\u0E01\" dataType=\"date\" alignment=\"center\"></dxi-column>\n                                        <dxi-column [calculateCellValue]=\"isImportant\" caption=\"\u0E04\u0E27\u0E32\u0E21\u0E2A\u0E33\u0E04\u0E31\u0E0D\"></dxi-column>\n                                        <div *dxTemplate=\"let data of 'cellTemplate'\">\n                                            {{getRowIndex(data)}}\n                                        </div>\n                                        <div *dxTemplate=\"let data of 'cellTemplateAction'\">\n                                            <a id=\"btnEditSend\" (click)=\"editSend(data.data)\" class=\"btn btn-default btn-sm icon\" data-toggle=\"tooltip\" data-placement=\"top\" title=\"\u0E41\u0E01\u0E49\u0E44\u0E02\"><i class=\"fal fa-pencil-alt\"></i></a>\n                                        </div>\n                                    </dx-data-grid>\n                                    <br>\n                                </div>\n                                <div *ngIf=\"isRecieve\">\n                                    <div class=\"row\">\n                                        <div class=\"col-sm-3\">\n                                            <span>\u0E23\u0E32\u0E22\u0E01\u0E32\u0E23\u0E23\u0E31\u0E1A :</span>\n                                        </div>\n                                        <div class=\"col-sm-9\">\n                                            <!--<a id=\"btnSendAdd\" (click)=\"sendModal.show()\" class=\"btn btn-default btn-sm icon\" data-toggle=\"tooltip\" data-placement=\"top\" title=\"Add\"><i class=\"fal fa-plus\"></i></a>-->\n                                            <a id=\"btnRecieveAdd\" class=\"btn btn-default btn-md btn-md-search\" (click)=\"recieveModal.show()\">\u0E40\u0E1E\u0E34\u0E48\u0E21\u0E23\u0E32\u0E22\u0E01\u0E32\u0E23\u0E23\u0E31\u0E1A</a>\n                                        </div>\n                                    </div>\n                                    <br>\n                                    <dx-data-grid #dxDataGridStepRecieveList class=\"card-list-table\"\n                                                  id=\"gridStepRecieveList\" noDataText=\"\"\n                                                  (onCellPrepared)=\"onCellPrepared($event)\" [dataSource]=\"recieveList\"\n                                                  [wordWrapEnabled]=\"true\"\n                                                  [showBorders]=\"true\">\n                                        <dxi-column caption=\"\u0E23\u0E32\u0E22\u0E01\u0E32\u0E23\u0E17\u0E35\u0E48\" [allowSorting]=\"false\" cellTemplate=\"cellTemplate\"></dxi-column>\n                                        <dxi-column caption=\"\u0E08\u0E31\u0E14\u0E01\u0E32\u0E23\" [allowSorting]=\"false\" cellTemplate=\"cellTemplateAction\"></dxi-column>\n                                        <dxi-column dataField=\"recv_from\" caption=\"\u0E2B\u0E19\u0E48\u0E27\u0E22\u0E07\u0E32\u0E19\"></dxi-column>\n                                        <dxi-column dataField=\"send_book_no\" caption=\"\u0E40\u0E25\u0E02\u0E17\u0E35\u0E48\u0E2B\u0E19\u0E31\u0E07\u0E2A\u0E37\u0E2D\u0E2A\u0E48\u0E07\u0E2D\u0E2D\u0E01\"></dxi-column>\n                                        <dxi-column dataField=\"send_date\" caption=\"\u0E27\u0E31\u0E19\u0E17\u0E35\u0E48\u0E2A\u0E48\u0E07\u0E2D\u0E2D\u0E01\" dataType=\"date\"></dxi-column>\n                                        <dxi-column dataField=\"book_no\" caption=\"\u0E40\u0E25\u0E02\u0E17\u0E35\u0E48\u0E23\u0E31\u0E1A\u0E2B\u0E19\u0E31\u0E07\u0E2A\u0E37\u0E2D\"></dxi-column>\n                                        <dxi-column dataField=\"recv_date\" caption=\"\u0E27\u0E31\u0E19\u0E17\u0E35\u0E48\u0E23\u0E31\u0E1A\" dataType=\"date\"></dxi-column>\n                                        <div *dxTemplate=\"let data of 'cellTemplate'\">\n                                            {{getRowIndex(data)}}\n                                        </div>\n                                        <div *dxTemplate=\"let data of 'cellTemplateAction'\">\n                                            <a id=\"btnEditRecieve\" (click)=\"editRecieve(data.data)\" class=\"btn btn-default btn-sm icon\" data-toggle=\"tooltip\" data-placement=\"top\" title=\"\u0E41\u0E01\u0E49\u0E44\u0E02\"><i class=\"fal fa-pencil-alt\"></i></a>\n                                        </div>\n                                    </dx-data-grid>\n                                    <br>\n                                </div>\n                            </div>\n                            <div class=\"m-portlet__foot m-portlet__foot--fit text-right\">\n                                <div class=\"m-form__actions\">\n                                    <button type=\"submit\" class=\"btn btn-success btn-md btn-md-save\">\n                                        \u0E1A\u0E31\u0E19\u0E17\u0E36\u0E01\n                                    </button>\n                                    <button type=\"reset\" class=\"btn btn-default btn-md btn-md-search\" (click)=\"closeModal()\">\n                                        \u0E22\u0E01\u0E40\u0E25\u0E34\u0E01\n                                    </button>\n                                </div>\n                            </div>\n                        </form>\n                    </div>\n                </div>\n            </div>\n        </div>\n    </div>\n</div>\n<div class=\"modal fade\" bsModal #sendModal=\"bs-modal\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"dialog-static-name2\" [config]=\"{backdrop: 'static'}\">\n    <div class=\"modal-dialog modal-md\">\n        <div class=\"modal-content\">\n            <div class=\"modal-header\">\n                <h4 id=\"dialog-static-send\" class=\"modal-title pull-left\"><label>\u0E23\u0E32\u0E22\u0E01\u0E32\u0E23\u0E2A\u0E48\u0E07</label></h4>\n                <button type=\"button\" class=\"close pull-right\" aria-label=\"Close\" (click)=\"closeSendModal()\">\n                    <span aria-hidden=\"true\">&times;</span>\n                </button>\n            </div>\n            <div class=\"modal-body\">\n                <form class=\"m-form m-form--state m-form--fit m-form--label-align-right\" [formGroup]=\"sendForm\" (ngSubmit)=\"onSubmitSend()\">\n                    <div class=\"ibox-body\">\n                        <div class=\"row\">\n                            <div class=\"form-group\">\n                                <label class=\"control-label\">\u0E2B\u0E19\u0E48\u0E27\u0E22\u0E07\u0E32\u0E19</label>\n                                <div class=\"form-group m-form__group\" [ngClass]=\"{ 'has-error': submittedSend && fs().send_to.errors }\">\n                                    <soc-auto-complete [id]=\"'txtSendTo'\" mode=\"local\" [orderBy]=\"'name'\"\n                                                       [api]=\"departmentUrl\" field=\"name\" [(value)]=\"sendData.send_to\"></soc-auto-complete>\n                                    <!--<p-autoComplete type=\"text\" styleClass=\"form-control m-input\" id=\"txtSendTo\" formControlName=\"send_to\" [(ngModel)]=\"sendData.send_to\"-->\n                                                    <!--[suggestions]=\"filteredDepartments\" (completeMethod)=\"filterDepartments($event)\"></p-autoComplete>-->\n                                    <div *ngIf=\"submittedSend && fs().send_to.errors\" class=\"invalid-feedback\">\n                                        <div *ngIf=\"fs().send_to.errors.required\">First Name is required</div>\n                                    </div>\n                                </div>\n                            </div>\n                            <div class=\"form-group\">\n                                <label class=\"control-label\">\u0E40\u0E25\u0E02\u0E17\u0E35\u0E48\u0E2B\u0E19\u0E31\u0E07\u0E2A\u0E37\u0E2D\u0E2A\u0E48\u0E07\u0E2D\u0E2D\u0E01</label>\n                                <div class=\"form-group m-form__group\" [ngClass]=\"{ 'has-error': submittedSend && fs().book_no.errors }\">\n                                    <input type=\"text\" class=\"form-control m-input\" id=\"txtSendBookNo\" formControlName=\"book_no\" [(ngModel)]=\"sendData.book_no\">\n                                    <div *ngIf=\"submittedSend && fs().book_no.errors\" class=\"invalid-feedback\">\n                                        <div *ngIf=\"fs().book_no.errors.required\">First Name is required</div>\n                                    </div>\n                                </div>\n                            </div>\n                            <div class=\"form-group\">\n                                <label class=\"control-label\">\u0E27\u0E31\u0E19\u0E17\u0E35\u0E48\u0E2A\u0E48\u0E07\u0E2D\u0E2D\u0E01</label>\n                                <div class=\"form-group m-form__group\" [ngClass]=\"{ 'has-error': submittedSend && fs().send_date.errors }\">\n                                    <soc-date-box [id]=\"'txtSendDate'\" [(value)]=\"sendData.send_date\"></soc-date-box>\n                                    <div *ngIf=\"submittedSend && fs().send_date.errors\" >\n                                        <div *ngIf=\"fs().send_date.errors.required\" class=\"lable-error\">Date is required</div>\n                                        <div *ngIf=\"fs().send_date.errors.date\" class=\"lable-error\">Date is invalid</div>\n                                    </div>\n                                </div>\n                            </div>\n                            <div class=\"form-group\">\n                                <label class=\"control-label\"></label>\n                                <input type=\"checkbox\" id=\"chkIsImportant\"  name=\"is_important\" formControlName=\"is_important\" [(ngModel)]=\"sendData.is_important\" ng-checked> \u0E2A\u0E33\u0E04\u0E31\u0E0D\n                            </div>\n                        </div>\n                    </div>\n                    <div class=\"m-portlet__foot m-portlet__foot--fit text-right\">\n                        <div class=\"m-form__actions\">\n                            <button type=\"submit\" class=\"btn btn-success btn-md btn-md-save\">\n                                \u0E1A\u0E31\u0E19\u0E17\u0E36\u0E01\n                            </button>\n                            <button type=\"reset\" class=\"btn btn-default btn-md btn-md-search\" (click)=\"closeSendModal()\">\n                                \u0E22\u0E01\u0E40\u0E25\u0E34\u0E01\n                            </button>\n                        </div>\n                    </div>\n                </form>\n            </div>\n        </div>\n    </div>\n</div>\n<div class=\"modal fade\" bsModal #recieveModal=\"bs-modal\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"dialog-static-name2\" [config]=\"{backdrop: 'static'}\">\n    <div class=\"modal-dialog modal-md\">\n        <div class=\"modal-content\">\n            <div class=\"modal-header\">\n                <h4 id=\"dialog-static-recieve\" class=\"modal-title pull-left\"><label>\u0E23\u0E31\u0E1A\u0E2B\u0E19\u0E31\u0E07\u0E2A\u0E37\u0E2D \u0E15\u0E2D\u0E1A\u0E04\u0E27\u0E32\u0E21\u0E40\u0E2B\u0E47\u0E19</label></h4>\n                <button type=\"button\" class=\"close pull-right\" aria-label=\"Close\" (click)=\"closeRecieveModal()\">\n                    <span aria-hidden=\"true\">&times;</span>\n                </button>\n            </div>\n            <div class=\"modal-body\">\n                <form class=\"m-form m-form--state m-form--fit m-form--label-align-right\" [formGroup]=\"recieveForm\" (ngSubmit)=\"onSubmitRecieve()\">\n                    <div class=\"ibox-body\">\n                        <div class=\"row\">\n                            <div class=\"form-group\">\n                                <label class=\"control-label\">\u0E40\u0E25\u0E02\u0E17\u0E35\u0E48\u0E23\u0E31\u0E1A\u0E2B\u0E19\u0E31\u0E07\u0E2A\u0E37\u0E2D</label>\n                                <div class=\"form-group m-form__group\" [ngClass]=\"{ 'has-error': submittedRecieve && fr().book_no.errors }\">\n                                    <input type=\"text\" class=\"form-control m-input\" id=\"txtRecieveBookNo\" formControlName=\"book_no\" [(ngModel)]=\"recieveData.book_no\">\n                                    <div *ngIf=\"submittedRecieve && fr().book_no.errors\" class=\"invalid-feedback\">\n                                        <div *ngIf=\"fr().book_no.errors.required\">First Name is required</div>\n                                    </div>\n                                </div>\n                            </div>\n                            <div class=\"form-group\">\n                                <label class=\"control-label\">\u0E27\u0E31\u0E19\u0E17\u0E35\u0E48\u0E23\u0E31\u0E1A</label>\n                                <div class=\"form-group m-form__group\" [ngClass]=\"{ 'has-error': submittedRecieve && fr().recv_date.errors }\">\n                                    <soc-date-box [id]=\"'txtRecieveDate'\" [(value)]=\"recieveData.recv_date\"></soc-date-box>\n                                    <div *ngIf=\"submittedRecieve && fr().recv_date.errors\" >\n                                        <div *ngIf=\"fr().recv_date.errors.required\" class=\"lable-error\">Date is required</div>\n                                        <div *ngIf=\"fr().recv_date.errors.date\" class=\"lable-error\">Date is invalid</div>\n                                    </div>\n                                </div>\n                            </div>\n                        </div>\n                    </div>\n                    <div class=\"m-portlet__foot m-portlet__foot--fit text-right\">\n                        <div class=\"m-form__actions\">\n                            <button type=\"submit\" class=\"btn btn-success btn-md btn-md-save\">\n                                \u0E1A\u0E31\u0E19\u0E17\u0E36\u0E01\n                            </button>\n                            <button type=\"reset\" class=\"btn btn-default btn-md btn-md-search\" (click)=\"closeRecieveModal()\">\n                                \u0E22\u0E01\u0E40\u0E25\u0E34\u0E01\n                            </button>\n                        </div>\n                    </div>\n                </form>\n            </div>\n        </div>\n    </div>\n</div>\n<app-alert #myModal (onClickBack)=\"onClickBack()\"></app-alert>\n"
                }] }
    ];
    /** @nocollapse */
    ModalStepComponent.ctorParameters = function () { return [
        { type: AppConfigService },
        { type: Request },
        { type: FormBuilder },
        { type: Common },
        { type: DateService },
        { type: B2bService }
    ]; };
    ModalStepComponent.propDecorators = {
        onUpdateModal: [{ type: Output }],
        modal: [{ type: ViewChild, args: ['modal',] }],
        myModal: [{ type: ViewChild, args: ['myModal',] }],
        sendModal: [{ type: ViewChild, args: ['sendModal',] }],
        recieveModal: [{ type: ViewChild, args: ['recieveModal',] }],
        dxDataGridStepSendList: [{ type: ViewChild, args: ['dxDataGridStepSendList',] }],
        uploadAttachment: [{ type: ViewChild, args: ['uploadAttachment',] }]
    };
    return ModalStepComponent;
}(Options));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var SocAutoCompleteComponent = /** @class */ (function () {
    function SocAutoCompleteComponent(request) {
        this.request = request;
        this.filteredOptions = [];
        /**
         * local, remote
         */
        this.mode = 'local';
        /**
         * API ที่ต้องการเรียกใช้เมื่อพิมพ์ auto complete
         */
        this.api = '';
        /**
         * field ที่ต้องการ query เมื่อยิง API
         */
        this.field = '';
        this.id = '';
        this.placeholder = '';
        this.disabled = false;
        this.orderBy = '';
        this.filter = '';
        this.limit = 1000;
        this.onLoad = new EventEmitter();
        this.valueChange = new EventEmitter();
        this.resData = [];
        this.openOnFieldClick = false;
        this.showDropDownButton = false;
        this.acceptCustomValue = true;
        this.searchEnabled = true;
        this.inputValue = '';
        this.fnCustomStoreOnLoaded = function (result) {
            return result;
        };
        /**
         * START Bind Value
         */
        this.onModelChange = function () { };
        this.onModelTouched = function () { };
    }
    /**
     * @return {?}
     */
    SocAutoCompleteComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                if (this.mode === 'dropdown') {
                    this.acceptCustomValue = false;
                    this.searchEnabled = false;
                }
                /** ถ้าเป็น โหมด local จะแสดง list ให้เลือกเลย แตถ้่เป็น remote จะต้องขึ้นเมื่อพิมพ์เท่านั้น */
                if (this.mode === 'local' || this.mode === 'dropdown') {
                    this.openOnFieldClick = true;
                    this.showDropDownButton = true;
                    this.fnStartDataSourceLocal();
                }
                else {
                    this.fnStartDataSourceRemote();
                }
                return [2 /*return*/];
            });
        });
    };
    /**
     * @return {?}
     */
    SocAutoCompleteComponent.prototype.ngAfterViewInit = /**
     * @return {?}
     */
    function () {
    };
    /**
     * @return {?}
     */
    SocAutoCompleteComponent.prototype.fnStartDataSourceLocal = /**
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            var params, resData;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        params = "?_fields=" + this.field;
                        if (this.filter) {
                            params += "&_where=(" + this.filter + ")";
                        }
                        if (this.orderBy && this.orderBy !== '') {
                            params += "&_sort=" + this.orderBy;
                        }
                        params += "&_limit=" + this.limit;
                        return [4 /*yield*/, this.fnPreResponse(params)];
                    case 1:
                        resData = _a.sent();
                        this.ds = new DataSource({
                            store: new ArrayStore({
                                data: resData,
                                onLoaded: this.fnCustomStoreOnLoaded
                            })
                        });
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @return {?}
     */
    SocAutoCompleteComponent.prototype.fnStartDataSourceRemote = /**
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                this.ds = new DataSource({
                    store: new CustomStore({
                        byKey: function (key) { return __awaiter(_this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                this.onLoad.emit(key);
                                return [2 /*return*/, this.fnGetCustomStore(key)];
                            });
                        }); },
                        load: function (loadOptions) { return __awaiter(_this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                this.onLoad.emit(loadOptions.searchValue);
                                return [2 /*return*/, this.fnGetCustomStore(loadOptions.searchValue)];
                            });
                        }); },
                        onLoaded: this.fnCustomStoreOnLoaded
                    })
                });
                return [2 /*return*/];
            });
        });
    };
    /**
     * @param {?} key
     * @return {?}
     */
    SocAutoCompleteComponent.prototype.fnGetCustomStore = /**
     * @param {?} key
     * @return {?}
     */
    function (key) {
        /** @type {?} */
        var params = "?_fields=" + this.field + "&_where=(" + this.field + ",like,$" + key + "$)";
        if (this.filter) {
            params = "?_fields=" + this.field + "&_where=((" + this.field + ",like,$" + key + "$)$and(" + this.filter + "))";
        }
        if (this.orderBy && this.orderBy !== '') {
            params += "&_sort=" + this.orderBy;
        }
        params += "&_limit=" + this.limit;
        return this.fnPreResponse(params);
    };
    /**
     * @param {?} e
     * @return {?}
     */
    SocAutoCompleteComponent.prototype.onValueChanged = /**
     * @param {?} e
     * @return {?}
     */
    function (e) {
        console.log("​SocAutoCompleteComponent -> onValueChanged -> e", e);
        this.valueChange.emit(e.value);
    };
    /**
     * @param {?} params
     * @return {?}
     */
    SocAutoCompleteComponent.prototype.fnPreResponse = /**
     * @param {?} params
     * @return {?}
     */
    function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var resData;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.request.get(this.api + params)];
                    case 1:
                        resData = _a.sent();
                        resData = map(resData, function (obj) {
                            return obj[_this.field];
                        });
                        resData = uniqBy(resData);
                        return [2 /*return*/, resData];
                }
            });
        });
    };
    /**
     * @param {?} e
     * @return {?}
     */
    SocAutoCompleteComponent.prototype.onOpened = /**
     * @param {?} e
     * @return {?}
     */
    function (e) {
        /** @type {?} */
        var element = document.querySelector('.dx-overlay-wrapper.dx-dropdowneditor-overlay.dx-popup-wrapper.dx-dropdownlist-popup-wrapper.dx-selectbox-popup-wrapper');
        element.setAttribute('style', 'z-index:9999;');
    };
    /**
     * @param {?} value
     * @return {?}
     */
    SocAutoCompleteComponent.prototype.writeValue = /**
     * @param {?} value
     * @return {?}
     */
    function (value) { };
    /**
     * @param {?} fn
     * @return {?}
     */
    SocAutoCompleteComponent.prototype.registerOnChange = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) { };
    /**
     * @param {?} fn
     * @return {?}
     */
    SocAutoCompleteComponent.prototype.registerOnTouched = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) { };
    SocAutoCompleteComponent.decorators = [
        { type: Component, args: [{
                    selector: 'soc-auto-complete',
                    providers: [{
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: forwardRef(function () { return SocAutoCompleteComponent; }),
                            multi: true
                        }],
                    template: "\n      <dx-select-box [dataSource]=\"ds\"\n                [searchEnabled]=\"searchEnabled\"\n                [openOnFieldClick]=\"openOnFieldClick\"\n                [showClearButton]=\"true\"\n                [showDropDownButton]=\"showDropDownButton\"\n                [inputAttr]=\"{ id: id }\"\n                [acceptCustomValue]=\"acceptCustomValue\"\n                [placeholder]=\"placeholder\"\n                [(value)]=\"value\"\n                (onValueChanged)=\"onValueChanged($event)\"\n                (onOpened)=\"onOpened($event)\"\n                [disabled]=\"disabled\"\n                noDataText=\"\u0E44\u0E21\u0E48\u0E1E\u0E1A\u0E02\u0E49\u0E2D\u0E21\u0E39\u0E25\"\n                placeholder=\"\u0E01\u0E23\u0E38\u0E13\u0E32\u0E40\u0E25\u0E37\u0E2D\u0E01\u0E23\u0E32\u0E22\u0E01\u0E32\u0E23\"\n            ></dx-select-box>\n"
                }] }
    ];
    /** @nocollapse */
    SocAutoCompleteComponent.ctorParameters = function () { return [
        { type: Request }
    ]; };
    SocAutoCompleteComponent.propDecorators = {
        mode: [{ type: Input }],
        api: [{ type: Input }],
        field: [{ type: Input }],
        id: [{ type: Input }],
        placeholder: [{ type: Input }],
        value: [{ type: Input }],
        disabled: [{ type: Input }],
        orderBy: [{ type: Input }],
        filter: [{ type: Input }],
        limit: [{ type: Input }],
        onLoad: [{ type: Output }],
        valueChange: [{ type: Output }]
    };
    return SocAutoCompleteComponent;
}());
var SharedAutoCompleteModule = /** @class */ (function () {
    function SharedAutoCompleteModule() {
    }
    SharedAutoCompleteModule.decorators = [
        { type: NgModule, args: [{
                    imports: [CommonModule, FormsModule, SharedModule, DxSelectBoxModule],
                    exports: [SocAutoCompleteComponent, SharedModule],
                    declarations: [SocAutoCompleteComponent],
                },] }
    ];
    return SharedAutoCompleteModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var SocAutoComplete2Component = /** @class */ (function () {
    function SocAutoComplete2Component(request) {
        var _this = this;
        this.request = request;
        this.filteredOptions = [];
        /**
         * local, remote
         */
        this.mode = 'local';
        /**
         * API ที่ต้องการเรียกใช้เมื่อพิมพ์ auto complete
         */
        this.api = '';
        /**
         * field ที่ต้องการ query เมื่อยิง API
         */
        this.field = '';
        this.fieldApi = '';
        this.id = '';
        this.placeholder = '';
        this.disabled = false;
        this.orderBy = '';
        this.filter = '';
        this.ex_type_view = '';
        this.limit = 1000;
        this.onLoad = new EventEmitter();
        this.valueChange = new EventEmitter();
        this.valueSelete = new EventEmitter();
        this.storeOnLoaded = new EventEmitter();
        this.acceptCustomValue = true;
        this.resData = [];
        this.loadOptionData = [];
        this.openOnFieldClick = false;
        this.showDropDownButton = false;
        // acceptCustomValue = true;
        this.searchEnabled = true;
        this.inputValue = '';
        this.fnCustomStoreOnLoaded = function (result) {
            _this.storeOnLoaded.emit(result);
            return result;
        };
        /**
         * START Bind Value
         */
        this.onModelChange = function () { };
        this.onModelTouched = function () { };
    }
    /**
     * @return {?}
     */
    SocAutoComplete2Component.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                if (this.mode === 'dropdown') {
                    this.acceptCustomValue = false;
                    this.searchEnabled = false;
                }
                /** ถ้าเป็น โหมด local จะแสดง list ให้เลือกเลย แตถ้่เป็น remote จะต้องขึ้นเมื่อพิมพ์เท่านั้น */
                if (this.mode === 'local' || this.mode === 'dropdown') {
                    this.openOnFieldClick = true;
                    this.showDropDownButton = true;
                    this.fnStartDataSourceLocal();
                }
                else {
                    this.fnStartDataSourceRemote();
                }
                return [2 /*return*/];
            });
        });
    };
    /**
     * @return {?}
     */
    SocAutoComplete2Component.prototype.ngAfterViewInit = /**
     * @return {?}
     */
    function () {
    };
    /**
     * @return {?}
     */
    SocAutoComplete2Component.prototype.fnStartDataSourceLocal = /**
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            var params, resData;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        params = "?_fields=" + (this.fieldApi ? this.fieldApi : this.field);
                        if (this.filter) {
                            params += this.filter; //`&_where=(${this.filter})`
                        }
                        if (this.orderBy && this.orderBy !== '') {
                            params += "&_sort=" + this.orderBy;
                        }
                        params += "&_limit=" + this.limit;
                        return [4 /*yield*/, this.fnPreResponse(params)];
                    case 1:
                        resData = _a.sent();
                        this.ds = new DataSource({
                            store: new ArrayStore({
                                data: resData,
                                onLoaded: this.fnCustomStoreOnLoaded
                            })
                        });
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @return {?}
     */
    SocAutoComplete2Component.prototype.fnStartDataSourceRemote = /**
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                this.ds = new DataSource({
                    store: new CustomStore({
                        byKey: function (key) { return __awaiter(_this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                this.onLoad.emit(key);
                                return [2 /*return*/, this.fnGetCustomStore(key)];
                            });
                        }); },
                        load: function (loadOptions) { return __awaiter(_this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                this.onLoad.emit(loadOptions.searchValue);
                                return [2 /*return*/, this.fnGetCustomStore(loadOptions.searchValue)];
                            });
                        }); },
                        onLoaded: this.fnCustomStoreOnLoaded
                    })
                });
                return [2 /*return*/];
            });
        });
    };
    /**
     * @param {?} key
     * @return {?}
     */
    SocAutoComplete2Component.prototype.fnGetCustomStore = /**
     * @param {?} key
     * @return {?}
     */
    function (key) {
        /** @type {?} */
        var params = "?_fields=" + (this.fieldApi ? this.fieldApi : this.field) + "&_where=(" + this.field + ",like,$" + key + "$)";
        if (this.filter) {
            params = "?_fields=" + (this.fieldApi ? this.fieldApi : this.field) + "&_where=((" + this.field + ",like,$" + key + "$)$and(" + this.filter + "))";
        }
        if (this.orderBy && this.orderBy !== '') {
            params += "&_sort=" + this.orderBy;
        }
        params += "&_limit=" + this.limit;
        return this.fnPreResponse(params);
    };
    /**
     * @param {?} e
     * @return {?}
     */
    SocAutoComplete2Component.prototype.onValueChanged = /**
     * @param {?} e
     * @return {?}
     */
    function (e) {
        this.onValueSelete(e);
        console.log("​SocAutoCompleteComponent -> onValueChanged -> e", e);
        this.valueChange.emit(e.value);
    };
    /**
     * @param {?} e
     * @return {?}
     */
    SocAutoComplete2Component.prototype.onValueSelete = /**
     * @param {?} e
     * @return {?}
     */
    function (e) {
        var _this = this;
        /** @type {?} */
        var temp = find(this.loadOptionData, function (r) {
            if (_this.ex_type_view === "ct_dropdown") {
                return r.code + " - " + r.name === e.value;
            }
            else if (_this.ex_type_view === "ct_ext_departmen") {
                return r.short_name + " - " + r.name === e.value;
            }
            return r[_this.field] === e.value;
        });
        console.log("​SocAutoCompleteComponent -> onValueSelete -> e", e, temp);
        this.valueSelete.emit(temp);
    };
    /**
     * @param {?} params
     * @return {?}
     */
    SocAutoComplete2Component.prototype.fnPreResponse = /**
     * @param {?} params
     * @return {?}
     */
    function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var resData, _resData, i, temp;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.request.get(this.api + params)];
                    case 1:
                        resData = _a.sent();
                        resData = map(resData, function (obj) {
                            return obj; //[this.field]
                        });
                        _resData = [];
                        for (i in resData) {
                            temp = find(_resData, function (r) { return r[_this.field] === resData[i][_this.field]; });
                            if (!temp) {
                                _resData.push(resData[i]);
                            }
                        }
                        this.loadOptionData = _resData;
                        return [2 /*return*/, map(_resData, function (obj) {
                                if (_this.ex_type_view === "ct_dropdown") {
                                    return obj.code + " - " + obj.name;
                                }
                                else if (_this.ex_type_view === "ct_ext_departmen") {
                                    return obj.short_name + " - " + obj.name;
                                }
                                return obj[_this.field];
                            })];
                }
            });
        });
    };
    /**
     * @param {?} e
     * @return {?}
     */
    SocAutoComplete2Component.prototype.onOpened = /**
     * @param {?} e
     * @return {?}
     */
    function (e) {
        /** @type {?} */
        var element = document.querySelector('.dx-overlay-wrapper.dx-dropdowneditor-overlay.dx-popup-wrapper.dx-dropdownlist-popup-wrapper.dx-selectbox-popup-wrapper');
        element.setAttribute('style', 'z-index:9999;');
    };
    /**
     * @param {?} value
     * @return {?}
     */
    SocAutoComplete2Component.prototype.writeValue = /**
     * @param {?} value
     * @return {?}
     */
    function (value) { };
    /**
     * @param {?} fn
     * @return {?}
     */
    SocAutoComplete2Component.prototype.registerOnChange = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) { };
    /**
     * @param {?} fn
     * @return {?}
     */
    SocAutoComplete2Component.prototype.registerOnTouched = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) { };
    SocAutoComplete2Component.decorators = [
        { type: Component, args: [{
                    selector: 'soc-auto-complete-2',
                    providers: [{
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: forwardRef(function () { return SocAutoComplete2Component; }),
                            multi: true
                        }],
                    template: "\n      <dx-select-box [dataSource]=\"ds\"\n                [searchEnabled]=\"searchEnabled\"\n                [openOnFieldClick]=\"openOnFieldClick\"\n                [showClearButton]=\"true\"\n                [showDropDownButton]=\"showDropDownButton\"\n                [inputAttr]=\"{ id: id }\"\n                [acceptCustomValue]=\"acceptCustomValue\"\n                [placeholder]=\"placeholder\"\n                [(value)]=\"value\"\n                (onValueChanged)=\"onValueChanged($event)\"\n                (onOpened)=\"onOpened($event)\"\n                [disabled]=\"disabled\"\n                noDataText=\"\u0E44\u0E21\u0E48\u0E1E\u0E1A\u0E02\u0E49\u0E2D\u0E21\u0E39\u0E25\"\n                placeholder=\"\u0E01\u0E23\u0E38\u0E13\u0E32\u0E40\u0E25\u0E37\u0E2D\u0E01\u0E23\u0E32\u0E22\u0E01\u0E32\u0E23\"\n            ></dx-select-box>\n"
                }] }
    ];
    /** @nocollapse */
    SocAutoComplete2Component.ctorParameters = function () { return [
        { type: Request }
    ]; };
    SocAutoComplete2Component.propDecorators = {
        mode: [{ type: Input }],
        api: [{ type: Input }],
        field: [{ type: Input }],
        fieldApi: [{ type: Input }],
        id: [{ type: Input }],
        placeholder: [{ type: Input }],
        value: [{ type: Input }],
        disabled: [{ type: Input }],
        orderBy: [{ type: Input }],
        filter: [{ type: Input }],
        ex_type_view: [{ type: Input }],
        limit: [{ type: Input }],
        onLoad: [{ type: Output }],
        valueChange: [{ type: Output }],
        valueSelete: [{ type: Output }],
        storeOnLoaded: [{ type: Output }],
        acceptCustomValue: [{ type: Input }]
    };
    return SocAutoComplete2Component;
}());
var SharedAutoComplete2Module = /** @class */ (function () {
    function SharedAutoComplete2Module() {
    }
    SharedAutoComplete2Module.decorators = [
        { type: NgModule, args: [{
                    imports: [CommonModule, FormsModule, SharedModule, DxSelectBoxModule],
                    exports: [SocAutoComplete2Component, SharedModule],
                    declarations: [SocAutoComplete2Component],
                },] }
    ];
    return SharedAutoComplete2Module;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var DisableControlDirective = /** @class */ (function () {
    function DisableControlDirective(ngControl) {
        this.ngControl = ngControl;
    }
    Object.defineProperty(DisableControlDirective.prototype, "disableControl", {
        set: /**
         * @param {?} condition
         * @return {?}
         */
        function (condition) {
            /** @type {?} */
            var action = condition ? 'disable' : 'enable';
            this.ngControl.control[action]();
        },
        enumerable: true,
        configurable: true
    });
    DisableControlDirective.decorators = [
        { type: Directive, args: [{
                    selector: '[disableControl]'
                },] }
    ];
    /** @nocollapse */
    DisableControlDirective.ctorParameters = function () { return [
        { type: NgControl }
    ]; };
    DisableControlDirective.propDecorators = {
        disableControl: [{ type: Input }]
    };
    return DisableControlDirective;
}());
var DisableControlDirectiveModule = /** @class */ (function () {
    function DisableControlDirectiveModule() {
    }
    DisableControlDirectiveModule.decorators = [
        { type: NgModule, args: [{
                    imports: [],
                    // , CommonModule
                    exports: [DisableControlDirective],
                    declarations: [DisableControlDirective]
                },] }
    ];
    return DisableControlDirectiveModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var CreateAlertComponent = /** @class */ (function () {
    function CreateAlertComponent(router) {
        // , private request: Request, private common: Common
        this.router = router;
        this.percent = 0;
        this.buttonText = '';
        this.onCloseModalError = new EventEmitter();
        this.onOkDelete = new EventEmitter();
        this.onOkConfirm = new EventEmitter();
        this.onCancelDelete = new EventEmitter();
        this.onCancelConfirm = new EventEmitter();
        this.onOkDeleteAttachment = new EventEmitter();
        this.onCancelDeleteAttachment = new EventEmitter();
        this.onClickBack = new EventEmitter();
        this.onCancelViewWarning = new EventEmitter();
        this.onCancelUploadValid = new EventEmitter();
        this.onDataErrorExcel = new EventEmitter();
        this.onClickExport = new EventEmitter();
        this.onClickDeleteExport = new EventEmitter();
        this.onOkClone = new EventEmitter();
        this.onOkReport = new EventEmitter();
        this.onCancelClone = new EventEmitter();
        this.onOkDiagramCancel = new EventEmitter();
        this.onCancelDiagramCancel = new EventEmitter();
        this.onCancelAddVOutlook = new EventEmitter();
        this.onOkAddVOutlook = new EventEmitter();
        this.onCancelAddMVara = new EventEmitter();
        this.onOkAddMVara = new EventEmitter();
        this.dataText = {
            userTitle: '',
            userMessage: ''
        };
    }
    /**
     * @return {?}
     */
    CreateAlertComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () { };
    /**
     * @return {?}
     */
    CreateAlertComponent.prototype.ngAfterViewInit = /**
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                try {
                    $(this.modalSuccess.nativeElement).on('hidden.bs.modal', function () { return __awaiter(_this, void 0, void 0, function () {
                        // put your default event here
                        return __generator(this, function (_a) {
                            this.onClickBack.emit();
                            return [2 /*return*/];
                        });
                    }); });
                    $(this.modalEditSuccess.nativeElement).on('hidden.bs.modal', function () { return __awaiter(_this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            // put your default event here
                            this.onClickBack.emit();
                            return [2 /*return*/];
                        });
                    }); });
                    $(this.modalError.nativeElement).on('hidden.bs.modal', function () { return __awaiter(_this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            // put your default event here
                            // await this.router.navigate([this.urlBack]);
                            this.onCloseModalError.emit();
                            return [2 /*return*/];
                        });
                    }); });
                    // $(this.modalViewWarning.nativeElement).on('hidden.bs.modal', async () => {
                    //   // put your default event here
                    //   // await this.router.navigate([this.urlBack]);
                    //   this.onCancelViewWarning.emit();
                    // });
                    // ปรับ html <body> ให้กลับเป็นปกติเมื่อเปิด-ปิด modal
                    // document.body.style.paddingRight = '0px';
                }
                catch (e) {
                    console.log(e);
                }
                return [2 /*return*/];
            });
        });
    };
    /**
     * @param {?} data
     * @return {?}
     */
    CreateAlertComponent.prototype.openModal = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        // console.log(this.elementRef.nativeElement.querySelector('#myModalDelete'));
        console.log(data);
        // this.userMessage = userMessage;
        // let data =
        // if(){
        //
        // }
        // ถ้าเป็น myModalExportLoading จะโยน data มาต่างกัน
        // if (data.modalId === 'myModalExportLoading') {
        //   this.dataExport = data.userMessage ? data.userMessage.dataExport : [];
        //   this.buttonText = data.userMessage ? data.userMessage.buttonText : 'PDF';
        // } else {
        this.dataText = {
            userTitle: data.userTitle,
            userMessage: data.userMessage
        };
        // }
        if (data.modalId === 'myModalDelete') {
            // $(this.modalDelete.nativeElement).modal('show');
            $(this.modalDelete.nativeElement).modal({
                backdrop: 'static'
            });
        }
        else if (data.modalId === 'myModalConfirm') {
            $(this.modalConfirm.nativeElement).modal('show');
        }
        else if (data.modalId === 'myModalDeleteAttachment') {
            $(this.modalDeleteAttachment.nativeElement).modal('show');
        }
        else if (data.modalId === 'myModalDeleteWarning') {
            $(this.modalDeleteWarning.nativeElement).modal('show');
        }
        else if (data.modalId === 'myModalSuccessDelete') {
            $(this.modalSuccessDelete.nativeElement).modal('show');
        }
        else if (data.modalId === 'myModalSuccess') {
            $(this.modalSuccess.nativeElement).modal('show');
        }
        else if (data.modalId === 'myModalSuccessWarning') {
            $(this.modalSuccessWarning.nativeElement).modal('show');
        }
        else if (data.modalId === 'myModalEditSuccess') {
            $(this.modalEditSuccess.nativeElement).modal('show');
        }
        else if (data.modalId === 'myModalWarning') {
            $(this.modalWarning.nativeElement).modal('show');
        }
        else if (data.modalId === 'myModalReportWarning') {
            $(this.myModalReportWarning.nativeElement).modal('show');
            // } else if (data.modalId === 'myModalViewWarning') {
            //   $(this.modalViewWarning.nativeElement).modal('show');
        }
        else if (data.modalId === 'myModalUploadImageWarning') {
            $(this.modalUploadImageWarning.nativeElement).modal('show');
        }
        else if (data.modalId === 'myModalUploadImageTypeWarning') {
            $(this.modalUploadImageTypeWarning.nativeElement).modal('show');
        }
        else if (data.modalId === 'myModalWarningNoTextSearch') {
            $(this.modalWarningNoTextSearch.nativeElement).modal('show');
        }
        else if (data.modalId === 'myModalErrorDataExisted') {
            $(this.modalErrorDataExisted.nativeElement).modal('show');
        }
        else if (data.modalId === 'myModalErrorDeleteButHaveMenuGroup') {
            $(this.modalErrorDeleteButHaveMenuGroup.nativeElement).modal('show');
        }
        else if (data.modalId === 'myModalAddVOutlook') {
            $(this.modalAddVOutlook.nativeElement).modal('show');
        }
        else if (data.modalId === 'myModalAddMVara') {
            $(this.modalAddMVara.nativeElement).modal('show');
        }
        else if (data.modalId === 'modalError') {
            $(this.modalError.nativeElement).modal('show');
        }
        else {
            $(this.modalError.nativeElement).modal('show');
        }
        // ปรับ html <body> ให้กลับเป็นปกติเมื่อเปิด-ปิด modal
        document.body.style.paddingRight = '0px';
    };
    /**
     * @param {?} modalId
     * @return {?}
     */
    CreateAlertComponent.prototype.closeModal = /**
     * @param {?} modalId
     * @return {?}
     */
    function (modalId) {
        if (modalId === 'myModalDelete') {
            $(this.modalDelete.nativeElement).modal('hide');
        }
        else if (modalId === 'myModalConfirm') {
            $(this.modalConfirm.nativeElement).modal('hide');
        }
        else if (modalId === 'myModalDeleteAttachment') {
            $(this.modalDeleteAttachment.nativeElement).modal('hide');
        }
        else if (modalId === 'myModalDeleteWarning') {
            $(this.modalDeleteWarning.nativeElement).modal('hide');
        }
        else if (modalId === 'myModalAddVOutlook') {
            $(this.modalAddVOutlook.nativeElement).modal('hide');
        }
        else if (modalId === 'myModalAddMVara') {
            $(this.modalAddMVara.nativeElement).modal('hide');
        }
        else if (modalId === 'myModalSuccessDelete') {
            $(this.modalSuccessDelete.nativeElement).modal('hide');
        }
        else if (modalId === 'myModalSuccess') {
            $(this.modalSuccess.nativeElement).modal('hide');
        }
        else if (modalId === 'myModalSuccessWarning') {
            $(this.modalSuccessWarning.nativeElement).modal('hide');
        }
        else if (modalId === 'myModalEditSuccess') {
            $(this.modalEditSuccess.nativeElement).modal('hide');
        }
        else if (modalId === 'myModalWarning') {
            $(this.modalWarning.nativeElement).modal('hide');
        }
        else if (modalId === 'myModalReportWarning') {
            $(this.myModalReportWarning.nativeElement).modal('hide');
            // } else if (modalId === 'myModalViewWarning') {
            //   $(this.modalViewWarning.nativeElement).modal('hide');
        }
        else if (modalId === 'myModalUploadImageWarning') {
            $(this.modalUploadImageWarning.nativeElement).modal('hide');
        }
        else if (modalId === 'myModalUploadImageTypeWarning') {
            $(this.modalUploadImageTypeWarning.nativeElement).modal('hide');
        }
        else if (modalId === 'myModalWarningNoTextSearch') {
            $(this.modalWarningNoTextSearch.nativeElement).modal('hide');
        }
        else if (modalId === 'myModalErrorDataExisted') {
            $(this.modalErrorDataExisted.nativeElement).modal('hide');
        }
        else if (modalId === 'myModalErrorDeleteButHaveMenuGroup') {
            $(this.modalErrorDeleteButHaveMenuGroup.nativeElement).modal('hide');
        }
        else if (modalId === 'myModalAddVOutlook') {
            $(this.modalAddVOutlook.nativeElement).modal('hide');
        }
        else {
            console.error('closeModal Error');
        }
    };
    /**
     * @param {?} data
     * @return {?}
     */
    CreateAlertComponent.prototype.showStringValidDataExcel = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        /** @type {?} */
        var text = '';
        if (data.data && data.data.itemOjb && data.data.itemOjb.failDescription) {
            for (var j = 0; j < data.data.itemOjb.failDescription.length; j++) {
                text += '[' + data.data.itemOjb.failDescription[j].columeName + ']' + ':"' + data.data.itemOjb.failDescription[j].text + '", <br/>';
            }
        }
        return text;
    };
    /**
     * @param {?} failDescription
     * @return {?}
     */
    CreateAlertComponent.prototype.showStringErrorDataExcel = /**
     * @param {?} failDescription
     * @return {?}
     */
    function (failDescription) {
        /** @type {?} */
        var text = '';
        for (var j = 0; j < failDescription.length; j++) {
            text += '[' + failDescription[j].columeName + ']' + ':"' + failDescription[j].text + '", <br/>';
        }
        return text;
    };
    /**
     * @return {?}
     */
    CreateAlertComponent.prototype.closeProgressbar = /**
     * @return {?}
     */
    function () {
        $(this.modalProgressBarWarning.nativeElement).modal('hide');
    };
    /**
     * @return {?}
     */
    CreateAlertComponent.prototype.onOkDeleteModal = /**
     * @return {?}
     */
    function () {
        $(this.modalDelete.nativeElement).modal('hide');
        this.onOkDelete.emit();
    };
    /**
     * @return {?}
     */
    CreateAlertComponent.prototype.onOkConfirmModal = /**
     * @return {?}
     */
    function () {
        $(this.modalConfirm.nativeElement).modal('hide');
        this.onOkConfirm.emit();
    };
    /**
     * @return {?}
     */
    CreateAlertComponent.prototype.onOkDeleteAttachmentModal = /**
     * @return {?}
     */
    function () {
        $(this.modalDeleteAttachment.nativeElement).modal('hide');
        this.onOkDeleteAttachment.emit();
    };
    /**
     * @return {?}
     */
    CreateAlertComponent.prototype.onOkReportModal = /**
     * @return {?}
     */
    function () {
        $(this.myModalReportWarning.nativeElement).modal('hide');
        this.onOkReport.emit();
    };
    /**
     * @return {?}
     */
    CreateAlertComponent.prototype.onCancelDeleteModal = /**
     * @return {?}
     */
    function () {
        this.onCancelDelete.emit();
    };
    /**
     * @return {?}
     */
    CreateAlertComponent.prototype.onCancelConfirmModal = /**
     * @return {?}
     */
    function () {
        this.onCancelConfirm.emit();
    };
    /**
     * @return {?}
     */
    CreateAlertComponent.prototype.onCancelDeleteAttachmentModal = /**
     * @return {?}
     */
    function () {
        this.onCancelDeleteAttachment.emit();
    };
    /**
     * @return {?}
     */
    CreateAlertComponent.prototype.onClickBackModal = /**
     * @return {?}
     */
    function () {
        this.onClickBack.emit();
    };
    /**
     * @return {?}
     */
    CreateAlertComponent.prototype.onCancelViewWarningModal = /**
     * @return {?}
     */
    function () {
        console.log('hjh');
        this.onCancelViewWarning.emit();
    };
    /**
     * @return {?}
     */
    CreateAlertComponent.prototype.onCancelUploadValidModal = /**
     * @return {?}
     */
    function () {
        this.onCancelUploadValid.emit();
    };
    /**
     * @return {?}
     */
    CreateAlertComponent.prototype.onDataErrorExcelModal = /**
     * @return {?}
     */
    function () {
        this.onDataErrorExcel.emit();
    };
    /**
     * @return {?}
     */
    CreateAlertComponent.prototype.onCloseModalErrorModal = /**
     * @return {?}
     */
    function () {
        this.onCloseModalError.emit();
    };
    /**
     * @return {?}
     */
    CreateAlertComponent.prototype.onCancelCloneModal = /**
     * @return {?}
     */
    function () {
        this.onCancelClone.emit();
    };
    /**
     * @return {?}
     */
    CreateAlertComponent.prototype.onCancelAddVOutlookModal = /**
     * @return {?}
     */
    function () {
        $(this.modalAddVOutlook.nativeElement).modal('hide');
        this.onCancelAddVOutlook.emit();
    };
    /**
     * @return {?}
     */
    CreateAlertComponent.prototype.onOkAddVOutlookModal = /**
     * @return {?}
     */
    function () {
        $(this.modalAddVOutlook.nativeElement).modal('hide');
        this.onOkAddVOutlook.emit();
    };
    /**
     * @return {?}
     */
    CreateAlertComponent.prototype.onCancelAddMVaraModal = /**
     * @return {?}
     */
    function () {
        $(this.modalAddMVara.nativeElement).modal('hide');
        this.onCancelAddMVara.emit();
    };
    /**
     * @return {?}
     */
    CreateAlertComponent.prototype.onOkAddMVaraModal = /**
     * @return {?}
     */
    function () {
        $(this.modalAddMVara.nativeElement).modal('hide');
        this.onOkAddMVara.emit();
    };
    /**
     * @return {?}
     */
    CreateAlertComponent.prototype.onCancelDiagramCancelModal = /**
     * @return {?}
     */
    function () {
        this.onCancelAddVOutlook.emit();
    };
    CreateAlertComponent.decorators = [
        { type: Component, args: [{
                    selector: 'app-alert',
                    providers: [],
                    template: "<!-- POPUP Confirm DELETE -->\n<style>\n  .modal {\n    position: fixed;\n    top: 0;\n    left: 0;\n    display: none;\n    width: 100%;\n    height: 100%;\n    overflow: hidden;\n    outline: 0;\n  }\n\n  .modal.in {\n    display: block;\n  }\n\n  .modal-dialog {\n    position: relative;\n    width: auto;\n    margin: .5rem;\n    pointer-events: none;\n  }\n  @media (min-width: 576px) {\n    .modal-dialog {\n      width: 450px;\n      margin: 1.75rem auto !important;\n    }\n  }\n\n  .modal-dialog-custom {\n    display: flex;\n    align-content: center;\n    min-height: calc(100% - 1rem);\n  }\n  @media (min-width: 576px) {\n    .modal-dialog-custom {\n      min-height: calc(100% - 3.5rem);\n    }\n  }\n  .modal-dialog-scrollable {\n    display: flex;\n    max-height: calc(100% - 1rem);\n  }\n  .modal-dialog-custom.modal-dialog-scrollable {\n    -ms-flex-direction: column;\n    flex-direction: column;\n    -ms-flex-pack: center;\n    justify-content: center;\n    height: 100%;\n  }\n  @media (min-width: 576px) {\n    .modal-dialog-scrollable {\n      max-height: calc(100% - 3.5rem);\n    }\n  }\n  .modal-dialog-scrollable .modal-content {\n    max-height: calc(100vh - 1rem);\n    overflow: hidden;\n  }\n  @media (min-width: 576px) {\n    .modal-dialog-scrollable .modal-content {\n      max-height: calc(100vh - 3.5rem);\n    }\n  }\n  .modal-dialog-custom.modal-dialog-scrollable .modal-content {\n    max-height: none;\n  }\n\n  .modal-content {\n    position: relative;\n    display: -ms-flexbox;\n    display: flex;\n    -ms-flex-direction: column;\n    flex-direction: column;\n    width: 100%;\n    pointer-events: auto;\n    background-color: #fff;\n    background-clip: padding-box;\n    border: 1px solid rgba(0,0,0,.2);\n    border-radius: .3rem;\n    outline: 0;\n  }\n</style>\n<div #myModalDelete class=\"modal inmodal\" id=\"myModalDelete\" tabindex=\"-1\" role=\"dialog\"  aria-hidden=\"true\" data-keyboard=\"false\">\n  <div class=\"modal-dialog modal-dialog-custom modal-dialog-scrollable\">\n    <div class=\"modal-content animated fadeIn\">\n      <div class=\"bgyellow\">\n        <div class=\"row\"  style=\"padding-top:10px;\">\n          <div class=\"col-sm-8 pull-right m-r\">\n            <a  id=\"btnCloseDelete\" name=\"btnCloseDelete\"  class=\"btn pull-right\" data-dismiss=\"modal\" style=\"border:none;visibility: hidden;\" ><i class=\"fa fa-times fontyellow\"></i>\n            </a>\n          </div>\n        </div>\n        <div class=\"m-l-n-sm\">\n          <div class=\"text-center\">\n            <img src=\"assets/img/warning.png\" width=\"110px\">\n          </div>\n        </div>\n      </div>\n      <br>\n      <div class=\"modal-header\">\n        <h4 class=\"modal-title fontyellow\">\u0E04\u0E38\u0E13\u0E01\u0E33\u0E25\u0E31\u0E07\u0E25\u0E1A\u0E02\u0E49\u0E2D\u0E21\u0E39\u0E25</h4>\n        <p>\u0E22\u0E37\u0E19\u0E22\u0E31\u0E19\u0E2D\u0E35\u0E01\u0E04\u0E23\u0E31\u0E49\u0E07\u0E40\u0E1E\u0E37\u0E48\u0E2D\u0E17\u0E33\u0E01\u0E32\u0E23\u0E25\u0E1A\u0E02\u0E49\u0E2D\u0E21\u0E39\u0E25\u0E19\u0E35\u0E49</p>\n        <br>\n        <div class=\"row\">\n          <button id=\"btnConfirmCancel\" name=\"btnConfirmCancel\" type=\"button\" class=\"btn btn-default font-btn width-btn-small\"\n                  data-dismiss=\"modal\" (click)=\"onCancelDeleteModal()\">\u0E22\u0E01\u0E40\u0E25\u0E34\u0E01</button>\n          <!--<button type=\"button\" class=\"btn btn-danger m-l-xs\" data-toggle=\"modal\" data-target=\"#myModal7\">Yes,delete it!</button>-->\n          <a id=\"btnConfirmOk\" name=\"btnConfirmOk\" style=\"margin-left:3px;\" class=\"btn btn-danger font-btn width-btn-small\"\n             data-toggle=\"modal\" data-target=\"#myModal99\" data-dismiss=\"model\"\n             (click)=\"onOkDeleteModal()\">\u0E22\u0E37\u0E19\u0E22\u0E31\u0E19\u0E01\u0E32\u0E23\u0E25\u0E1A\n          </a>\n        </div>\n      </div>\n    </div>\n  </div>\n</div>\n<!-- POPUP Confirm  -->\n<div #myModalConfirm class=\"modal inmodal\" id=\"myModalConfirm\" tabindex=\"-1\" role=\"dialog\"  aria-hidden=\"true\" data-keyboard=\"false\">\n  <div class=\"modal-dialog modal-dialog-custom modal-dialog-scrollable\">\n    <div class=\"modal-content animated fadeIn\">\n      <div class=\"bgyellow\">\n        <div class=\"row\"  style=\"padding-top:10px;\">\n          <div class=\"col-sm-8 pull-right m-r\">\n            <a  id=\"btnCloseConfirm\" name=\"btnCloseConfirm\"  class=\"btn pull-right\" data-dismiss=\"modal\" style=\"border:none;visibility: hidden;\" ><i class=\"fa fa-times fontyellow\"></i>\n            </a>\n          </div>\n        </div>\n        <div class=\"m-l-n-sm\">\n          <div class=\"text-center\">\n            <img src=\"assets/img/warning.png\" width=\"110px\">\n          </div>\n        </div>\n      </div>\n      <br>\n      <div class=\"modal-header\">\n        <h4 class=\"modal-title fontyellow\">{{dataText.userTitle}}</h4>\n        <p>{{dataText.userMessage}}</p>\n        <br>\n        <div class=\"row\">\n          <button id=\"btnConfirmCancel\" name=\"btnConfirmCancel\" type=\"button\" class=\"btn btn-default font-btn width-btn-small\"\n                  data-dismiss=\"modal\" (click)=\"onCancelConfirmModal()\">\u0E22\u0E01\u0E40\u0E25\u0E34\u0E01</button>\n          <a id=\"btnConfirmOk\" name=\"btnConfirmOk\" style=\"margin-left:3px;\" class=\"btn btn-danger font-btn width-btn-small\"\n             data-toggle=\"modal\" data-target=\"#myModal99\" data-dismiss=\"model\"\n             (click)=\"onOkConfirmModal()\">\u0E22\u0E37\u0E19\u0E22\u0E31\u0E19\n          </a>\n        </div>\n      </div>\n    </div>\n  </div>\n</div>\n\n<!-- POPUP Confirm DELETE Attachment-->\n<div #myModalDeleteAttachment class=\"modal inmodal\" id=\"myModalDeleteAttachment\" tabindex=\"-1\" role=\"dialog\"  aria-hidden=\"true\" data-keyboard=\"false\">\n  <div class=\"modal-dialog modal-dialog-custom modal-dialog-scrollable\">\n    <div class=\"modal-content animated fadeIn\">\n      <div class=\"bgyellow\">\n        <div class=\"row\"  style=\"padding-top:10px;\">\n          <div class=\"col-sm-8 pull-right m-r\">\n            <a  id=\"btnCloseDeleteAttachment\" name=\"btnCloseDeleteAttachment\"  class=\"btn pull-right\" data-dismiss=\"modal\" style=\"border:none;visibility: hidden;\" ><i class=\"fa fa-times fontyellow\"></i>\n            </a>\n          </div>\n        </div>\n        <div class=\"m-l-n-sm\">\n          <div class=\"text-center\">\n            <img src=\"assets/img/warning.png\" width=\"110px\">\n          </div>\n        </div>\n      </div>\n      <br>\n      <div class=\"modal-header\">\n        <h4 class=\"modal-title fontyellow\">\u0E04\u0E38\u0E13\u0E01\u0E33\u0E25\u0E31\u0E07\u0E25\u0E1A\u0E02\u0E49\u0E2D\u0E21\u0E39\u0E25</h4>\n        <p>\u0E22\u0E37\u0E19\u0E22\u0E31\u0E19\u0E2D\u0E35\u0E01\u0E04\u0E23\u0E31\u0E49\u0E07\u0E40\u0E1E\u0E37\u0E48\u0E2D\u0E17\u0E33\u0E01\u0E32\u0E23\u0E25\u0E1A\u0E02\u0E49\u0E2D\u0E21\u0E39\u0E25\u0E19\u0E35\u0E49</p>\n        <br>\n        <div class=\"row\">\n          <button id=\"btnConfirmCancel\" name=\"btnConfirmCancel\" type=\"button\" class=\"btn btn-default font-btn width-btn-small\"\n                  data-dismiss=\"modal\" (click)=\"onCancelDeleteAttachmentModal()\">\u0E22\u0E01\u0E40\u0E25\u0E34\u0E01</button>\n          <!--<button type=\"button\" class=\"btn btn-danger m-l-xs\" data-toggle=\"modal\" data-target=\"#myModal7\">Yes,delete it!</button>-->\n          <a id=\"btnConfirmOk\" name=\"btnConfirmOk\" style=\"margin-left:3px;\" class=\"btn btn-danger font-btn width-btn-small\"\n             data-toggle=\"modal\" data-target=\"#myModal99\" data-dismiss=\"model\"\n             (click)=\"onOkDeleteAttachmentModal()\">\u0E22\u0E37\u0E19\u0E22\u0E31\u0E19\u0E01\u0E32\u0E23\u0E25\u0E1A\n          </a>\n        </div>\n      </div>\n    </div>\n  </div>\n</div>\n\n<!-- POPUP Add vOutlook -->\n<div #myModalAddVOutlook class=\"modal inmodal\" id=\"myModalAddVOutlook\" tabindex=\"-1\" role=\"dialog\"  aria-hidden=\"true\" data-keyboard=\"false\">\n  <div class=\"modal-dialog modal-dialog-custom modal-dialog-scrollable\">\n    <div class=\"modal-content animated fadeIn\">\n      <div class=\"bgyellow\">\n        <div class=\"row\"  style=\"padding-top:10px;\">\n          <div class=\"col-sm-8 pull-right m-r\">\n            <a  id=\"btnCloseAddVOutlook\" name=\"btnCloseAddVOutlook\"  class=\"btn pull-right\" data-dismiss=\"modal\" style=\"border:none;visibility: hidden;\" ><i class=\"fa fa-times fontyellow\"></i>\n            </a>\n          </div>\n        </div>\n        <div class=\"m-l-n-sm\">\n          <div class=\"text-center\">\n            <img src=\"assets/img/warning.png\" width=\"110px\">\n          </div>\n        </div>\n      </div>\n      <br>\n      <div class=\"modal-header\">\n        <h4 class=\"modal-title fontyellow\">\u0E04\u0E38\u0E13\u0E01\u0E33\u0E25\u0E31\u0E07\u0E2A\u0E48\u0E07\u0E02\u0E49\u0E2D\u0E21\u0E39\u0E25\u0E40\u0E02\u0E49\u0E32\u0E23\u0E30\u0E1A\u0E1A\u0E25\u0E07\u0E17\u0E30\u0E40\u0E1A\u0E35\u0E22\u0E19\u0E1C\u0E39\u0E49\u0E0A\u0E35\u0E49\u0E41\u0E08\u0E07</h4>\n        <p>\u0E22\u0E37\u0E19\u0E22\u0E31\u0E19\u0E2D\u0E35\u0E01\u0E04\u0E23\u0E31\u0E49\u0E07\u0E40\u0E1E\u0E37\u0E48\u0E2D\u0E17\u0E33\u0E01\u0E32\u0E23\u0E2A\u0E48\u0E07\u0E02\u0E49\u0E2D\u0E21\u0E39\u0E25</p>\n        <br>\n        <div class=\"row\">\n          <button id=\"btnCancelAddVOutlook\" name=\"btnCancelAddVOutlook\" type=\"button\" class=\"btn btn-default font-btn width-btn-small\"\n                  data-dismiss=\"modal\" (click)=\"onCancelAddVOutlookModal()\">\u0E22\u0E01\u0E40\u0E25\u0E34\u0E01</button>\n          <!--<button type=\"button\" class=\"btn btn-danger m-l-xs\" data-toggle=\"modal\" data-target=\"#myModal7\">Yes,delete it!</button>-->\n          <a id=\"btnConfirmAddVOutlook\" name=\"btnConfirmAddVOutlook\" style=\"margin-left:3px;\" class=\"btn btn-danger font-btn width-btn-small\"\n             data-toggle=\"modal\" data-target=\"#myModal99\" data-dismiss=\"model\"\n             (click)=\"onOkAddVOutlookModal()\">\u0E22\u0E37\u0E19\u0E22\u0E31\u0E19\u0E01\u0E32\u0E23\u0E2A\u0E48\u0E07\u0E02\u0E49\u0E2D\u0E21\u0E39\u0E25\n          </a>\n        </div>\n      </div>\n    </div>\n  </div>\n</div>\n<!-- POPUP Add MVara -->\n<div #myModalAddMVara class=\"modal inmodal\" id=\"myModalAddMVara\" tabindex=\"-1\" role=\"dialog\"  aria-hidden=\"true\" data-keyboard=\"false\">\n  <div class=\"modal-dialog modal-dialog-custom modal-dialog-scrollable\">\n    <div class=\"modal-content animated fadeIn\">\n      <div class=\"bgyellow\">\n        <div class=\"row\"  style=\"padding-top:10px;\">\n          <div class=\"col-sm-8 pull-right m-r\">\n            <a  id=\"btnCloseAddMVara\" name=\"btnCloseAddMVara\"  class=\"btn pull-right\" data-dismiss=\"modal\" style=\"border:none;visibility: hidden;\" ><i class=\"fa fa-times fontyellow\"></i>\n            </a>\n          </div>\n        </div>\n        <div class=\"m-l-n-sm\">\n          <div class=\"text-center\">\n            <img src=\"assets/img/warning.png\" width=\"110px\">\n          </div>\n        </div>\n      </div>\n      <br>\n      <div class=\"modal-header\">\n        <h4 class=\"modal-title fontyellow\">\u0E04\u0E38\u0E13\u0E01\u0E33\u0E25\u0E31\u0E07\u0E2A\u0E48\u0E07\u0E02\u0E49\u0E2D\u0E21\u0E39\u0E25\u0E40\u0E02\u0E49\u0E32\u0E23\u0E30\u0E1A\u0E1A M-Vara</h4>\n        <p>\u0E22\u0E37\u0E19\u0E22\u0E31\u0E19\u0E2D\u0E35\u0E01\u0E04\u0E23\u0E31\u0E49\u0E07\u0E40\u0E1E\u0E37\u0E48\u0E2D\u0E17\u0E33\u0E01\u0E32\u0E23\u0E2A\u0E48\u0E07\u0E02\u0E49\u0E2D\u0E21\u0E39\u0E25</p>\n        <br>\n        <div class=\"row\">\n          <button id=\"btnCancelAddMVara\" name=\"btnCancelAddMVara\" type=\"button\" class=\"btn btn-default font-btn width-btn-small\"\n                  data-dismiss=\"modal\" (click)=\"onCancelAddMVaraModal()\">\u0E22\u0E01\u0E40\u0E25\u0E34\u0E01</button>\n          <!--<button type=\"button\" class=\"btn btn-danger m-l-xs\" data-toggle=\"modal\" data-target=\"#myModal7\">Yes,delete it!</button>-->\n          <a id=\"btnConfirmAddMVara\" name=\"btnConfirmAddMVara\" style=\"margin-left:3px;\" class=\"btn btn-danger font-btn width-btn-small\"\n             data-toggle=\"modal\" data-target=\"#myModal99\" data-dismiss=\"model\"\n             (click)=\"onOkAddMVaraModal()\">\u0E22\u0E37\u0E19\u0E22\u0E31\u0E19\u0E01\u0E32\u0E23\u0E2A\u0E48\u0E07\u0E02\u0E49\u0E2D\u0E21\u0E39\u0E25\n          </a>\n        </div>\n      </div>\n    </div>\n  </div>\n</div>\n\n<!-- POPUP Success DELETE -->\n<div #myModalSuccessDelete class=\"modal inmodal\" id=\"myModalSuccessDelete\" tabindex=\"-1\" role=\"dialog\"  aria-hidden=\"true\"\n     style=\"margin-left:-17px;\" data-keyboard=\"false\">\n  <div class=\"modal-dialog modal-dialog-custom modal-dialog-scrollable\">\n    <div class=\"modal-content animated fadeIn\">\n      <div class=\"bggreen\">\n        <div class=\"row\"  style=\"padding-top:10px;\">\n          <div class=\"col-sm-8 pull-right m-r\">\n            <a id=\"btnSuccessClose\" name=\"btnSuccessClose\" class=\"btn pull-right\" data-dismiss=\"modal\" style=\"border:none;\" ><font style=\"color:#ffffff;\"><i class=\"fa flaticon-cross-16px\"></i></font>\n            </a>\n          </div>\n        </div>\n        <div class=\"m-l-n-sm\">\n          <div class=\"text-center\">\n            <img src=\"assets/img/success.png\" width=\"110px\">\n          </div>\n        </div>\n      </div>\n      <br>\n      <div class=\"modal-header\">\n        <h4 class=\"modal-title fontgreen\">\u0E04\u0E27\u0E32\u0E21\u0E2A\u0E33\u0E40\u0E23\u0E47\u0E08</h4>\n        <p>\u0E25\u0E1A\u0E02\u0E49\u0E2D\u0E21\u0E39\u0E25\u0E40\u0E23\u0E35\u0E22\u0E1A\u0E23\u0E49\u0E2D\u0E22</p>\n        <br>\n      </div>\n    </div>\n  </div>\n</div>\n\n<!--delete Warning-->\n<div #myModalDeleteWarning class=\"modal inmodal\" id=\"myModalDeleteWarning\" tabindex=\"-1\" role=\"dialog\"     aria-hidden=\"true\" data-keyboard=\"false\">\n  <div class=\"modal-dialog modal-dialog-custom modal-dialog-scrollable\">\n    <div class=\"modal-content animated fadeIn\">\n      <div class=\"bgyellow\">\n        <div class=\"row\"  style=\"padding-top:10px;\">\n          <div class=\"col-sm-8 pull-right m-r\">\n            <a id=\"btnCloseDeleteWarning\" name=\"btnCloseDeleteWarning\" class=\"btn pull-right\" data-dismiss=\"modal\" style=\"border:none;\" ><i class=\"fa btn-em-btn-close fa-close-em-white\"></i>\n            </a>\n          </div>\n          <div class=\"col-sm-4\"></div>\n        </div>\n        <div class=\"m-l-n-sm\">\n          <div class=\"text-center\">\n            <img src=\"assets/img/warning.png\" width=\"110px\">\n          </div>\n        </div>\n      </div>\n      <br>\n      <div class=\"modal-header\">\n        <h4 class=\"modal-title fontyellow\">\u0E41\u0E08\u0E49\u0E07\u0E40\u0E15\u0E37\u0E2D\u0E19</h4>\n        <p>\u0E25\u0E1A\u0E02\u0E49\u0E2D\u0E21\u0E39\u0E25\u0E44\u0E21\u0E48\u0E2A\u0E33\u0E40\u0E23\u0E47\u0E08</p>\n        <br>\n      </div>\n    </div>\n  </div>\n</div>\n\n<!--Create-->\n<div #myModalSuccess class=\"modal inmodal\" id=\"myModalSuccess\" tabindex=\"-1\" role=\"dialog\" aria-hidden=\"true\" data-keyboard=\"false\">\n  <div class=\"modal-dialog modal-dialog-custom modal-dialog-scrollable\">\n    <div class=\"modal-content animated fadeIn\">\n      <div class=\"bggreen\">\n        <div class=\"row\"  style=\"padding-top:10px;\">\n          <div class=\"col-sm-8 pull-right m-r\">\n            <a id=\"btnSuccessClose\" name=\"btnSuccessClose\" class=\"btn pull-right\" data-dismiss=\"modal\" style=\"border:none;\" ><font style=\"color:#ffffff;\"><i class=\"fa flaticon-cross-16px\"></i></font>\n            </a>\n          </div>\n        </div>\n        <div class=\"m-l-n-sm\">\n          <div class=\"text-center\">\n            <img src=\"assets/img/success.png\" width=\"110px\">\n          </div>\n        </div>\n      </div>\n      <br>\n      <div class=\"modal-header\">\n        <h4 class=\"modal-title fontgreen\">\u0E04\u0E27\u0E32\u0E21\u0E2A\u0E33\u0E40\u0E23\u0E47\u0E08</h4>\n        <p>{{dataText.userMessage}}</p>\n        <br>\n      </div>\n    </div>\n  </div>\n</div>\n\n<!--edit-->\n<div #myModalEditSuccess class=\"modal inmodal\" id=\"myModalEditSuccess\" tabindex=\"-1\" role=\"dialog\" aria-hidden=\"true\" data-keyboard=\"false\">\n  <div class=\"modal-dialog modal-dialog-custom modal-dialog-scrollable\">\n    <div class=\"modal-content animated fadeIn\">\n      <div class=\"bggreen\">\n        <div class=\"row\"  style=\"padding-top:10px;\">\n          <div class=\"col-sm-8 pull-right m-r\">\n            <a id=\"btnClose\" name=\"btnClose\"  class=\"btn pull-right\" data-dismiss=\"modal\" style=\"border:none;\" ><font style=\"color:#ffffff;\"><i class=\"fa flaticon-cross-16px\"></i></font>\n            </a>\n          </div>\n        </div>\n        <div class=\"m-l-n-sm\">\n          <div class=\"text-center\">\n            <img src=\"assets/img/success.png\" width=\"110px\">\n          </div>\n        </div>\n      </div>\n      <br>\n      <div class=\"modal-header\">\n        <h4 class=\"modal-title fontgreen\">\u0E04\u0E27\u0E32\u0E21\u0E2A\u0E33\u0E40\u0E23\u0E47\u0E08</h4>\n        <p>\u0E41\u0E01\u0E49\u0E44\u0E02\u0E2A\u0E33\u0E40\u0E23\u0E47\u0E08</p>\n        <!--<h4 class=\"modal-title fontgreen\">Success !</h4>-->\n        <!--<p>Your data has been updated successfully.</p>-->\n        <br>\n      </div>\n    </div>\n  </div>\n</div>\n\n<!--myModalDbError 50001-->\n<div #myModalDbError class=\"modal inmodal\" id=\"myModalDbError\" tabindex=\"-1\" role=\"dialog\" aria-hidden=\"true\" data-keyboard=\"false\">\n  <div class=\"modal-dialog modal-dialog-custom modal-dialog-scrollable\">\n    <div class=\"modal-content animated fadeIn\">\n      <div class=\"bgred\">\n        <div class=\"row\"  style=\"padding-top:10px;\">\n          <div class=\"col-sm-8 pull-right m-r\">\n            <a id=\"btnCloseDataExisted\" name=\"btnCloseDataExisted\"  class=\"btn pull-right\" data-dismiss=\"modal\" style=\"border:none;\" ><font style=\"color:#ffffff;\"><i class=\"fa flaticon-cross-16px\"></i></font>\n            </a>\n          </div>\n        </div>\n        <div class=\"m-l-n-sm\">\n          <div class=\"text-center\">\n            <img src=\"assets/img/error.png\" width=\"110px\">\n          </div>\n        </div>\n      </div>\n      <br>\n      <div class=\"modal-header\">\n        <h4 class=\"modal-title fontred\">{{dataText.userTitle}}</h4>\n        <p>{{dataText.userMessage}}</p>\n        <!--<h4 class=\"modal-title fontred\">Error Connecting to Database !</h4>-->\n        <!--<p> Please contact your administrator.</p>-->\n        <br>\n      </div>\n    </div>\n  </div>\n</div>\n\n<!--myModalErrorDeleteButHaveMenuGroup 50002-->\n<div #myModalErrorDeleteButHaveMenuGroup class=\"modal inmodal\" id=\"myModalErrorDeleteButHaveMenuGroup\" tabindex=\"-1\" role=\"dialog\" aria-hidden=\"true\" data-keyboard=\"false\">\n  <div class=\"modal-dialog modal-dialog-custom modal-dialog-scrollable\">\n    <div class=\"modal-content animated fadeIn\">\n      <div class=\"bgred\">\n        <div class=\"row\"  style=\"padding-top:10px;\">\n          <div class=\"col-sm-8 pull-right m-r\">\n            <a id=\"btnCloseDataExisted\" name=\"btnCloseDataExisted\"  class=\"btn pull-right\" data-dismiss=\"modal\" style=\"border:none;\" ><font style=\"color:#ffffff;\"><i class=\"fa flaticon-cross-16px\"></i></font>\n            </a>\n          </div>\n        </div>\n        <div class=\"m-l-n-sm\">\n          <div class=\"text-center\">\n            <img src=\"assets/img/error.png\" width=\"110px\">\n          </div>\n        </div>\n      </div>\n      <br>\n      <div class=\"modal-header\">\n        <h4 class=\"modal-title fontred\">{{dataText.userTitle}}</h4>\n        <p>{{dataText.userMessage}}</p>\n        <!--<h4 class=\"modal-title fontred\">Error !</h4>-->\n        <!--<p>Please check menu or group before delete this microservice.</p>-->\n        <br>\n      </div>\n    </div>\n  </div>\n</div>\n\n<!--MissingParameter create -->\n<div #myModalErrorDataExisted class=\"modal inmodal\" id=\"myModalErrorDataExisted\" tabindex=\"-1\" role=\"dialog\" aria-hidden=\"true\" data-keyboard=\"false\">\n  <div class=\"modal-dialog modal-dialog-custom modal-dialog-scrollable\">\n    <div class=\"modal-content animated fadeIn\">\n      <div class=\"bgred\">\n        <div class=\"row\"  style=\"padding-top:10px;\">\n          <div class=\"col-sm-8 pull-right m-r\">\n            <a id=\"btnCloseDataExisted\" name=\"btnCloseDataExisted\"  class=\"btn pull-right\" data-dismiss=\"modal\" style=\"border:none;\" ><font style=\"color:#ffffff;\"><i class=\"fa flaticon-cross-16px\"></i></font>\n            </a>\n          </div>\n        </div>\n        <div class=\"m-l-n-sm\">\n          <div class=\"text-center\">\n            <img src=\"assets/img/error.png\" width=\"110px\">\n          </div>\n        </div>\n      </div>\n      <br>\n      <div class=\"modal-header\">\n        <h4 class=\"modal-title fontred\">{{dataText.userTitle}}</h4>\n        <p>{{dataText.userMessage}}</p>\n        <!--<h4 class=\"modal-title fontred\">Error !</h4>-->\n        <!--<p>Data existed. Please check your data and try again.</p>-->\n        <br>\n      </div>\n    </div>\n  </div>\n</div>\n\n<div #myModalWarning class=\"modal inmodal\" id=\"myModalWarning\" class=\"modal inmodal\"  tabindex=\"-1\" role=\"dialog\" aria-hidden=\"true\" data-keyboard=\"false\">\n  <div class=\"modal-dialog modal-dialog-custom modal-dialog-scrollable\">\n    <div class=\"modal-content animated fadeIn\">\n      <div class=\"bgyellow\">\n        <div class=\"row\" style=\"padding-top:10px;\">\n          <div class=\"col-sm-8 pull-right m-r\">\n            <a id=\"btnWarningClose\" name=\"btnWarningClose\" class=\"btn pull-right\" data-dismiss=\"modal\" style=\"border:none;\"><font style=\"color:#ffffff;\"><i class=\"fa flaticon-cross-16px\"></i></font>\n            </a>\n          </div>\n        </div>\n        <div class=\"m-l-n-sm\">\n          <div class=\"text-center\">\n            <img src=\"assets/img/warning.png\" width=\"110px\">\n          </div>\n        </div>\n      </div>\n      <br>\n      <div class=\"modal-header\">\n        <h4 class=\"modal-title fontyellow\">{{dataText.userTitle}}</h4>\n        <p>{{dataText.userMessage}}</p>\n        <br>\n      </div>\n    </div>\n  </div>\n</div>\n\n<div #myModalError  class=\"modal inmodal\" id=\"myModalError\" tabindex=\"-1\" role=\"dialog\" aria-hidden=\"true\" data-keyboard=\"false\">\n  <div class=\"modal-dialog modal-dialog-custom modal-dialog-scrollable\">\n    <div class=\"modal-content animated fadeIn\">\n      <div class=\"bgred\">\n        <div class=\"row\"  style=\"padding-top:10px;\">\n          <div class=\"col-sm-8 pull-right m-r\">\n            <a id=\"btnErrorClose\" name=\"btnErrorClose\"  class=\"btn pull-right\" data-dismiss=\"modal\" style=\"border:none;\" ><font style=\"color:#ffffff;\"><i class=\"fa flaticon-cross-16px\"></i></font>\n            </a>\n          </div>\n        </div>\n        <div class=\"m-l-n-sm\">\n          <div class=\"text-center\">\n            <img src=\"assets/img/error.png\" width=\"110px\">\n          </div>\n        </div>\n      </div>\n      <br>\n      <div class=\"modal-header\">\n        <h4 class=\"modal-title fontred\">\u0E41\u0E08\u0E49\u0E07\u0E40\u0E15\u0E37\u0E2D\u0E19</h4>\n        <p>{{dataText.userMessage}}</p>\n\n        <br>\n      </div>\n    </div>\n  </div>\n</div>\n\n<!--Report Warning-->\n<div #myModalReportWarning class=\"modal inmodal\" id=\"myModalReportWarning\" tabindex=\"-1\" role=\"dialog\" aria-hidden=\"true\" data-keyboard=\"false\">\n  <div class=\"modal-dialog modal-dialog-custom modal-dialog-scrollable\">\n    <div class=\"modal-content animated fadeIn\">\n      <div class=\"bgyellow\">\n        <div class=\"row\"  style=\"padding-top:10px;\">\n          <div class=\"col-sm-8 pull-right m-r\">\n            <a  id=\"btnCloseWarning\" name=\"btnCloseWarning\"  class=\"btn pull-right\" data-dismiss=\"modal\" style=\"border:none;visibility: hidden;\" ><i class=\"fa fa-times fontyellow\"></i>\n            </a>\n          </div>\n        </div>\n        <div class=\"m-l-n-sm\">\n          <div class=\"text-center\">\n            <img src=\"assets/img/warning.png\" width=\"110px\">\n          </div>\n        </div>\n      </div>\n      <br>\n      <div class=\"modal-header\">\n        <h4 class=\"modal-title fontyellow\">\u0E44\u0E21\u0E48\u0E1E\u0E1A\u0E02\u0E49\u0E2D\u0E21\u0E39\u0E25\u0E15\u0E32\u0E21\u0E40\u0E07\u0E37\u0E48\u0E2D\u0E19\u0E44\u0E02\u0E17\u0E35\u0E48\u0E17\u0E48\u0E32\u0E19\u0E40\u0E25\u0E37\u0E2D\u0E01</h4>\n        <!--<p>\u0E44\u0E21\u0E48\u0E1E\u0E1A\u0E02\u0E49\u0E2D\u0E21\u0E39\u0E25\u0E15\u0E32\u0E21\u0E40\u0E07\u0E37\u0E48\u0E2D\u0E19\u0E44\u0E02\u0E17\u0E35\u0E48\u0E17\u0E48\u0E32\u0E19\u0E40\u0E25\u0E37\u0E2D\u0E01</p>-->\n        <br>\n        <div class=\"row\">\n          <!--<button id=\"btnConfirmCancel\" name=\"btnConfirmCancel\" type=\"button\" class=\"btn btn-default font-btn width-btn-small\" data-dismiss=\"modal\" (click)=\"onCancelDeleteModal()\" title=\"Cancel\" >Cancel</button>-->\n          <!--<button type=\"button\" class=\"btn btn-danger m-l-xs\" data-toggle=\"modal\" data-target=\"#myModal7\">Yes,delete it!</button>-->\n          <button id=\"btnConfirmOk\" name=\"btnConfirmOk\" style=\"margin-left:3px;\" class=\"btn btn-default font-btn width-btn-small\" data-dismiss=\"model\" (click)=\"onOkReportModal()\">\u0E15\u0E01\u0E25\u0E07</button>\n        </div>\n      </div>\n    </div>\n  </div>\n</div>\n"
                }] }
    ];
    /** @nocollapse */
    CreateAlertComponent.ctorParameters = function () { return [
        { type: Router }
    ]; };
    CreateAlertComponent.propDecorators = {
        dataGrid: [{ type: ViewChild, args: [DxDataGridComponent,] }],
        gridExport: [{ type: ViewChild, args: ['gridExport',] }],
        gridAlertValidExcel: [{ type: ViewChild, args: ['gridAlertValidExcel',] }],
        gridAlertErrorExcel: [{ type: ViewChild, args: ['gridAlertErrorExcel',] }],
        gridAdvance: [{ type: ViewChild, args: ['gridAdvance',] }],
        modalSuccess: [{ type: ViewChild, args: ['myModalSuccess',] }],
        modalSuccessWarning: [{ type: ViewChild, args: ['myModalSuccessWarning',] }],
        modalDelete: [{ type: ViewChild, args: ['myModalDelete',] }],
        modalConfirm: [{ type: ViewChild, args: ['myModalConfirm',] }],
        modalDeleteAttachment: [{ type: ViewChild, args: ['myModalDeleteAttachment',] }],
        modalDeleteWarning: [{ type: ViewChild, args: ['myModalDeleteWarning',] }],
        modalSuccessDelete: [{ type: ViewChild, args: ['myModalSuccessDelete',] }],
        modalEditSuccess: [{ type: ViewChild, args: ['myModalEditSuccess',] }],
        modalWarning: [{ type: ViewChild, args: ['myModalWarning',] }],
        myModalReportWarning: [{ type: ViewChild, args: ['myModalReportWarning',] }],
        modalError: [{ type: ViewChild, args: ['myModalError',] }],
        modalViewWarning: [{ type: ViewChild, args: ['myModalViewWarning',] }],
        modalProgressBarWarning: [{ type: ViewChild, args: ['myModalProgressBarWarning',] }],
        modalUploadImageWarning: [{ type: ViewChild, args: ['myModalUploadImageWarning',] }],
        modalUploadImageTypeWarning: [{ type: ViewChild, args: ['myModalUploadImageTypeWarning',] }],
        modalWarningNoTextSearch: [{ type: ViewChild, args: ['myModalWarningNoTextSearch',] }],
        modalErrorDataExisted: [{ type: ViewChild, args: ['myModalErrorDataExisted',] }],
        modalErrorDeleteButHaveMenuGroup: [{ type: ViewChild, args: ['myModalErrorDeleteButHaveMenuGroup',] }],
        modalAddVOutlook: [{ type: ViewChild, args: ['myModalAddVOutlook',] }],
        modalAddMVara: [{ type: ViewChild, args: ['myModalAddMVara',] }],
        onCloseModalError: [{ type: Output }],
        onOkDelete: [{ type: Output }],
        onOkConfirm: [{ type: Output }],
        onCancelDelete: [{ type: Output }],
        onCancelConfirm: [{ type: Output }],
        onOkDeleteAttachment: [{ type: Output }],
        onCancelDeleteAttachment: [{ type: Output }],
        onClickBack: [{ type: Output }],
        onCancelViewWarning: [{ type: Output }],
        onCancelUploadValid: [{ type: Output }],
        onDataErrorExcel: [{ type: Output }],
        onClickExport: [{ type: Output }],
        onClickDeleteExport: [{ type: Output }],
        onOkClone: [{ type: Output }],
        onOkReport: [{ type: Output }],
        onCancelClone: [{ type: Output }],
        onOkDiagramCancel: [{ type: Output }],
        onCancelDiagramCancel: [{ type: Output }],
        onCancelAddVOutlook: [{ type: Output }],
        onOkAddVOutlook: [{ type: Output }],
        onCancelAddMVara: [{ type: Output }],
        onOkAddMVara: [{ type: Output }]
    };
    return CreateAlertComponent;
}());
var CreateAlertModule = /** @class */ (function () {
    function CreateAlertModule() {
    }
    CreateAlertModule.decorators = [
        { type: NgModule, args: [{
                    imports: [DxDataGridModule, FormsModule],
                    // , CommonModule
                    exports: [CreateAlertComponent],
                    declarations: [CreateAlertComponent]
                },] }
    ];
    return CreateAlertModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
// # Calendar TH
locale('th');
var ModalStepModule = /** @class */ (function () {
    function ModalStepModule() {
    }
    ModalStepModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule,
                        SharedDateBoxModule,
                        FormsModule,
                        ReactiveFormsModule,
                        DxFileUploaderModule,
                        ModalModule.forRoot(),
                        DxDataGridModule,
                        DxTemplateModule,
                        DxTabPanelModule,
                        AutoCompleteModule,
                        TabViewModule,
                        SharedAutoCompleteModule,
                        UploadAttachmentModule,
                        DisableControlDirectiveModule,
                        CreateAlertModule,
                        SharedAutoComplete2Module
                    ], exports: [
                        ModalStepComponent
                    ], providers: [], declarations: [
                        ModalStepComponent,
                    ],
                },] }
    ];
    return ModalStepModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
// # Calendar TH
locale('th');
var ɵ0 = th_TH;
/**
 * end
 */
var StepListModule = /** @class */ (function () {
    function StepListModule() {
    }
    StepListModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule,
                        DxDataGridModule$1,
                        DxTemplateModule,
                        ModalStepModule,
                        ModalStepViewModule
                    ],
                    exports: [
                        StepListComponent
                    ],
                    declarations: [
                        StepListComponent,
                    ],
                    providers: [
                        { provide: NZ_I18N, useValue: ɵ0 },
                    ],
                },] }
    ];
    return StepListModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var Options$1 = /** @class */ (function () {
    function Options() {
    }
    return Options;
}());
var ModalAttachmentComponent = /** @class */ (function (_super) {
    __extends(ModalAttachmentComponent, _super);
    function ModalAttachmentComponent(appConfigService, request, formBuilder, common, date) {
        var _this = _super.call(this) || this;
        _this.appConfigService = appConfigService;
        _this.request = request;
        _this.formBuilder = formBuilder;
        _this.common = common;
        _this.date = date;
        _this.isImage = false;
        _this.onModalCreateSubmit = new EventEmitter();
        _this.onModalEditSubmit = new EventEmitter();
        _this.submitted = false;
        _this.title = '';
        _this.selectList = [];
        _this.modalConfig = {
            ignoreBackdropClick: true
        };
        _this.isMore = false;
        _this.attachmentData = {
            doc_type: null
        };
        _this.tmpData = {};
        _this.filteredDepartments = [];
        _this.departmentList = [];
        _this.disabledForm = false;
        _this.isOpen = false;
        _this.isEnable = false;
        _this.config = appConfigService.getConfig();
        _this.attachmentUrl = get(_this.config, 'apiServers.alfresco.url') || "https://203.154.32.126:2585/api/mfec/Alfresco";
        return _this;
    }
    /**
     * @return {?}
     */
    ModalAttachmentComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.th = this.common.fnLocalPCalendar('th');
        this.registerForm = this.formBuilder.group({
            name: [{ value: '', disabled: this.disabledForm }, Validators.required],
            doc_type: [{ value: '', disabled: this.disabledForm }],
            url: [{ value: '', disabled: this.disabledForm }],
            is_classifieds: [{ value: '', disabled: this.disabledForm }],
            is_image: [{ value: '', disabled: this.disabledForm }],
            keyword: [{ value: '', disabled: this.disabledForm }],
            book_no: [{ value: '', disabled: this.disabledForm }],
            amount: [{ value: '', disabled: this.disabledForm }],
            record_date: [{ value: '', disabled: this.disabledForm }],
            version: [{ value: '', disabled: this.disabledForm }],
            resolution: [{ value: '', disabled: this.disabledForm }],
            remark: [{ value: '', disabled: this.disabledForm }],
            moreField: this.formBuilder.array([])
        });
    };
    /**
     * @param {?=} options
     * @return {?}
     */
    ModalAttachmentComponent.prototype.open = /**
     * @param {?=} options
     * @return {?}
     */
    function (options) {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        this.isEnable = false;
                        console.log(options);
                        this.attachmentData = {};
                        if (!options) return [3 /*break*/, 2];
                        this.mode = options.mode;
                        this.title = options.title || '';
                        this.downloadToken = options.downloadToken;
                        this.attachmentData = JSON.parse(JSON.stringify(options.data));
                        if (!this.attachmentData.doc_type) {
                            this.attachmentData.doc_type = null;
                        }
                        // ต้องเปลี่ยนเป็นเรียก api
                        _a = this;
                        return [4 /*yield*/, this.request.getDropDown(options.data.system_id, "ประเภทเอกสาร")];
                    case 1:
                        // ต้องเปลี่ยนเป็นเรียก api
                        _a.selectList = _b.sent();
                        _b.label = 2;
                    case 2:
                        if (this.mode) {
                            this.attachmentData.record_date = this.date.getNow();
                        }
                        if (this.mode !== 'VIEW') {
                            if (this.mode === 'EDIT') {
                                this.isEnable = true;
                            }
                            this.uploadAttachment.clearValue();
                            this.disabledForm = false;
                        }
                        else {
                            this.disabledForm = true;
                        }
                        if (this.attachmentData.system_id === 11) {
                            this.attachmentData.is_classifieds = true;
                        }
                        this.modal.show();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @return {?}
     */
    ModalAttachmentComponent.prototype.f = /**
     * @return {?}
     */
    function () {
        return this.registerForm.controls;
    };
    /**
     * @return {?}
     */
    ModalAttachmentComponent.prototype.closeModal = /**
     * @return {?}
     */
    function () {
        this.submitted = false;
        this.selectList = [];
        this.isMore = false;
        this.moreField = [];
        this.attachmentData = {};
        this.modal.hide();
    };
    /**
     * @param {?} modal
     * @return {?}
     */
    ModalAttachmentComponent.prototype.onYesClick = /**
     * @param {?} modal
     * @return {?}
     */
    function (modal) {
        modal.hide();
    };
    /**
     * @param {?} modal
     * @return {?}
     */
    ModalAttachmentComponent.prototype.onNoClick = /**
     * @param {?} modal
     * @return {?}
     */
    function (modal) {
        modal.hide();
    };
    /**
     * @param {?} $event
     * @return {?}
     */
    ModalAttachmentComponent.prototype.onHidden = /**
     * @param {?} $event
     * @return {?}
     */
    function ($event) {
        console.log('LOG MESSAGE: ModalConfirm -> onHidden -> $event', $event);
    };
    /**
     * @return {?}
     */
    ModalAttachmentComponent.prototype.checkExtraField = /**
     * @return {?}
     */
    function () {
        console.log(this.selectList.map(function (r) { return r.name; }).indexOf(this.attachmentData.name), this.attachmentData.name);
        if (!this.attachmentData.name || this.attachmentData.name == '' || (this.selectList.map(function (r) { return r.name; }).indexOf(this.attachmentData.name) > -1)) {
            this.attachmentData.name = this.attachmentData.doc_type;
        }
        this.moreField = [];
        if (this.attachmentData.system_id) {
            // this.addField(newField, +requireFlag);
            // this.moreField.push(newField);
            this.isMore = true;
        }
        else {
            this.isMore = false;
        }
    };
    /**
     * @param {?} e
     * @return {?}
     */
    ModalAttachmentComponent.prototype.onCellPrepared = /**
     * @param {?} e
     * @return {?}
     */
    function (e) {
        if (e.rowType === 'data') {
            for (var i in e.component.columns) {
                if (e.column.dataField === e.component.columns[i]) {
                    e.cellElement.accessKey = e.component.columns[i];
                }
            }
        }
    };
    /**
     * @param {?} data
     * @param {?} required
     * @return {?}
     */
    ModalAttachmentComponent.prototype.addField = /**
     * @param {?} data
     * @param {?} required
     * @return {?}
     */
    function (data, required) {
        /** @type {?} */
        var control = /** @type {?} */ (this.registerForm.controls['moreField']);
        /** @type {?} */
        var newgroup;
        if (data.type === 'text') {
            if (required) {
                /** @type {?} */
                var group = {};
                group[data.field_name] = [{ value: '', disabled: this.disabledForm }];
                newgroup = this.formBuilder.group(group);
            }
            else {
                /** @type {?} */
                var group = {};
                group[data.field_name] = [{ value: '', disabled: this.disabledForm }];
                newgroup = this.formBuilder.group(group);
            }
        }
        else if (data.type === 'datetime') {
            if (required) {
                /** @type {?} */
                var group = {};
                group[data.field_name] = [Validators.required, CustomValidators.date];
                newgroup = this.formBuilder.group(group);
            }
            else {
                /** @type {?} */
                var group = {};
                group[data.field_name] = [{ value: '', disabled: this.disabledForm }];
                newgroup = this.formBuilder.group(group);
            }
        }
        else if (data.type === 'special') {
            if (required) {
                /** @type {?} */
                var group = {};
                group[data.field_name] = [{ value: '', disabled: this.disabledForm }];
                newgroup = this.formBuilder.group(group);
            }
            else {
                /** @type {?} */
                var group = {};
                group[data.field_name] = [{ value: '', disabled: this.disabledForm }];
                newgroup = this.formBuilder.group(group);
            }
            if (data.field_name === 'amount') {
                /** @type {?} */
                var group = {};
                group['amount_type'] = [{ value: '', disabled: this.disabledForm }];
                control.push(this.formBuilder.group(group));
            }
        }
        control.push(newgroup);
    };
    /**
     * @param {?} i
     * @param {?} field
     * @param {?=} validateType
     * @return {?}
     */
    ModalAttachmentComponent.prototype.getValidateMoreField = /**
     * @param {?} i
     * @param {?} field
     * @param {?=} validateType
     * @return {?}
     */
    function (i, field, validateType) {
        /** @type {?} */
        var formMoreField = this.f['moreField'];
        if (validateType) {
            formMoreField = formMoreField.controls[i];
            formMoreField = formMoreField.controls[field];
            if (formMoreField.errors) {
                return formMoreField.errors[validateType];
            }
            else {
                return formMoreField.errors;
            }
        }
        else {
            return formMoreField.errors;
        }
    };
    /**
     * @param {?} data
     * @return {?}
     */
    ModalAttachmentComponent.prototype.getRowIndex = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        if (!data.data) {
            return '';
        }
        /** @type {?} */
        var no = data.row.dataIndex + 1;
        return no;
    };
    /**
     * @return {?}
     */
    ModalAttachmentComponent.prototype.onSubmit = /**
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this.submitted = true;
                // ถ้า form ไม่ครบหรือผิดตามเงื่อนไขที่ตั้งไว้จะจบที่ตรงนี้
                if (this.registerForm.invalid) {
                    return [2 /*return*/];
                }
                // let postData = [];
                // await this.request.post("/db/rc_attachment",this.attachmentData);
                if (this.mode === 'CREATE') {
                    this.attachmentData.created_at = this.date.getNow();
                    if (!this.attachmentData.doc_type || this.attachmentData.doc_type === 'null') {
                        delete this.attachmentData['doc_type'];
                    }
                    this.onModalCreateSubmit.emit(cloneDeep(this.attachmentData));
                }
                else {
                    this.onModalEditSubmit.emit(cloneDeep(this.attachmentData));
                }
                this.closeModal();
                return [2 /*return*/];
            });
        });
    };
    /**
     * @param {?} data
     * @return {?}
     */
    ModalAttachmentComponent.prototype.onUploaded = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        console.log("data", data);
        if (data && data.uuid) {
            this.attachmentData.url = this.attachmentUrl + '/' + data.uuid;
            this.attachmentData.uuid = data.uuid;
            this.attachmentData.filename = data.fileName;
            this.isEnable = true;
        }
        else {
            this.isEnable = false;
        }
    };
    /**
     * @return {?}
     */
    ModalAttachmentComponent.prototype.clickUrl = /**
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        _b = (_a = window).open;
                        return [4 /*yield*/, this.request.getAttachmentLinkToken(this.attachmentData.url)];
                    case 1:
                        _b.apply(_a, [_c.sent()]);
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @param {?} data
     * @return {?}
     */
    ModalAttachmentComponent.prototype.getImageLink = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        return data.url + "?downloadToken=" + this.downloadToken;
    };
    ModalAttachmentComponent.decorators = [
        { type: Component, args: [{
                    selector: 'modal-attachment',
                    template: "<div class=\"modal fade\" bsModal #modal=\"bs-modal\" [config]=\"{backdrop: 'static'}\"\n     tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"dialog-static-name1\">\n    <div class=\"modal-dialog modal-lg\">\n        <div class=\"modal-content\">\n            <div class=\"modal-header\">\n                <h4 id=\"dialog-static-name\" class=\"modal-title pull-left\">{{title}}</h4>\n                <button type=\"button\" class=\"close pull-right\" aria-label=\"Close\" (click)=\"closeModal()\">\n                    <span aria-hidden=\"true\">&times;</span>\n                </button>\n            </div>\n            <div class=\"modal-body\">\n                <div class=\"row\">\n                    <div class=\"col-lg-12\">\n                        <form class=\"m-form m-form--state m-form--fit m-form--label-align-right\" [formGroup]=\"registerForm\" (ngSubmit)=\"onSubmit()\">\n                            <div class=\"m-portlet__body\">\n                                <!-- \u0E40\u0E2D\u0E01\u0E2A\u0E32\u0E23\u0E41\u0E19\u0E1A -->\n                                <div *ngIf=\"attachmentData.system_id !== 17\">\n                                    <div class=\"row\">\n                                        <!--<div class=\"col-sm-2\">-->\n                                            <!--<span>\u0E0A\u0E37\u0E48\u0E2D\u0E40\u0E23\u0E37\u0E48\u0E2D\u0E07 :</span>-->\n                                        <!--</div>-->\n                                        <div class=\"col-sm-12\">\n                                            <div class=\"form-group m-form__group\" [ngClass]=\"{ 'has-error': submitted && f().name.errors }\">\n                                                <label class=\"control-label\">\u0E0A\u0E37\u0E48\u0E2D\u0E40\u0E2D\u0E01\u0E2A\u0E32\u0E23<span class=\"color-red\">&nbsp;*</span></label>\n                                                <input type=\"text\" class=\"form-control m-input\" id=\"txtCategoryName\" formControlName=\"name\" [(ngModel)]=\"attachmentData.name\" [disabled]=\"disabledForm\">\n                                                <!--<input type=\"text\" class=\"form-control m-input\" id=\"txtCategoryName\" [(ngModel)]=\"stepData.name\" disabled>-->\n                                                <!--<div *ngIf=\"submitted && f().name.errors\" class=\"invalid-feedback\">-->\n                                                    <!--<div *ngIf=\"f().name.errors.required\">First Name is required</div>-->\n                                                <!--</div>-->\n                                            </div>\n                                        </div>\n                                    </div>\n                                </div>\n                                <div class=\"row\">\n                                    <!--<div class=\"col-sm-2\">-->\n                                        <!--<span>\u0E1B\u0E23\u0E30\u0E40\u0E20\u0E17\u0E40\u0E2D\u0E01\u0E2A\u0E32\u0E23 :</span>-->\n                                    <!--</div>-->\n                                    <div class=\"col-sm-12\">\n                                        <div class=\"form-group m-form__group\" [ngClass]=\"{ 'has-error': submitted && f().doc_type.errors }\">\n                                            <label class=\"control-label\">\u0E1B\u0E23\u0E30\u0E40\u0E20\u0E17\u0E40\u0E2D\u0E01\u0E2A\u0E32\u0E23</label>\n                                            <select id=\"selNewStatus\" style=\"width: 100%\" [(ngModel)]=\"attachmentData.doc_type\" formControlName=\"doc_type\"   (change)=\"checkExtraField()\" [disabled]=\"disabledForm\">\n                                                <option value=\"null\">\u0E01\u0E23\u0E38\u0E13\u0E32\u0E40\u0E25\u0E37\u0E2D\u0E01\u0E23\u0E32\u0E22\u0E01\u0E32\u0E23</option>\n                                                <option *ngFor=\"let data of selectList\" [ngValue]=\"data.name\">{{data.name}}</option>\n                                            </select>\n                                            <div *ngIf=\"submitted && f().doc_type.errors\" class=\"invalid-feedback\">\n                                                <div *ngIf=\"f().doc_type.errors.required\">First Name is required</div>\n                                            </div>\n                                        </div>\n                                    </div>\n                                </div>\n                                <div *ngIf=\"attachmentData.system_id !== 17 && attachmentData.system_id !== 11\">\n                                    <div class=\"row\">\n                                        <div class=\"col-sm-12\">\n                                            <div class=\"form-group m-form__group\" [ngClass]=\"{ 'has-error': submitted && f().remark.errors }\">\n                                                <label class=\"control-label\">\u0E2B\u0E21\u0E32\u0E22\u0E40\u0E2B\u0E15\u0E38</label>\n                                                <input type=\"text\" class=\"form-control m-input\" id=\"txtRemark\" formControlName=\"remark\" [(ngModel)]=\"attachmentData.remark\" [disabled]=\"disabledForm\">\n                                                <div *ngIf=\"submitted && f().remark.errors\" class=\"invalid-feedback\">\n                                                    <div *ngIf=\"f().remark.errors.required\">\u0E01\u0E23\u0E38\u0E13\u0E32\u0E01\u0E23\u0E2D\u0E01 \u0E2B\u0E21\u0E32\u0E22\u0E40\u0E2B\u0E15\u0E38</div>\n                                                </div>\n                                            </div>\n                                        </div>\n                                    </div>\n                                </div>\n                                <div class=\"row\">\n                                    <!--<div class=\"col-sm-2\">-->\n                                        <!--<span>\u0E40\u0E2D\u0E01\u0E2A\u0E32\u0E23\u0E41\u0E19\u0E1A :</span>-->\n                                    <!--</div>-->\n                                    <div *ngIf=\"mode !== 'VIEW'\" class=\"col-sm-12\">\n                                        <label class=\"control-label\">\u0E40\u0E2D\u0E01\u0E2A\u0E32\u0E23\u0E41\u0E19\u0E1A</label>\n                                        <upload-attachment #uploadAttachment [systemId]=\"attachmentData.system_id\" (uploaded)=\"onUploaded($event)\" [onlyImage]=\"isImage\"></upload-attachment>\n                                    </div>\n                                    <div *ngIf=\"mode === 'VIEW'\" class=\"col-sm-12\">\n                                        <label *ngIf=\"!isImage\" class=\"control-label\">\u0E40\u0E2D\u0E01\u0E2A\u0E32\u0E23\u0E41\u0E19\u0E1A</label>\n                                        <label *ngIf=\"isImage\" class=\"control-label\">\u0E40\u0E04\u0E23\u0E37\u0E48\u0E2D\u0E07\u0E2B\u0E21\u0E32\u0E22</label>\n                                        <br>\n                                        <a *ngIf=\"!isImage\" [href]=\"getImageLink(attachmentData)\" target=\"_blank\">{{attachmentData.url}}</a>\n                                        <img *ngIf=\"isImage\" [src]=\"getImageLink(attachmentData)\" style=\"width: auto !important; text-align: center\">\n                                    </div>\n                                </div>\n                                <br>\n                                <div *ngIf=\"attachmentData.system_id === 11\">\n                                    <div class=\"row\">\n                                        <!--<div class=\"col-sm-2\">-->\n                                            <!--<span>\u0E08\u0E31\u0E14\u0E40\u0E02\u0E49\u0E32\u0E27\u0E32\u0E23\u0E30 :</span>-->\n                                        <!--</div>-->\n                                        <div class=\"col-sm-12\">\n                                            <div class=\"form-group m-form__group\" [ngClass]=\"{ 'has-error': submitted && f().is_classifieds.errors }\">\n                                                <!--<label class=\"control-label\"></label>-->\n                                                <!--<label class=\"control-label\"></label>-->\n                                                <input type=\"checkbox\" id=\"chxIsClassifieds\"  name=\"is_classifieds\" formControlName=\"is_classifieds\" [(ngModel)]=\"attachmentData.is_classifieds\" [disabled]=\"disabledForm\" ng-checked> \u0E08\u0E31\u0E14\u0E40\u0E02\u0E49\u0E32\u0E27\u0E32\u0E23\u0E30\n                                                <!--<input type=\"text\" class=\"form-control m-input\" id=\"txtCategoryName\" formControlName=\"name\" [(ngModel)]=\"attachmentData.is_classifieds\">-->\n                                                <!--<div *ngIf=\"submitted && f().is_classifieds.errors\" class=\"invalid-feedback\">-->\n                                                    <!--<div *ngIf=\"f().is_classifieds.errors.required\">First Name is required</div>-->\n                                                <!--</div>-->\n                                            </div>\n                                        </div>\n                                    </div>\n                                </div>\n                                <div *ngIf=\"attachmentData.system_id === 11\">\n                                    <div class=\"row\">\n                                        <!--<div class=\"col-sm-2\">-->\n                                            <!--<span>\u0E41\u0E1B\u0E25\u0E07\u0E40\u0E1B\u0E47\u0E19\u0E20\u0E32\u0E1E\u0E41\u0E25\u0E49\u0E27 :</span>-->\n                                        <!--</div>-->\n                                        <div class=\"col-sm-12\">\n                                            <div class=\"form-group m-form__group\" [ngClass]=\"{ 'has-error': submitted && f().is_image.errors }\">\n                                                <!--<label class=\"control-label\">\u0E41\u0E1B\u0E25\u0E07\u0E40\u0E1B\u0E47\u0E19\u0E20\u0E32\u0E1E\u0E41\u0E25\u0E49\u0E27</label>-->\n                                                <!--<label class=\"control-label\"></label>-->\n                                                <input type=\"checkbox\" id=\"chxIsImage\"  name=\"is_image\" formControlName=\"is_image\" [(ngModel)]=\"attachmentData.is_image\" [disabled]=\"disabledForm\" ng-checked> \u0E41\u0E1B\u0E25\u0E07\u0E40\u0E1B\u0E47\u0E19\u0E20\u0E32\u0E1E\u0E41\u0E25\u0E49\u0E27\n                                                <!--<input type=\"text\" class=\"form-control m-input\" id=\"txtCategoryName\" formControlName=\"name\" [(ngModel)]=\"attachmentData.is_classifieds\">-->\n                                                <!--<div *ngIf=\"submitted && f().is_classifieds.errors\" class=\"invalid-feedback\">-->\n                                                <!--<div *ngIf=\"f().is_classifieds.errors.required\">First Name is required</div>-->\n                                                <!--</div>-->\n                                            </div>\n                                        </div>\n                                    </div>\n                                </div>\n                                <div *ngIf=\"attachmentData.system_id === 11\">\n                                    <div class=\"row\">\n                                        <!--<div class=\"col-sm-2\">-->\n                                            <!--<span>\u0E04\u0E33\u0E2A\u0E33\u0E04\u0E31\u0E0D :</span>-->\n                                        <!--</div>-->\n                                        <div class=\"col-sm-12\">\n                                            <div class=\"form-group m-form__group\" [ngClass]=\"{ 'has-error': submitted && f().keyword.errors }\">\n                                                <label class=\"control-label\">\u0E04\u0E33\u0E2A\u0E33\u0E04\u0E31\u0E0D</label>\n                                                <!--<label class=\"control-label\"></label>-->\n                                                <input type=\"text\" class=\"form-control m-input\" id=\"txtKeyword\" formControlName=\"keyword\" [(ngModel)]=\"attachmentData.keyword\" [disabled]=\"disabledForm\">\n                                                <!--<input type=\"text\" class=\"form-control m-input\" id=\"txtCategoryName\" formControlName=\"name\" [(ngModel)]=\"attachmentData.is_classifieds\">-->\n                                                <div *ngIf=\"submitted && f().keyword.errors\" class=\"invalid-feedback\">\n                                                    <div *ngIf=\"f().keyword.errors.required\">\u0E01\u0E23\u0E38\u0E13\u0E32\u0E01\u0E23\u0E2D\u0E01 \u0E04\u0E33\u0E2A\u0E33\u0E04\u0E31\u0E0D</div>\n                                                </div>\n                                            </div>\n                                        </div>\n                                    </div>\n                                </div>\n                                <div *ngIf=\"attachmentData.system_id === 17\">\n                                    <div class=\"row\">\n                                        <!--<div class=\"col-sm-2\">-->\n                                            <!--<span>\u0E40\u0E25\u0E02\u0E17\u0E35\u0E48\u0E40\u0E2D\u0E01\u0E2A\u0E32\u0E23 :</span>-->\n                                        <!--</div>-->\n                                        <div class=\"col-sm-12\">\n                                            <div class=\"form-group m-form__group\" [ngClass]=\"{ 'has-error': submitted && f().book_no.errors }\">\n                                                <label class=\"control-label\">\u0E40\u0E25\u0E02\u0E17\u0E35\u0E48\u0E40\u0E2D\u0E01\u0E2A\u0E32\u0E23</label>\n                                                <!--<label class=\"control-label\"></label>-->\n                                                <input type=\"text\" class=\"form-control m-input\" id=\"txtBookNo\" formControlName=\"book_no\" [(ngModel)]=\"attachmentData.book_no\" [disabled]=\"disabledForm\">\n                                                <!--<input type=\"text\" class=\"form-control m-input\" id=\"txtCategoryName\" formControlName=\"name\" [(ngModel)]=\"attachmentData.is_classifieds\">-->\n                                                <div *ngIf=\"submitted && f().book_no.errors\" class=\"invalid-feedback\">\n                                                    <div *ngIf=\"f().book_no.errors.required\">\u0E01\u0E23\u0E38\u0E13\u0E32\u0E01\u0E23\u0E2D\u0E01 \u0E40\u0E25\u0E02\u0E17\u0E35\u0E48\u0E40\u0E2D\u0E01\u0E2A\u0E32\u0E23</div>\n                                                </div>\n                                            </div>\n                                        </div>\n                                    </div>\n                                </div>\n                                <!--<div *ngIf=\"attachmentData.system_id === 17\">-->\n                                    <!--<div class=\"row\">-->\n                                        <!--<div class=\"col-sm-2\">-->\n                                            <!--<span>\u0E08\u0E33\u0E19\u0E27\u0E19 :</span>-->\n                                        <!--</div>-->\n                                        <!--<div class=\"col-sm-10\">-->\n                                            <!--<div class=\"form-group m-form__group\" [ngClass]=\"{ 'has-error': submitted && f().amount.errors }\">-->\n                                                <!--&lt;!&ndash;<label class=\"control-label\"></label>&ndash;&gt;-->\n                                                <!--<input type=\"number\" class=\"form-control m-input\" id=\"txtAmount\" name=\"amount\" formControlName=\"amount\" [(ngModel)]=\"attachmentData.amount\">-->\n                                                <!--&lt;!&ndash;<input type=\"text\" class=\"form-control m-input\" id=\"txtCategoryName\" formControlName=\"name\" [(ngModel)]=\"attachmentData.is_classifieds\">&ndash;&gt;-->\n                                                <!--<div *ngIf=\"submitted && f().amount.errors\" class=\"invalid-feedback\">-->\n                                                    <!--<div *ngIf=\"f().amount.errors.required\">\u0E01\u0E23\u0E38\u0E13\u0E32\u0E01\u0E23\u0E2D\u0E01 \u0E08\u0E33\u0E19\u0E27\u0E19</div>-->\n                                                <!--</div>-->\n                                            <!--</div>-->\n                                        <!--</div>-->\n                                    <!--</div>-->\n                                <!--</div>-->\n                                <div *ngIf=\"attachmentData.system_id === 17\">\n                                    <div class=\"row\">\n                                        <!--<div class=\"col-sm-2\">-->\n                                            <!--<span>\u0E27\u0E31\u0E19\u0E17\u0E35\u0E48\u0E08\u0E31\u0E14\u0E40\u0E01\u0E47\u0E1A :</span>-->\n                                        <!--</div>-->\n                                        <div class=\"col-sm-12\">\n                                            <div class=\"form-group m-form__group\" [ngClass]=\"{ 'has-error': submitted && f().record_date.errors }\">\n                                                <label class=\"control-label\">\u0E27\u0E31\u0E19\u0E17\u0E35\u0E48\u0E08\u0E31\u0E14\u0E40\u0E01\u0E47\u0E1A</label>\n                                                <soc-date-box [id]=\"'txtDate'\" [(value)]=\"attachmentData.record_date\" [disabled]=\"disabledForm\"></soc-date-box>\n                                                <div *ngIf=\"submitted && f().record_date.errors\" >\n                                                    <div *ngIf=\"f().record_date.errors.required\" class=\"lable-error\">\u0E01\u0E23\u0E38\u0E13\u0E32\u0E01\u0E23\u0E2D\u0E01 \u0E27\u0E31\u0E19\u0E17\u0E35\u0E48\u0E08\u0E31\u0E14\u0E40\u0E01\u0E47\u0E1A</div>\n                                                    <div *ngIf=\"f().record_date.errors.date\" class=\"lable-error\">\u0E01\u0E23\u0E38\u0E13\u0E32\u0E01\u0E23\u0E2D\u0E01 \u0E27\u0E31\u0E19\u0E17\u0E35\u0E48\u0E08\u0E31\u0E14\u0E40\u0E01\u0E47\u0E1A \u0E43\u0E2B\u0E49\u0E16\u0E39\u0E01\u0E15\u0E49\u0E2D\u0E07</div>\n                                                </div>\n                                            </div>\n                                        </div>\n                                    </div>\n                                </div>\n                                <!--<div *ngIf=\"attachmentData.system_id === 17\">-->\n                                    <!--<div class=\"row\">-->\n                                        <!--<div class=\"col-sm-2\">-->\n                                            <!--<span>\u0E40\u0E27\u0E2D\u0E23\u0E4C\u0E0A\u0E31\u0E48\u0E19/\u0E40\u0E25\u0E02\u0E23\u0E38\u0E48\u0E19 :</span>-->\n                                        <!--</div>-->\n                                        <!--<div class=\"col-sm-10\">-->\n                                            <!--<div class=\"form-group m-form__group\" [ngClass]=\"{ 'has-error': submitted && f().version.errors }\">-->\n                                                <!--<input type=\"text\" class=\"form-control m-input\" id=\"txtVersion\"  name=\"version\" formControlName=\"version\" [(ngModel)]=\"attachmentData.version\">-->\n                                                <!--<div *ngIf=\"submitted && f().version.errors\" class=\"invalid-feedback\">-->\n                                                    <!--<div *ngIf=\"f().version.errors.required\">\u0E01\u0E23\u0E38\u0E13\u0E32\u0E01\u0E23\u0E2D\u0E01 \u0E40\u0E27\u0E2D\u0E23\u0E4C\u0E0A\u0E31\u0E48\u0E19/\u0E40\u0E25\u0E02\u0E23\u0E38\u0E48\u0E19</div>-->\n                                                <!--</div>-->\n                                            <!--</div>-->\n                                        <!--</div>-->\n                                    <!--</div>-->\n                                <!--</div>-->\n                            </div>\n                            <div class=\"m-portlet__foot m-portlet__foot--fit text-right\">\n                                <div class=\"m-form__actions\" style=\"margin-left: -5px;margin-right: -5px;\">\n                                    <button *ngIf=\"mode !== 'VIEW'\" [disabled]=\"!isEnable\" type=\"submit\" class=\"btn btn-success btn-md btn-md-save\">\n                                        \u0E1A\u0E31\u0E19\u0E17\u0E36\u0E01\n                                    </button>\n                                    <button type=\"reset\" class=\"btn btn-default btn-md btn-md-search\" (click)=\"closeModal()\">\n                                        \u0E22\u0E01\u0E40\u0E25\u0E34\u0E01\n                                    </button>\n                                </div>\n                            </div>\n                        </form>\n                    </div>\n                </div>\n            </div>\n        </div>\n    </div>\n</div>"
                }] }
    ];
    /** @nocollapse */
    ModalAttachmentComponent.ctorParameters = function () { return [
        { type: AppConfigService },
        { type: Request },
        { type: FormBuilder },
        { type: Common },
        { type: DateService }
    ]; };
    ModalAttachmentComponent.propDecorators = {
        isImage: [{ type: Input }],
        onModalCreateSubmit: [{ type: Output }],
        onModalEditSubmit: [{ type: Output }],
        modal: [{ type: ViewChild, args: ['modal',] }],
        uploadAttachment: [{ type: ViewChild, args: ['uploadAttachment',] }]
    };
    return ModalAttachmentComponent;
}(Options$1));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
// # Calendar TH
locale('th');
var ModalAttachmentModule = /** @class */ (function () {
    function ModalAttachmentModule() {
    }
    ModalAttachmentModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule,
                        SharedDateBoxModule,
                        FormsModule,
                        ReactiveFormsModule,
                        ModalModule.forRoot(),
                        DxDataGridModule,
                        DxTemplateModule,
                        AutoCompleteModule,
                        UploadAttachmentModule
                    ], exports: [
                        ModalAttachmentComponent
                    ], providers: [], declarations: [
                        ModalAttachmentComponent,
                    ],
                },] }
    ];
    return ModalAttachmentModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var SocAppLibraryModule = /** @class */ (function () {
    function SocAppLibraryModule() {
    }
    SocAppLibraryModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        UploadAttachmentModule,
                        StepListModule,
                        ModalStepModule,
                        ModalStepViewModule,
                        ModalAttachmentModule
                    ],
                    declarations: [
                        SocAppLibraryComponent
                    ],
                    providers: [
                        Request,
                        Common,
                        DateService
                    ],
                    exports: [
                        SocAppLibraryComponent
                    ]
                },] }
    ];
    return SocAppLibraryModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var SentListComponent = /** @class */ (function () {
    // downloadToken:any;
    function SentListComponent(appConfigService, request, common, formBuilder, b2b) {
        this.appConfigService = appConfigService;
        this.request = request;
        this.common = common;
        this.formBuilder = formBuilder;
        this.b2b = b2b;
        this.mode = 'CREATE';
        this.sentList = [];
        this.dxgridPageSize = 10;
        this.allowedPageSizes1 = 10;
        this.allowedPageSizes2 = 25;
        this.allowedPageSizes3 = 50;
        this.allowedPageSizes4 = 100;
        this.customers = [];
        this.lastStep = '';
        this.recieveData = {};
        this.submittedRecieve = false;
        this.config = appConfigService.getConfig();
    }
    /**
     * @return {?}
     */
    SentListComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        // if(this.mode === "EDIT"){
        // setTimeout(async ()=>{
        //     this.downloadToken = await this.b2b.getAttachmentToken();
        // },500)
        this.getSentList();
        this.recieveForm = this.formBuilder.group({
            book_no: ['', [Validators.required]],
            recv_date: new FormControl(''),
        });
        // }
    };
    /**
     * @return {?}
     */
    SentListComponent.prototype.fr = /**
     * @return {?}
     */
    function () { return this.recieveForm.controls; };
    /**
     * @return {?}
     */
    SentListComponent.prototype.getSentList = /**
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            var sentData, filter$$1, data;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        console.log('getSentList', this.sentList);
                        sentData = this.option.data;
                        filter$$1 = {
                            filter: {
                                ref_table: sentData.ref_table,
                                ref_id: sentData.ref_id
                            },
                            order_by: ["is_important", "send_book_no", "created_at"]
                        };
                        return [4 /*yield*/, this.request.post('/search/v_ct_step_sent', filter$$1)];
                    case 1:
                        data = _a.sent();
                        this.sentList = data.resultData;
                        console.log('getSentList', this.sentList);
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @param {?} data
     * @return {?}
     */
    SentListComponent.prototype.getRowIndex = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        if (!data.data) {
            return '';
        }
        /** @type {?} */
        var page = this.dxDataGridSentList.instance.option('paging.pageIndex') || 0;
        /** @type {?} */
        var pageSize = this.dxDataGridSentList.instance.option('paging.pageSize');
        /** @type {?} */
        var no = data.row.dataIndex + 1;
        return page * pageSize + no;
    };
    /**
     * @param {?} data
     * @return {?}
     */
    SentListComponent.prototype.editRecieve = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        console.log('data', data);
        this.tmpData = data;
        this.recieveModal.show();
    };
    /**
     * @return {?}
     */
    SentListComponent.prototype.closeRecieveModal = /**
     * @return {?}
     */
    function () {
        this.submittedRecieve = false;
        this.recieveData = {};
        this.tmpData = {};
        this.recieveModal.hide();
    };
    /**
     * @return {?}
     */
    SentListComponent.prototype.onSubmitRecieve = /**
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.submittedRecieve = true;
                        // ถ้า form ไม่ครบหรือผิดตามเงื่อนไขที่ตั้งไว้จะจบที่ตรงนี้
                        if (this.recieveForm.invalid) {
                            return [2 /*return*/];
                        }
                        console.log('tmpData', this.tmpData);
                        this.recieveData.name = this.tmpData.name;
                        if (this.tmpData.ct_main_id)
                            this.recieveData.ct_main_id = this.tmpData.ct_main_id;
                        if (this.tmpData.ct_send_id)
                            this.recieveData.ct_send_id = this.tmpData.ct_send_id;
                        if (this.tmpData.ct_step_data_id)
                            this.recieveData.ct_step_data_id = this.tmpData.ct_step_data_id;
                        console.log('recieveData', this.recieveData);
                        return [4 /*yield*/, this.request.post("/db/ct_recieve", this.recieveData)];
                    case 1:
                        _a.sent();
                        this.getSentList();
                        this.closeRecieveModal();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @param {?} data
     * @return {?}
     */
    SentListComponent.prototype.isImportant = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        return data.is_important ? "สำคัญ" : "";
    };
    /**
     * @param {?} e
     * @return {?}
     */
    SentListComponent.prototype.onCellPrepared = /**
     * @param {?} e
     * @return {?}
     */
    function (e) {
        if (e.rowType === 'data') {
            e.cellElement.accessKey = e.column.caption;
        }
    };
    SentListComponent.decorators = [
        { type: Component, args: [{
                    selector: 'soc-sent-list',
                    template: "\n<div class=\"col-sm-12\">\n    <div class=\"table-responsive table-wrapper\">\n        <dx-data-grid #dxDataGridSentList\n                      id=\"gridContainer\" noDataText=\"\" showBorders=\"true\" class=\"card-list-table\"\n                      (onCellPrepared)=\"onCellPrepared($event)\" [dataSource]=\"sentList\"\n                      [hoverStateEnabled]=\"true\" [rowAlternationEnabled]=\"true\" [columnAutoWidth]=\"false\"\n                      [allowColumnResizing]=\"true\" [allowColumnReordering]=\"true\" [wordWrapEnabled]=\"false\"\n                      [showBorders]=\"true\">\n            <dxi-column caption=\"\u0E23\u0E32\u0E22\u0E01\u0E32\u0E23\u0E17\u0E35\u0E48\" [allowSorting]=\"false\" cellTemplate=\"cellTemplate\" alignment=\"center\" [width]=\"70\"></dxi-column>\n            <dxi-column *ngIf=\"mode === 'EDIT'\" caption=\"\u0E08\u0E31\u0E14\u0E01\u0E32\u0E23\" [allowSorting]=\"false\" cellTemplate=\"cellTemplateAction\" alignment=\"center\" [width]=\"70\"></dxi-column>\n            <dxi-column dataField=\"send_to\" caption=\"\u0E2B\u0E19\u0E48\u0E27\u0E22\u0E07\u0E32\u0E19\"></dxi-column>\n            <dxi-column dataField=\"send_book_no\" caption=\"\u0E40\u0E25\u0E02\u0E17\u0E35\u0E48\u0E2B\u0E19\u0E31\u0E07\u0E2A\u0E37\u0E2D\u0E2A\u0E48\u0E07\u0E2D\u0E2D\u0E01\"></dxi-column>\n            <dxi-column dataField=\"send_date\" caption=\"\u0E27\u0E31\u0E19\u0E17\u0E35\u0E48\u0E2A\u0E48\u0E07\u0E2D\u0E2D\u0E01\" dataType=\"date\" alignment=\"center\" [width]=\"100\"></dxi-column>\n            <dxi-column [calculateCellValue]=\"isImportant\" caption=\"\u0E04\u0E27\u0E32\u0E21\u0E2A\u0E33\u0E04\u0E31\u0E0D\"></dxi-column>\n            <dxi-column dataField=\"book_no\" caption=\"\u0E40\u0E25\u0E02\u0E17\u0E35\u0E48\u0E23\u0E31\u0E1A\u0E2B\u0E19\u0E31\u0E07\u0E2A\u0E37\u0E2D\"></dxi-column>\n            <dxi-column dataField=\"recv_date\" caption=\"\u0E27\u0E31\u0E19\u0E17\u0E35\u0E48\u0E23\u0E31\u0E1A\" dataType=\"date\" alignment=\"center\" [width]=\"100\"></dxi-column>\n            <dxo-paging [pageSize]=\"dxgridPageSize\"></dxo-paging>\n            <dxo-pager [showPageSizeSelector]=\"true\" [allowedPageSizes]=\"[allowedPageSizes1, allowedPageSizes2, allowedPageSizes3, allowedPageSizes4]\"\n                       [showInfo]=\"false\" [visible]=\"true\" [showNavigationButtons]=\"true\">\n            </dxo-pager>\n            <dxo-state-storing [enabled]=\"true\" type=\"localStorage\" storageKey=\"sentListDataGrid\"></dxo-state-storing>\n            <div *dxTemplate=\"let data of 'cellTemplate'\">\n                {{getRowIndex(data)}}\n            </div>\n            <div *dxTemplate=\"let data of 'cellTemplateAction'\">\n                <a *ngIf=\"mode === 'EDIT'\" id=\"btnEditRecieve\" (click)=\"editRecieve(data.data)\" class=\"btn btn-default btn-sm icon\" data-toggle=\"tooltip\" data-placement=\"top\" title=\"\u0E41\u0E01\u0E49\u0E44\u0E02\"><i class=\"fal fa-pencil-alt\"></i></a>\n            </div>\n        </dx-data-grid>\n    </div>\n</div><!--End col-sm-12-->\n<div class=\"modal fade\" bsModal #recieveModal=\"bs-modal\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"dialog-static-name2\" [config]=\"{backdrop: 'static'}\">\n    <div class=\"modal-dialog modal-md\">\n        <div class=\"modal-content\">\n            <div class=\"modal-header\">\n                <h4 id=\"dialog-static-recieve\" class=\"modal-title pull-left\"><label>\u0E23\u0E31\u0E1A\u0E2B\u0E19\u0E31\u0E07\u0E2A\u0E37\u0E2D \u0E15\u0E2D\u0E1A\u0E04\u0E27\u0E32\u0E21\u0E40\u0E2B\u0E47\u0E19</label></h4>\n                <button type=\"button\" class=\"close pull-right\" aria-label=\"Close\" (click)=\"closeRecieveModal()\">\n                    <span aria-hidden=\"true\">&times;</span>\n                </button>\n            </div>\n            <div class=\"modal-body\">\n                <form class=\"m-form m-form--state m-form--fit m-form--label-align-right\" [formGroup]=\"recieveForm\" (ngSubmit)=\"onSubmitRecieve()\">\n                    <div class=\"ibox-body\">\n                        <div class=\"row\">\n                            <div class=\"form-group\">\n                                <label class=\"control-label\">\u0E40\u0E25\u0E02\u0E17\u0E35\u0E48\u0E23\u0E31\u0E1A\u0E2B\u0E19\u0E31\u0E07\u0E2A\u0E37\u0E2D</label>\n                                <div class=\"form-group m-form__group\" [ngClass]=\"{ 'has-error': submittedRecieve && fr().book_no.errors }\">\n                                    <input type=\"text\" class=\"form-control m-input\" id=\"txtRecieveBookNo\" formControlName=\"book_no\" [(ngModel)]=\"recieveData.book_no\">\n                                    <div *ngIf=\"submittedRecieve && fr().book_no.errors\" class=\"invalid-feedback\">\n                                        <div *ngIf=\"fr().book_no.errors.required\">First Name is required</div>\n                                    </div>\n                                </div>\n                            </div>\n                            <div class=\"form-group\">\n                                <label class=\"control-label\">\u0E27\u0E31\u0E19\u0E17\u0E35\u0E48\u0E23\u0E31\u0E1A</label>\n                                <!--<div class=\"form-group m-form__group\" [ngClass]=\"{ 'has-error': submittedRecieve && fr().recv_date.errors }\">-->\n                                    <soc-date-box [id]=\"'txtRecieveDate'\" [(value)]=\"recieveData.recv_date\"></soc-date-box>\n                                    <!--<div *ngIf=\"submittedRecieve && fr().recv_date.errors\" >-->\n                                        <!--<div *ngIf=\"fr().recv_date.errors.required\" class=\"lable-error\">Date is required</div>-->\n                                        <!--<div *ngIf=\"fr().recv_date.errors.date\" class=\"lable-error\">Date is invalid</div>-->\n                                    <!--</div>-->\n                                <!--</div>-->\n                            </div>\n                        </div>\n                    </div>\n                    <div class=\"m-portlet__foot m-portlet__foot--fit text-right\">\n                        <div class=\"m-form__actions\">\n                            <button type=\"submit\" class=\"btn btn-success btn-md btn-md-save\">\n                                \u0E1A\u0E31\u0E19\u0E17\u0E36\u0E01\n                            </button>\n                            <button type=\"reset\" class=\"btn btn-default btn-md btn-md-search\" (click)=\"closeRecieveModal()\">\n                                \u0E22\u0E01\u0E40\u0E25\u0E34\u0E01\n                            </button>\n                        </div>\n                    </div>\n                </form>\n            </div>\n        </div>\n    </div>\n</div>\n"
                }] }
    ];
    /** @nocollapse */
    SentListComponent.ctorParameters = function () { return [
        { type: AppConfigService },
        { type: Request },
        { type: Common },
        { type: FormBuilder },
        { type: B2bService }
    ]; };
    SentListComponent.propDecorators = {
        mode: [{ type: Input }],
        option: [{ type: Input }],
        dxDataGridSentList: [{ type: ViewChild, args: ['dxDataGridSentList',] }],
        modalStepView: [{ type: ViewChild, args: ['modalStepView',] }],
        recieveModal: [{ type: ViewChild, args: ['recieveModal',] }]
    };
    return SentListComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
// # Calendar TH
locale('th');
var ɵ0$1 = th_TH;
/**
 * end
 */
var SentListModule = /** @class */ (function () {
    function SentListModule() {
    }
    SentListModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule,
                        DxDataGridModule$1,
                        DxTemplateModule,
                        ModalStepModule,
                        FormsModule,
                        ModalModule.forRoot(),
                        ReactiveFormsModule,
                        SharedDateBoxModule,
                        ModalStepViewModule
                    ],
                    exports: [
                        SentListComponent
                    ],
                    declarations: [
                        SentListComponent,
                    ],
                    providers: [
                        { provide: NZ_I18N, useValue: ɵ0$1 },
                    ],
                },] }
    ];
    return SentListModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var Options$2 = /** @class */ (function () {
    function Options() {
    }
    return Options;
}());
var ModalAttachmentViewComponent = /** @class */ (function (_super) {
    __extends(ModalAttachmentViewComponent, _super);
    function ModalAttachmentViewComponent(appConfigService, request, formBuilder, common) {
        var _this = _super.call(this) || this;
        _this.appConfigService = appConfigService;
        _this.request = request;
        _this.formBuilder = formBuilder;
        _this.common = common;
        _this.isImage = false;
        _this.onModalCreateSubmit = new EventEmitter();
        _this.onModalEditSubmit = new EventEmitter();
        _this.submitted = false;
        _this.title = '';
        _this.selectList = [];
        _this.modalConfig = {
            ignoreBackdropClick: true
        };
        _this.isMore = false;
        _this.attachmentData = {
            doc_type: null
        };
        _this.tmpData = {};
        _this.filteredDepartments = [];
        _this.departmentList = [];
        _this.disabledForm = false;
        _this.isOpen = false;
        _this.config = appConfigService.getConfig();
        _this.attachmentUrl = get(_this.config, 'apiServers.alfresco.url') || "https://203.154.32.126:2585/api/mfec/Alfresco";
        return _this;
    }
    /**
     * @return {?}
     */
    ModalAttachmentViewComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.th = this.common.fnLocalPCalendar('th');
        this.registerForm = this.formBuilder.group({
            name: [{ value: '', disabled: this.disabledForm }],
            doc_type: [{ value: '', disabled: this.disabledForm }],
            url: [{ value: '', disabled: this.disabledForm }],
            is_classifieds: [{ value: '', disabled: this.disabledForm }],
            is_image: [{ value: '', disabled: this.disabledForm }],
            keyword: [{ value: '', disabled: this.disabledForm }],
            book_no: [{ value: '', disabled: this.disabledForm }],
            amount: [{ value: '', disabled: this.disabledForm }],
            record_date: [{ value: '', disabled: this.disabledForm }],
            version: [{ value: '', disabled: this.disabledForm }],
            resolution: [{ value: '', disabled: this.disabledForm }],
            remark: [{ value: '', disabled: this.disabledForm }],
            moreField: this.formBuilder.array([])
        });
    };
    /**
     * @param {?=} options
     * @return {?}
     */
    ModalAttachmentViewComponent.prototype.open = /**
     * @param {?=} options
     * @return {?}
     */
    function (options) {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        console.log(options);
                        this.attachmentData = {};
                        if (!options) return [3 /*break*/, 2];
                        this.mode = options.mode;
                        this.title = options.title || '';
                        this.downloadToken = options.downloadToken;
                        this.attachmentData = cloneDeep(options.data);
                        if (!this.attachmentData.doc_type) {
                            this.attachmentData.doc_type = null;
                        }
                        // ต้องเปลี่ยนเป็นเรียก api
                        _a = this;
                        return [4 /*yield*/, this.request.getDropDown(options.data.system_id, "ประเภทเอกสาร")];
                    case 1:
                        // ต้องเปลี่ยนเป็นเรียก api
                        _a.selectList = _b.sent();
                        _b.label = 2;
                    case 2:
                        if (this.mode !== 'VIEW') {
                            this.uploadAttachment.clearValue();
                            this.disabledForm = false;
                        }
                        else {
                            this.disabledForm = true;
                        }
                        this.modal.show();
                        this.isOpen = true;
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @return {?}
     */
    ModalAttachmentViewComponent.prototype.f = /**
     * @return {?}
     */
    function () {
        return this.registerForm.controls;
    };
    /**
     * @return {?}
     */
    ModalAttachmentViewComponent.prototype.closeModal = /**
     * @return {?}
     */
    function () {
        this.submitted = false;
        this.selectList = [];
        this.isMore = false;
        this.moreField = [];
        this.attachmentData = {};
        this.modal.hide();
        this.isOpen = false;
    };
    /**
     * @param {?} modal
     * @return {?}
     */
    ModalAttachmentViewComponent.prototype.onYesClick = /**
     * @param {?} modal
     * @return {?}
     */
    function (modal) {
        modal.hide();
    };
    /**
     * @param {?} modal
     * @return {?}
     */
    ModalAttachmentViewComponent.prototype.onNoClick = /**
     * @param {?} modal
     * @return {?}
     */
    function (modal) {
        modal.hide();
    };
    /**
     * @param {?} $event
     * @return {?}
     */
    ModalAttachmentViewComponent.prototype.onHidden = /**
     * @param {?} $event
     * @return {?}
     */
    function ($event) {
        console.log('LOG MESSAGE: ModalConfirm -> onHidden -> $event', $event);
    };
    /**
     * @return {?}
     */
    ModalAttachmentViewComponent.prototype.checkExtraField = /**
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this.moreField = [];
                if (this.attachmentData.system_id) {
                    // this.addField(newField, +requireFlag);
                    // this.moreField.push(newField);
                    this.isMore = true;
                }
                else {
                    this.isMore = false;
                }
                return [2 /*return*/];
            });
        });
    };
    /**
     * @param {?} e
     * @return {?}
     */
    ModalAttachmentViewComponent.prototype.onCellPrepared = /**
     * @param {?} e
     * @return {?}
     */
    function (e) {
        if (e.rowType === 'data') {
            for (var i in e.component.columns) {
                if (e.column.dataField === e.component.columns[i]) {
                    e.cellElement.accessKey = e.component.columns[i];
                }
            }
        }
    };
    /**
     * @param {?} data
     * @param {?} required
     * @return {?}
     */
    ModalAttachmentViewComponent.prototype.addField = /**
     * @param {?} data
     * @param {?} required
     * @return {?}
     */
    function (data, required) {
        /** @type {?} */
        var control = /** @type {?} */ (this.registerForm.controls['moreField']);
        /** @type {?} */
        var newgroup;
        if (data.type === 'text') {
            if (required) {
                /** @type {?} */
                var group = {};
                group[data.field_name] = [{ value: '', disabled: this.disabledForm }];
                newgroup = this.formBuilder.group(group);
            }
            else {
                /** @type {?} */
                var group = {};
                group[data.field_name] = [{ value: '', disabled: this.disabledForm }];
                newgroup = this.formBuilder.group(group);
            }
        }
        else if (data.type === 'datetime') {
            if (required) {
                /** @type {?} */
                var group = {};
                group[data.field_name] = [Validators.required, CustomValidators.date];
                newgroup = this.formBuilder.group(group);
            }
            else {
                /** @type {?} */
                var group = {};
                group[data.field_name] = [{ value: '', disabled: this.disabledForm }];
                newgroup = this.formBuilder.group(group);
            }
        }
        else if (data.type === 'special') {
            if (required) {
                /** @type {?} */
                var group = {};
                group[data.field_name] = [{ value: '', disabled: this.disabledForm }];
                newgroup = this.formBuilder.group(group);
            }
            else {
                /** @type {?} */
                var group = {};
                group[data.field_name] = [{ value: '', disabled: this.disabledForm }];
                newgroup = this.formBuilder.group(group);
            }
            if (data.field_name === 'amount') {
                /** @type {?} */
                var group = {};
                group['amount_type'] = [{ value: '', disabled: this.disabledForm }];
                control.push(this.formBuilder.group(group));
            }
        }
        control.push(newgroup);
    };
    /**
     * @param {?} i
     * @param {?} field
     * @param {?=} validateType
     * @return {?}
     */
    ModalAttachmentViewComponent.prototype.getValidateMoreField = /**
     * @param {?} i
     * @param {?} field
     * @param {?=} validateType
     * @return {?}
     */
    function (i, field, validateType) {
        /** @type {?} */
        var formMoreField = this.f['moreField'];
        if (validateType) {
            formMoreField = formMoreField.controls[i];
            formMoreField = formMoreField.controls[field];
            if (formMoreField.errors) {
                return formMoreField.errors[validateType];
            }
            else {
                return formMoreField.errors;
            }
        }
        else {
            return formMoreField.errors;
        }
    };
    /**
     * @param {?} data
     * @return {?}
     */
    ModalAttachmentViewComponent.prototype.getRowIndex = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        if (!data.data) {
            return '';
        }
        /** @type {?} */
        var no = data.row.dataIndex + 1;
        return no;
    };
    /**
     * @return {?}
     */
    ModalAttachmentViewComponent.prototype.onSubmit = /**
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this.submitted = true;
                // ถ้า form ไม่ครบหรือผิดตามเงื่อนไขที่ตั้งไว้จะจบที่ตรงนี้
                if (this.registerForm.invalid) {
                    return [2 /*return*/];
                }
                // let postData = [];
                // await this.request.post("/db/rc_attachment",this.attachmentData);
                if (this.mode === 'CREATE') {
                    this.onModalCreateSubmit.emit(this.attachmentData);
                }
                else {
                    this.onModalEditSubmit.emit(this.attachmentData);
                }
                this.closeModal();
                this.isOpen = false;
                return [2 /*return*/];
            });
        });
    };
    /**
     * @param {?} data
     * @return {?}
     */
    ModalAttachmentViewComponent.prototype.onUploaded = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        console.log("data", data);
        this.attachmentData.url = this.attachmentUrl + '/' + data.uuid;
        this.attachmentData.uuid = data.uuid;
        this.attachmentData.filename = data.fileName;
    };
    /**
     * @return {?}
     */
    ModalAttachmentViewComponent.prototype.clickUrl = /**
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        _b = (_a = window).open;
                        return [4 /*yield*/, this.request.getAttachmentLinkToken(this.attachmentData.url)];
                    case 1:
                        _b.apply(_a, [_c.sent()]);
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @param {?} data
     * @return {?}
     */
    ModalAttachmentViewComponent.prototype.getImageLink = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        return data.url + "?downloadToken=" + this.downloadToken;
    };
    ModalAttachmentViewComponent.decorators = [
        { type: Component, args: [{
                    selector: 'modal-attachment-view',
                    template: "<div class=\"modal fade\" bsModal #modal=\"bs-modal\" [config]=\"{backdrop: 'static'}\"\n     tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"dialog-static-name1\">\n    <div class=\"modal-dialog modal-lg\">\n        <div class=\"modal-content\">\n            <div class=\"modal-header\">\n                <h4 id=\"dialog-static-name\" class=\"modal-title pull-left\">{{title}}</h4>\n                <button type=\"button\" class=\"close pull-right\" aria-label=\"Close\" (click)=\"closeModal()\">\n                    <span aria-hidden=\"true\">&times;</span>\n                </button>\n            </div>\n            <div class=\"modal-body\">\n                <div class=\"row\">\n                    <div class=\"col-lg-12\">\n                        <!--<form *ngIf=\"isOpen\" class=\"m-form m-form&#45;&#45;state m-form&#45;&#45;fit m-form&#45;&#45;label-align-right\" [formGroup]=\"registerForm\" (ngSubmit)=\"onSubmit()\">-->\n                            <div class=\"m-portlet__body\">\n                                <!-- \u0E40\u0E2D\u0E01\u0E2A\u0E32\u0E23\u0E41\u0E19\u0E1A -->\n                                <div *ngIf=\"attachmentData.system_id !== 17\">\n                                    <div class=\"row\">\n                                        <!--<div class=\"col-sm-2\">-->\n                                            <!--<span>\u0E0A\u0E37\u0E48\u0E2D\u0E40\u0E23\u0E37\u0E48\u0E2D\u0E07 :</span>-->\n                                        <!--</div>-->\n                                        <div class=\"col-sm-12\">\n                                            <!--<div class=\"form-group m-form__group\" [ngClass]=\"{ 'has-error': submitted && f().name.errors }\">-->\n                                                <label class=\"control-label\">\u0E0A\u0E37\u0E48\u0E2D\u0E40\u0E2D\u0E01\u0E2A\u0E32\u0E23</label>\n                                                <!--<input type=\"text\" class=\"form-control m-input\" id=\"txtCategoryName\" disabled>-->\n                                                <input type=\"text\" class=\"form-control m-input\" id=\"txtCategoryName\" [(ngModel)]=\"attachmentData.name\" disabled>\n                                                <!--<div *ngIf=\"submitted && f().name.errors\" class=\"invalid-feedback\">-->\n                                                    <!--<div *ngIf=\"f().name.errors.required\">First Name is required</div>-->\n                                                <!--</div>-->\n                                            <!--</div>-->\n                                        </div>\n                                    </div>\n                                </div>\n                                <div class=\"row\">\n                                    <!--<div class=\"col-sm-2\">-->\n                                        <!--<span>\u0E1B\u0E23\u0E30\u0E40\u0E20\u0E17\u0E40\u0E2D\u0E01\u0E2A\u0E32\u0E23 :</span>-->\n                                    <!--</div>-->\n                                    <div class=\"col-sm-12\">\n                                        <!--<div class=\"form-group m-form__group\" [ngClass]=\"{ 'has-error': submitted && f().doc_type.errors }\">-->\n                                            <label class=\"control-label\">\u0E1B\u0E23\u0E30\u0E40\u0E20\u0E17\u0E40\u0E2D\u0E01\u0E2A\u0E32\u0E23</label>\n                                            <select id=\"selNewStatus\" style=\"width: 100%\" [(ngModel)]=\"attachmentData.doc_type\" disabled>\n                                                <option value=\"null\">\u0E01\u0E23\u0E38\u0E13\u0E32\u0E40\u0E25\u0E37\u0E2D\u0E01\u0E23\u0E32\u0E22\u0E01\u0E32\u0E23</option>\n                                                <option *ngFor=\"let data of selectList\" [ngValue]=\"data.name\">{{data.name}}</option>\n                                            </select>\n                                            <!--<div *ngIf=\"submitted && f().doc_type.errors\" class=\"invalid-feedback\">-->\n                                                <!--<div *ngIf=\"f().doc_type.errors.required\">First Name is required</div>-->\n                                            <!--</div>-->\n                                        <!--</div>-->\n                                    </div>\n                                </div>\n                                <div *ngIf=\"attachmentData.system_id !== 17 && attachmentData.system_id !== 11\">\n                                    <div class=\"row\">\n                                        <div class=\"col-sm-12\">\n                                            <!--<div class=\"form-group m-form__group\" [ngClass]=\"{ 'has-error': submitted && f().remark.errors }\">-->\n                                            <label class=\"control-label\">\u0E2B\u0E21\u0E32\u0E22\u0E40\u0E2B\u0E15\u0E38</label>\n                                                <!--<input type=\"text\" class=\"form-control m-input\" id=\"txtRemark\" formControlName=\"remark\" [(ngModel)]=\"attachmentData.remark\" [disabled]=\"disabledForm\">-->\n                                            <input type=\"text\" class=\"form-control m-input\" id=\"txtRemark\" [(ngModel)]=\"attachmentData.remark\" disabled>\n                                                <!--<div *ngIf=\"submitted && f().remark.errors\" class=\"invalid-feedback\">-->\n                                                    <!--<div *ngIf=\"f().remark.errors.required\">\u0E01\u0E23\u0E38\u0E13\u0E32\u0E01\u0E23\u0E2D\u0E01 \u0E2B\u0E21\u0E32\u0E22\u0E40\u0E2B\u0E15\u0E38</div>-->\n                                                <!--</div>-->\n                                            <!--</div>-->\n                                        </div>\n                                    </div>\n                                </div>\n                                <div class=\"row\">\n                                    <!--<div class=\"col-sm-2\">-->\n                                        <!--<span>\u0E40\u0E2D\u0E01\u0E2A\u0E32\u0E23\u0E41\u0E19\u0E1A :</span>-->\n                                    <!--</div>-->\n                                    <div class=\"col-sm-12\">\n                                        <!--<label class=\"control-label\">\u0E40\u0E2D\u0E01\u0E2A\u0E32\u0E23\u0E41\u0E19\u0E1A</label>-->\n                                        <!--<upload-attachment #uploadAttachment [systemId]=\"attachmentData.system_id\" (uploaded)=\"onUploaded($event)\" [onlyImage]=\"isImage\"></upload-attachment>-->\n                                    <!--</div>-->\n                                    <!--<div *ngIf=\"mode === 'VIEW'\" class=\"col-sm-12\">-->\n                                        <label *ngIf=\"!isImage\" class=\"control-label\">\u0E40\u0E2D\u0E01\u0E2A\u0E32\u0E23\u0E41\u0E19\u0E1A</label>\n                                        <label *ngIf=\"isImage\" class=\"control-label\">\u0E40\u0E04\u0E23\u0E37\u0E48\u0E2D\u0E07\u0E2B\u0E21\u0E32\u0E22</label>\n                                        <br>\n                                        <a *ngIf=\"!isImage\" [href]=\"getImageLink(attachmentData)\" target=\"_blank\">{{attachmentData.url}}</a>\n                                        <img *ngIf=\"isImage\" [src]=\"getImageLink(attachmentData)\" style=\"width: auto !important; text-align: center\">\n                                    </div>\n                                </div>\n                                <br>\n                                <div *ngIf=\"attachmentData.system_id === 11\">\n                                    <div class=\"row\">\n                                        <!--<div class=\"col-sm-2\">-->\n                                            <!--<span>\u0E08\u0E31\u0E14\u0E40\u0E02\u0E49\u0E32\u0E27\u0E32\u0E23\u0E30 :</span>-->\n                                        <!--</div>-->\n                                        <div class=\"col-sm-12\">\n                                            <!--<div class=\"form-group m-form__group\" [ngClass]=\"{ 'has-error': submitted && f().is_classifieds.errors }\">-->\n                                                <!--<label class=\"control-label\"></label>-->\n                                                <!--<label class=\"control-label\"></label>-->\n                                                <input type=\"checkbox\" class=\"form-control m-input\" id=\"chxIsClassifieds\" [(ngModel)]=\"attachmentData.is_classifieds\" disabled> \u0E08\u0E31\u0E14\u0E40\u0E02\u0E49\u0E32\u0E27\u0E32\u0E23\u0E30\n                                                <!--<input type=\"text\" class=\"form-control m-input\" id=\"txtCategoryName\" formControlName=\"name\" [(ngModel)]=\"attachmentData.is_classifieds\">-->\n                                                <!--<div *ngIf=\"submitted && f().is_classifieds.errors\" class=\"invalid-feedback\">-->\n                                                    <!--<div *ngIf=\"f().is_classifieds.errors.required\">First Name is required</div>-->\n                                                <!--</div>-->\n                                            <!--</div>-->\n                                        </div>\n                                    </div>\n                                </div>\n                                <div *ngIf=\"attachmentData.system_id === 11\">\n                                    <div class=\"row\">\n                                        <!--<div class=\"col-sm-2\">-->\n                                            <!--<span>\u0E41\u0E1B\u0E25\u0E07\u0E40\u0E1B\u0E47\u0E19\u0E20\u0E32\u0E1E\u0E41\u0E25\u0E49\u0E27 :</span>-->\n                                        <!--</div>-->\n                                        <div class=\"col-sm-12\">\n                                            <!--<div class=\"form-group m-form__group\" [ngClass]=\"{ 'has-error': submitted && f().is_image.errors }\">-->\n                                                <!--<label class=\"control-label\">\u0E41\u0E1B\u0E25\u0E07\u0E40\u0E1B\u0E47\u0E19\u0E20\u0E32\u0E1E\u0E41\u0E25\u0E49\u0E27</label>-->\n                                                <!--<label class=\"control-label\"></label>-->\n                                                <input type=\"checkbox\" class=\"form-control m-input\" id=\"chxIsImage\" [(ngModel)]=\"attachmentData.is_image\" disabled> \u0E41\u0E1B\u0E25\u0E07\u0E40\u0E1B\u0E47\u0E19\u0E20\u0E32\u0E1E\u0E41\u0E25\u0E49\u0E27\n                                                <!--<input type=\"text\" class=\"form-control m-input\" id=\"txtCategoryName\" formControlName=\"name\" [(ngModel)]=\"attachmentData.is_classifieds\">-->\n                                                <!--<div *ngIf=\"submitted && f().is_classifieds.errors\" class=\"invalid-feedback\">-->\n                                                <!--<div *ngIf=\"f().is_classifieds.errors.required\">First Name is required</div>-->\n                                                <!--</div>-->\n                                            <!--</div>-->\n                                        </div>\n                                    </div>\n                                </div>\n                                <div *ngIf=\"attachmentData.system_id === 11\">\n                                    <div class=\"row\">\n                                        <!--<div class=\"col-sm-2\">-->\n                                            <!--<span>\u0E04\u0E33\u0E2A\u0E33\u0E04\u0E31\u0E0D :</span>-->\n                                        <!--</div>-->\n                                        <div class=\"col-sm-12\">\n                                            <!--<div class=\"form-group m-form__group\" [ngClass]=\"{ 'has-error': submitted && f().keyword.errors }\">-->\n                                                <label class=\"control-label\">\u0E04\u0E33\u0E2A\u0E33\u0E04\u0E31\u0E0D</label>\n                                                <!--<label class=\"control-label\"></label>-->\n                                                <input type=\"text\" class=\"form-control m-input\" id=\"txtKeyword\" [(ngModel)]=\"attachmentData.keyword\" disabled>\n                                                <!--<input type=\"text\" class=\"form-control m-input\" id=\"txtCategoryName\" formControlName=\"name\" [(ngModel)]=\"attachmentData.is_classifieds\">-->\n                                                <!--<div *ngIf=\"submitted && f().keyword.errors\" class=\"invalid-feedback\">-->\n                                                    <!--<div *ngIf=\"f().keyword.errors.required\">\u0E01\u0E23\u0E38\u0E13\u0E32\u0E01\u0E23\u0E2D\u0E01 \u0E04\u0E33\u0E2A\u0E33\u0E04\u0E31\u0E0D</div>-->\n                                                <!--</div>-->\n                                            <!--</div>-->\n                                        </div>\n                                    </div>\n                                </div>\n                                <div *ngIf=\"attachmentData.system_id === 17\">\n                                    <div class=\"row\">\n                                        <!--<div class=\"col-sm-2\">-->\n                                            <!--<span>\u0E40\u0E25\u0E02\u0E17\u0E35\u0E48\u0E40\u0E2D\u0E01\u0E2A\u0E32\u0E23 :</span>-->\n                                        <!--</div>-->\n                                        <div class=\"col-sm-12\">\n                                            <!--<div class=\"form-group m-form__group\" [ngClass]=\"{ 'has-error': submitted && f().book_no.errors }\">-->\n                                                <label class=\"control-label\">\u0E40\u0E25\u0E02\u0E17\u0E35\u0E48\u0E40\u0E2D\u0E01\u0E2A\u0E32\u0E23</label>\n                                                <!--<label class=\"control-label\"></label>-->\n                                                <input type=\"text\" class=\"form-control m-input\" id=\"txtBookNo\"[(ngModel)]=\"attachmentData.book_no\" disabled>\n                                                <!--<input type=\"text\" class=\"form-control m-input\" id=\"txtCategoryName\" formControlName=\"name\" [(ngModel)]=\"attachmentData.is_classifieds\">-->\n                                                <!--<div *ngIf=\"submitted && f().book_no.errors\" class=\"invalid-feedback\">-->\n                                                    <!--<div *ngIf=\"f().book_no.errors.required\">\u0E01\u0E23\u0E38\u0E13\u0E32\u0E01\u0E23\u0E2D\u0E01 \u0E40\u0E25\u0E02\u0E17\u0E35\u0E48\u0E40\u0E2D\u0E01\u0E2A\u0E32\u0E23</div>-->\n                                                <!--</div>-->\n                                            <!--</div>-->\n                                        </div>\n                                    </div>\n                                </div>\n                                <!--<div *ngIf=\"attachmentData.system_id === 17\">-->\n                                    <!--<div class=\"row\">-->\n                                        <!--<div class=\"col-sm-2\">-->\n                                            <!--<span>\u0E08\u0E33\u0E19\u0E27\u0E19 :</span>-->\n                                        <!--</div>-->\n                                        <!--<div class=\"col-sm-10\">-->\n                                            <!--<div class=\"form-group m-form__group\" [ngClass]=\"{ 'has-error': submitted && f().amount.errors }\">-->\n                                                <!--&lt;!&ndash;<label class=\"control-label\"></label>&ndash;&gt;-->\n                                                <!--<input type=\"number\" class=\"form-control m-input\" id=\"txtAmount\" name=\"amount\" formControlName=\"amount\" [(ngModel)]=\"attachmentData.amount\">-->\n                                                <!--&lt;!&ndash;<input type=\"text\" class=\"form-control m-input\" id=\"txtCategoryName\" formControlName=\"name\" [(ngModel)]=\"attachmentData.is_classifieds\">&ndash;&gt;-->\n                                                <!--<div *ngIf=\"submitted && f().amount.errors\" class=\"invalid-feedback\">-->\n                                                    <!--<div *ngIf=\"f().amount.errors.required\">\u0E01\u0E23\u0E38\u0E13\u0E32\u0E01\u0E23\u0E2D\u0E01 \u0E08\u0E33\u0E19\u0E27\u0E19</div>-->\n                                                <!--</div>-->\n                                            <!--</div>-->\n                                        <!--</div>-->\n                                    <!--</div>-->\n                                <!--</div>-->\n                                <div *ngIf=\"attachmentData.system_id === 17\">\n                                    <div class=\"row\">\n                                        <!--<div class=\"col-sm-2\">-->\n                                            <!--<span>\u0E27\u0E31\u0E19\u0E17\u0E35\u0E48\u0E08\u0E31\u0E14\u0E40\u0E01\u0E47\u0E1A :</span>-->\n                                        <!--</div>-->\n                                        <div class=\"col-sm-12\">\n                                            <!--<div class=\"form-group m-form__group\" [ngClass]=\"{ 'has-error': submitted && f().record_date.errors }\">-->\n                                                <label class=\"control-label\">\u0E27\u0E31\u0E19\u0E17\u0E35\u0E48\u0E08\u0E31\u0E14\u0E40\u0E01\u0E47\u0E1A</label>\n                                                <soc-date-box [id]=\"'txtDate'\" [(value)]=\"attachmentData.record_date\" [disabled]=\"true\"></soc-date-box>\n                                                <!--<div *ngIf=\"submitted && f().record_date.errors\" >-->\n                                                    <!--<div *ngIf=\"f().record_date.errors.required\" class=\"lable-error\">\u0E01\u0E23\u0E38\u0E13\u0E32\u0E01\u0E23\u0E2D\u0E01 \u0E27\u0E31\u0E19\u0E17\u0E35\u0E48\u0E08\u0E31\u0E14\u0E40\u0E01\u0E47\u0E1A</div>-->\n                                                    <!--<div *ngIf=\"f().record_date.errors.date\" class=\"lable-error\">\u0E01\u0E23\u0E38\u0E13\u0E32\u0E01\u0E23\u0E2D\u0E01 \u0E27\u0E31\u0E19\u0E17\u0E35\u0E48\u0E08\u0E31\u0E14\u0E40\u0E01\u0E47\u0E1A \u0E43\u0E2B\u0E49\u0E16\u0E39\u0E01\u0E15\u0E49\u0E2D\u0E07</div>-->\n                                                <!--</div>-->\n                                            <!--</div>-->\n                                        </div>\n                                    </div>\n                                </div>\n                                <!--<div *ngIf=\"attachmentData.system_id === 17\">-->\n                                    <!--<div class=\"row\">-->\n                                        <!--<div class=\"col-sm-2\">-->\n                                            <!--<span>\u0E40\u0E27\u0E2D\u0E23\u0E4C\u0E0A\u0E31\u0E48\u0E19/\u0E40\u0E25\u0E02\u0E23\u0E38\u0E48\u0E19 :</span>-->\n                                        <!--</div>-->\n                                        <!--<div class=\"col-sm-10\">-->\n                                            <!--<div class=\"form-group m-form__group\" [ngClass]=\"{ 'has-error': submitted && f().version.errors }\">-->\n                                                <!--<input type=\"text\" class=\"form-control m-input\" id=\"txtVersion\"  name=\"version\" formControlName=\"version\" [(ngModel)]=\"attachmentData.version\">-->\n                                                <!--<div *ngIf=\"submitted && f().version.errors\" class=\"invalid-feedback\">-->\n                                                    <!--<div *ngIf=\"f().version.errors.required\">\u0E01\u0E23\u0E38\u0E13\u0E32\u0E01\u0E23\u0E2D\u0E01 \u0E40\u0E27\u0E2D\u0E23\u0E4C\u0E0A\u0E31\u0E48\u0E19/\u0E40\u0E25\u0E02\u0E23\u0E38\u0E48\u0E19</div>-->\n                                                <!--</div>-->\n                                            <!--</div>-->\n                                        <!--</div>-->\n                                    <!--</div>-->\n                                <!--</div>-->\n                            </div>\n                            <div class=\"m-portlet__foot m-portlet__foot--fit text-right\">\n                                <div class=\"m-form__actions\">\n                                    <!--<button *ngIf=\"mode !== 'VIEW'\" type=\"submit\" class=\"btn btn-success btn-md btn-md-save\">-->\n                                        <!--\u0E1A\u0E31\u0E19\u0E17\u0E36\u0E01-->\n                                    <!--</button>-->\n                                    <button type=\"button\" class=\"btn btn-default btn-md btn-md-search\" (click)=\"closeModal()\">\n                                        \u0E22\u0E01\u0E40\u0E25\u0E34\u0E01\n                                    </button>\n                                </div>\n                            </div>\n                        <!--</form>-->\n                    </div>\n                </div>\n            </div>\n        </div>\n    </div>\n</div>"
                }] }
    ];
    /** @nocollapse */
    ModalAttachmentViewComponent.ctorParameters = function () { return [
        { type: AppConfigService },
        { type: Request },
        { type: FormBuilder },
        { type: Common }
    ]; };
    ModalAttachmentViewComponent.propDecorators = {
        isImage: [{ type: Input }],
        onModalCreateSubmit: [{ type: Output }],
        onModalEditSubmit: [{ type: Output }],
        modal: [{ type: ViewChild, args: ['modal',] }],
        uploadAttachment: [{ type: ViewChild, args: ['uploadAttachment',] }]
    };
    return ModalAttachmentViewComponent;
}(Options$2));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var AttachmentListComponent = /** @class */ (function () {
    function AttachmentListComponent(appConfigService, request, common, b2b) {
        this.appConfigService = appConfigService;
        this.request = request;
        this.common = common;
        this.b2b = b2b;
        this.mode = 'CREATE';
        this.type = 2;
        this.showImage = false;
        this.onLoaded = new EventEmitter();
        this.onClickScan = new EventEmitter();
        this.onClickDelete = new EventEmitter();
        this.columns = ['ลำดับที่', 'ผู้แก้ไข', 'วันที่', 'สถานะการติดตาม', 'หมายเหตุ'];
        this.attachmentList = [];
        this.dxgridPageSize = 10;
        this.allowedPageSizes1 = 10;
        this.allowedPageSizes2 = 25;
        this.allowedPageSizes3 = 50;
        this.allowedPageSizes4 = 100;
        this.customers = [];
        this.lastStep = '';
        this.deleteIdList = [];
        this.dsAttachment = [];
        this.selectedAttachment = [];
        this.tmpId = -1;
        this.classifieds = 0;
        this.username_caption = 'ผู้บันทึก/ผู้นำเข้า';
        this.config = appConfigService.getConfig();
    }
    /**
     * @return {?}
     */
    AttachmentListComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                setTimeout(function () { return __awaiter(_this, void 0, void 0, function () {
                    var _a;
                    return __generator(this, function (_b) {
                        switch (_b.label) {
                            case 0:
                                _a = this;
                                return [4 /*yield*/, this.b2b.getAttachmentToken()];
                            case 1:
                                _a.downloadToken = _b.sent();
                                return [2 /*return*/];
                        }
                    });
                }); }, 500);
                if (this.mode !== "CREATE") {
                    this.getAttachmentList();
                }
                return [2 /*return*/];
            });
        });
    };
    /**
     * @return {?}
     */
    AttachmentListComponent.prototype.getAttachmentList = /**
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            var e_1, _a, filter$$1, data, _b, _c, i;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        console.log('getAttachmentList', this.attachmentList, this.option.username_caption);
                        filter$$1 = {
                            filter: {
                                ref_table: this.option.data.ref_table,
                                ref_id: this.option.data.ref_id,
                                system_id: this.option.data.system_id
                            },
                            order_by: ["order_no"]
                        };
                        if (this.option.data.result_table_id)
                            filter$$1.filter.result_table_id = this.option.data.result_table_id;
                        return [4 /*yield*/, this.request.post('/search/rc_attachment_prop', filter$$1)];
                    case 1:
                        data = _d.sent();
                        this.attachmentList = data.resultData;
                        this.classifieds = 0;
                        try {
                            for (_b = __values(this.attachmentList), _c = _b.next(); !_c.done; _c = _b.next()) {
                                i = _c.value;
                                if (i.is_classifieds) {
                                    this.classifieds++;
                                }
                            }
                        }
                        catch (e_1_1) { e_1 = { error: e_1_1 }; }
                        finally {
                            try {
                                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                            }
                            finally { if (e_1) throw e_1.error; }
                        }
                        console.log('getAttachmentList', this.attachmentList);
                        this.onLoaded.emit();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @param {?} data
     * @return {?}
     */
    AttachmentListComponent.prototype.addAttachmentList = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        data.id = this.tmpId;
        this.tmpId--;
        if (this.b2b.getVerifyToken().phoneBookData && this.b2b.getVerifyToken().phoneBookData.length > 0) {
            data.username = this.b2b.getVerifyToken().username;
            data.recorder_name = this.b2b.getVerifyToken().phoneBookData[0].name;
        }
        data.action = "add";
        if (data.is_classifieds) {
            this.classifieds++;
        }
        this.attachmentList.push(data);
        console.log('getAttachmentList', this.attachmentList);
    };
    /**
     * @param {?} data
     * @return {?}
     */
    AttachmentListComponent.prototype.editAttachmentList = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        for (var i = 0; i < this.attachmentList.length; i++) {
            if (this.attachmentList[i].id === data.id) {
                if (data.is_classifieds && !this.attachmentList[i].is_classifieds) {
                    this.classifieds++;
                }
                else if (!data.is_classifieds && this.attachmentList[i].is_classifieds) {
                    this.classifieds--;
                }
                this.attachmentList[i] = data;
            }
        }
        console.log('getAttachmentList', this.attachmentList);
    };
    /**
     * @param {?} data
     * @return {?}
     */
    AttachmentListComponent.prototype.getRowIndex = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        if (!data.data) {
            return '';
        }
        data.data.order_no = data.component.pageIndex() * data.component.pageSize() + data.rowIndex + 1;
        return data.data.order_no;
    };
    /**
     * @return {?}
     */
    AttachmentListComponent.prototype.clickAdd = /**
     * @return {?}
     */
    function () {
        this.option.mode = 'CREATE';
        if (this.attachmentModal) {
            this.attachmentModal.open(this.option);
        }
        else {
            this.modalAttachment.open(this.option);
        }
    };
    /**
     * @param {?} data
     * @return {?}
     */
    AttachmentListComponent.prototype.clickEdit = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        console.log('clickEdit', data);
        /** @type {?} */
        var fileName = data.filename;
        /** @type {?} */
        var fileType = fileName.substring(fileName.length - 3, fileName.length);
        console.log('fileType', fileType);
        if (this.type == 1 && (fileType == 'pdf' || fileType == 'PDF')) {
            /** @type {?} */
            var editData = cloneDeep(this.option);
            editData.data = data;
            editData.mode = 'EDIT';
            editData.downloadToken = this.downloadToken;
            this.onClickScan.emit(editData);
        }
        else {
            /** @type {?} */
            var editData = cloneDeep(this.option);
            editData.data = data;
            editData.mode = 'EDIT';
            editData.downloadToken = this.downloadToken;
            if (this.attachmentModal) {
                this.attachmentModal.open(editData);
            }
            else {
                this.modalAttachment.open(editData);
            }
        }
    };
    /**
     * @param {?} data
     * @return {?}
     */
    AttachmentListComponent.prototype.clickView = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        /** @type {?} */
        var fileName = data.filename;
        /** @type {?} */
        var fileType = fileName.substring(fileName.length - 3, fileName.length);
        console.log('fileType', fileType);
        if (this.type == 1 && (fileType == 'pdf' || fileType == 'PDF')) {
            /** @type {?} */
            var viewData = cloneDeep(this.option);
            viewData.data = data;
            viewData.mode = 'VIEW';
            this.onClickScan.emit(viewData);
        }
        else {
            /** @type {?} */
            var viewData = cloneDeep(this.option);
            viewData.data = data;
            viewData.mode = 'VIEW';
            viewData.downloadToken = this.downloadToken;
            if (this.attachmentViewModal) {
                this.attachmentViewModal.open(viewData);
            }
            else {
                this.modalAttachmentView.open(viewData);
            }
        }
    };
    /**
     * @param {?} data
     * @return {?}
     */
    AttachmentListComponent.prototype.clickMoveUp = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        /** @type {?} */
        var tmp = this.attachmentList[data.rowIndex];
        this.attachmentList[data.rowIndex] = this.attachmentList[data.rowIndex - 1];
        this.attachmentList[data.rowIndex - 1] = tmp;
    };
    /**
     * @param {?} data
     * @return {?}
     */
    AttachmentListComponent.prototype.clickMoveDown = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        /** @type {?} */
        var tmp = this.attachmentList[data.rowIndex];
        this.attachmentList[data.rowIndex] = this.attachmentList[data.rowIndex + 1];
        this.attachmentList[data.rowIndex + 1] = tmp;
    };
    /**
     * @param {?} data
     * @return {?}
     */
    AttachmentListComponent.prototype.clickDownload = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                window.open(data.url + "?downloadToken=" + this.downloadToken);
                return [2 /*return*/];
            });
        });
    };
    /**
     * @return {?}
     */
    AttachmentListComponent.prototype.getLastStep = /**
     * @return {?}
     */
    function () {
        return this.lastStep;
    };
    /** START DELETE */
    /**
     * START DELETE
     * @param {?} idList
     * @return {?}
     */
    AttachmentListComponent.prototype.fnClickDelete = /**
     * START DELETE
     * @param {?} idList
     * @return {?}
     */
    function (idList) {
        this.onClickDelete.emit();
        this.deleteIdList = idList;
        if (this.deleteIdList.length > 0) {
            this.confirmDelete();
        }
    };
    /**
     * @return {?}
     */
    AttachmentListComponent.prototype.confirmDelete = /**
     * @return {?}
     */
    function () {
        this.goAlert('', '', 'myModalDeleteAttachment');
    };
    /**
     * @param {?} userTitle
     * @param {?} userMessage
     * @param {?} modalId
     * @return {?}
     */
    AttachmentListComponent.prototype.goAlert = /**
     * @param {?} userTitle
     * @param {?} userMessage
     * @param {?} modalId
     * @return {?}
     */
    function (userTitle, userMessage, modalId) {
        /** @type {?} */
        var dataAlert = {
            'modalId': modalId,
            'userTitle': userTitle,
            'userMessage': userMessage
        };
        if (this.alertModal) {
            this.alertModal.openModal(dataAlert);
        }
        else {
            this.myModal.openModal(dataAlert);
        }
    };
    /**
     * @param {?} e
     * @return {?}
     */
    AttachmentListComponent.prototype.onCellPrepared = /**
     * @param {?} e
     * @return {?}
     */
    function (e) {
        if (e.rowType === 'data') {
            e.cellElement.accessKey = e.column.caption;
        }
    };
    /**
     * @return {?}
     */
    AttachmentListComponent.prototype.fnDeleteMultiple = /**
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            var e_2, _a, _b, _c, id, i;
            return __generator(this, function (_d) {
                console.log("this.deleteIdList", this.deleteIdList);
                console.log("this.attachmentList before", this.attachmentList);
                try {
                    for (_b = __values(this.deleteIdList), _c = _b.next(); !_c.done; _c = _b.next()) {
                        id = _c.value;
                        for (i = this.attachmentList.length - 1; i >= 0; i--) {
                            if (this.attachmentList[i].id === id) {
                                if (this.attachmentList[i].is_classifieds) {
                                    this.classifieds--;
                                }
                                this.attachmentList.splice(i, 1);
                            }
                        }
                    }
                }
                catch (e_2_1) { e_2 = { error: e_2_1 }; }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                    }
                    finally { if (e_2) throw e_2.error; }
                }
                console.log("this.attachmentList after", this.attachmentList);
                return [2 /*return*/];
            });
        });
    };
    /**
     * @return {?}
     */
    AttachmentListComponent.prototype.onClickBack = /**
     * @return {?}
     */
    function () {
        console.log("clickback");
    };
    /**
     * @param {?} data
     * @return {?}
     */
    AttachmentListComponent.prototype.getImageLink = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        return data.url + "?downloadToken=" + this.downloadToken;
    };
    /**
     * @return {?}
     */
    AttachmentListComponent.prototype.scan = /**
     * @return {?}
     */
    function () {
        this.option.mode = 'CREATE';
        this.onClickScan.emit(this.option);
    };
    AttachmentListComponent.decorators = [
        { type: Component, args: [{
                    selector: 'soc-attachment-list',
                    template: "<div class=\"col-sm-12\">\n        <div class=\"ibox-heading-total\" style=\"padding: 0px 20px 0;\">\n                <h5 class=\"ibox-title-text\"></h5>\n                <!--<button id=\"btn\" name=\"btn\" type=\"button\" class=\"btn btn-success \" data-toggle=\"tooltip\"-->\n                <!--title=\"\u0E40\u0E1E\u0E34\u0E48\u0E21\u0E02\u0E49\u0E2D\u0E21\u0E39\u0E25\u0E23\u0E32\u0E22\u0E25\u0E30\u0E40\u0E2D\u0E35\u0E22\u0E14\u0E1B\u0E23\u0E30\u0E40\u0E14\u0E47\u0E19\" data-placement=\"top\" style=\"min-width: 80px;padding: 8px 10px;\">\u0E17\u0E33\u0E2A\u0E33\u0E40\u0E19\u0E32</button>-->\n                <button *ngIf=\"mode !== 'VIEW' &&  type === 1\" id=\"btnScan\" name=\"btnScan\" type=\"button\"\n                        class=\"btn btn-success\" data-toggle=\"tooltip\" data-placement=\"top\"\n                        style=\"min-width: 80px;padding: 8px 10px;\" (click)=\"scan()\">\u0E2A\u0E41\u0E01\u0E19</button>\n                <button *ngIf=\"mode !== 'VIEW'\" [disabled]=\"selectedAttachment.length === 0\" id=\"btnDelete\"\n                        name=\"btnDelete\" type=\"button\" class=\"btn btn-success\" data-toggle=\"tooltip\"\n                        data-placement=\"top\" style=\"min-width: 80px;padding: 8px 10px;\"\n                        (click)=\"fnClickDelete(selectedAttachment)\">\u0E25\u0E1A</button>\n                <button *ngIf=\"mode !== 'VIEW'\" id=\"btnAdd\" name=\"btnAdd\" type=\"button\" class=\"btn btn-success\"\n                        data-toggle=\"tooltip\" data-placement=\"top\" style=\"min-width: 80px;padding: 8px 10px;\"\n                        (click)=\"clickAdd()\">\u0E40\u0E1E\u0E34\u0E48\u0E21</button>\n        </div>\n        <div class=\"ibox-body\">\n                <div class=\"table-responsive table-wrapper\">\n                        <!--(onCellPrepared)=\"onCellPrepared1($event)\"-->\n                        <dx-data-grid #dxDataGridPrisoner id=\"dxDataGridPrisoner\" [dataSource]=\"attachmentList\"\n                                keyExpr=\"id\" [hoverStateEnabled]=\"true\" noDataText=\"\" showBorders=\"true\"\n                                [rowAlternationEnabled]=\"true\" [columnAutoWidth]=\"false\" class=\"card-list-table\"\n                                [allowColumnResizing]=\"true\" [allowColumnReordering]=\"true\"\n                                (onCellPrepared)=\"onCellPrepared($event)\" [wordWrapEnabled]=\"false\"\n                                [(selectedRowKeys)]=\"selectedAttachment\" class=\"card-list-table\">\n                                <dxo-paging [pageSize]=\"dxgridPageSize\"></dxo-paging>\n                                <dxo-pager [showPageSizeSelector]=\"true\"\n                                        [allowedPageSizes]=\"[allowedPageSizes1, allowedPageSizes2, allowedPageSizes3, allowedPageSizes4]\"\n                                        [showInfo]=\"false\" [visible]=\"true\" [showNavigationButtons]=\"true\"></dxo-pager>\n                                <dxo-scrolling showScrollbar=\"always\"></dxo-scrolling>\n                                <dxo-remote-operations [sorting]=\"true\" [paging]=\"true\"></dxo-remote-operations>\n                                <dxo-selection *ngIf=\"mode !== 'VIEW'\" selectAllMode=\"page\" showCheckBoxesMode=\"always\"\n                                        mode=\"multiple\" style=\"min-width: 50px !important;\"></dxo-selection>\n                                <dxo-state-storing [enabled]=\"true\" type=\"localStorage\"\n                                        storageKey=\"attachmentListDataGrid\"></dxo-state-storing>\n                                <dxi-column caption=\"\u0E25\u0E33\u0E14\u0E31\u0E1A\u0E17\u0E35\u0E48\" [allowSorting]=\"false\" cellTemplate=\"cellTemplateNo\"\n                                        alignment=\"center\" [width]=\"70\"></dxi-column>\n                                <dxi-column caption=\"\u0E08\u0E31\u0E14\u0E01\u0E32\u0E23\" [allowSorting]=\"false\" cellTemplate=\"cellTemplateAction\"\n                                        alignment=\"center\" [width]=\"mode !== 'VIEW' ? 255 : 105\"></dxi-column>\n                                <dxi-column dataField=\"recorder_name\" [caption]=\"option.username_caption ?option.username_caption :username_caption\"></dxi-column>\n                                <dxi-column *ngIf=\"type === 3\" dataField=\"book_no\" caption=\"\u0E40\u0E25\u0E02\u0E17\u0E35\u0E48\u0E40\u0E2D\u0E01\u0E2A\u0E32\u0E23\"></dxi-column>\n                                <dxi-column *ngIf=\"type === 2 || type === 1\" dataField=\"name\" caption=\"\u0E0A\u0E37\u0E48\u0E2D\u0E40\u0E2D\u0E01\u0E2A\u0E32\u0E23\">\n                                </dxi-column>\n                                <dxi-column dataField=\"doc_type\" caption=\"\u0E1B\u0E23\u0E30\u0E40\u0E20\u0E17\u0E40\u0E2D\u0E01\u0E2A\u0E32\u0E23\"></dxi-column>\n                                <dxi-column *ngIf=\"type === 1\" dataField=\"is_classifieds\" caption=\"\u0E08\u0E31\u0E14\u0E40\u0E02\u0E49\u0E32\u0E27\u0E32\u0E23\u0E30\">\n                                </dxi-column>\n                                <!--<dxi-column dataField=\"order\" caption=\"\u0E25\u0E33\u0E14\u0E31\u0E1A\"></dxi-column>-->\n                                <dxi-column dataField=\"created_at\" caption=\"\u0E27\u0E31\u0E19\u0E17\u0E35\u0E48\u0E2A\u0E23\u0E49\u0E32\u0E07/\u0E19\u0E33\u0E40\u0E02\u0E49\u0E32\" dataType=\"date\"\n                                        alignment=\"center\" [width]=\"100\"></dxi-column>\n                                <dxi-column *ngIf=\"type === 3\" dataField=\"record_date\" dataType=\"date\"\n                                        caption=\"\u0E27\u0E31\u0E19\u0E17\u0E35\u0E48\u0E08\u0E31\u0E14\u0E40\u0E01\u0E47\u0E1A\" alignment=\"center\" [width]=\"100\"></dxi-column>\n                                <dxi-column *ngIf=\"type === 2 || type === 1\" dataField=\"remark\" caption=\"\u0E2B\u0E21\u0E32\u0E22\u0E40\u0E2B\u0E15\u0E38\">\n                                </dxi-column>\n                                <!--<dxi-column *ngIf=\"type === 3\" dataField=\"amount\" caption=\"\u0E08\u0E33\u0E19\u0E27\u0E19\"></dxi-column>-->\n                                <!--<dxi-column *ngIf=\"type === 4\" dataField=\"version\" caption=\"\u0E40\u0E27\u0E2D\u0E23\u0E4C\u0E0A\u0E31\u0E48\u0E19\"></dxi-column>-->\n                                <dxi-column *ngIf=\"showImage\" caption=\"\u0E40\u0E04\u0E23\u0E37\u0E48\u0E2D\u0E07\u0E2B\u0E21\u0E32\u0E22\" cellTemplate=\"cellTemplateImage\">\n                                </dxi-column>\n                                <div *dxTemplate=\"let data of 'cellTemplateImage'\" class=\" text-center\">\n                                        <img *ngIf=\"showImage\" [src]=\"getImageLink(data.data)\"\n                                                style=\"width: auto !important;\">\n                                </div>\n                                <div *dxTemplate=\"let data of 'cellTemplateNo'\" class=\" text-center\">\n                                        <span>{{getRowIndex(data)}}</span>\n                                </div>\n                                <div *dxTemplate=\"let data of 'cellTemplateAction'\">\n                                        <a *ngIf=\"mode !== 'VIEW'\" id=\"btnEdit\" (click)=\"clickEdit(data.data)\"\n                                                class=\"btn btn-default btn-sm  icon\" data-toggle=\"tooltip\"\n                                                data-placement=\"top\" title=\"\u0E41\u0E01\u0E49\u0E44\u0E02\"><i class=\"fal fa-pencil-alt\"></i></a>\n                                        <a id=\"btnView\" (click)=\"clickView(data.data)\"\n                                                class=\"btn btn-default btn-sm icon\" data-toggle=\"tooltip\"\n                                                data-placement=\"top\" title=\"\u0E14\u0E39\u0E02\u0E49\u0E2D\u0E21\u0E39\u0E25\"><i class=\"fal fa-eye\"></i></a>\n                                        <a *ngIf=\"data.rowIndex !== 0 && mode !== 'VIEW'\" id=\"btnMoveUp\"\n                                                (click)=\"clickMoveUp(data)\" class=\"btn btn-default btn-sm icon\"\n                                                data-toggle=\"tooltip\" data-placement=\"top\" title=\"\u0E40\u0E25\u0E37\u0E48\u0E2D\u0E19\u0E02\u0E36\u0E49\u0E19\"><i\n                                                        class=\"fal fa-arrow-up\"></i></a>\n                                        <a *ngIf=\"data.rowIndex < data.component.pageSize() -1 && data.rowIndex < attachmentList.length - 1 && mode !== 'VIEW'\"\n                                                id=\"btnMoveDown\" (click)=\"clickMoveDown(data)\"\n                                                class=\"btn btn-default btn-sm icon\" data-toggle=\"tooltip\"\n                                                data-placement=\"top\" title=\"\u0E40\u0E25\u0E37\u0E48\u0E2D\u0E19\u0E25\u0E07\"><i\n                                                        class=\"fal fa-arrow-down\"></i></a>\n                                        <a id=\"btnDownload\" (click)=\"clickDownload(data.data)\"\n                                                class=\"btn btn-default btn-sm icon\" data-toggle=\"tooltip\"\n                                                data-placement=\"top\" title=\"\u0E14\u0E32\u0E27\u0E19\u0E4C\u0E42\u0E2B\u0E25\u0E14\"><i\n                                                        class=\"fal fa-download\"></i></a>\n                                </div>\n                        </dx-data-grid>\n                </div>\n        </div>\n</div>\n<!--End col-sm-12-->\n<!--<modal-step #modalStep (onUpdateModal)='getAttachmentList()' (onCreateModal)=\"addAttachmentList($event)\" [mode]=\"mode\"></modal-step>-->\n<modal-attachment #modalAttachment (onModalCreateSubmit)=\"addAttachmentList($event)\"\n        (onModalEditSubmit)=\"editAttachmentList($event)\" [isImage]=\"showImage\"></modal-attachment>\n<modal-attachment-view #modalAttachmentView [isImage]=\"showImage\"></modal-attachment-view>\n<app-alert #myModal (onOkDeleteAttachment)=\"fnDeleteMultiple()\" (onClickBack)=\"onClickBack()\"></app-alert>\n"
                }] }
    ];
    /** @nocollapse */
    AttachmentListComponent.ctorParameters = function () { return [
        { type: AppConfigService },
        { type: Request },
        { type: Common },
        { type: B2bService }
    ]; };
    AttachmentListComponent.propDecorators = {
        mode: [{ type: Input }],
        type: [{ type: Input }],
        option: [{ type: Input }],
        showImage: [{ type: Input }],
        alertModal: [{ type: Input }],
        attachmentModal: [{ type: Input }],
        attachmentViewModal: [{ type: Input }],
        onLoaded: [{ type: Output }],
        onClickScan: [{ type: Output }],
        onClickDelete: [{ type: Output }],
        dxDataGridAttachmentList: [{ type: ViewChild, args: ['dxDataGridAttachmentList',] }],
        modalAttachment: [{ type: ViewChild, args: ['modalAttachment',] }],
        modalAttachmentView: [{ type: ViewChild, args: ['modalAttachmentView',] }],
        myModal: [{ type: ViewChild, args: ['myModal',] }]
    };
    return AttachmentListComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
// # Calendar TH
locale('th');
var ModalAttachmentViewModule = /** @class */ (function () {
    function ModalAttachmentViewModule() {
    }
    ModalAttachmentViewModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule,
                        SharedDateBoxModule,
                        FormsModule,
                        ReactiveFormsModule,
                        ModalModule.forRoot(),
                        DxDataGridModule,
                        DxTemplateModule,
                        AutoCompleteModule,
                        UploadAttachmentModule
                    ], exports: [
                        ModalAttachmentViewComponent
                    ], providers: [], declarations: [
                        ModalAttachmentViewComponent,
                    ],
                },] }
    ];
    return ModalAttachmentViewModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
// # Calendar TH
locale('th');
var ɵ0$2 = th_TH;
/**
 * end
 */
var AttachmentListModule = /** @class */ (function () {
    function AttachmentListModule() {
    }
    AttachmentListModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule,
                        DxDataGridModule$1,
                        DxTemplateModule,
                        ModalStepModule,
                        CreateAlertModule,
                        ModalAttachmentModule,
                        ModalAttachmentViewModule
                    ],
                    exports: [
                        AttachmentListComponent
                    ],
                    declarations: [
                        AttachmentListComponent,
                    ],
                    providers: [
                        { provide: NZ_I18N, useValue: ɵ0$2 },
                    ],
                },] }
    ];
    return AttachmentListModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var ModalImageUploadComponent = /** @class */ (function () {
    function ModalImageUploadComponent(appConfigService, request, common, http) {
        var _this = this;
        this.appConfigService = appConfigService;
        this.request = request;
        this.common = common;
        this.http = http;
        this.upLoadType = [{ title: "File", type: 1 }, { title: "Scan", type: 2 }, { title: "Link", type: 3 }, { title: "QR Code", type: 3 }];
        this.systemId = '0';
        this.RelatedAgency = 'SOC';
        this.RecordId = '0';
        this.Subject = '-';
        this.TypeId = '0';
        this.popupTitle = 'เลือกรูปประจำตัว';
        this.uploaded = new EventEmitter();
        this.onSubmit = new EventEmitter();
        // @ViewChild('myModal') myModal;
        this.fileList = [];
        this.uploadHeaders = {
            "Authorization": "Basic " + btoa("APPSOC:123456")
        };
        this.loading = false;
        this.beforeUpload = function (file, _fileList) {
            return new Observable$1(function (observer) {
                /** @type {?} */
                var whitelist = [
                    'application/pdf',
                    'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet',
                    'application/vnd.ms-excel',
                    'application/vnd.msexcel',
                    'application/csv',
                    'text/csv',
                    'application/msword',
                    'application/vnd.openxmlformats-officedocument.wordprocessingml.document',
                    'application/vnd.ms-powerpoint',
                    'application/vnd.openxmlformats-officedocument.presentationml.slideshow',
                    'application/vnd.openxmlformats-officedocument.presentationml.presentation',
                    'text/plain',
                    'text/comma-separated-values',
                    'text/anytext',
                    'image/png',
                    'image/jpeg',
                    'image/gif',
                    'image/bmp'
                ];
                /** @type {?} */
                var isWhitelist = (file && whitelist.indexOf(file.type) > -1);
                if (!isWhitelist) {
                    setTimeout(function () {
                        _this.fileList = [{
                                uid: '999',
                                name: 'สามารถอัพโหลดได้เฉพาะไฟล์  pdf , png  , jpeg  ,gif , text , word , excel , powerpoint',
                                status: 'error',
                                response: 'สามารถอัพโหลดได้เฉพาะไฟล์  pdf , png  , jpeg  ,gif , text , word , excel , powerpoint',
                                url: null
                            }];
                    }, 50);
                    observer.complete();
                    return;
                }
                /** @type {?} */
                var isLt30M = /** @type {?} */ ((file.size)) / 1024 / 1024 < 30;
                if (!isLt30M) {
                    _this.fileList = [{
                            uid: '999',
                            name: 'File must smaller than 30MB!',
                            status: 'error',
                            response: 'File must smaller than 30MB!',
                            url: null
                        }];
                    observer.complete();
                    return;
                }
                observer.next(isWhitelist && isLt30M);
                observer.complete();
            });
        };
        this.customReq = function (item) {
            /** @type {?} */
            var formData = new FormData();
            // tslint:disable-next-line:no-any
            formData.append('FileData', /** @type {?} */ (item.file));
            formData.append('SystemId', '' + _this.systemId);
            formData.append('RelatedAgency', _this.RelatedAgency);
            formData.append('RecordId', _this.RecordId);
            formData.append('Subject', _this.Subject);
            formData.append('TypeId', _this.TypeId);
            /** @type {?} */
            var headers = new HttpHeaders();
            headers = headers.set('Authorization', 'Basic ' + btoa('APPSOC:123456'));
            /** @type {?} */
            var req = new HttpRequest('POST', item.action, formData, {
                reportProgress: true,
                headers: headers
            });
            // req.headers.set('Authorization', 'Basic ' + btoa('APPSOC:123456'));
            return _this.http.request(req).subscribe(function (event) {
                if (event.type === HttpEventType.UploadProgress) {
                    if (event.total > 0) {
                        (/** @type {?} */ (event)).percent = event.loaded / event.total * 100;
                    }
                    item.onProgress(event, item.file);
                }
                else if (event instanceof HttpResponse) {
                    // console.log("event.body",event.body);
                    // let res = JSON.parse(event.body);
                    if (_this.fileList && _this.fileList.length > 1) {
                        _this.fileList = [_this.fileList[_this.fileList.length - 1]];
                    }
                    _this.uploaded.emit(event.body);
                    _this.data = event.body;
                    item.onSuccess(event.body, item.file, event);
                }
            }, function (err) {
                item.onError(err, item.file);
            });
        };
        this.config = appConfigService.getConfig();
        this.url = get(this.config, 'apiServers.alfresco.url') || "https://203.154.32.126:2585/api/mfec/Alfresco";
    }
    /**
     * @return {?}
     */
    ModalImageUploadComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    /**
     * @param {?} file
     * @return {?}
     */
    ModalImageUploadComponent.prototype.onUploaded = /**
     * @param {?} file
     * @return {?}
     */
    function (file) {
        var _this = this;
        console.log("file", file);
        /** @type {?} */
        var res = JSON.parse(file.request.response);
        this.request.getAttachmentLinkToken(this.url + '/' + res.uuid).then(function (url) {
            _this.avatarUrl = url;
        });
        this.uploaded.emit(res);
    };
    /**
     * @return {?}
     */
    ModalImageUploadComponent.prototype.clearValue = /**
     * @return {?}
     */
    function () {
        this.fileList = [];
    };
    /**
     * @return {?}
     */
    ModalImageUploadComponent.prototype.closeModal = /**
     * @return {?}
     */
    function () {
        this.modal.hide();
        this.data = null;
        this.fileList = [];
    };
    /**
     * @return {?}
     */
    ModalImageUploadComponent.prototype.clickSubmit = /**
     * @return {?}
     */
    function () {
        this.onSubmit.emit(this.data);
        this.modal.hide();
        this.data = null;
        this.fileList = [];
    };
    ModalImageUploadComponent.decorators = [
        { type: Component, args: [{
                    selector: 'modal-image-upload',
                    template: "<div class=\"modal fade\" bsModal #modal=\"bs-modal\" [config]=\"{backdrop: 'static'}\"\n     tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"dialog-static-name1\">\n    <div class=\"modal-dialog modal-md\">\n        <div class=\"modal-content\">\n            <div class=\"modal-header\">\n                <h4 id=\"dialog-static-name\" class=\"modal-title pull-left\">{{popupTitle}}</h4>\n                <button type=\"button\" class=\"close pull-right\" aria-label=\"Close\" (click)=\"closeModal()\">\n                    <span aria-hidden=\"true\">&times;</span>\n                </button>\n            </div>\n\n            <div class=\"modal-body\">\n                <form class=\"m-form m-form--state m-form--fit m-form--label-align-right\" (ngSubmit)=\"clickSubmit()\">\n                    <div class=\"ibox-body\">\n                        <div class=\"col-sm-12\" style=\"text-align: center\">\n                            <br>\n                            <nz-upload nzType=\"drag\"\n                                       [nzAction]=\"url\"\n                                       [nzCustomRequest]=\"customReq\"\n                                       nzFileType=\"image/png,image/jpeg,image/gif,image/bmp\"\n                                       [(nzFileList)]=\"fileList\"\n                                       [nzBeforeUpload]=\"beforeUpload\"\n                                       >\n                                <!--<nz-upload nzType=\"drag\"-->\n                                <!--nzAction=\"https://203.154.32.126:2585/api/mfec/Alfresco\"-->\n                                <!--&gt;-->\n                                <a nz-button>\n                                    <i nz-icon type=\"upload\"></i><span>Click to Upload</span>\n                                </a>\n                            </nz-upload>\n                            <br>\n                        </div>\n                        <div class=\"col-sm-12\" style=\"text-align: center\" *ngIf=\"avatarUrl\">\n                            <div class=\"avatar-box\">\n                                <img [src]=\"avatarUrl\" alt=\"\">\n                            </div>\n                        </div>\n                    </div>\n                    <div class=\"m-portlet__foot m-portlet__foot--fit text-right\">\n                        <div class=\"m-form__actions\">\n                            <button type=\"submit\" class=\"btn btn-success btn-md btn-md-save\">\n                                \u0E1A\u0E31\u0E19\u0E17\u0E36\u0E01\n                            </button>\n                            <button type=\"reset\" class=\"btn btn-default btn-md btn-md-search\" (click)=\"closeModal()\">\n                                \u0E22\u0E01\u0E40\u0E25\u0E34\u0E01\n                            </button>\n                        </div>\n                    </div>\n                </form>\n            </div>\n        </div>\n    </div>\n</div>\n",
                    styles: ["\n    :host ::ng-deep .avatar-uploader > .ant-upload, :host ::ng-deep .avatar {\n      width: 128px;\n      height: 128px;\n    }\n    :host ::ng-deep .ant-upload-select-picture-card i {\n      font-size: 32px;\n      color: #999;\n    }\n    :host ::ng-deep .ant-upload-select-picture-card .ant-upload-text {\n      margin-top: 8px;\n      color: #666;\n    }\n  "]
                }] }
    ];
    /** @nocollapse */
    ModalImageUploadComponent.ctorParameters = function () { return [
        { type: AppConfigService },
        { type: Request },
        { type: Common },
        { type: HttpClient }
    ]; };
    ModalImageUploadComponent.propDecorators = {
        modal: [{ type: ViewChild, args: ['modal',] }],
        upLoadType: [{ type: Input }],
        systemId: [{ type: Input }],
        RelatedAgency: [{ type: Input }],
        RecordId: [{ type: Input }],
        Subject: [{ type: Input }],
        TypeId: [{ type: Input }],
        downloadToken: [{ type: Input }],
        popupTitle: [{ type: Input }],
        uploaded: [{ type: Output }],
        onSubmit: [{ type: Output }]
    };
    return ModalImageUploadComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
// # Calendar TH
locale('th');
var ModalImageUploadModule = /** @class */ (function () {
    function ModalImageUploadModule() {
    }
    ModalImageUploadModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule,
                        SharedDateBoxModule,
                        FormsModule,
                        ReactiveFormsModule,
                        ModalModule.forRoot(),
                        DxDataGridModule,
                        DxTemplateModule,
                        AutoCompleteModule,
                        NgZorroAntdModule,
                        UploadAttachmentModule
                    ], exports: [
                        ModalImageUploadComponent
                    ], providers: [], declarations: [
                        ModalImageUploadComponent,
                    ],
                },] }
    ];
    return ModalImageUploadModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var ModalSpellCheckComponent = /** @class */ (function () {
    function ModalSpellCheckComponent(appConfigService, request, common, http) {
        this.appConfigService = appConfigService;
        this.request = request;
        this.common = common;
        this.http = http;
        this.onSave = new EventEmitter();
        this.objectKeys = Object.keys;
        this.spellCheck = {};
        this.model = {};
        this.enableList = [];
        this.isEdit = false;
        this.config = appConfigService.getConfig();
    }
    /**
     * @return {?}
     */
    ModalSpellCheckComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    /**
     * @param {?=} data
     * @return {?}
     */
    ModalSpellCheckComponent.prototype.open = /**
     * @param {?=} data
     * @return {?}
     */
    function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var after, regex, i;
            return __generator(this, function (_a) {
                after = { re: '(<font\\s+color=#[a-zA-Z0-9]+\\s*>(?<word>[^<]+)<\\/font>\\s*)', flags: 'g' };
                regex = new RegExp(after.re, after.flags);
                for (i in data) {
                    this.model[i] = data[i].value.replace(regex, '$<word>');
                    console.log(this.model[i]);
                    this.enableList.push(false);
                }
                this.spellCheck = data || {};
                this.modal.show();
                return [2 /*return*/];
            });
        });
    };
    /**
     * @return {?}
     */
    ModalSpellCheckComponent.prototype.closeModal = /**
     * @return {?}
     */
    function () {
        this.modal.hide();
        this.spellCheck = {};
        this.model = {};
        this.enableList = [];
        this.isEdit = false;
    };
    /**
     * @param {?} i
     * @return {?}
     */
    ModalSpellCheckComponent.prototype.enableEdit = /**
     * @param {?} i
     * @return {?}
     */
    function (i) {
        this.enableList[i] = !this.enableList[i];
        this.isEdit = true;
    };
    /**
     * @return {?}
     */
    ModalSpellCheckComponent.prototype.saveModal = /**
     * @return {?}
     */
    function () {
        this.onSave.emit(this.model);
        this.modal.hide();
        this.spellCheck = {};
        this.model = {};
        this.enableList = [];
        this.isEdit = false;
    };
    ModalSpellCheckComponent.decorators = [
        { type: Component, args: [{
                    selector: 'modal-spell-check',
                    template: "<div class=\"modal fade\" bsModal #modal=\"bs-modal\" [config]=\"{backdrop: 'static'}\"\n     tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"dialog-static-name1\">\n    <div class=\"modal-dialog modal-md\">\n        <div class=\"modal-content\">\n            <div class=\"modal-header\">\n                <h4 id=\"dialog-static-name\" class=\"modal-title pull-left\">\u0E15\u0E23\u0E27\u0E08\u0E04\u0E33\u0E28\u0E31\u0E1E\u0E17\u0E4C</h4>\n                <button type=\"button\" class=\"close pull-right\" aria-label=\"Close\" (click)=\"closeModal()\">\n                    <span aria-hidden=\"true\">&times;</span>\n                </button>\n            </div>\n\n            <div class=\"modal-body\">\n                <div *ngFor=\"let name of objectKeys(spellCheck); let i = index\" class=\"row\">\n                    <!--<div class=\"col-sm-3\">-->\n                    <!--<span>\u0E0A\u0E37\u0E48\u0E2D\u0E40\u0E23\u0E37\u0E48\u0E2D\u0E07 :</span>-->\n                    <!--</div>-->\n                    <div class=\"col-sm-12\">\n                        <div class=\"form-group\">\n                            <label class=\"control-label\">{{spellCheck[name].display}}</label>\n                            <div [innerHtml]=\"spellCheck[name].value\" [(hidden)]=\"enableList[i]\"></div>\n                            <input [id]=\"'txt'+name\" class=\"form-control m-input\" [(ngModel)]=\"model[name]\" [(hidden)]=\"!enableList[i]\">\n                        </div>\n                        <a type=\"button\" (click)=\"enableEdit(i)\" [(hidden)]=\"enableList[i]\" class=\"btn btn-default btn-sm  icon\" data-toggle=\"tooltip\"\n                           data-placement=\"top\" title=\"\u0E41\u0E01\u0E49\u0E44\u0E02\"><i class=\"fal fa-pencil-alt\"></i></a>\n                    </div>\n                </div>\n                <div class=\"m-portlet__foot m-portlet__foot--fit text-right\">\n                    \u0E04\u0E27\u0E32\u0E21\u0E2B\u0E21\u0E32\u0E22\u0E02\u0E2D\u0E07\u0E2A\u0E35 : <font color=#ff0000>  \u0E04\u0E33\u0E17\u0E35\u0E48\u0E44\u0E21\u0E48\u0E23\u0E39\u0E49\u0E08\u0E31\u0E01 </font>\n                    <div class=\"m-form__actions\">\n                        <button type=\"submit\" class=\"btn btn-success btn-md btn-md-save\" (click)=\"saveModal()\" [(hidden)]=\"!isEdit\">\n                            \u0E1A\u0E31\u0E19\u0E17\u0E36\u0E01\n                        </button>\n                    </div>\n                </div>\n            </div>\n        </div>\n    </div>\n</div>"
                }] }
    ];
    /** @nocollapse */
    ModalSpellCheckComponent.ctorParameters = function () { return [
        { type: AppConfigService },
        { type: Request },
        { type: Common },
        { type: HttpClient }
    ]; };
    ModalSpellCheckComponent.propDecorators = {
        modal: [{ type: ViewChild, args: ['modal',] }],
        onSave: [{ type: Output }]
    };
    return ModalSpellCheckComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
// # Calendar TH
locale('th');
var ModalSpellCheckModule = /** @class */ (function () {
    function ModalSpellCheckModule() {
    }
    ModalSpellCheckModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule,
                        SharedDateBoxModule,
                        FormsModule,
                        ReactiveFormsModule,
                        ModalModule.forRoot(),
                        DxDataGridModule,
                        DxTemplateModule,
                        AutoCompleteModule,
                        NgZorroAntdModule,
                        UploadAttachmentModule
                    ], exports: [
                        ModalSpellCheckComponent
                    ], providers: [], declarations: [
                        ModalSpellCheckComponent,
                    ],
                },] }
    ];
    return ModalSpellCheckModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var B2bModule = /** @class */ (function () {
    function B2bModule() {
    }
    B2bModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [],
                    imports: [
                        CommonModule,
                        FormsModule,
                        HttpModule,
                    ],
                    providers: [
                        B2bService,
                    ],
                    entryComponents: [],
                },] }
    ];
    return B2bModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var PermissionGuard = /** @class */ (function () {
    function PermissionGuard(router, route, dataservice, appConfigService) {
        this.router = router;
        this.route = route;
        this.dataservice = dataservice;
        this.appConfigService = appConfigService;
        this.config = appConfigService.getConfig();
    }
    /**
     * @param {?} next
     * @param {?} state
     * @return {?}
     */
    PermissionGuard.prototype.canActivate = /**
     * @param {?} next
     * @param {?} state
     * @return {?}
     */
    function (next, state$$1) {
        console.log(next.queryParams);
        /** @type {?} */
        var params = next.queryParams;
        if (params["token"]) {
            sessionStorage.setItem('token', params["token"]);
            // token = params.token
            return this.getPermission(next);
        }
        else if (params["token"] === '') {
            return false;
        }
        else {
            /** @type {?} */
            var token = sessionStorage.getItem('token');
            if (token) {
                return this.getPermission(next);
            }
            else {
                return false;
            }
        }
        // const path = this.getUrlPath(next);
        // let configData = null;
        // configData = this.getConfigByUrl(path);
        // if (configData) {
        //     if (this.dataservice.isCheckGuard(configData.role)) {
        //         return true;
        //     }
        //     else { return false; }
        // } else { return true; }
    };
    /**
     * @param {?} next
     * @return {?}
     */
    PermissionGuard.prototype.getPermission = /**
     * @param {?} next
     * @return {?}
     */
    function (next) {
        return __awaiter(this, void 0, void 0, function () {
            var verifyToken, path, configData, __resultData;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.dataservice.verify()];
                    case 1:
                        verifyToken = _a.sent();
                        console.log("verifyToken", verifyToken, verifyToken['resultCode'] === '40100');
                        if (verifyToken['resultCode'] == '20000') {
                            path = this.getUrlPath(next);
                            configData = null;
                            configData = this.getConfigByUrl(path);
                            console.log('configData ', configData);
                            if (configData) {
                                if (this.dataservice.isCheckGuardRoutePath(configData.routingPath) || configData.routingPath === '') {
                                    console.log('isCheckGuardRoutePath ', true);
                                    return [2 /*return*/, true];
                                }
                                else
                                    return [2 /*return*/, false];
                            }
                            else
                                return [2 /*return*/, true];
                        }
                        else if (verifyToken['resultCode'] === '40100') {
                            __resultData = verifyToken['resultData'];
                            this.checkSession(__resultData.userMessage);
                            return [2 /*return*/, false];
                        }
                        else {
                            return [2 /*return*/, false];
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @param {?} userMessage
     * @return {?}
     */
    PermissionGuard.prototype.checkSession = /**
     * @param {?} userMessage
     * @return {?}
     */
    function (userMessage) {
        console.log('checkSession');
        /** @type {?} */
        var token = sessionStorage.getItem('token');
        window.parent.postMessage(JSON.stringify({
            command: "checkSession",
            message: token,
            userMessage: userMessage || 'Unknow'
        }), '*');
        console.log('checkSession', JSON.stringify({
            command: "checkSession",
            message: token,
            userMessage: userMessage || 'Unknow'
        }));
    };
    /**
     * @param {?} url
     * @return {?}
     */
    PermissionGuard.prototype.getUrlPath = /**
     * @param {?} url
     * @return {?}
     */
    function (url) {
        console.log('path ', url.routeConfig.path);
        return url.routeConfig.path;
    };
    /**
     * @param {?} path
     * @return {?}
     */
    PermissionGuard.prototype.getConfigByUrl = /**
     * @param {?} path
     * @return {?}
     */
    function (path) {
        var e_1, _a;
        /** @type {?} */
        var permissionConfig = this.config.permission;
        /** @type {?} */
        var permissionData = null;
        try {
            for (var permissionConfig_1 = __values(permissionConfig), permissionConfig_1_1 = permissionConfig_1.next(); !permissionConfig_1_1.done; permissionConfig_1_1 = permissionConfig_1.next()) {
                var data = permissionConfig_1_1.value;
                if (path == data.routingPath) {
                    permissionData = data;
                    break;
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (permissionConfig_1_1 && !permissionConfig_1_1.done && (_a = permissionConfig_1.return)) _a.call(permissionConfig_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        console.log('Data ', permissionData);
        return permissionData;
    };
    PermissionGuard.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    PermissionGuard.ctorParameters = function () { return [
        { type: Router },
        { type: ActivatedRoute },
        { type: B2bService },
        { type: AppConfigService }
    ]; };
    /** @nocollapse */ PermissionGuard.ngInjectableDef = defineInjectable({ factory: function PermissionGuard_Factory() { return new PermissionGuard(inject(Router), inject(ActivatedRoute), inject(B2bService), inject(AppConfigService)); }, token: PermissionGuard, providedIn: "root" });
    return PermissionGuard;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
/** @type {?} */
var CALENDAR_VALUE_ACCESSOR = {
    provide: NG_VALUE_ACCESSOR,
    useExisting: forwardRef(function () { return Calendar; }),
    multi: true
};
var Calendar = /** @class */ (function () {
    function Calendar(el, domHandler, renderer, cd) {
        this.el = el;
        this.domHandler = domHandler;
        this.renderer = renderer;
        this.cd = cd;
        this.dateFormat = 'dd/mm/yy';
        this.inline = false;
        this.showOtherMonths = true;
        this.icon = 'pi pi-calendar';
        this.shortYearCutoff = '+10';
        this.hourFormat = '24';
        this.stepHour = 1;
        this.stepMinute = 1;
        this.stepSecond = 1;
        this.showSeconds = false;
        this.showOnFocus = true;
        this.dataType = 'date';
        this.selectionMode = 'single';
        this.todayButtonStyleClass = 'ui-button-secondary';
        this.clearButtonStyleClass = 'ui-button-secondary';
        this.autoZIndex = true;
        this.baseZIndex = 0;
        this.keepInvalid = false;
        this.hideOnDateTimeSelect = false;
        this.numberOfMonths = 1;
        this.view = 'date';
        this.onFocus = new EventEmitter();
        this.onBlur = new EventEmitter();
        this.onClose = new EventEmitter();
        this.onSelect = new EventEmitter();
        this.onInput = new EventEmitter();
        this.onTodayClick = new EventEmitter();
        this.onClearClick = new EventEmitter();
        this.onMonthChange = new EventEmitter();
        this.onYearChange = new EventEmitter();
        this._locale = {
            firstDayOfWeek: 0,
            dayNames: ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'],
            dayNamesShort: ['Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat'],
            dayNamesMin: ['Su', 'Mo', 'Tu', 'We', 'Th', 'Fr', 'Sa'],
            monthNames: ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'],
            monthNamesShort: ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'],
            today: 'Today',
            clear: 'Clear'
        };
        this.inputFieldValue = null;
        this.onModelChange = function () { };
        this.onModelTouched = function () { };
    }
    Object.defineProperty(Calendar.prototype, "utc", {
        get: /**
         * @return {?}
         */
        function () {
            return this._utc;
        },
        set: /**
         * @param {?} _utc
         * @return {?}
         */
        function (_utc) {
            this._utc = _utc;
            console.log('Setting utc has no effect as built-in UTC support is dropped.');
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Calendar.prototype, "minDate", {
        get: /**
         * @return {?}
         */
        function () {
            return this._minDate;
        },
        set: /**
         * @param {?} date
         * @return {?}
         */
        function (date) {
            this._minDate = date;
            if (this.currentMonth != undefined && this.currentMonth != null && this.currentYear) {
                this.createMonths(this.currentMonth, this.currentYear);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Calendar.prototype, "maxDate", {
        get: /**
         * @return {?}
         */
        function () {
            return this._maxDate;
        },
        set: /**
         * @param {?} date
         * @return {?}
         */
        function (date) {
            this._maxDate = date;
            if (this.currentMonth != undefined && this.currentMonth != null && this.currentYear) {
                this.createMonths(this.currentMonth, this.currentYear);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Calendar.prototype, "disabledDates", {
        get: /**
         * @return {?}
         */
        function () {
            return this._disabledDates;
        },
        set: /**
         * @param {?} disabledDates
         * @return {?}
         */
        function (disabledDates) {
            this._disabledDates = disabledDates;
            if (this.currentMonth != undefined && this.currentMonth != null && this.currentYear) {
                this.createMonths(this.currentMonth, this.currentYear);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Calendar.prototype, "disabledDays", {
        get: /**
         * @return {?}
         */
        function () {
            return this._disabledDays;
        },
        set: /**
         * @param {?} disabledDays
         * @return {?}
         */
        function (disabledDays) {
            this._disabledDays = disabledDays;
            if (this.currentMonth != undefined && this.currentMonth != null && this.currentYear) {
                this.createMonths(this.currentMonth, this.currentYear);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Calendar.prototype, "showTime", {
        get: /**
         * @return {?}
         */
        function () {
            return this._showTime;
        },
        set: /**
         * @param {?} showTime
         * @return {?}
         */
        function (showTime) {
            this._showTime = showTime;
            if (this.currentHour === undefined) {
                this.initTime(this.value || new Date());
            }
            this.updateInputfield();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Calendar.prototype, "locale", {
        get: /**
         * @return {?}
         */
        function () {
            return this._locale;
        },
        set: /**
         * @param {?} newLocale
         * @return {?}
         */
        function (newLocale) {
            this._locale = newLocale;
            if (this.view === 'date') {
                this.createWeekDays();
                this.createMonths(this.currentMonth, this.currentYear);
            }
            else if (this.view === 'month') {
                this.createMonthPickerValues();
            }
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    Calendar.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var date = this.defaultDate || new Date();
        this.currentMonth = date.getMonth();
        this.currentYear = date.getFullYear();
        if (this.yearNavigator && this.yearRange) {
            /** @type {?} */
            var years = this.yearRange.split(':');
            /** @type {?} */
            var yearStart = parseInt(years[0]);
            /** @type {?} */
            var yearEnd = parseInt(years[1]);
            this.populateYearOptions(yearStart, yearEnd);
        }
        if (this.view === 'date') {
            this.createWeekDays();
            this.initTime(date);
            this.createMonths(this.currentMonth, this.currentYear);
            this.ticksTo1970 = (((1970 - 1) * 365 + Math.floor(1970 / 4) - Math.floor(1970 / 100) + Math.floor(1970 / 400)) * 24 * 60 * 60 * 10000000);
        }
        else if (this.view === 'month') {
            this.createMonthPickerValues();
        }
    };
    /**
     * @return {?}
     */
    Calendar.prototype.ngAfterContentInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.templates.forEach(function (item) {
            switch (item.getType()) {
                case 'date':
                    _this.dateTemplate = item.template;
                    break;
                default:
                    _this.dateTemplate = item.template;
                    break;
            }
        });
    };
    /**
     * @param {?} start
     * @param {?} end
     * @return {?}
     */
    Calendar.prototype.populateYearOptions = /**
     * @param {?} start
     * @param {?} end
     * @return {?}
     */
    function (start, end) {
        this.yearOptions = [];
        for (var i = start; i <= end; i++) {
            this.yearOptions.push(i);
        }
    };
    /**
     * @return {?}
     */
    Calendar.prototype.createWeekDays = /**
     * @return {?}
     */
    function () {
        this.weekDays = [];
        /** @type {?} */
        var dayIndex = this.locale.firstDayOfWeek;
        for (var i = 0; i < 7; i++) {
            this.weekDays.push(this.locale.dayNamesMin[dayIndex]);
            dayIndex = (dayIndex == 6) ? 0 : ++dayIndex;
        }
    };
    /**
     * @return {?}
     */
    Calendar.prototype.createMonthPickerValues = /**
     * @return {?}
     */
    function () {
        this.monthPickerValues = [];
        for (var i = 0; i <= 11; i++) {
            this.monthPickerValues.push(this.locale.monthNamesShort[i]);
        }
    };
    /**
     * @param {?} month
     * @param {?} year
     * @return {?}
     */
    Calendar.prototype.createMonths = /**
     * @param {?} month
     * @param {?} year
     * @return {?}
     */
    function (month, year) {
        this.months = this.months = [];
        for (var i = 0; i < this.numberOfMonths; i++) {
            /** @type {?} */
            var m = month + i;
            /** @type {?} */
            var y = year;
            if (m > 11) {
                m = m % 11 - 1;
                y = year + 1;
            }
            this.months.push(this.createMonth(m, y));
        }
    };
    /**
     * @param {?} month
     * @param {?} year
     * @return {?}
     */
    Calendar.prototype.createMonth = /**
     * @param {?} month
     * @param {?} year
     * @return {?}
     */
    function (month, year) {
        /** @type {?} */
        var dates = [];
        /** @type {?} */
        var firstDay = this.getFirstDayOfMonthIndex(month, year);
        /** @type {?} */
        var daysLength = this.getDaysCountInMonth(month, year);
        /** @type {?} */
        var prevMonthDaysLength = this.getDaysCountInPrevMonth(month, year);
        /** @type {?} */
        var sundayIndex = this.getSundayIndex();
        /** @type {?} */
        var dayNo = 1;
        /** @type {?} */
        var today = new Date();
        for (var i = 0; i < 6; i++) {
            /** @type {?} */
            var week = [];
            if (i == 0) {
                for (var j = (prevMonthDaysLength - firstDay + 1); j <= prevMonthDaysLength; j++) {
                    /** @type {?} */
                    var prev = this.getPreviousMonthAndYear(month, year);
                    week.push({ day: j, month: prev.month, year: prev.year, otherMonth: true,
                        today: this.isToday(today, j, prev.month, prev.year), selectable: this.isSelectable(j, prev.month, prev.year, true) });
                }
                /** @type {?} */
                var remainingDaysLength = 7 - week.length;
                for (var j = 0; j < remainingDaysLength; j++) {
                    week.push({ day: dayNo, month: month, year: year, today: this.isToday(today, dayNo, month, year),
                        selectable: this.isSelectable(dayNo, month, year, false) });
                    dayNo++;
                }
            }
            else {
                for (var j = 0; j < 7; j++) {
                    if (dayNo > daysLength) {
                        /** @type {?} */
                        var next = this.getNextMonthAndYear(month, year);
                        week.push({ day: dayNo - daysLength, month: next.month, year: next.year, otherMonth: true,
                            today: this.isToday(today, dayNo - daysLength, next.month, next.year),
                            selectable: this.isSelectable((dayNo - daysLength), next.month, next.year, true) });
                    }
                    else {
                        week.push({ day: dayNo, month: month, year: year, today: this.isToday(today, dayNo, month, year),
                            selectable: this.isSelectable(dayNo, month, year, false) });
                    }
                    dayNo++;
                }
            }
            dates.push(week);
        }
        return {
            month: month,
            year: year,
            dates: dates
        };
    };
    /**
     * @param {?} date
     * @return {?}
     */
    Calendar.prototype.initTime = /**
     * @param {?} date
     * @return {?}
     */
    function (date) {
        this.pm = date.getHours() > 11;
        if (this.showTime) {
            this.currentMinute = date.getMinutes();
            this.currentSecond = date.getSeconds();
            if (this.hourFormat == '12') {
                this.currentHour = date.getHours() == 0 ? 12 : date.getHours() % 12;
            }
            else {
                this.currentHour = date.getHours();
            }
        }
        else if (this.timeOnly) {
            this.currentMinute = 0;
            this.currentHour = 0;
            this.currentSecond = 0;
        }
    };
    /**
     * @param {?} event
     * @return {?}
     */
    Calendar.prototype.navBackward = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        if (this.disabled) {
            event.preventDefault();
            return;
        }
        if (this.view === 'month') {
            this.decrementYear();
        }
        else {
            if (this.currentMonth === 0) {
                this.currentMonth = 11;
                this.decrementYear();
            }
            else {
                this.currentMonth--;
            }
            this.onMonthChange.emit({ month: this.currentMonth + 1, year: this.currentYear });
            this.createMonths(this.currentMonth, this.currentYear);
        }
        event.preventDefault();
    };
    /**
     * @param {?} event
     * @return {?}
     */
    Calendar.prototype.navForward = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        if (this.disabled) {
            event.preventDefault();
            return;
        }
        if (this.view === 'month') {
            this.incrementYear();
        }
        else {
            if (this.currentMonth === 11) {
                this.currentMonth = 0;
                this.incrementYear();
            }
            else {
                this.currentMonth++;
            }
            this.onMonthChange.emit({ month: this.currentMonth + 1, year: this.currentYear });
            this.createMonths(this.currentMonth, this.currentYear);
        }
        event.preventDefault();
    };
    /**
     * @return {?}
     */
    Calendar.prototype.decrementYear = /**
     * @return {?}
     */
    function () {
        this.currentYear--;
        if (this.yearNavigator && this.currentYear < this.yearOptions[0]) {
            /** @type {?} */
            var difference = this.yearOptions[this.yearOptions.length - 1] - this.yearOptions[0];
            this.populateYearOptions(this.yearOptions[0] - difference, this.yearOptions[this.yearOptions.length - 1] - difference);
        }
    };
    /**
     * @return {?}
     */
    Calendar.prototype.incrementYear = /**
     * @return {?}
     */
    function () {
        this.currentYear++;
        if (this.yearNavigator && this.currentYear > this.yearOptions[this.yearOptions.length - 1]) {
            /** @type {?} */
            var difference = this.yearOptions[this.yearOptions.length - 1] - this.yearOptions[0];
            this.populateYearOptions(this.yearOptions[0] + difference, this.yearOptions[this.yearOptions.length - 1] + difference);
        }
    };
    /**
     * @param {?} event
     * @param {?} dateMeta
     * @return {?}
     */
    Calendar.prototype.onDateSelect = /**
     * @param {?} event
     * @param {?} dateMeta
     * @return {?}
     */
    function (event, dateMeta) {
        var _this = this;
        if (this.disabled || !dateMeta.selectable) {
            event.preventDefault();
            return;
        }
        if (this.isMultipleSelection() && this.isSelected(dateMeta)) {
            this.value = this.value.filter(function (date, i) {
                return !_this.isDateEquals(date, dateMeta);
            });
            this.updateModel(this.value);
        }
        else {
            if (this.shouldSelectDate(dateMeta)) {
                if (dateMeta.otherMonth) {
                    this.currentMonth = dateMeta.month;
                    this.currentYear = dateMeta.year;
                    this.createMonths(this.currentMonth, this.currentYear);
                    this.selectDate(dateMeta);
                }
                else {
                    this.selectDate(dateMeta);
                }
            }
        }
        if (this.isSingleSelection() && (!this.showTime || this.hideOnDateTimeSelect)) {
            setTimeout(function () {
                event.preventDefault();
                _this.overlayVisible = false;
                if (_this.mask) {
                    _this.disableModality();
                }
                _this.cd.markForCheck();
            }, 150);
        }
        this.updateInputfield();
        event.preventDefault();
    };
    /**
     * @param {?} dateMeta
     * @return {?}
     */
    Calendar.prototype.shouldSelectDate = /**
     * @param {?} dateMeta
     * @return {?}
     */
    function (dateMeta) {
        if (this.isMultipleSelection()) {
            return !this.maxDateCount || !this.value || this.maxDateCount > this.value.length;
        }
        else {
            return true;
        }
    };
    /**
     * @param {?} event
     * @param {?} index
     * @return {?}
     */
    Calendar.prototype.onMonthSelect = /**
     * @param {?} event
     * @param {?} index
     * @return {?}
     */
    function (event, index) {
        this.onDateSelect(event, { year: this.currentYear, month: index, day: 1, selectable: true });
    };
    /**
     * @return {?}
     */
    Calendar.prototype.updateInputfield = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var formattedValue = '';
        if (this.value) {
            if (this.isSingleSelection()) {
                formattedValue = this.formatDateTime(this.value);
            }
            else if (this.isMultipleSelection()) {
                for (var i = 0; i < this.value.length; i++) {
                    /** @type {?} */
                    var dateAsString = this.formatDateTime(this.value[i]);
                    formattedValue += dateAsString;
                    if (i !== (this.value.length - 1)) {
                        formattedValue += ', ';
                    }
                }
            }
            else if (this.isRangeSelection()) {
                if (this.value && this.value.length) {
                    /** @type {?} */
                    var startDate = this.value[0];
                    /** @type {?} */
                    var endDate = this.value[1];
                    formattedValue = this.formatDateTime(startDate);
                    if (endDate) {
                        formattedValue += ' - ' + this.formatDateTime(endDate);
                    }
                }
            }
        }
        this.inputFieldValue = formattedValue;
        this.updateFilledState();
        if (this.inputfieldViewChild && this.inputfieldViewChild.nativeElement) {
            this.inputfieldViewChild.nativeElement.value = this.inputFieldValue;
        }
    };
    /**
     * @param {?} date
     * @return {?}
     */
    Calendar.prototype.formatDateTime = /**
     * @param {?} date
     * @return {?}
     */
    function (date) {
        /** @type {?} */
        var formattedValue = null;
        if (date) {
            if (this.timeOnly) {
                formattedValue = this.formatTime(date);
            }
            else {
                formattedValue = this.formatDate(date, this.dateFormat);
                if (this.showTime) {
                    formattedValue += ' ' + this.formatTime(date);
                }
            }
        }
        return formattedValue;
    };
    /**
     * @param {?} dateMeta
     * @return {?}
     */
    Calendar.prototype.selectDate = /**
     * @param {?} dateMeta
     * @return {?}
     */
    function (dateMeta) {
        /** @type {?} */
        var date = new Date(dateMeta.year, dateMeta.month, dateMeta.day);
        if (this.showTime) {
            if (this.hourFormat === '12' && this.pm && this.currentHour != 12) {
                date.setHours(this.currentHour + 12);
            }
            else {
                date.setHours(this.currentHour);
            }
            date.setMinutes(this.currentMinute);
            date.setSeconds(this.currentSecond);
        }
        if (this.minDate && this.minDate > date) {
            date = this.minDate;
            this.currentHour = date.getHours();
            this.currentMinute = date.getMinutes();
            this.currentSecond = date.getSeconds();
        }
        if (this.maxDate && this.maxDate < date) {
            date = this.maxDate;
            this.currentHour = date.getHours();
            this.currentMinute = date.getMinutes();
            this.currentSecond = date.getSeconds();
        }
        if (this.isSingleSelection()) {
            this.updateModel(date);
        }
        else if (this.isMultipleSelection()) {
            this.updateModel(this.value ? __spread(this.value, [date]) : [date]);
        }
        else if (this.isRangeSelection()) {
            if (this.value && this.value.length) {
                /** @type {?} */
                var startDate = this.value[0];
                /** @type {?} */
                var endDate = this.value[1];
                if (!endDate && date.getTime() >= startDate.getTime()) {
                    endDate = date;
                }
                else {
                    startDate = date;
                    endDate = null;
                }
                this.updateModel([startDate, endDate]);
            }
            else {
                this.updateModel([date, null]);
            }
        }
        this.onSelect.emit(date);
    };
    /**
     * @param {?} value
     * @return {?}
     */
    Calendar.prototype.updateModel = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        var _this = this;
        this.value = value;
        if (this.dataType == 'date') {
            this.onModelChange(this.value);
        }
        else if (this.dataType == 'string') {
            if (this.isSingleSelection()) {
                this.onModelChange(this.formatDateTime(this.value));
            }
            else {
                /** @type {?} */
                var stringArrValue = null;
                if (this.value) {
                    stringArrValue = this.value.map(function (date) { return _this.formatDateTime(date); });
                }
                this.onModelChange(stringArrValue);
            }
        }
    };
    /**
     * @param {?} month
     * @param {?} year
     * @return {?}
     */
    Calendar.prototype.getFirstDayOfMonthIndex = /**
     * @param {?} month
     * @param {?} year
     * @return {?}
     */
    function (month, year) {
        /** @type {?} */
        var day = new Date();
        day.setDate(1);
        day.setMonth(month);
        day.setFullYear(year);
        /** @type {?} */
        var dayIndex = day.getDay() + this.getSundayIndex();
        return dayIndex >= 7 ? dayIndex - 7 : dayIndex;
    };
    /**
     * @param {?} month
     * @param {?} year
     * @return {?}
     */
    Calendar.prototype.getDaysCountInMonth = /**
     * @param {?} month
     * @param {?} year
     * @return {?}
     */
    function (month, year) {
        return 32 - this.daylightSavingAdjust(new Date(year, month, 32)).getDate();
    };
    /**
     * @param {?} month
     * @param {?} year
     * @return {?}
     */
    Calendar.prototype.getDaysCountInPrevMonth = /**
     * @param {?} month
     * @param {?} year
     * @return {?}
     */
    function (month, year) {
        /** @type {?} */
        var prev = this.getPreviousMonthAndYear(month, year);
        return this.getDaysCountInMonth(prev.month, prev.year);
    };
    /**
     * @param {?} month
     * @param {?} year
     * @return {?}
     */
    Calendar.prototype.getPreviousMonthAndYear = /**
     * @param {?} month
     * @param {?} year
     * @return {?}
     */
    function (month, year) {
        /** @type {?} */
        var m;
        /** @type {?} */
        var y;
        if (month === 0) {
            m = 11;
            y = year - 1;
        }
        else {
            m = month - 1;
            y = year;
        }
        return { 'month': m, 'year': y };
    };
    /**
     * @param {?} month
     * @param {?} year
     * @return {?}
     */
    Calendar.prototype.getNextMonthAndYear = /**
     * @param {?} month
     * @param {?} year
     * @return {?}
     */
    function (month, year) {
        /** @type {?} */
        var m;
        /** @type {?} */
        var y;
        if (month === 11) {
            m = 0;
            y = year + 1;
        }
        else {
            m = month + 1;
            y = year;
        }
        return { 'month': m, 'year': y };
    };
    /**
     * @return {?}
     */
    Calendar.prototype.getSundayIndex = /**
     * @return {?}
     */
    function () {
        return this.locale.firstDayOfWeek > 0 ? 7 - this.locale.firstDayOfWeek : 0;
    };
    /**
     * @param {?} dateMeta
     * @return {?}
     */
    Calendar.prototype.isSelected = /**
     * @param {?} dateMeta
     * @return {?}
     */
    function (dateMeta) {
        var e_1, _a;
        if (this.value) {
            if (this.isSingleSelection()) {
                return this.isDateEquals(this.value, dateMeta);
            }
            else if (this.isMultipleSelection()) {
                /** @type {?} */
                var selected = false;
                try {
                    for (var _b = __values(this.value), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var date = _c.value;
                        selected = this.isDateEquals(date, dateMeta);
                        if (selected) {
                            break;
                        }
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
                return selected;
            }
            else if (this.isRangeSelection()) {
                if (this.value[1]) {
                    return this.isDateEquals(this.value[0], dateMeta) || this.isDateEquals(this.value[1], dateMeta) || this.isDateBetween(this.value[0], this.value[1], dateMeta);
                }
                else {
                    return this.isDateEquals(this.value[0], dateMeta);
                }
            }
        }
        else {
            return false;
        }
    };
    /**
     * @param {?} month
     * @return {?}
     */
    Calendar.prototype.isMonthSelected = /**
     * @param {?} month
     * @return {?}
     */
    function (month) {
        if (this.value) {
            return this.value.getDate() === 1 && this.value.getMonth() === month && this.value.getFullYear() === this.currentYear;
        }
        else {
            return false;
        }
    };
    /**
     * @param {?} value
     * @param {?} dateMeta
     * @return {?}
     */
    Calendar.prototype.isDateEquals = /**
     * @param {?} value
     * @param {?} dateMeta
     * @return {?}
     */
    function (value, dateMeta) {
        if (value) {
            return value.getDate() === dateMeta.day && value.getMonth() === dateMeta.month && value.getFullYear() === dateMeta.year;
        }
        else {
            return false;
        }
    };
    /**
     * @param {?} start
     * @param {?} end
     * @param {?} dateMeta
     * @return {?}
     */
    Calendar.prototype.isDateBetween = /**
     * @param {?} start
     * @param {?} end
     * @param {?} dateMeta
     * @return {?}
     */
    function (start, end, dateMeta) {
        /** @type {?} */
        var between = false;
        if (start && end) {
            /** @type {?} */
            var date = new Date(dateMeta.year, dateMeta.month, dateMeta.day);
            return start.getTime() <= date.getTime() && end.getTime() >= date.getTime();
        }
        return between;
    };
    /**
     * @return {?}
     */
    Calendar.prototype.isSingleSelection = /**
     * @return {?}
     */
    function () {
        return this.selectionMode === 'single';
    };
    /**
     * @return {?}
     */
    Calendar.prototype.isRangeSelection = /**
     * @return {?}
     */
    function () {
        return this.selectionMode === 'range';
    };
    /**
     * @return {?}
     */
    Calendar.prototype.isMultipleSelection = /**
     * @return {?}
     */
    function () {
        return this.selectionMode === 'multiple';
    };
    /**
     * @param {?} today
     * @param {?} day
     * @param {?} month
     * @param {?} year
     * @return {?}
     */
    Calendar.prototype.isToday = /**
     * @param {?} today
     * @param {?} day
     * @param {?} month
     * @param {?} year
     * @return {?}
     */
    function (today, day, month, year) {
        return today.getDate() === day && today.getMonth() === month && today.getFullYear() === year;
    };
    /**
     * @param {?} day
     * @param {?} month
     * @param {?} year
     * @param {?} otherMonth
     * @return {?}
     */
    Calendar.prototype.isSelectable = /**
     * @param {?} day
     * @param {?} month
     * @param {?} year
     * @param {?} otherMonth
     * @return {?}
     */
    function (day, month, year, otherMonth) {
        /** @type {?} */
        var validMin = true;
        /** @type {?} */
        var validMax = true;
        /** @type {?} */
        var validDate = true;
        /** @type {?} */
        var validDay = true;
        if (otherMonth && !this.selectOtherMonths) {
            return false;
        }
        if (this.minDate) {
            if (this.minDate.getFullYear() > year) {
                validMin = false;
            }
            else if (this.minDate.getFullYear() === year) {
                if (this.minDate.getMonth() > month) {
                    validMin = false;
                }
                else if (this.minDate.getMonth() === month) {
                    if (this.minDate.getDate() > day) {
                        validMin = false;
                    }
                }
            }
        }
        if (this.maxDate) {
            if (this.maxDate.getFullYear() < year) {
                validMax = false;
            }
            else if (this.maxDate.getFullYear() === year) {
                if (this.maxDate.getMonth() < month) {
                    validMax = false;
                }
                else if (this.maxDate.getMonth() === month) {
                    if (this.maxDate.getDate() < day) {
                        validMax = false;
                    }
                }
            }
        }
        if (this.disabledDates) {
            validDate = !this.isDateDisabled(day, month, year);
        }
        if (this.disabledDays) {
            validDay = !this.isDayDisabled(day, month, year);
        }
        return validMin && validMax && validDate && validDay;
    };
    /**
     * @param {?} day
     * @param {?} month
     * @param {?} year
     * @return {?}
     */
    Calendar.prototype.isDateDisabled = /**
     * @param {?} day
     * @param {?} month
     * @param {?} year
     * @return {?}
     */
    function (day, month, year) {
        var e_2, _a;
        if (this.disabledDates) {
            try {
                for (var _b = __values(this.disabledDates), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var disabledDate = _c.value;
                    if (disabledDate.getFullYear() === year && disabledDate.getMonth() === month && disabledDate.getDate() === day) {
                        return true;
                    }
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_2) throw e_2.error; }
            }
        }
        return false;
    };
    /**
     * @param {?} day
     * @param {?} month
     * @param {?} year
     * @return {?}
     */
    Calendar.prototype.isDayDisabled = /**
     * @param {?} day
     * @param {?} month
     * @param {?} year
     * @return {?}
     */
    function (day, month, year) {
        if (this.disabledDays) {
            /** @type {?} */
            var weekday = new Date(year, month, day);
            /** @type {?} */
            var weekdayNumber = weekday.getDay();
            return this.disabledDays.indexOf(weekdayNumber) !== -1;
        }
        return false;
    };
    /**
     * @param {?} event
     * @return {?}
     */
    Calendar.prototype.onInputFocus = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        this.focus = true;
        if (this.showOnFocus) {
            this.showOverlay();
        }
        this.onFocus.emit(event);
    };
    /**
     * @param {?} event
     * @return {?}
     */
    Calendar.prototype.onInputClick = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        this.datepickerClick = true;
        if (this.overlay && this.autoZIndex) {
            this.overlay.style.zIndex = String(this.baseZIndex + (++DomHandler.zindex));
        }
    };
    /**
     * @param {?} event
     * @return {?}
     */
    Calendar.prototype.onInputBlur = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        this.focus = false;
        this.onBlur.emit(event);
        if (!this.keepInvalid) {
            this.updateInputfield();
        }
        this.onModelTouched();
    };
    /**
     * @param {?} event
     * @param {?} inputfield
     * @return {?}
     */
    Calendar.prototype.onButtonClick = /**
     * @param {?} event
     * @param {?} inputfield
     * @return {?}
     */
    function (event, inputfield) {
        if (!this.overlayVisible) {
            inputfield.focus();
            this.showOverlay();
        }
        else {
            this.overlayVisible = false;
        }
        this.datepickerClick = true;
    };
    /**
     * @param {?} event
     * @return {?}
     */
    Calendar.prototype.onInputKeydown = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        this.isKeydown = true;
        if (event.keyCode === 9) {
            this.overlayVisible = false;
        }
    };
    /**
     * @param {?} m
     * @return {?}
     */
    Calendar.prototype.onMonthDropdownChange = /**
     * @param {?} m
     * @return {?}
     */
    function (m) {
        this.currentMonth = parseInt(m);
        this.onMonthChange.emit({ month: this.currentMonth + 1, year: this.currentYear });
        this.createMonths(this.currentMonth, this.currentYear);
    };
    /**
     * @param {?} y
     * @return {?}
     */
    Calendar.prototype.onYearDropdownChange = /**
     * @param {?} y
     * @return {?}
     */
    function (y) {
        this.currentYear = parseInt(y);
        this.onYearChange.emit({ month: this.currentMonth + 1, year: this.currentYear });
        this.createMonths(this.currentMonth, this.currentYear);
    };
    /**
     * @param {?} event
     * @return {?}
     */
    Calendar.prototype.incrementHour = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        /** @type {?} */
        var prevHour = this.currentHour;
        /** @type {?} */
        var newHour = this.currentHour + this.stepHour;
        if (this.validateHour(newHour)) {
            if (this.hourFormat == '24') {
                this.currentHour = (newHour >= 24) ? (newHour - 24) : newHour;
            }
            else if (this.hourFormat == '12') {
                // Before the AM/PM break, now after
                if (prevHour < 12 && newHour > 11) {
                    this.pm = !this.pm;
                }
                this.currentHour = (newHour >= 13) ? (newHour - 12) : newHour;
            }
            this.updateTime();
        }
        event.preventDefault();
    };
    /**
     * @param {?} event
     * @return {?}
     */
    Calendar.prototype.decrementHour = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        /** @type {?} */
        var newHour = this.currentHour - this.stepHour;
        if (this.validateHour(newHour)) {
            if (this.hourFormat == '24') {
                this.currentHour = (newHour < 0) ? (24 + newHour) : newHour;
            }
            else if (this.hourFormat == '12') {
                // If we were at noon/midnight, then switch
                if (this.currentHour === 12) {
                    this.pm = !this.pm;
                }
                this.currentHour = (newHour <= 0) ? (12 + newHour) : newHour;
            }
            this.updateTime();
        }
        event.preventDefault();
    };
    /**
     * @param {?} hour
     * @return {?}
     */
    Calendar.prototype.validateHour = /**
     * @param {?} hour
     * @return {?}
     */
    function (hour) {
        /** @type {?} */
        var valid = true;
        /** @type {?} */
        var value = this.value;
        if (this.isRangeSelection()) {
            value = this.value[1] || this.value[0];
        }
        if (this.isMultipleSelection()) {
            value = this.value[this.value.length - 1];
        }
        /** @type {?} */
        var valueDateString = value ? value.toDateString() : null;
        if (this.minDate && valueDateString && this.minDate.toDateString() === valueDateString) {
            if (this.minDate.getHours() > hour) {
                valid = false;
            }
        }
        if (this.maxDate && valueDateString && this.maxDate.toDateString() === valueDateString) {
            if (this.maxDate.getHours() < hour) {
                valid = false;
            }
        }
        return valid;
    };
    /**
     * @param {?} event
     * @return {?}
     */
    Calendar.prototype.incrementMinute = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        /** @type {?} */
        var newMinute = this.currentMinute + this.stepMinute;
        if (this.validateMinute(newMinute)) {
            this.currentMinute = (newMinute > 59) ? newMinute - 60 : newMinute;
            this.updateTime();
        }
        event.preventDefault();
    };
    /**
     * @param {?} event
     * @return {?}
     */
    Calendar.prototype.decrementMinute = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        /** @type {?} */
        var newMinute = this.currentMinute - this.stepMinute;
        if (this.validateMinute(newMinute)) {
            this.currentMinute = (newMinute < 0) ? 60 + newMinute : newMinute;
            this.updateTime();
        }
        event.preventDefault();
    };
    /**
     * @param {?} minute
     * @return {?}
     */
    Calendar.prototype.validateMinute = /**
     * @param {?} minute
     * @return {?}
     */
    function (minute) {
        /** @type {?} */
        var valid = true;
        /** @type {?} */
        var value = this.value;
        if (this.isRangeSelection()) {
            value = this.value[1] || this.value[0];
        }
        if (this.isMultipleSelection()) {
            value = this.value[this.value.length - 1];
        }
        /** @type {?} */
        var valueDateString = value ? value.toDateString() : null;
        if (this.minDate && valueDateString && this.minDate.toDateString() === valueDateString) {
            if (value.getHours() == this.minDate.getHours()) {
                if (this.minDate.getMinutes() > minute) {
                    valid = false;
                }
            }
        }
        if (this.maxDate && valueDateString && this.maxDate.toDateString() === valueDateString) {
            if (value.getHours() == this.maxDate.getHours()) {
                if (this.maxDate.getMinutes() < minute) {
                    valid = false;
                }
            }
        }
        return valid;
    };
    /**
     * @param {?} event
     * @return {?}
     */
    Calendar.prototype.incrementSecond = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        /** @type {?} */
        var newSecond = this.currentSecond + this.stepSecond;
        if (this.validateSecond(newSecond)) {
            this.currentSecond = (newSecond > 59) ? newSecond - 60 : newSecond;
            this.updateTime();
        }
        event.preventDefault();
    };
    /**
     * @param {?} event
     * @return {?}
     */
    Calendar.prototype.decrementSecond = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        /** @type {?} */
        var newSecond = this.currentSecond - this.stepSecond;
        if (this.validateSecond(newSecond)) {
            this.currentSecond = (newSecond < 0) ? 60 + newSecond : newSecond;
            this.updateTime();
        }
        event.preventDefault();
    };
    /**
     * @param {?} second
     * @return {?}
     */
    Calendar.prototype.validateSecond = /**
     * @param {?} second
     * @return {?}
     */
    function (second) {
        /** @type {?} */
        var valid = true;
        /** @type {?} */
        var value = this.value;
        if (this.isRangeSelection()) {
            value = this.value[1] || this.value[0];
        }
        if (this.isMultipleSelection()) {
            value = this.value[this.value.length - 1];
        }
        /** @type {?} */
        var valueDateString = value ? value.toDateString() : null;
        if (this.minDate && valueDateString && this.minDate.toDateString() === valueDateString) {
            if (this.minDate.getSeconds() > second) {
                valid = false;
            }
        }
        if (this.maxDate && valueDateString && this.maxDate.toDateString() === valueDateString) {
            if (this.maxDate.getSeconds() < second) {
                valid = false;
            }
        }
        return valid;
    };
    /**
     * @return {?}
     */
    Calendar.prototype.updateTime = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var value = this.value;
        if (this.isRangeSelection()) {
            value = this.value[1] || this.value[0];
        }
        if (this.isMultipleSelection()) {
            value = this.value[this.value.length - 1];
        }
        value = value ? new Date(value.getTime()) : new Date();
        if (this.hourFormat == '12') {
            if (this.currentHour === 12) {
                value.setHours(this.pm ? 12 : 0);
            }
            else {
                value.setHours(this.pm ? this.currentHour + 12 : this.currentHour);
            }
        }
        else {
            value.setHours(this.currentHour);
        }
        value.setMinutes(this.currentMinute);
        value.setSeconds(this.currentSecond);
        if (this.isRangeSelection()) {
            if (this.value[1]) {
                value = [this.value[0], value];
            }
            else {
                value = [value, null];
            }
        }
        if (this.isMultipleSelection()) {
            value = __spread(this.value.slice(0, -1), [value]);
        }
        this.updateModel(value);
        this.onSelect.emit(value);
        this.updateInputfield();
    };
    /**
     * @param {?} event
     * @return {?}
     */
    Calendar.prototype.toggleAMPM = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        this.pm = !this.pm;
        this.updateTime();
        event.preventDefault();
    };
    /**
     * @param {?} event
     * @return {?}
     */
    Calendar.prototype.onUserInput = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        // IE 11 Workaround for input placeholder : https://github.com/primefaces/primeng/issues/2026
        if (!this.isKeydown) {
            return;
        }
        this.isKeydown = false;
        /** @type {?} */
        var val = event.target.value;
        try {
            /** @type {?} */
            var value = this.parseValueFromString(val);
            this.updateModel(value);
            this.updateUI();
        }
        catch (err) {
            // invalid date
            this.updateModel(null);
        }
        this.filled = val != null && val.length;
        this.onInput.emit(event);
    };
    /**
     * @param {?} text
     * @return {?}
     */
    Calendar.prototype.parseValueFromString = /**
     * @param {?} text
     * @return {?}
     */
    function (text) {
        var e_3, _a;
        if (!text || text.trim().length === 0) {
            return null;
        }
        /** @type {?} */
        var value;
        if (this.isSingleSelection()) {
            value = this.parseDateTime(text);
        }
        else if (this.isMultipleSelection()) {
            /** @type {?} */
            var tokens = text.split(',');
            value = [];
            try {
                for (var tokens_1 = __values(tokens), tokens_1_1 = tokens_1.next(); !tokens_1_1.done; tokens_1_1 = tokens_1.next()) {
                    var token = tokens_1_1.value;
                    value.push(this.parseDateTime(token.trim()));
                }
            }
            catch (e_3_1) { e_3 = { error: e_3_1 }; }
            finally {
                try {
                    if (tokens_1_1 && !tokens_1_1.done && (_a = tokens_1.return)) _a.call(tokens_1);
                }
                finally { if (e_3) throw e_3.error; }
            }
        }
        else if (this.isRangeSelection()) {
            /** @type {?} */
            var tokens = text.split(' - ');
            value = [];
            for (var i = 0; i < tokens.length; i++) {
                value[i] = this.parseDateTime(tokens[i].trim());
            }
        }
        return value;
    };
    /**
     * @param {?} text
     * @return {?}
     */
    Calendar.prototype.parseDateTime = /**
     * @param {?} text
     * @return {?}
     */
    function (text) {
        /** @type {?} */
        var date;
        /** @type {?} */
        var parts = text.split(' ');
        if (this.timeOnly) {
            date = new Date();
            this.populateTime(date, parts[0], parts[1]);
        }
        else {
            if (this.showTime) {
                date = this.parseDate(parts[0], this.dateFormat);
                this.populateTime(date, parts[1], parts[2]);
            }
            else {
                date = this.parseDate(text, this.dateFormat);
            }
        }
        return date;
    };
    /**
     * @param {?} value
     * @param {?} timeString
     * @param {?} ampm
     * @return {?}
     */
    Calendar.prototype.populateTime = /**
     * @param {?} value
     * @param {?} timeString
     * @param {?} ampm
     * @return {?}
     */
    function (value, timeString, ampm) {
        if (this.hourFormat == '12' && !ampm) {
            throw new Error('Invalid Time');
        }
        this.pm = (ampm === 'PM' || ampm === 'pm');
        /** @type {?} */
        var time = this.parseTime(timeString);
        value.setHours(time.hour);
        value.setMinutes(time.minute);
        value.setSeconds(time.second);
    };
    /**
     * @return {?}
     */
    Calendar.prototype.updateUI = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var val = this.value || this.defaultDate || new Date();
        if (Array.isArray(val)) {
            val = val[0];
        }
        this.currentMonth = val.getMonth();
        this.currentYear = val.getFullYear();
        this.createMonths(this.currentMonth, this.currentYear);
        if (this.showTime || this.timeOnly) {
            /** @type {?} */
            var hours = val.getHours();
            if (this.hourFormat == '12') {
                this.pm = hours > 11;
                if (hours >= 12) {
                    this.currentHour = (hours == 12) ? 12 : hours - 12;
                }
                else {
                    this.currentHour = (hours == 0) ? 12 : hours;
                }
            }
            else {
                this.currentHour = val.getHours();
            }
            this.currentMinute = val.getMinutes();
            this.currentSecond = val.getSeconds();
        }
    };
    /**
     * @param {?} event
     * @return {?}
     */
    Calendar.prototype.onDatePickerClick = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        this.datepickerClick = true;
    };
    /**
     * @return {?}
     */
    Calendar.prototype.showOverlay = /**
     * @return {?}
     */
    function () {
        this.overlayVisible = true;
    };
    /**
     * @param {?} event
     * @return {?}
     */
    Calendar.prototype.onOverlayAnimationStart = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        switch (event.toState) {
            case 'visible':
            case 'visibleTouchUI':
                if (!this.inline) {
                    this.overlay = event.element;
                    this.appendOverlay();
                    if (this.autoZIndex) {
                        this.overlay.style.zIndex = String(this.baseZIndex + (++DomHandler.zindex));
                    }
                    this.alignOverlay();
                    this.bindDocumentClickListener();
                }
                break;
            case 'void':
                this.onOverlayHide();
                break;
        }
    };
    /**
     * @return {?}
     */
    Calendar.prototype.appendOverlay = /**
     * @return {?}
     */
    function () {
        if (this.appendTo) {
            if (this.appendTo === 'body') {
                document.body.appendChild(this.overlay);
            }
            else {
                this.domHandler.appendChild(this.overlay, this.appendTo);
            }
        }
    };
    /**
     * @return {?}
     */
    Calendar.prototype.restoreOverlayAppend = /**
     * @return {?}
     */
    function () {
        if (this.overlay && this.appendTo) {
            this.el.nativeElement.appendChild(this.overlay);
        }
    };
    /**
     * @return {?}
     */
    Calendar.prototype.alignOverlay = /**
     * @return {?}
     */
    function () {
        if (this.touchUI) {
            this.enableModality(this.overlay);
        }
        else {
            if (this.appendTo) {
                this.domHandler.absolutePosition(this.overlay, this.inputfieldViewChild.nativeElement);
            }
            else {
                this.domHandler.relativePosition(this.overlay, this.inputfieldViewChild.nativeElement);
            }
        }
    };
    /**
     * @param {?} element
     * @return {?}
     */
    Calendar.prototype.enableModality = /**
     * @param {?} element
     * @return {?}
     */
    function (element) {
        var _this = this;
        if (!this.mask) {
            this.mask = document.createElement('div');
            this.mask.style.zIndex = String(parseInt(element.style.zIndex) - 1);
            /** @type {?} */
            var maskStyleClass = 'ui-widget-overlay ui-datepicker-mask ui-datepicker-mask-scrollblocker';
            this.domHandler.addMultipleClasses(this.mask, maskStyleClass);
            this.maskClickListener = this.renderer.listen(this.mask, 'click', function (event) {
                _this.disableModality();
            });
            document.body.appendChild(this.mask);
            this.domHandler.addClass(document.body, 'ui-overflow-hidden');
        }
    };
    /**
     * @return {?}
     */
    Calendar.prototype.disableModality = /**
     * @return {?}
     */
    function () {
        if (this.mask) {
            document.body.removeChild(this.mask);
            /** @type {?} */
            var bodyChildren = document.body.children;
            /** @type {?} */
            var hasBlockerMasks = void 0;
            for (var i = 0; i < bodyChildren.length; i++) {
                /** @type {?} */
                var bodyChild = bodyChildren[i];
                if (this.domHandler.hasClass(bodyChild, 'ui-datepicker-mask-scrollblocker')) {
                    hasBlockerMasks = true;
                    break;
                }
            }
            if (!hasBlockerMasks) {
                this.domHandler.removeClass(document.body, 'ui-overflow-hidden');
            }
            this.overlayVisible = false;
            this.unbindMaskClickListener();
            this.mask = null;
        }
    };
    /**
     * @return {?}
     */
    Calendar.prototype.unbindMaskClickListener = /**
     * @return {?}
     */
    function () {
        if (this.maskClickListener) {
            this.maskClickListener();
            this.maskClickListener = null;
        }
    };
    /**
     * @param {?} value
     * @return {?}
     */
    Calendar.prototype.writeValue = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        this.value = value;
        if (this.value && typeof this.value === 'string') {
            this.value = this.parseValueFromString(this.value);
        }
        this.updateInputfield();
        this.updateUI();
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    Calendar.prototype.registerOnChange = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) {
        this.onModelChange = fn;
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    Calendar.prototype.registerOnTouched = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) {
        this.onModelTouched = fn;
    };
    /**
     * @param {?} val
     * @return {?}
     */
    Calendar.prototype.setDisabledState = /**
     * @param {?} val
     * @return {?}
     */
    function (val) {
        this.disabled = val;
    };
    // Ported from jquery-ui datepicker formatDate
    /**
     * @param {?} date
     * @param {?} format
     * @return {?}
     */
    Calendar.prototype.formatDate = /**
     * @param {?} date
     * @param {?} format
     * @return {?}
     */
    function (date, format) {
        if (!date) {
            return '';
        }
        /** @type {?} */
        var iFormat;
        /** @type {?} */
        var lookAhead = function (match) {
            /** @type {?} */
            var matches = (iFormat + 1 < format.length && format.charAt(iFormat + 1) === match);
            if (matches) {
                iFormat++;
            }
            return matches;
        };
        /** @type {?} */
        var formatNumber = function (match, value, len) {
            /** @type {?} */
            var num = '' + value;
            if (lookAhead(match)) {
                while (num.length < len) {
                    num = '0' + num;
                }
            }
            return num;
        };
        /** @type {?} */
        var formatName = function (match, value, shortNames, longNames) {
            return (lookAhead(match) ? longNames[value] : shortNames[value]);
        };
        /** @type {?} */
        var output = '';
        /** @type {?} */
        var literal = false;
        if (date) {
            for (iFormat = 0; iFormat < format.length; iFormat++) {
                if (literal) {
                    if (format.charAt(iFormat) === '\'' && !lookAhead('\'')) {
                        literal = false;
                    }
                    else {
                        output += format.charAt(iFormat);
                    }
                }
                else {
                    switch (format.charAt(iFormat)) {
                        case 'd':
                            output += formatNumber('d', date.getDate(), 2);
                            break;
                        case 'D':
                            output += formatName('D', date.getDay(), this.locale.dayNamesShort, this.locale.dayNames);
                            break;
                        case 'o':
                            output += formatNumber('o', Math.round((new Date(date.getFullYear(), date.getMonth(), date.getDate()).getTime() -
                                new Date(date.getFullYear(), 0, 0).getTime()) / 86400000), 3);
                            break;
                        case 'm':
                            output += formatNumber('m', date.getMonth() + 1, 2);
                            break;
                        case 'M':
                            output += formatName('M', date.getMonth(), this.locale.monthNamesShort, this.locale.monthNames);
                            break;
                        case 'y':
                            output += lookAhead('y') ? date.getFullYear() : (date.getFullYear() % 100 < 10 ? '0' : '') + (date.getFullYear() % 100);
                            break;
                        case '@':
                            output += date.getTime();
                            break;
                        case '!':
                            output += date.getTime() * 10000 + this.ticksTo1970;
                            break;
                        case '\'':
                            if (lookAhead('\'')) {
                                output += '\'';
                            }
                            else {
                                literal = true;
                            }
                            break;
                        default:
                            output += format.charAt(iFormat);
                    }
                }
            }
        }
        return output;
    };
    /**
     * @param {?} date
     * @return {?}
     */
    Calendar.prototype.formatTime = /**
     * @param {?} date
     * @return {?}
     */
    function (date) {
        if (!date) {
            return '';
        }
        /** @type {?} */
        var output = '';
        /** @type {?} */
        var hours = date.getHours();
        /** @type {?} */
        var minutes = date.getMinutes();
        /** @type {?} */
        var seconds = date.getSeconds();
        if (this.hourFormat == '12' && hours > 11 && hours != 12) {
            hours -= 12;
        }
        if (this.hourFormat == '12') {
            output += hours === 0 ? 12 : (hours < 10) ? '0' + hours : hours;
        }
        else {
            output += (hours < 10) ? '0' + hours : hours;
        }
        output += ':';
        output += (minutes < 10) ? '0' + minutes : minutes;
        if (this.showSeconds) {
            output += ':';
            output += (seconds < 10) ? '0' + seconds : seconds;
        }
        if (this.hourFormat == '12') {
            output += date.getHours() > 11 ? ' PM' : ' AM';
        }
        return output;
    };
    /**
     * @param {?} value
     * @return {?}
     */
    Calendar.prototype.parseTime = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        /** @type {?} */
        var tokens = value.split(':');
        /** @type {?} */
        var validTokenLength = this.showSeconds ? 3 : 2;
        if (tokens.length !== validTokenLength) {
            throw new Error('Invalid time');
        }
        /** @type {?} */
        var h = parseInt(tokens[0]);
        /** @type {?} */
        var m = parseInt(tokens[1]);
        /** @type {?} */
        var s = this.showSeconds ? parseInt(tokens[2]) : null;
        if (isNaN(h) || isNaN(m) || h > 23 || m > 59 || (this.hourFormat == '12' && h > 12) || (this.showSeconds && (isNaN(s) || s > 59))) {
            throw new Error('Invalid time');
        }
        else {
            if (this.hourFormat == '12' && h !== 12 && this.pm) {
                h += 12;
            }
            return { hour: h, minute: m, second: s };
        }
    };
    // Ported from jquery-ui datepicker parseDate
    /**
     * @param {?} value
     * @param {?} format
     * @return {?}
     */
    Calendar.prototype.parseDate = /**
     * @param {?} value
     * @param {?} format
     * @return {?}
     */
    function (value, format) {
        if (format == null || value == null) {
            throw new Error('Invalid arguments');
        }
        value = (typeof value === 'object' ? value.toString() : value + '');
        if (value === '') {
            return null;
        }
        /** @type {?} */
        var iFormat;
        /** @type {?} */
        var dim;
        /** @type {?} */
        var extra;
        /** @type {?} */
        var iValue = 0;
        /** @type {?} */
        var shortYearCutoff = (typeof this.shortYearCutoff !== 'string' ? this.shortYearCutoff : new Date().getFullYear() % 100 + parseInt(this.shortYearCutoff, 10));
        /** @type {?} */
        var year = -1;
        /** @type {?} */
        var month = -1;
        /** @type {?} */
        var day = -1;
        /** @type {?} */
        var doy = -1;
        /** @type {?} */
        var literal = false;
        /** @type {?} */
        var date;
        /** @type {?} */
        var lookAhead = function (match) {
            /** @type {?} */
            var matches = (iFormat + 1 < format.length && format.charAt(iFormat + 1) === match);
            if (matches) {
                iFormat++;
            }
            return matches;
        };
        /** @type {?} */
        var getNumber = function (match) {
            /** @type {?} */
            var isDoubled = lookAhead(match);
            /** @type {?} */
            var size$$1 = (match === '@' ? 14 : (match === '!' ? 20 :
                (match === 'y' && isDoubled ? 4 : (match === 'o' ? 3 : 2))));
            /** @type {?} */
            var minSize = (match === 'y' ? size$$1 : 1);
            /** @type {?} */
            var digits = new RegExp('^\\d{' + minSize + ',' + size$$1 + '}');
            /** @type {?} */
            var num = value.substring(iValue).match(digits);
            if (!num) {
                throw new Error('Missing number at position ' + iValue);
            }
            iValue += num[0].length;
            return parseInt(num[0], 10);
        };
        /** @type {?} */
        var getName = function (match, shortNames, longNames) {
            /** @type {?} */
            var index = -1;
            /** @type {?} */
            var arr = lookAhead(match) ? longNames : shortNames;
            /** @type {?} */
            var names = [];
            for (var i = 0; i < arr.length; i++) {
                names.push([i, arr[i]]);
            }
            names.sort(function (a, b) {
                return -(a[1].length - b[1].length);
            });
            for (var i = 0; i < names.length; i++) {
                /** @type {?} */
                var name_1 = names[i][1];
                if (value.substr(iValue, name_1.length).toLowerCase() === name_1.toLowerCase()) {
                    index = names[i][0];
                    iValue += name_1.length;
                    break;
                }
            }
            if (index !== -1) {
                return index + 1;
            }
            else {
                throw new Error('Unknown name at position ' + iValue);
            }
        };
        /** @type {?} */
        var checkLiteral = function () {
            if (value.charAt(iValue) !== format.charAt(iFormat)) {
                throw new Error('Unexpected literal at position ' + iValue);
            }
            iValue++;
        };
        if (this.view === 'month') {
            day = 1;
        }
        for (iFormat = 0; iFormat < format.length; iFormat++) {
            if (literal) {
                if (format.charAt(iFormat) === '\'' && !lookAhead('\'')) {
                    literal = false;
                }
                else {
                    checkLiteral();
                }
            }
            else {
                switch (format.charAt(iFormat)) {
                    case 'd':
                        day = getNumber('d');
                        break;
                    case 'D':
                        getName('D', this.locale.dayNamesShort, this.locale.dayNames);
                        break;
                    case 'o':
                        doy = getNumber('o');
                        break;
                    case 'm':
                        month = getNumber('m');
                        break;
                    case 'M':
                        month = getName('M', this.locale.monthNamesShort, this.locale.monthNames);
                        break;
                    case 'y':
                        year = getNumber('y');
                        break;
                    case '@':
                        date = new Date(getNumber('@'));
                        year = date.getFullYear();
                        month = date.getMonth() + 1;
                        day = date.getDate();
                        break;
                    case '!':
                        date = new Date((getNumber('!') - this.ticksTo1970) / 10000);
                        year = date.getFullYear();
                        month = date.getMonth() + 1;
                        day = date.getDate();
                        break;
                    case '\'':
                        if (lookAhead('\'')) {
                            checkLiteral();
                        }
                        else {
                            literal = true;
                        }
                        break;
                    default:
                        checkLiteral();
                }
            }
        }
        if (iValue < value.length) {
            extra = value.substr(iValue);
            if (!/^\s+/.test(extra)) {
                throw new Error('Extra/unparsed characters found in date: ' + extra);
            }
        }
        if (year === -1) {
            year = new Date().getFullYear();
        }
        else if (year < 100) {
            year += new Date().getFullYear() - new Date().getFullYear() % 100 +
                (year <= shortYearCutoff ? 0 : -100);
        }
        if (doy > -1) {
            month = 1;
            day = doy;
            do {
                dim = this.getDaysCountInMonth(year, month - 1);
                if (day <= dim) {
                    break;
                }
                month++;
                day -= dim;
            } while (true);
        }
        date = this.daylightSavingAdjust(new Date(year, month - 1, day));
        if (date.getFullYear() !== year || date.getMonth() + 1 !== month || date.getDate() !== day) {
            throw new Error('Invalid date'); // E.g. 31/02/00
        }
        return date;
    };
    /**
     * @param {?} date
     * @return {?}
     */
    Calendar.prototype.daylightSavingAdjust = /**
     * @param {?} date
     * @return {?}
     */
    function (date) {
        if (!date) {
            return null;
        }
        date.setHours(date.getHours() > 12 ? date.getHours() + 2 : 0);
        return date;
    };
    /**
     * @return {?}
     */
    Calendar.prototype.updateFilledState = /**
     * @return {?}
     */
    function () {
        this.filled = this.inputFieldValue && this.inputFieldValue != '';
    };
    /**
     * @param {?} event
     * @return {?}
     */
    Calendar.prototype.onTodayButtonClick = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        /** @type {?} */
        var date = new Date();
        /** @type {?} */
        var dateMeta = { day: date.getDate(), month: date.getMonth(), year: date.getFullYear(), otherMonth: date.getMonth() !== this.currentMonth || date.getFullYear() !== this.currentYear, today: true, selectable: true };
        this.onDateSelect(event, dateMeta);
        this.onTodayClick.emit(event);
    };
    /**
     * @param {?} event
     * @return {?}
     */
    Calendar.prototype.onClearButtonClick = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        this.updateModel(null);
        this.updateInputfield();
        this.overlayVisible = false;
        this.onClearClick.emit(event);
    };
    /**
     * @return {?}
     */
    Calendar.prototype.bindDocumentClickListener = /**
     * @return {?}
     */
    function () {
        var _this = this;
        if (!this.documentClickListener) {
            this.documentClickListener = this.renderer.listen('document', 'click', function (event) {
                if (!_this.datepickerClick && _this.overlayVisible) {
                    _this.overlayVisible = false;
                    _this.onClose.emit(event);
                }
                _this.datepickerClick = false;
                _this.cd.detectChanges();
            });
        }
    };
    /**
     * @return {?}
     */
    Calendar.prototype.unbindDocumentClickListener = /**
     * @return {?}
     */
    function () {
        if (this.documentClickListener) {
            this.documentClickListener();
            this.documentClickListener = null;
        }
    };
    /**
     * @return {?}
     */
    Calendar.prototype.onOverlayHide = /**
     * @return {?}
     */
    function () {
        this.unbindDocumentClickListener();
        this.unbindMaskClickListener();
        this.overlay = null;
    };
    /**
     * @return {?}
     */
    Calendar.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this.restoreOverlayAppend();
        this.onOverlayHide();
    };
    Calendar.decorators = [
        { type: Component, args: [{
                    selector: 's-calendar',
                    template: "\n        <span [ngClass]=\"{'input-group':true,'ui-calendar-':true, 'ui-calendar-w-btn-': showIcon, 'ui-calendar-timeonly': timeOnly}\" [ngStyle]=\"style\" [class]=\"styleClass\" style=\"width:100%\">\n            <ng-template [ngIf]=\"!inline\">\n                <input #inputfield type=\"text\" [attr.id]=\"inputId\" [attr.name]=\"name\" [attr.required]=\"required\" [value]=\"inputFieldValue\" (focus)=\"onInputFocus($event)\" (keydown)=\"onInputKeydown($event)\" (click)=\"onInputClick($event)\" (blur)=\"onInputBlur($event)\"\n                    [readonly]=\"readonlyInput\" (input)=\"onUserInput($event)\" [ngStyle]=\"inputStyle\" [class]=\"inputStyleClass\" [placeholder]=\"placeholder||''\" [disabled]=\"disabled\" [attr.tabindex]=\"tabindex\"\n                    [ngClass]=\"'ui-inputtext ui-widget ui-state-default ui-corner-all'\" autocomplete=\"off\"\n                    >\n                    <span class=\"input-group-btn add-bt\">\n                     <!-- [icon]=\"icon\"  ui-datepicker-trigger ui-calendar-button pButton-->\n                    <button type=\"button\"  *ngIf=\"showIcon\" (click)=\"onButtonClick($event,inputfield)\" class=\"btn btn-success btn-md icon\"\n                    [ngClass]=\"{'ui-state-disabled':disabled}\" [disabled]=\"disabled\" tabindex=\"-1\">\n                        <i class=\"far fa-calendar-alt\"></i>\n                    </button>\n                    </span>\n            </ng-template>\n            <div [class]=\"panelStyleClass\" [ngStyle]=\"panelStyle\" [ngClass]=\"{'ui-datepicker ui-widget ui-widget-content ui-helper-clearfix ui-corner-all': true, 'ui-datepicker-inline':inline,'ui-shadow':!inline,\n                'ui-state-disabled':disabled,'ui-datepicker-timeonly':timeOnly,'ui-datepicker-multiple-month': this.numberOfMonths > 1, 'ui-datepicker-monthpicker': (view === 'month'), 'ui-datepicker-touch-ui': touchUI}\"\n                (click)=\"onDatePickerClick($event)\" [@overlayAnimation]=\"touchUI ? 'visibleTouchUI': 'visible'\" [@.disabled]=\"inline === true\" (@overlayAnimation.start)=\"onOverlayAnimationStart($event)\" *ngIf=\"inline || overlayVisible\">\n                <ng-container *ngIf=\"!timeOnly\">\n                    <div class=\"ui-datepicker-group ui-widget-content\" *ngFor=\"let month of months; let i = index;\">\n                        <div class=\"ui-datepicker-header ui-widget-header ui-helper-clearfix ui-corner-all\">\n                            <ng-content select=\"p-header\"></ng-content>\n                            <a class=\"ui-datepicker-prev ui-corner-all\" href=\"#\" (click)=\"navBackward($event)\" *ngIf=\"i === 0\">\n                                <span class=\"pi pi-chevron-left\"></span>\n                            </a>\n                            <a class=\"ui-datepicker-next ui-corner-all\" href=\"#\" (click)=\"navForward($event)\" *ngIf=\"numberOfMonths === 1 ? true : (i === numberOfMonths -1)\">\n                                <span class=\"pi pi-chevron-right\"></span>\n                            </a>\n                            <div class=\"ui-datepicker-title\">\n                                <span class=\"ui-datepicker-month\" *ngIf=\"!monthNavigator && (view !== 'month')\">{{locale.monthNames[month.month]}}</span>\n                                <select class=\"ui-datepicker-month\" *ngIf=\"monthNavigator && (view !== 'month') && numberOfMonths === 1\" (change)=\"onMonthDropdownChange($event.target.value)\">\n                                    <option [value]=\"i\" *ngFor=\"let monthName of locale.monthNames;let i = index\" [selected]=\"i === month.month\">{{monthName}}</option>\n                                </select>\n                                <select class=\"ui-datepicker-year\" *ngIf=\"yearNavigator && numberOfMonths === 1\" (change)=\"onYearDropdownChange($event.target.value)\">\n                                    <option [value]=\"year\" *ngFor=\"let year of yearOptions\" [selected]=\"year === currentYear\">{{year}}</option>\n                                </select>\n                                <span class=\"ui-datepicker-year\" *ngIf=\"!yearNavigator\">{{view === 'month' ? currentYear : month.year}}</span>\n                            </div>\n                        </div>\n                        <div class=\"ui-datepicker-calendar-container\" *ngIf=\"view ==='date'\">\n                            <table class=\"ui-datepicker-calendar\">\n                                <thead>\n                                    <tr>\n                                        <th scope=\"col\" *ngFor=\"let weekDay of weekDays;let begin = first; let end = last\">\n                                            <span>{{weekDay}}</span>\n                                        </th>\n                                    </tr>\n                                </thead>\n                                <tbody>\n                                    <tr *ngFor=\"let week of month.dates\">\n                                        <td *ngFor=\"let date of week\" [ngClass]=\"{'ui-datepicker-other-month': date.otherMonth,\n                                            'ui-datepicker-current-day':isSelected(date),'ui-datepicker-today':date.today}\">\n                                            <ng-container *ngIf=\"date.otherMonth ? showOtherMonths : true\">\n                                                <a class=\"ui-state-default\" *ngIf=\"date.selectable\" [ngClass]=\"{'ui-state-active':isSelected(date), 'ui-state-highlight':date.today}\"\n                                                    (click)=\"onDateSelect($event,date)\" draggable=\"false\">\n                                                    <ng-container *ngIf=\"!dateTemplate\">{{date.day}}</ng-container>\n                                                    <ng-container *ngTemplateOutlet=\"dateTemplate; context: {$implicit: date}\"></ng-container>\n                                                </a>\n                                                <span class=\"ui-state-default ui-state-disabled\" *ngIf=\"!date.selectable\">\n                                                    {{date.day}}\n                                                </span>\n                                            </ng-container>\n                                        </td>\n                                    </tr>\n                                </tbody>\n                            </table>\n                        </div>\n                    </div>\n                    <div class=\"ui-monthpicker\" *ngIf=\"view === 'month'\">\n                        <a href=\"#\" *ngFor=\"let m of monthPickerValues; let i = index\" (click)=\"onMonthSelect($event, i)\" class=\"ui-monthpicker-month\" [ngClass]=\"{'ui-state-active': isMonthSelected(i)}\">\n                            {{m}}\n                        </a>\n                    </div>\n                </ng-container>\n                <div class=\"ui-timepicker ui-widget-header ui-corner-all\" *ngIf=\"showTime||timeOnly\">\n                    <div class=\"ui-hour-picker\">\n                        <a href=\"#\" (click)=\"incrementHour($event)\">\n                            <span class=\"pi pi-chevron-up\"></span>\n                        </a>\n                        <span [ngStyle]=\"{'display': currentHour < 10 ? 'inline': 'none'}\">0</span><span>{{currentHour}}</span>\n                        <a href=\"#\" (click)=\"decrementHour($event)\">\n                            <span class=\"pi pi-chevron-down\"></span>\n                        </a>\n                    </div>\n                    <div class=\"ui-separator\">\n                        <a href=\"#\">\n                            <span class=\"pi pi-chevron-up\"></span>\n                        </a>\n                        <span>:</span>\n                        <a href=\"#\">\n                            <span class=\"pi pi-chevron-down\"></span>\n                        </a>\n                    </div>\n                    <div class=\"ui-minute-picker\">\n                        <a href=\"#\" (click)=\"incrementMinute($event)\">\n                            <span class=\"pi pi-chevron-up\"></span>\n                        </a>\n                        <span [ngStyle]=\"{'display': currentMinute < 10 ? 'inline': 'none'}\">0</span><span>{{currentMinute}}</span>\n                        <a href=\"#\" (click)=\"decrementMinute($event)\">\n                            <span class=\"pi pi-chevron-down\"></span>\n                        </a>\n                    </div>\n                    <div class=\"ui-separator\" *ngIf=\"showSeconds\">\n                        <a href=\"#\">\n                            <span class=\"pi pi-chevron-up\"></span>\n                        </a>\n                        <span>:</span>\n                        <a href=\"#\">\n                            <span class=\"pi pi-chevron-down\"></span>\n                        </a>\n                    </div>\n                    <div class=\"ui-second-picker\" *ngIf=\"showSeconds\">\n                        <a href=\"#\" (click)=\"incrementSecond($event)\">\n                            <span class=\"pi pi-chevron-up\"></span>\n                        </a>\n                        <span [ngStyle]=\"{'display': currentSecond < 10 ? 'inline': 'none'}\">0</span><span>{{currentSecond}}</span>\n                        <a href=\"#\" (click)=\"decrementSecond($event)\">\n                            <span class=\"pi pi-chevron-down\"></span>\n                        </a>\n                    </div>\n                    <div class=\"ui-ampm-picker\" *ngIf=\"hourFormat=='12'\">\n                        <a href=\"#\" (click)=\"toggleAMPM($event)\">\n                            <span class=\"pi pi-chevron-up\"></span>\n                        </a>\n                        <span>{{pm ? 'PM' : 'AM'}}</span>\n                        <a href=\"#\" (click)=\"toggleAMPM($event)\">\n                            <span class=\"pi pi-chevron-down\"></span>\n                        </a>\n                    </div>\n                </div>\n                <div class=\"ui-datepicker-buttonbar ui-widget-header\" *ngIf=\"showButtonBar\">\n                    <div class=\"ui-g\">\n                        <div class=\"ui-g-6\">\n                            <button type=\"button\" [label]=\"_locale.today\" (click)=\"onTodayButtonClick($event)\" pButton [ngClass]=\"[todayButtonStyleClass]\"></button>\n                        </div>\n                        <div class=\"ui-g-6\">\n                            <button type=\"button\" [label]=\"_locale.clear\" (click)=\"onClearButtonClick($event)\" pButton [ngClass]=\"[clearButtonStyleClass]\"></button>\n                        </div>\n                    </div>\n                </div>\n                <ng-content select=\"p-footer\"></ng-content>\n            </div>\n        </span>\n    ",
                    animations: [
                        trigger('overlayAnimation', [
                            state('visible', style({
                                transform: 'translateY(0)',
                                opacity: 1
                            })),
                            state('visibleTouchUI', style({
                                transform: 'translate(-50%,-50%)',
                                opacity: 1
                            })),
                            transition('void => visible', [
                                style({ transform: 'translateY(5%)', opacity: 0 }),
                                animate('225ms ease-out')
                            ]),
                            transition('visible => void', [
                                animate(('195ms ease-in'), style({
                                    opacity: 0,
                                    transform: 'translateY(5%)'
                                }))
                            ]),
                            transition('void => visibleTouchUI', [
                                style({ opacity: 0, transform: 'translate3d(-50%, -40%, 0) scale(0.9)' }),
                                animate('225ms ease-out')
                            ]),
                            transition('visibleTouchUI => void', [
                                animate(('195ms ease-in'), style({
                                    opacity: 0,
                                    transform: 'translate3d(-50%, -40%, 0) scale(0.9)'
                                }))
                            ])
                        ])
                    ],
                    host: {
                        '[class.ui-inputwrapper-filled]': 'filled',
                        '[class.ui-inputwrapper-focus]': 'focus'
                    },
                    providers: [DomHandler, CALENDAR_VALUE_ACCESSOR]
                }] }
    ];
    /** @nocollapse */
    Calendar.ctorParameters = function () { return [
        { type: ElementRef },
        { type: DomHandler },
        { type: Renderer2 },
        { type: ChangeDetectorRef }
    ]; };
    Calendar.propDecorators = {
        utc: [{ type: Input }],
        minDate: [{ type: Input }],
        maxDate: [{ type: Input }],
        disabledDates: [{ type: Input }],
        disabledDays: [{ type: Input }],
        showTime: [{ type: Input }],
        locale: [{ type: Input }],
        defaultDate: [{ type: Input }],
        style: [{ type: Input }],
        styleClass: [{ type: Input }],
        inputStyle: [{ type: Input }],
        inputId: [{ type: Input }],
        name: [{ type: Input }],
        inputStyleClass: [{ type: Input }],
        placeholder: [{ type: Input }],
        disabled: [{ type: Input }],
        dateFormat: [{ type: Input }],
        inline: [{ type: Input }],
        showOtherMonths: [{ type: Input }],
        selectOtherMonths: [{ type: Input }],
        showIcon: [{ type: Input }],
        icon: [{ type: Input }],
        appendTo: [{ type: Input }],
        readonlyInput: [{ type: Input }],
        shortYearCutoff: [{ type: Input }],
        monthNavigator: [{ type: Input }],
        yearNavigator: [{ type: Input }],
        yearRange: [{ type: Input }],
        hourFormat: [{ type: Input }],
        timeOnly: [{ type: Input }],
        stepHour: [{ type: Input }],
        stepMinute: [{ type: Input }],
        stepSecond: [{ type: Input }],
        showSeconds: [{ type: Input }],
        required: [{ type: Input }],
        showOnFocus: [{ type: Input }],
        dataType: [{ type: Input }],
        selectionMode: [{ type: Input }],
        maxDateCount: [{ type: Input }],
        showButtonBar: [{ type: Input }],
        todayButtonStyleClass: [{ type: Input }],
        clearButtonStyleClass: [{ type: Input }],
        autoZIndex: [{ type: Input }],
        baseZIndex: [{ type: Input }],
        panelStyleClass: [{ type: Input }],
        panelStyle: [{ type: Input }],
        keepInvalid: [{ type: Input }],
        hideOnDateTimeSelect: [{ type: Input }],
        numberOfMonths: [{ type: Input }],
        view: [{ type: Input }],
        touchUI: [{ type: Input }],
        onFocus: [{ type: Output }],
        onBlur: [{ type: Output }],
        onClose: [{ type: Output }],
        onSelect: [{ type: Output }],
        onInput: [{ type: Output }],
        onTodayClick: [{ type: Output }],
        onClearClick: [{ type: Output }],
        onMonthChange: [{ type: Output }],
        onYearChange: [{ type: Output }],
        templates: [{ type: ContentChildren, args: [PrimeTemplate,] }],
        tabindex: [{ type: Input }],
        inputfieldViewChild: [{ type: ViewChild, args: ['inputfield',] }]
    };
    return Calendar;
}());
var SharedCalendarModule = /** @class */ (function () {
    function SharedCalendarModule() {
    }
    SharedCalendarModule.decorators = [
        { type: NgModule, args: [{
                    imports: [CommonModule, ButtonModule, SharedModule],
                    exports: [Calendar, ButtonModule, SharedModule],
                    declarations: [Calendar]
                },] }
    ];
    return SharedCalendarModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var CanShowDirective = /** @class */ (function () {
    function CanShowDirective(templateRef, viewContainer, dataservice) {
        this.templateRef = templateRef;
        this.viewContainer = viewContainer;
        this.dataservice = dataservice;
    }
    /**
     * @return {?}
     */
    CanShowDirective.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        console.log(this.appCanShow);
        // const appCanShow = true;
        // if (appCanShow) {
        //   this.viewContainer.createEmbeddedView(this.templateRef);
        // } else {
        //   this.viewContainer.clear();
        // }
        // console.log("this.appCanShow",this.appCanShow)
        // console.log("this.templateRef",this.templateRef)
        console.log(this.dataservice.isCheckGroup(this.appCanShow));
        if (this.appCanShow.component.length === 0 || this.appCanShow.role === '') {
            this.viewContainer.createEmbeddedView(this.templateRef);
        }
        else {
            if (this.dataservice.isCheckGroup(this.appCanShow)) {
                console.log(this.templateRef);
                this.viewContainer.createEmbeddedView(this.templateRef);
            }
            else {
                this.viewContainer.clear();
            }
        }
    };
    CanShowDirective.decorators = [
        { type: Directive, args: [{
                    selector: '[appCanShow]'
                },] }
    ];
    /** @nocollapse */
    CanShowDirective.ctorParameters = function () { return [
        { type: TemplateRef },
        { type: ViewContainerRef },
        { type: B2bService }
    ]; };
    CanShowDirective.propDecorators = {
        appCanShow: [{ type: Input, args: ['appCanShow',] }]
    };
    return CanShowDirective;
}());
var CanShowDirectiveModule = /** @class */ (function () {
    function CanShowDirectiveModule() {
    }
    CanShowDirectiveModule.decorators = [
        { type: NgModule, args: [{
                    imports: [],
                    // , CommonModule
                    exports: [CanShowDirective],
                    declarations: [CanShowDirective]
                },] }
    ];
    return CanShowDirectiveModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var SocLoadingService = /** @class */ (function () {
    function SocLoadingService() {
        this.spinnerObservable = new Subject();
    }
    /**
     * @return {?}
     */
    SocLoadingService.prototype.show = /**
     * @return {?}
     */
    function () {
        this.spinnerObservable.next(true);
    };
    /**
     * @return {?}
     */
    SocLoadingService.prototype.hide = /**
     * @return {?}
     */
    function () {
        this.spinnerObservable.next(false);
    };
    SocLoadingService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    SocLoadingService.ctorParameters = function () { return []; };
    /** @nocollapse */ SocLoadingService.ngInjectableDef = defineInjectable({ factory: function SocLoadingService_Factory() { return new SocLoadingService(); }, token: SocLoadingService, providedIn: "root" });
    return SocLoadingService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
/** @type {?} */
var LOADERS = {
    'ball-8bits': 16,
    'ball-atom': 4,
    'ball-beat': 3,
    'ball-circus': 5,
    'ball-climbing-dot': 4,
    'ball-clip-rotate': 1,
    'ball-clip-rotate-multiple': 2,
    'ball-clip-rotate-pulse': 2,
    'ball-elastic-dots': 5,
    'ball-fall': 3,
    'ball-fussion': 4,
    'ball-grid-beat': 9,
    'ball-grid-pulse': 9,
    'ball-newton-cradle': 4,
    'ball-pulse': 3,
    'ball-pulse-rise': 5,
    'ball-pulse-sync': 3,
    'ball-rotate': 1,
    'ball-running-dots': 5,
    'ball-scale': 1,
    'ball-scale-multiple': 3,
    'ball-scale-pulse': 2,
    'ball-scale-ripple': 1,
    'ball-scale-ripple-multiple': 3,
    'ball-spin': 8,
    'ball-spin-clockwise': 8,
    'ball-spin-clockwise-fade': 8,
    'ball-spin-clockwise-fade-rotating': 8,
    'ball-spin-fade': 8,
    'ball-spin-fade-rotating': 8,
    'ball-spin-rotate': 2,
    'ball-square-clockwise-spin': 8,
    'ball-square-spin': 8,
    'ball-triangle-path': 3,
    'ball-zig-zag': 2,
    'ball-zig-zag-deflect': 2,
    'cog': 1,
    'cube-transition': 2,
    'fire': 3,
    'line-scale': 5,
    'line-scale-party': 5,
    'line-scale-pulse-out': 5,
    'line-scale-pulse-out-rapid': 5,
    'line-spin-clockwise-fade': 8,
    'line-spin-clockwise-fade-rotating': 8,
    'line-spin-fade': 8,
    'line-spin-fade-rotating': 8,
    'pacman': 6,
    'square-jelly-box': 2,
    'square-loader': 1,
    'square-spin': 1,
    'timer': 1,
    'triangle-skew-spin': 1
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var SocLoadingComponent = /** @class */ (function () {
    function SocLoadingComponent(spinnerService) {
        var _this = this;
        this.spinnerService = spinnerService;
        this.bdColor = 'rgba(51,51,51,0.8)';
        this.size = '';
        this.color = '#fff';
        this.fullScreen = true;
        this.showSpinner = false;
        this.divArray = [];
        this.divCount = 0;
        this.spinnerSubscription = this.spinnerService.spinnerObservable.subscribe(function (flag) {
            _this.showSpinner = flag;
        });
    }
    /**
     * @return {?}
     */
    SocLoadingComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.onInputChange();
    };
    /**
     * @param {?} changes
     * @return {?}
     */
    SocLoadingComponent.prototype.ngOnChanges = /**
     * @param {?} changes
     * @return {?}
     */
    function (changes) {
        /** @type {?} */
        var typeChange = changes["type"];
        /** @type {?} */
        var sizeChange = changes["size"];
        if (typeChange) {
            if (typeof typeChange.currentValue !== 'undefined' && typeChange.currentValue !== typeChange.previousValue) {
                if (typeChange.currentValue !== '') {
                    this.type = typeChange.currentValue;
                    this.onInputChange();
                }
            }
        }
        if (sizeChange) {
            if (typeof sizeChange.currentValue !== 'undefined' && sizeChange.currentValue !== sizeChange.previousValue) {
                if (sizeChange.currentValue !== '') {
                    this.size = sizeChange.currentValue;
                    this.onInputChange();
                }
            }
        }
    };
    /**
     * @param {?=} type
     * @param {?=} size
     * @return {?}
     */
    SocLoadingComponent.prototype.getClass = /**
     * @param {?=} type
     * @param {?=} size
     * @return {?}
     */
    function (type, size$$1) {
        if (type === void 0) { type = 'ball-scale-multiple'; }
        if (size$$1 === void 0) { size$$1 = 'large'; }
        this.divCount = LOADERS[type];
        this.divArray = Array(this.divCount).fill(0).map(function (x, i) { return i; });
        /** @type {?} */
        var sizeClass = '';
        switch (size$$1.toLowerCase()) {
            case 'small':
                sizeClass = 'la-sm';
                break;
            case 'medium':
                sizeClass = 'la-2x';
                break;
            case 'large':
                sizeClass = 'la-3x';
                break;
            default:
                break;
        }
        return 'la-' + type + ' ' + sizeClass;
    };
    /**
     * @return {?}
     */
    SocLoadingComponent.prototype.onInputChange = /**
     * @return {?}
     */
    function () {
        this.spinnerClass = this.getClass(this.type, this.size);
    };
    /**
     * @return {?}
     */
    SocLoadingComponent.prototype.hideSpinner = /**
     * @return {?}
     */
    function () {
        this.spinnerService.hide();
    };
    /**
     * @return {?}
     */
    SocLoadingComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this.spinnerSubscription.unsubscribe();
    };
    SocLoadingComponent.decorators = [
        { type: Component, args: [{
                    selector: 'soc-loading',
                    template: "<div class=\"black-overlay\" *ngIf=\"showSpinner\" [ngStyle]=\"{'background-color': bdColor}\" [style.position]=\"fullScreen ? 'fixed' : 'absolute'\" (click)=\"hideSpinner()\">\n  <div [class]=\"spinnerClass\" [style.color]=\"color\">\n    <div *ngFor=\"let i of divArray\"></div>\n  </div>\n  <div class=\"loading-text\">\n    <ng-content></ng-content>\n  </div>\n</div>",
                    styles: [".la-ball-8bits,.la-ball-8bits>div{position:relative;box-sizing:border-box}.la-ball-8bits{display:block;font-size:0;color:#fff;width:12px;height:12px}.la-ball-8bits.la-dark{color:#333}.la-ball-8bits>div{display:inline-block;float:none;background-color:currentColor;border:0 solid currentColor;position:absolute;top:50%;left:50%;width:4px;height:4px;border-radius:0;opacity:0;-webkit-transform:translate(100%,100%);transform:translate(100%,100%);-webkit-animation:1s infinite ball-8bits;animation:1s infinite ball-8bits}.la-ball-8bits>div:nth-child(1){-webkit-animation-delay:-.9375s;animation-delay:-.9375s;top:-100%;left:0}.la-ball-8bits>div:nth-child(2){-webkit-animation-delay:-.875s;animation-delay:-.875s;top:-100%;left:33.3333333333%}.la-ball-8bits>div:nth-child(3){-webkit-animation-delay:-.8125s;animation-delay:-.8125s;top:-66.6666666667%;left:66.6666666667%}.la-ball-8bits>div:nth-child(4){-webkit-animation-delay:-.75s;animation-delay:-.75s;top:-33.3333333333%;left:100%}.la-ball-8bits>div:nth-child(5){-webkit-animation-delay:-.6875s;animation-delay:-.6875s;top:0;left:100%}.la-ball-8bits>div:nth-child(6){-webkit-animation-delay:-.625s;animation-delay:-.625s;top:33.3333333333%;left:100%}.la-ball-8bits>div:nth-child(7){-webkit-animation-delay:-.5625s;animation-delay:-.5625s;top:66.6666666667%;left:66.6666666667%}.la-ball-8bits>div:nth-child(8){-webkit-animation-delay:-.5s;animation-delay:-.5s;top:100%;left:33.3333333333%}.la-ball-8bits>div:nth-child(9){-webkit-animation-delay:-.4375s;animation-delay:-.4375s;top:100%;left:0}.la-ball-8bits>div:nth-child(10){-webkit-animation-delay:-.375s;animation-delay:-.375s;top:100%;left:-33.3333333333%}.la-ball-8bits>div:nth-child(11){-webkit-animation-delay:-.3125s;animation-delay:-.3125s;top:66.6666666667%;left:-66.6666666667%}.la-ball-8bits>div:nth-child(12){-webkit-animation-delay:-.25s;animation-delay:-.25s;top:33.3333333333%;left:-100%}.la-ball-8bits>div:nth-child(13){-webkit-animation-delay:-.1875s;animation-delay:-.1875s;top:0;left:-100%}.la-ball-8bits>div:nth-child(14){-webkit-animation-delay:-.125s;animation-delay:-.125s;top:-33.3333333333%;left:-100%}.la-ball-8bits>div:nth-child(15){-webkit-animation-delay:-.0625s;animation-delay:-.0625s;top:-66.6666666667%;left:-66.6666666667%}.la-ball-8bits>div:nth-child(16){-webkit-animation-delay:0s;animation-delay:0s;top:-100%;left:-33.3333333333%}.la-ball-8bits.la-sm{width:6px;height:6px}.la-ball-8bits.la-sm>div{width:2px;height:2px}.la-ball-8bits.la-2x{width:24px;height:24px}.la-ball-8bits.la-2x>div{width:8px;height:8px}.la-ball-8bits.la-3x{width:36px;height:36px}.la-ball-8bits.la-3x>div{width:12px;height:12px}@-webkit-keyframes ball-8bits{0%,50%{opacity:1}51%{opacity:0}}@keyframes ball-8bits{0%,50%{opacity:1}51%{opacity:0}}.la-ball-atom,.la-ball-atom>div{position:relative;box-sizing:border-box}.la-ball-atom{display:block;font-size:0;color:#fff;width:32px;height:32px}.la-ball-atom.la-dark{color:#333}.la-ball-atom>div{display:inline-block;float:none;background-color:currentColor;border:0 solid currentColor}.la-ball-atom>div:nth-child(1){position:absolute;top:50%;left:50%;z-index:1;width:60%;height:60%;background:#aaa;border-radius:100%;-webkit-transform:translate(-50%,-50%);transform:translate(-50%,-50%);-webkit-animation:4.5s linear infinite ball-atom-shrink;animation:4.5s linear infinite ball-atom-shrink}.la-ball-atom>div:not(:nth-child(1)){position:absolute;left:0;z-index:0;width:100%;height:100%;background:0 0;-webkit-animation:1.5s steps(2,end) infinite ball-atom-zindex;animation:1.5s steps(2,end) infinite ball-atom-zindex}.la-ball-atom>div:not(:nth-child(1)):before{position:absolute;top:0;left:0;width:10px;height:10px;margin-top:-5px;margin-left:-5px;content:\"\";background:currentColor;border-radius:50%;opacity:.75;-webkit-animation:1.5s infinite ball-atom-position,1.5s infinite ball-atom-size;animation:1.5s infinite ball-atom-position,1.5s infinite ball-atom-size}.la-ball-atom>div:nth-child(2){-webkit-animation-delay:.75s;animation-delay:.75s}.la-ball-atom>div:nth-child(2):before{-webkit-animation-delay:0s,-1.125s;animation-delay:0s,-1.125s}.la-ball-atom>div:nth-child(3){-webkit-transform:rotate(120deg);transform:rotate(120deg);-webkit-animation-delay:-.25s;animation-delay:-.25s}.la-ball-atom>div:nth-child(3):before{-webkit-animation-delay:-1s,-.75s;animation-delay:-1s,-.75s}.la-ball-atom>div:nth-child(4){-webkit-transform:rotate(240deg);transform:rotate(240deg);-webkit-animation-delay:.25s;animation-delay:.25s}.la-ball-atom>div:nth-child(4):before{-webkit-animation-delay:-.5s,-125ms;animation-delay:-.5s,-125ms}.la-ball-atom.la-sm{width:16px;height:16px}.la-ball-atom.la-sm>div:not(:nth-child(1)):before{width:4px;height:4px;margin-top:-2px;margin-left:-2px}.la-ball-atom.la-2x{width:64px;height:64px}.la-ball-atom.la-2x>div:not(:nth-child(1)):before{width:20px;height:20px;margin-top:-10px;margin-left:-10px}.la-ball-atom.la-3x{width:96px;height:96px}.la-ball-atom.la-3x>div:not(:nth-child(1)):before{width:30px;height:30px;margin-top:-15px;margin-left:-15px}@-webkit-keyframes ball-atom-position{50%{top:100%;left:100%}}@keyframes ball-atom-position{50%{top:100%;left:100%}}@-webkit-keyframes ball-atom-size{50%{-webkit-transform:scale(.5,.5);transform:scale(.5,.5)}}@keyframes ball-atom-size{50%{-webkit-transform:scale(.5,.5);transform:scale(.5,.5)}}@-webkit-keyframes ball-atom-zindex{50%{z-index:10}}@keyframes ball-atom-zindex{50%{z-index:10}}@-webkit-keyframes ball-atom-shrink{50%{-webkit-transform:translate(-50%,-50%) scale(.8,.8);transform:translate(-50%,-50%) scale(.8,.8)}}@keyframes ball-atom-shrink{50%{-webkit-transform:translate(-50%,-50%) scale(.8,.8);transform:translate(-50%,-50%) scale(.8,.8)}}.la-ball-beat,.la-ball-beat>div{position:relative;box-sizing:border-box}.la-ball-beat{display:block;font-size:0;color:#fff;width:54px;height:18px}.la-ball-beat.la-dark{color:#333}.la-ball-beat>div{display:inline-block;float:none;background-color:currentColor;border:0 solid currentColor;width:10px;height:10px;margin:4px;border-radius:100%;-webkit-animation:.7s linear -.15s infinite ball-beat;animation:.7s linear -.15s infinite ball-beat}.la-ball-beat>div:nth-child(2n-1){-webkit-animation-delay:-.5s;animation-delay:-.5s}.la-ball-beat.la-sm{width:26px;height:8px}.la-ball-beat.la-sm>div{width:4px;height:4px;margin:2px}.la-ball-beat.la-2x{width:108px;height:36px}.la-ball-beat.la-2x>div{width:20px;height:20px;margin:8px}.la-ball-beat.la-3x{width:162px;height:54px}.la-ball-beat.la-3x>div{width:30px;height:30px;margin:12px}@-webkit-keyframes ball-beat{50%{opacity:.2;-webkit-transform:scale(.75);transform:scale(.75)}100%{opacity:1;-webkit-transform:scale(1);transform:scale(1)}}@keyframes ball-beat{50%{opacity:.2;-webkit-transform:scale(.75);transform:scale(.75)}100%{opacity:1;-webkit-transform:scale(1);transform:scale(1)}}.la-ball-circus,.la-ball-circus>div{position:relative;box-sizing:border-box}.la-ball-circus{display:block;font-size:0;color:#fff;width:16px;height:16px}.la-ball-circus.la-dark{color:#333}.la-ball-circus>div{float:none;background-color:currentColor;border:0 solid currentColor;position:absolute;top:0;left:-100%;display:block;width:100%;height:100%;border-radius:100%;opacity:.5;-webkit-animation:2.5s cubic-bezier(.25,0,.75,1) infinite ball-circus-position,2.5s cubic-bezier(.25,0,.75,1) infinite ball-circus-size;animation:2.5s cubic-bezier(.25,0,.75,1) infinite ball-circus-position,2.5s cubic-bezier(.25,0,.75,1) infinite ball-circus-size}.la-ball-circus>div:nth-child(1){-webkit-animation-delay:0s,-.5s;animation-delay:0s,-.5s}.la-ball-circus>div:nth-child(2){-webkit-animation-delay:-.5s,-1s;animation-delay:-.5s,-1s}.la-ball-circus>div:nth-child(3){-webkit-animation-delay:-1s,-1.5s;animation-delay:-1s,-1.5s}.la-ball-circus>div:nth-child(4){-webkit-animation-delay:-1.5s,-2s;animation-delay:-1.5s,-2s}.la-ball-circus>div:nth-child(5){-webkit-animation-delay:-2s,-2.5s;animation-delay:-2s,-2.5s}.la-ball-circus.la-sm,.la-ball-circus.la-sm>div{width:8px;height:8px}.la-ball-circus.la-2x,.la-ball-circus.la-2x>div{width:32px;height:32px}.la-ball-circus.la-3x,.la-ball-circus.la-3x>div{width:48px;height:48px}@-webkit-keyframes ball-circus-position{50%{left:100%}}@keyframes ball-circus-position{50%{left:100%}}@-webkit-keyframes ball-circus-size{50%{-webkit-transform:scale(.3,.3);transform:scale(.3,.3)}}@keyframes ball-circus-size{50%{-webkit-transform:scale(.3,.3);transform:scale(.3,.3)}}.la-ball-climbing-dot,.la-ball-climbing-dot>div{position:relative;box-sizing:border-box}.la-ball-climbing-dot{display:block;font-size:0;color:#fff;width:42px;height:32px}.la-ball-climbing-dot.la-dark{color:#333}.la-ball-climbing-dot>div{display:inline-block;float:none;background-color:currentColor;border:0 solid currentColor}.la-ball-climbing-dot>div:nth-child(1){position:absolute;bottom:32%;left:18%;width:14px;height:14px;border-radius:100%;-webkit-transform-origin:center bottom;transform-origin:center bottom;-webkit-animation:.6s ease-in-out infinite ball-climbing-dot-jump;animation:.6s ease-in-out infinite ball-climbing-dot-jump}.la-ball-climbing-dot>div:not(:nth-child(1)){position:absolute;top:0;right:0;width:14px;height:2px;border-radius:0;-webkit-transform:translate(60%,0);transform:translate(60%,0);-webkit-animation:1.8s linear infinite ball-climbing-dot-steps;animation:1.8s linear infinite ball-climbing-dot-steps}.la-ball-climbing-dot>div:not(:nth-child(1)):nth-child(2){-webkit-animation-delay:0s;animation-delay:0s}.la-ball-climbing-dot>div:not(:nth-child(1)):nth-child(3){-webkit-animation-delay:-.6s;animation-delay:-.6s}.la-ball-climbing-dot>div:not(:nth-child(1)):nth-child(4){-webkit-animation-delay:-1.2s;animation-delay:-1.2s}.la-ball-climbing-dot.la-sm{width:20px;height:16px}.la-ball-climbing-dot.la-sm>div:nth-child(1){width:6px;height:6px}.la-ball-climbing-dot.la-sm>div:not(:nth-child(1)){width:6px;height:1px}.la-ball-climbing-dot.la-2x{width:84px;height:64px}.la-ball-climbing-dot.la-2x>div:nth-child(1){width:28px;height:28px}.la-ball-climbing-dot.la-2x>div:not(:nth-child(1)){width:28px;height:4px}.la-ball-climbing-dot.la-3x{width:126px;height:96px}.la-ball-climbing-dot.la-3x>div:nth-child(1){width:42px;height:42px}.la-ball-climbing-dot.la-3x>div:not(:nth-child(1)){width:42px;height:6px}@-webkit-keyframes ball-climbing-dot-jump{0%,100%{-webkit-transform:scale(1,.7);transform:scale(1,.7)}20%,80%,90%{-webkit-transform:scale(.7,1.2);transform:scale(.7,1.2)}40%,46%{-webkit-transform:scale(1,1);transform:scale(1,1)}50%{bottom:125%}}@keyframes ball-climbing-dot-jump{0%,100%{-webkit-transform:scale(1,.7);transform:scale(1,.7)}20%,80%,90%{-webkit-transform:scale(.7,1.2);transform:scale(.7,1.2)}40%,46%{-webkit-transform:scale(1,1);transform:scale(1,1)}50%{bottom:125%}}@-webkit-keyframes ball-climbing-dot-steps{0%{top:0;right:0;opacity:0}50%{opacity:1}100%{top:100%;right:100%;opacity:0}}@keyframes ball-climbing-dot-steps{0%{top:0;right:0;opacity:0}50%{opacity:1}100%{top:100%;right:100%;opacity:0}}.la-ball-clip-rotate-multiple,.la-ball-clip-rotate-multiple>div{position:relative;box-sizing:border-box}.la-ball-clip-rotate-multiple{display:block;font-size:0;color:#fff;width:32px;height:32px}.la-ball-clip-rotate-multiple.la-dark{color:#333}.la-ball-clip-rotate-multiple>div{display:inline-block;float:none;border:2px solid currentColor;position:absolute;top:50%;left:50%;background:0 0;border-radius:100%;-webkit-animation:1s ease-in-out infinite ball-clip-rotate-multiple-rotate;animation:1s ease-in-out infinite ball-clip-rotate-multiple-rotate}.la-ball-clip-rotate-multiple>div:first-child{position:absolute;width:32px;height:32px;border-right-color:transparent;border-left-color:transparent}.la-ball-clip-rotate-multiple>div:last-child{width:16px;height:16px;border-top-color:transparent;border-bottom-color:transparent;-webkit-animation-duration:.5s;animation-duration:.5s;-webkit-animation-direction:reverse;animation-direction:reverse}.la-ball-clip-rotate-multiple.la-sm{width:16px;height:16px}.la-ball-clip-rotate-multiple.la-sm>div{border-width:1px}.la-ball-clip-rotate-multiple.la-sm>div:first-child{width:16px;height:16px}.la-ball-clip-rotate-multiple.la-sm>div:last-child{width:8px;height:8px}.la-ball-clip-rotate-multiple.la-2x{width:64px;height:64px}.la-ball-clip-rotate-multiple.la-2x>div{border-width:4px}.la-ball-clip-rotate-multiple.la-2x>div:first-child{width:64px;height:64px}.la-ball-clip-rotate-multiple.la-2x>div:last-child{width:32px;height:32px}.la-ball-clip-rotate-multiple.la-3x{width:96px;height:96px}.la-ball-clip-rotate-multiple.la-3x>div{border-width:6px}.la-ball-clip-rotate-multiple.la-3x>div:first-child{width:96px;height:96px}.la-ball-clip-rotate-multiple.la-3x>div:last-child{width:48px;height:48px}@-webkit-keyframes ball-clip-rotate-multiple-rotate{0%{-webkit-transform:translate(-50%,-50%) rotate(0);transform:translate(-50%,-50%) rotate(0)}50%{-webkit-transform:translate(-50%,-50%) rotate(180deg);transform:translate(-50%,-50%) rotate(180deg)}100%{-webkit-transform:translate(-50%,-50%) rotate(360deg);transform:translate(-50%,-50%) rotate(360deg)}}@keyframes ball-clip-rotate-multiple-rotate{0%{-webkit-transform:translate(-50%,-50%) rotate(0);transform:translate(-50%,-50%) rotate(0)}50%{-webkit-transform:translate(-50%,-50%) rotate(180deg);transform:translate(-50%,-50%) rotate(180deg)}100%{-webkit-transform:translate(-50%,-50%) rotate(360deg);transform:translate(-50%,-50%) rotate(360deg)}}.la-ball-clip-rotate-pulse,.la-ball-clip-rotate-pulse>div{position:relative;box-sizing:border-box}.la-ball-clip-rotate-pulse{display:block;font-size:0;color:#fff;width:32px;height:32px}.la-ball-clip-rotate-pulse.la-dark{color:#333}.la-ball-clip-rotate-pulse>div{display:inline-block;float:none;background-color:currentColor;border:0 solid currentColor;position:absolute;top:50%;left:50%;border-radius:100%}.la-ball-clip-rotate-pulse>div:first-child{position:absolute;width:32px;height:32px;background:0 0;border-style:solid;border-width:2px;border-right-color:transparent;border-left-color:transparent;-webkit-animation:1s cubic-bezier(.09,.57,.49,.9) infinite ball-clip-rotate-pulse-rotate;animation:1s cubic-bezier(.09,.57,.49,.9) infinite ball-clip-rotate-pulse-rotate}.la-ball-clip-rotate-pulse>div:last-child{width:16px;height:16px;-webkit-animation:1s cubic-bezier(.09,.57,.49,.9) infinite ball-clip-rotate-pulse-scale;animation:1s cubic-bezier(.09,.57,.49,.9) infinite ball-clip-rotate-pulse-scale}.la-ball-clip-rotate-pulse.la-sm{width:16px;height:16px}.la-ball-clip-rotate-pulse.la-sm>div:first-child{width:16px;height:16px;border-width:1px}.la-ball-clip-rotate-pulse.la-sm>div:last-child{width:8px;height:8px}.la-ball-clip-rotate-pulse.la-2x{width:64px;height:64px}.la-ball-clip-rotate-pulse.la-2x>div:first-child{width:64px;height:64px;border-width:4px}.la-ball-clip-rotate-pulse.la-2x>div:last-child{width:32px;height:32px}.la-ball-clip-rotate-pulse.la-3x{width:96px;height:96px}.la-ball-clip-rotate-pulse.la-3x>div:first-child{width:96px;height:96px;border-width:6px}.la-ball-clip-rotate-pulse.la-3x>div:last-child{width:48px;height:48px}@-webkit-keyframes ball-clip-rotate-pulse-rotate{0%{-webkit-transform:translate(-50%,-50%) rotate(0);transform:translate(-50%,-50%) rotate(0)}50%{-webkit-transform:translate(-50%,-50%) rotate(180deg);transform:translate(-50%,-50%) rotate(180deg)}100%{-webkit-transform:translate(-50%,-50%) rotate(360deg);transform:translate(-50%,-50%) rotate(360deg)}}@keyframes ball-clip-rotate-pulse-rotate{0%{-webkit-transform:translate(-50%,-50%) rotate(0);transform:translate(-50%,-50%) rotate(0)}50%{-webkit-transform:translate(-50%,-50%) rotate(180deg);transform:translate(-50%,-50%) rotate(180deg)}100%{-webkit-transform:translate(-50%,-50%) rotate(360deg);transform:translate(-50%,-50%) rotate(360deg)}}@-webkit-keyframes ball-clip-rotate-pulse-scale{0%,100%{opacity:1;-webkit-transform:translate(-50%,-50%) scale(1);transform:translate(-50%,-50%) scale(1)}30%{opacity:.3;-webkit-transform:translate(-50%,-50%) scale(.15);transform:translate(-50%,-50%) scale(.15)}}@keyframes ball-clip-rotate-pulse-scale{0%,100%{opacity:1;-webkit-transform:translate(-50%,-50%) scale(1);transform:translate(-50%,-50%) scale(1)}30%{opacity:.3;-webkit-transform:translate(-50%,-50%) scale(.15);transform:translate(-50%,-50%) scale(.15)}}.la-ball-clip-rotate,.la-ball-clip-rotate>div{position:relative;box-sizing:border-box}.la-ball-clip-rotate{display:block;font-size:0;color:#fff;width:32px;height:32px}.la-ball-clip-rotate.la-dark{color:#333}.la-ball-clip-rotate>div{display:inline-block;float:none;border:2px solid currentColor;width:32px;height:32px;background:0 0;border-bottom-color:transparent;border-radius:100%;-webkit-animation:.75s linear infinite ball-clip-rotate;animation:.75s linear infinite ball-clip-rotate}.la-ball-clip-rotate.la-sm{width:16px;height:16px}.la-ball-clip-rotate.la-sm>div{width:16px;height:16px;border-width:1px}.la-ball-clip-rotate.la-2x{width:64px;height:64px}.la-ball-clip-rotate.la-2x>div{width:64px;height:64px;border-width:4px}.la-ball-clip-rotate.la-3x{width:96px;height:96px}.la-ball-clip-rotate.la-3x>div{width:96px;height:96px;border-width:6px}@-webkit-keyframes ball-clip-rotate{0%{-webkit-transform:rotate(0);transform:rotate(0)}50%{-webkit-transform:rotate(180deg);transform:rotate(180deg)}100%{-webkit-transform:rotate(360deg);transform:rotate(360deg)}}@keyframes ball-clip-rotate{0%{-webkit-transform:rotate(0);transform:rotate(0)}50%{-webkit-transform:rotate(180deg);transform:rotate(180deg)}100%{-webkit-transform:rotate(360deg);transform:rotate(360deg)}}.la-ball-elastic-dots,.la-ball-elastic-dots>div{position:relative;box-sizing:border-box}.la-ball-elastic-dots{display:block;color:#fff;width:120px;height:10px;font-size:0;text-align:center}.la-ball-elastic-dots.la-dark{color:#333}.la-ball-elastic-dots>div{float:none;background-color:currentColor;border:0 solid currentColor;display:inline-block;width:10px;height:10px;white-space:nowrap;border-radius:100%;-webkit-animation:1s infinite ball-elastic-dots-anim;animation:1s infinite ball-elastic-dots-anim}.la-ball-elastic-dots.la-sm{width:60px;height:4px}.la-ball-elastic-dots.la-sm>div{width:4px;height:4px}.la-ball-elastic-dots.la-2x{width:240px;height:20px}.la-ball-elastic-dots.la-2x>div{width:20px;height:20px}.la-ball-elastic-dots.la-3x{width:360px;height:30px}.la-ball-elastic-dots.la-3x>div{width:30px;height:30px}@-webkit-keyframes ball-elastic-dots-anim{0%,100%{margin:0;-webkit-transform:scale(1);transform:scale(1)}50%{margin:0 5%;-webkit-transform:scale(.65);transform:scale(.65)}}@keyframes ball-elastic-dots-anim{0%,100%{margin:0;-webkit-transform:scale(1);transform:scale(1)}50%{margin:0 5%;-webkit-transform:scale(.65);transform:scale(.65)}}.la-ball-fall,.la-ball-fall>div{position:relative;box-sizing:border-box}.la-ball-fall{display:block;font-size:0;color:#fff;width:54px;height:18px}.la-ball-fall.la-dark{color:#333}.la-ball-fall>div{display:inline-block;float:none;background-color:currentColor;border:0 solid currentColor;width:10px;height:10px;margin:4px;border-radius:100%;opacity:0;-webkit-animation:1s ease-in-out infinite ball-fall;animation:1s ease-in-out infinite ball-fall}.la-ball-fall>div:nth-child(1){-webkit-animation-delay:-.2s;animation-delay:-.2s}.la-ball-fall>div:nth-child(2){-webkit-animation-delay:-.1s;animation-delay:-.1s}.la-ball-fall>div:nth-child(3){-webkit-animation-delay:0s;animation-delay:0s}.la-ball-fall.la-sm{width:26px;height:8px}.la-ball-fall.la-sm>div{width:4px;height:4px;margin:2px}.la-ball-fall.la-2x{width:108px;height:36px}.la-ball-fall.la-2x>div{width:20px;height:20px;margin:8px}.la-ball-fall.la-3x{width:162px;height:54px}.la-ball-fall.la-3x>div{width:30px;height:30px;margin:12px}@-webkit-keyframes ball-fall{0%{opacity:0;-webkit-transform:translateY(-145%);transform:translateY(-145%)}10%,90%{opacity:.5}20%,80%{opacity:1;-webkit-transform:translateY(0);transform:translateY(0)}100%{opacity:0;-webkit-transform:translateY(145%);transform:translateY(145%)}}@keyframes ball-fall{0%{opacity:0;-webkit-transform:translateY(-145%);transform:translateY(-145%)}10%,90%{opacity:.5}20%,80%{opacity:1;-webkit-transform:translateY(0);transform:translateY(0)}100%{opacity:0;-webkit-transform:translateY(145%);transform:translateY(145%)}}.la-ball-fussion,.la-ball-fussion>div{position:relative;box-sizing:border-box}.la-ball-fussion{display:block;font-size:0;color:#fff;width:8px;height:8px}.la-ball-fussion.la-dark{color:#333}.la-ball-fussion>div{display:inline-block;float:none;background-color:currentColor;border:0 solid currentColor;position:absolute;width:12px;height:12px;border-radius:100%;-webkit-transform:translate(-50%,-50%);transform:translate(-50%,-50%);-webkit-animation:1s infinite ball-fussion-ball1;animation:1s infinite ball-fussion-ball1}.la-ball-fussion>div:nth-child(1){top:0;left:50%;z-index:1}.la-ball-fussion>div:nth-child(2){top:50%;left:100%;z-index:2;-webkit-animation-name:ball-fussion-ball2;animation-name:ball-fussion-ball2}.la-ball-fussion>div:nth-child(3){top:100%;left:50%;z-index:1;-webkit-animation-name:ball-fussion-ball3;animation-name:ball-fussion-ball3}.la-ball-fussion>div:nth-child(4){top:50%;left:0;z-index:2;-webkit-animation-name:ball-fussion-ball4;animation-name:ball-fussion-ball4}.la-ball-fussion.la-sm{width:4px;height:4px}.la-ball-fussion.la-sm>div{width:6px;height:6px}.la-ball-fussion.la-2x{width:16px;height:16px}.la-ball-fussion.la-2x>div,.la-ball-fussion.la-3x{width:24px;height:24px}.la-ball-fussion.la-3x>div{width:36px;height:36px}@-webkit-keyframes ball-fussion-ball1{0%{opacity:.35}50%{top:-100%;left:200%;opacity:1}100%{top:50%;left:100%;z-index:2;opacity:.35}}@keyframes ball-fussion-ball1{0%{opacity:.35}50%{top:-100%;left:200%;opacity:1}100%{top:50%;left:100%;z-index:2;opacity:.35}}@-webkit-keyframes ball-fussion-ball2{0%{opacity:.35}50%{top:200%;left:200%;opacity:1}100%{top:100%;left:50%;z-index:1;opacity:.35}}@keyframes ball-fussion-ball2{0%{opacity:.35}50%{top:200%;left:200%;opacity:1}100%{top:100%;left:50%;z-index:1;opacity:.35}}@-webkit-keyframes ball-fussion-ball3{0%{opacity:.35}50%{top:200%;left:-100%;opacity:1}100%{top:50%;left:0;z-index:2;opacity:.35}}@keyframes ball-fussion-ball3{0%{opacity:.35}50%{top:200%;left:-100%;opacity:1}100%{top:50%;left:0;z-index:2;opacity:.35}}@-webkit-keyframes ball-fussion-ball4{0%{opacity:.35}50%{top:-100%;left:-100%;opacity:1}100%{top:0;left:50%;z-index:1;opacity:.35}}@keyframes ball-fussion-ball4{0%{opacity:.35}50%{top:-100%;left:-100%;opacity:1}100%{top:0;left:50%;z-index:1;opacity:.35}}.la-ball-grid-beat,.la-ball-grid-beat>div{position:relative;box-sizing:border-box}.la-ball-grid-beat{display:block;font-size:0;color:#fff;width:36px;height:36px}.la-ball-grid-beat.la-dark{color:#333}.la-ball-grid-beat>div{display:inline-block;float:none;background-color:currentColor;border:0 solid currentColor;width:8px;height:8px;margin:2px;border-radius:100%;-webkit-animation-name:ball-grid-beat;animation-name:ball-grid-beat;-webkit-animation-iteration-count:infinite;animation-iteration-count:infinite}.la-ball-grid-beat>div:nth-child(1){-webkit-animation-duration:.65s;animation-duration:.65s;-webkit-animation-delay:.03s;animation-delay:.03s}.la-ball-grid-beat>div:nth-child(2){-webkit-animation-duration:1.02s;animation-duration:1.02s;-webkit-animation-delay:.09s;animation-delay:.09s}.la-ball-grid-beat>div:nth-child(3){-webkit-animation-duration:1.06s;animation-duration:1.06s;-webkit-animation-delay:-.69s;animation-delay:-.69s}.la-ball-grid-beat>div:nth-child(4){-webkit-animation-duration:1.5s;animation-duration:1.5s;-webkit-animation-delay:-.41s;animation-delay:-.41s}.la-ball-grid-beat>div:nth-child(5){-webkit-animation-duration:1.6s;animation-duration:1.6s;-webkit-animation-delay:.04s;animation-delay:.04s}.la-ball-grid-beat>div:nth-child(6){-webkit-animation-duration:.84s;animation-duration:.84s;-webkit-animation-delay:.07s;animation-delay:.07s}.la-ball-grid-beat>div:nth-child(7){-webkit-animation-duration:.68s;animation-duration:.68s;-webkit-animation-delay:-.66s;animation-delay:-.66s}.la-ball-grid-beat>div:nth-child(8){-webkit-animation-duration:.93s;animation-duration:.93s;-webkit-animation-delay:-.76s;animation-delay:-.76s}.la-ball-grid-beat>div:nth-child(9){-webkit-animation-duration:1.24s;animation-duration:1.24s;-webkit-animation-delay:-.76s;animation-delay:-.76s}.la-ball-grid-beat.la-sm{width:18px;height:18px}.la-ball-grid-beat.la-sm>div{width:4px;height:4px;margin:1px}.la-ball-grid-beat.la-2x{width:72px;height:72px}.la-ball-grid-beat.la-2x>div{width:16px;height:16px;margin:4px}.la-ball-grid-beat.la-3x{width:108px;height:108px}.la-ball-grid-beat.la-3x>div{width:24px;height:24px;margin:6px}@-webkit-keyframes ball-grid-beat{0%,100%{opacity:1}50%{opacity:.35}}@keyframes ball-grid-beat{0%,100%{opacity:1}50%{opacity:.35}}.la-ball-grid-pulse,.la-ball-grid-pulse>div{position:relative;box-sizing:border-box}.la-ball-grid-pulse{display:block;font-size:0;color:#fff;width:36px;height:36px}.la-ball-grid-pulse.la-dark{color:#333}.la-ball-grid-pulse>div{display:inline-block;float:none;background-color:currentColor;border:0 solid currentColor;width:8px;height:8px;margin:2px;border-radius:100%;-webkit-animation-name:ball-grid-pulse;animation-name:ball-grid-pulse;-webkit-animation-iteration-count:infinite;animation-iteration-count:infinite}.la-ball-grid-pulse>div:nth-child(1){-webkit-animation-duration:.65s;animation-duration:.65s;-webkit-animation-delay:.03s;animation-delay:.03s}.la-ball-grid-pulse>div:nth-child(2){-webkit-animation-duration:1.02s;animation-duration:1.02s;-webkit-animation-delay:.09s;animation-delay:.09s}.la-ball-grid-pulse>div:nth-child(3){-webkit-animation-duration:1.06s;animation-duration:1.06s;-webkit-animation-delay:-.69s;animation-delay:-.69s}.la-ball-grid-pulse>div:nth-child(4){-webkit-animation-duration:1.5s;animation-duration:1.5s;-webkit-animation-delay:-.41s;animation-delay:-.41s}.la-ball-grid-pulse>div:nth-child(5){-webkit-animation-duration:1.6s;animation-duration:1.6s;-webkit-animation-delay:.04s;animation-delay:.04s}.la-ball-grid-pulse>div:nth-child(6){-webkit-animation-duration:.84s;animation-duration:.84s;-webkit-animation-delay:.07s;animation-delay:.07s}.la-ball-grid-pulse>div:nth-child(7){-webkit-animation-duration:.68s;animation-duration:.68s;-webkit-animation-delay:-.66s;animation-delay:-.66s}.la-ball-grid-pulse>div:nth-child(8){-webkit-animation-duration:.93s;animation-duration:.93s;-webkit-animation-delay:-.76s;animation-delay:-.76s}.la-ball-grid-pulse>div:nth-child(9){-webkit-animation-duration:1.24s;animation-duration:1.24s;-webkit-animation-delay:-.76s;animation-delay:-.76s}.la-ball-grid-pulse.la-sm{width:18px;height:18px}.la-ball-grid-pulse.la-sm>div{width:4px;height:4px;margin:1px}.la-ball-grid-pulse.la-2x{width:72px;height:72px}.la-ball-grid-pulse.la-2x>div{width:16px;height:16px;margin:4px}.la-ball-grid-pulse.la-3x{width:108px;height:108px}.la-ball-grid-pulse.la-3x>div{width:24px;height:24px;margin:6px}@-webkit-keyframes ball-grid-pulse{0%,100%{opacity:1;-webkit-transform:scale(1);transform:scale(1)}50%{opacity:.35;-webkit-transform:scale(.45);transform:scale(.45)}}@keyframes ball-grid-pulse{0%,100%{opacity:1;-webkit-transform:scale(1);transform:scale(1)}50%{opacity:.35;-webkit-transform:scale(.45);transform:scale(.45)}}.la-ball-newton-cradle,.la-ball-newton-cradle>div{position:relative;box-sizing:border-box}.la-ball-newton-cradle{display:block;font-size:0;color:#fff;width:40px;height:10px}.la-ball-newton-cradle.la-dark{color:#333}.la-ball-newton-cradle>div{display:inline-block;float:none;background-color:currentColor;border:0 solid currentColor;width:10px;height:10px;border-radius:100%}.la-ball-newton-cradle>div:first-child{-webkit-transform:translateX(0);transform:translateX(0);-webkit-animation:1s ease-out infinite ball-newton-cradle-left;animation:1s ease-out infinite ball-newton-cradle-left}.la-ball-newton-cradle>div:last-child{-webkit-transform:translateX(0);transform:translateX(0);-webkit-animation:1s ease-out infinite ball-newton-cradle-right;animation:1s ease-out infinite ball-newton-cradle-right}.la-ball-newton-cradle.la-sm{width:20px;height:4px}.la-ball-newton-cradle.la-sm>div{width:4px;height:4px}.la-ball-newton-cradle.la-2x{width:80px;height:20px}.la-ball-newton-cradle.la-2x>div{width:20px;height:20px}.la-ball-newton-cradle.la-3x{width:120px;height:30px}.la-ball-newton-cradle.la-3x>div{width:30px;height:30px}@-webkit-keyframes ball-newton-cradle-left{25%{-webkit-transform:translateX(-100%);transform:translateX(-100%);-webkit-animation-timing-function:ease-in;animation-timing-function:ease-in}50%{-webkit-transform:translateX(0);transform:translateX(0)}}@keyframes ball-newton-cradle-left{25%{-webkit-transform:translateX(-100%);transform:translateX(-100%);-webkit-animation-timing-function:ease-in;animation-timing-function:ease-in}50%{-webkit-transform:translateX(0);transform:translateX(0)}}@-webkit-keyframes ball-newton-cradle-right{100%,50%{-webkit-transform:translateX(0);transform:translateX(0)}75%{-webkit-transform:translateX(100%);transform:translateX(100%);-webkit-animation-timing-function:ease-in;animation-timing-function:ease-in}}@keyframes ball-newton-cradle-right{100%,50%{-webkit-transform:translateX(0);transform:translateX(0)}75%{-webkit-transform:translateX(100%);transform:translateX(100%);-webkit-animation-timing-function:ease-in;animation-timing-function:ease-in}}.la-ball-pulse-rise,.la-ball-pulse-rise>div{position:relative;box-sizing:border-box}.la-ball-pulse-rise{display:block;font-size:0;color:#fff;width:70px;height:14px}.la-ball-pulse-rise.la-dark{color:#333}.la-ball-pulse-rise>div{display:inline-block;float:none;background-color:currentColor;border:0 solid currentColor;width:10px;height:10px;margin:2px;border-radius:100%;-webkit-animation:1s cubic-bezier(.15,.36,.9,.6) infinite ball-pulse-rise-even;animation:1s cubic-bezier(.15,.36,.9,.6) infinite ball-pulse-rise-even}.la-ball-pulse-rise>div:nth-child(2n-1){-webkit-animation-name:ball-pulse-rise-odd;animation-name:ball-pulse-rise-odd}.la-ball-pulse-rise.la-sm{width:34px;height:6px}.la-ball-pulse-rise.la-sm>div{width:4px;height:4px;margin:1px}.la-ball-pulse-rise.la-2x{width:140px;height:28px}.la-ball-pulse-rise.la-2x>div{width:20px;height:20px;margin:4px}.la-ball-pulse-rise.la-3x{width:210px;height:42px}.la-ball-pulse-rise.la-3x>div{width:30px;height:30px;margin:6px}@-webkit-keyframes ball-pulse-rise-even{0%{opacity:1;-webkit-transform:scale(1.1);transform:scale(1.1)}25%{-webkit-transform:translateY(-200%);transform:translateY(-200%)}50%{opacity:.35;-webkit-transform:scale(.3);transform:scale(.3)}75%{-webkit-transform:translateY(200%);transform:translateY(200%)}100%{opacity:1;-webkit-transform:translateY(0);-webkit-transform:scale(1);transform:translateY(0);transform:scale(1)}}@keyframes ball-pulse-rise-even{0%{opacity:1;-webkit-transform:scale(1.1);transform:scale(1.1)}25%{-webkit-transform:translateY(-200%);transform:translateY(-200%)}50%{opacity:.35;-webkit-transform:scale(.3);transform:scale(.3)}75%{-webkit-transform:translateY(200%);transform:translateY(200%)}100%{opacity:1;-webkit-transform:translateY(0);-webkit-transform:scale(1);transform:translateY(0);transform:scale(1)}}@-webkit-keyframes ball-pulse-rise-odd{0%{opacity:.35;-webkit-transform:scale(.4);transform:scale(.4)}25%{-webkit-transform:translateY(200%);transform:translateY(200%)}50%{opacity:1;-webkit-transform:scale(1.1);transform:scale(1.1)}75%{-webkit-transform:translateY(-200%);transform:translateY(-200%)}100%{opacity:.35;-webkit-transform:translateY(0);-webkit-transform:scale(.75);transform:translateY(0);transform:scale(.75)}}@keyframes ball-pulse-rise-odd{0%{opacity:.35;-webkit-transform:scale(.4);transform:scale(.4)}25%{-webkit-transform:translateY(200%);transform:translateY(200%)}50%{opacity:1;-webkit-transform:scale(1.1);transform:scale(1.1)}75%{-webkit-transform:translateY(-200%);transform:translateY(-200%)}100%{opacity:.35;-webkit-transform:translateY(0);-webkit-transform:scale(.75);transform:translateY(0);transform:scale(.75)}}.la-ball-pulse-sync,.la-ball-pulse-sync>div{position:relative;box-sizing:border-box}.la-ball-pulse-sync{display:block;font-size:0;color:#fff;width:54px;height:18px}.la-ball-pulse-sync.la-dark{color:#333}.la-ball-pulse-sync>div{display:inline-block;float:none;background-color:currentColor;border:0 solid currentColor;width:10px;height:10px;margin:4px;border-radius:100%;-webkit-animation:.6s ease-in-out infinite ball-pulse-sync;animation:.6s ease-in-out infinite ball-pulse-sync}.la-ball-pulse-sync>div:nth-child(1){-webkit-animation-delay:-.14s;animation-delay:-.14s}.la-ball-pulse-sync>div:nth-child(2){-webkit-animation-delay:-.07s;animation-delay:-.07s}.la-ball-pulse-sync>div:nth-child(3){-webkit-animation-delay:0s;animation-delay:0s}.la-ball-pulse-sync.la-sm{width:26px;height:8px}.la-ball-pulse-sync.la-sm>div{width:4px;height:4px;margin:2px}.la-ball-pulse-sync.la-2x{width:108px;height:36px}.la-ball-pulse-sync.la-2x>div{width:20px;height:20px;margin:8px}.la-ball-pulse-sync.la-3x{width:162px;height:54px}.la-ball-pulse-sync.la-3x>div{width:30px;height:30px;margin:12px}@-webkit-keyframes ball-pulse-sync{33%{-webkit-transform:translateY(100%);transform:translateY(100%)}66%{-webkit-transform:translateY(-100%);transform:translateY(-100%)}100%{-webkit-transform:translateY(0);transform:translateY(0)}}@keyframes ball-pulse-sync{33%{-webkit-transform:translateY(100%);transform:translateY(100%)}66%{-webkit-transform:translateY(-100%);transform:translateY(-100%)}100%{-webkit-transform:translateY(0);transform:translateY(0)}}.la-ball-pulse,.la-ball-pulse>div{position:relative;box-sizing:border-box}.la-ball-pulse{display:block;font-size:0;color:#fff;width:54px;height:18px}.la-ball-pulse.la-dark{color:#333}.la-ball-pulse>div{display:inline-block;float:none;background-color:currentColor;border:0 solid currentColor;width:10px;height:10px;margin:4px;border-radius:100%;-webkit-animation:1s infinite ball-pulse;animation:1s infinite ball-pulse}.la-ball-pulse>div:nth-child(1){-webkit-animation-delay:-.2s;animation-delay:-.2s}.la-ball-pulse>div:nth-child(2){-webkit-animation-delay:-.1s;animation-delay:-.1s}.la-ball-pulse>div:nth-child(3){-webkit-animation-delay:0s;animation-delay:0s}.la-ball-pulse.la-sm{width:26px;height:8px}.la-ball-pulse.la-sm>div{width:4px;height:4px;margin:2px}.la-ball-pulse.la-2x{width:108px;height:36px}.la-ball-pulse.la-2x>div{width:20px;height:20px;margin:8px}.la-ball-pulse.la-3x{width:162px;height:54px}.la-ball-pulse.la-3x>div{width:30px;height:30px;margin:12px}@-webkit-keyframes ball-pulse{0%,100%,60%{opacity:1;-webkit-transform:scale(1);transform:scale(1)}30%{opacity:.1;-webkit-transform:scale(.01);transform:scale(.01)}}@keyframes ball-pulse{0%,100%,60%{opacity:1;-webkit-transform:scale(1);transform:scale(1)}30%{opacity:.1;-webkit-transform:scale(.01);transform:scale(.01)}}.la-ball-rotate,.la-ball-rotate>div{position:relative;box-sizing:border-box}.la-ball-rotate{display:block;font-size:0;color:#fff;width:10px;height:10px}.la-ball-rotate.la-dark{color:#333}.la-ball-rotate>div{display:inline-block;float:none;background-color:currentColor;border:0 solid currentColor;width:10px;height:10px;border-radius:100%;-webkit-animation:1s cubic-bezier(.7,-.13,.22,.86) infinite ball-rotate-animation;animation:1s cubic-bezier(.7,-.13,.22,.86) infinite ball-rotate-animation}.la-ball-rotate>div:after,.la-ball-rotate>div:before{position:absolute;width:inherit;height:inherit;margin:inherit;content:\"\";background:currentColor;border-radius:inherit;opacity:.8}.la-ball-rotate>div:before{top:0;left:-150%}.la-ball-rotate>div:after{top:0;left:150%}.la-ball-rotate.la-sm,.la-ball-rotate.la-sm>div{width:4px;height:4px}.la-ball-rotate.la-2x,.la-ball-rotate.la-2x>div{width:20px;height:20px}.la-ball-rotate.la-3x,.la-ball-rotate.la-3x>div{width:30px;height:30px}@-webkit-keyframes ball-rotate-animation{0%{-webkit-transform:rotate(0);transform:rotate(0)}50%{-webkit-transform:rotate(180deg);transform:rotate(180deg)}100%{-webkit-transform:rotate(360deg);transform:rotate(360deg)}}@keyframes ball-rotate-animation{0%{-webkit-transform:rotate(0);transform:rotate(0)}50%{-webkit-transform:rotate(180deg);transform:rotate(180deg)}100%{-webkit-transform:rotate(360deg);transform:rotate(360deg)}}.la-ball-running-dots,.la-ball-running-dots>div{position:relative;box-sizing:border-box}.la-ball-running-dots{display:block;font-size:0;color:#fff;width:10px;height:10px}.la-ball-running-dots.la-dark{color:#333}.la-ball-running-dots>div{display:inline-block;float:none;background-color:currentColor;border:0 solid currentColor;position:absolute;width:10px;height:10px;margin-left:-25px;border-radius:100%;-webkit-animation:2s linear infinite ball-running-dots-animate;animation:2s linear infinite ball-running-dots-animate}.la-ball-running-dots>div:nth-child(1){-webkit-animation-delay:0s;animation-delay:0s}.la-ball-running-dots>div:nth-child(2){-webkit-animation-delay:-.4s;animation-delay:-.4s}.la-ball-running-dots>div:nth-child(3){-webkit-animation-delay:-.8s;animation-delay:-.8s}.la-ball-running-dots>div:nth-child(4){-webkit-animation-delay:-1.2s;animation-delay:-1.2s}.la-ball-running-dots>div:nth-child(5){-webkit-animation-delay:-1.6s;animation-delay:-1.6s}.la-ball-running-dots>div:nth-child(6){-webkit-animation-delay:-2s;animation-delay:-2s}.la-ball-running-dots>div:nth-child(7){-webkit-animation-delay:-2.4s;animation-delay:-2.4s}.la-ball-running-dots>div:nth-child(8){-webkit-animation-delay:-2.8s;animation-delay:-2.8s}.la-ball-running-dots>div:nth-child(9){-webkit-animation-delay:-3.2s;animation-delay:-3.2s}.la-ball-running-dots>div:nth-child(10){-webkit-animation-delay:-3.6s;animation-delay:-3.6s}.la-ball-running-dots.la-sm{width:4px;height:4px}.la-ball-running-dots.la-sm>div{width:4px;height:4px;margin-left:-12px}.la-ball-running-dots.la-2x{width:20px;height:20px}.la-ball-running-dots.la-2x>div{width:20px;height:20px;margin-left:-50px}.la-ball-running-dots.la-3x{width:30px;height:30px}.la-ball-running-dots.la-3x>div{width:30px;height:30px;margin-left:-75px}@-webkit-keyframes ball-running-dots-animate{0%,100%{width:100%;height:100%;-webkit-transform:translateY(0) translateX(500%);transform:translateY(0) translateX(500%)}80%{-webkit-transform:translateY(0) translateX(0);transform:translateY(0) translateX(0)}85%{width:100%;height:100%;-webkit-transform:translateY(-125%) translateX(0);transform:translateY(-125%) translateX(0)}90%{width:200%;height:75%}95%{width:100%;height:100%;-webkit-transform:translateY(-100%) translateX(500%);transform:translateY(-100%) translateX(500%)}}@keyframes ball-running-dots-animate{0%,100%{width:100%;height:100%;-webkit-transform:translateY(0) translateX(500%);transform:translateY(0) translateX(500%)}80%{-webkit-transform:translateY(0) translateX(0);transform:translateY(0) translateX(0)}85%{width:100%;height:100%;-webkit-transform:translateY(-125%) translateX(0);transform:translateY(-125%) translateX(0)}90%{width:200%;height:75%}95%{width:100%;height:100%;-webkit-transform:translateY(-100%) translateX(500%);transform:translateY(-100%) translateX(500%)}}.la-ball-scale-multiple,.la-ball-scale-multiple>div{position:relative;box-sizing:border-box}.la-ball-scale-multiple{display:block;font-size:0;color:#fff;width:32px;height:32px}.la-ball-scale-multiple.la-dark{color:#333}.la-ball-scale-multiple>div{display:inline-block;float:none;background-color:currentColor;border:0 solid currentColor;position:absolute;top:0;left:0;width:32px;height:32px;border-radius:100%;opacity:0;-webkit-animation:1s linear infinite ball-scale-multiple;animation:1s linear infinite ball-scale-multiple}.la-ball-scale-multiple>div:nth-child(2){-webkit-animation-delay:.2s;animation-delay:.2s}.la-ball-scale-multiple>div:nth-child(3){-webkit-animation-delay:.4s;animation-delay:.4s}.la-ball-scale-multiple.la-sm,.la-ball-scale-multiple.la-sm>div{width:16px;height:16px}.la-ball-scale-multiple.la-2x,.la-ball-scale-multiple.la-2x>div{width:64px;height:64px}.la-ball-scale-multiple.la-3x,.la-ball-scale-multiple.la-3x>div{width:96px;height:96px}@-webkit-keyframes ball-scale-multiple{0%{opacity:0;-webkit-transform:scale(0);transform:scale(0)}5%{opacity:.75}100%{opacity:0;-webkit-transform:scale(1);transform:scale(1)}}@keyframes ball-scale-multiple{0%{opacity:0;-webkit-transform:scale(0);transform:scale(0)}5%{opacity:.75}100%{opacity:0;-webkit-transform:scale(1);transform:scale(1)}}.la-ball-scale-pulse,.la-ball-scale-pulse>div{position:relative;box-sizing:border-box}.la-ball-scale-pulse{display:block;font-size:0;color:#fff;width:32px;height:32px}.la-ball-scale-pulse.la-dark{color:#333}.la-ball-scale-pulse>div{display:inline-block;float:none;background-color:currentColor;border:0 solid currentColor;position:absolute;top:0;left:0;width:32px;height:32px;border-radius:100%;opacity:.5;-webkit-animation:2s ease-in-out infinite ball-scale-pulse;animation:2s ease-in-out infinite ball-scale-pulse}.la-ball-scale-pulse>div:last-child{-webkit-animation-delay:-1s;animation-delay:-1s}.la-ball-scale-pulse.la-sm,.la-ball-scale-pulse.la-sm>div{width:16px;height:16px}.la-ball-scale-pulse.la-2x,.la-ball-scale-pulse.la-2x>div{width:64px;height:64px}.la-ball-scale-pulse.la-3x,.la-ball-scale-pulse.la-3x>div{width:96px;height:96px}@-webkit-keyframes ball-scale-pulse{0%,100%{-webkit-transform:scale(0);transform:scale(0)}50%{-webkit-transform:scale(1);transform:scale(1)}}@keyframes ball-scale-pulse{0%,100%{-webkit-transform:scale(0);transform:scale(0)}50%{-webkit-transform:scale(1);transform:scale(1)}}.la-ball-scale-ripple-multiple,.la-ball-scale-ripple-multiple>div{position:relative;box-sizing:border-box}.la-ball-scale-ripple-multiple{display:block;font-size:0;color:#fff;width:32px;height:32px}.la-ball-scale-ripple-multiple.la-dark{color:#333}.la-ball-scale-ripple-multiple>div{display:inline-block;float:none;border:2px solid currentColor;position:absolute;top:0;left:0;width:32px;height:32px;background:0 0;border-radius:100%;opacity:0;-webkit-animation:1.25s cubic-bezier(.21,.53,.56,.8) infinite ball-scale-ripple-multiple;animation:1.25s cubic-bezier(.21,.53,.56,.8) infinite ball-scale-ripple-multiple}.la-ball-scale-ripple-multiple>div:nth-child(1){-webkit-animation-delay:0s;animation-delay:0s}.la-ball-scale-ripple-multiple>div:nth-child(2){-webkit-animation-delay:.25s;animation-delay:.25s}.la-ball-scale-ripple-multiple>div:nth-child(3){-webkit-animation-delay:.5s;animation-delay:.5s}.la-ball-scale-ripple-multiple.la-sm{width:16px;height:16px}.la-ball-scale-ripple-multiple.la-sm>div{width:16px;height:16px;border-width:1px}.la-ball-scale-ripple-multiple.la-2x{width:64px;height:64px}.la-ball-scale-ripple-multiple.la-2x>div{width:64px;height:64px;border-width:4px}.la-ball-scale-ripple-multiple.la-3x{width:96px;height:96px}.la-ball-scale-ripple-multiple.la-3x>div{width:96px;height:96px;border-width:6px}@-webkit-keyframes ball-scale-ripple-multiple{0%{opacity:1;-webkit-transform:scale(.1);transform:scale(.1)}70%{opacity:.5;-webkit-transform:scale(1);transform:scale(1)}95%{opacity:0}}@keyframes ball-scale-ripple-multiple{0%{opacity:1;-webkit-transform:scale(.1);transform:scale(.1)}70%{opacity:.5;-webkit-transform:scale(1);transform:scale(1)}95%{opacity:0}}.la-ball-scale-ripple,.la-ball-scale-ripple>div{position:relative;box-sizing:border-box}.la-ball-scale-ripple{display:block;font-size:0;color:#fff;width:32px;height:32px}.la-ball-scale-ripple.la-dark{color:#333}.la-ball-scale-ripple>div{display:inline-block;float:none;border:2px solid currentColor;width:32px;height:32px;background:0 0;border-radius:100%;opacity:0;-webkit-animation:1s cubic-bezier(.21,.53,.56,.8) infinite ball-scale-ripple;animation:1s cubic-bezier(.21,.53,.56,.8) infinite ball-scale-ripple}.la-ball-scale-ripple.la-sm{width:16px;height:16px}.la-ball-scale-ripple.la-sm>div{width:16px;height:16px;border-width:1px}.la-ball-scale-ripple.la-2x{width:64px;height:64px}.la-ball-scale-ripple.la-2x>div{width:64px;height:64px;border-width:4px}.la-ball-scale-ripple.la-3x{width:96px;height:96px}.la-ball-scale-ripple.la-3x>div{width:96px;height:96px;border-width:6px}@-webkit-keyframes ball-scale-ripple{0%{opacity:1;-webkit-transform:scale(.1);transform:scale(.1)}70%{opacity:.65;-webkit-transform:scale(1);transform:scale(1)}100%{opacity:0}}@keyframes ball-scale-ripple{0%{opacity:1;-webkit-transform:scale(.1);transform:scale(.1)}70%{opacity:.65;-webkit-transform:scale(1);transform:scale(1)}100%{opacity:0}}.la-ball-scale,.la-ball-scale>div{position:relative;box-sizing:border-box}.la-ball-scale{display:block;font-size:0;color:#fff;width:32px;height:32px}.la-ball-scale.la-dark{color:#333}.la-ball-scale>div{display:inline-block;float:none;background-color:currentColor;border:0 solid currentColor;width:32px;height:32px;border-radius:100%;opacity:0;-webkit-animation:1s ease-in-out infinite ball-scale;animation:1s ease-in-out infinite ball-scale}.la-ball-scale.la-sm,.la-ball-scale.la-sm>div{width:16px;height:16px}.la-ball-scale.la-2x,.la-ball-scale.la-2x>div{width:64px;height:64px}.la-ball-scale.la-3x,.la-ball-scale.la-3x>div{width:96px;height:96px}@-webkit-keyframes ball-scale{0%{opacity:1;-webkit-transform:scale(0);transform:scale(0)}100%{opacity:0;-webkit-transform:scale(1);transform:scale(1)}}@keyframes ball-scale{0%{opacity:1;-webkit-transform:scale(0);transform:scale(0)}100%{opacity:0;-webkit-transform:scale(1);transform:scale(1)}}.la-ball-spin-clockwise-fade-rotating,.la-ball-spin-clockwise-fade-rotating>div{position:relative;box-sizing:border-box}.la-ball-spin-clockwise-fade-rotating{display:block;font-size:0;color:#fff;width:32px;height:32px;-webkit-animation:6s linear infinite ball-spin-clockwise-fade-rotating-rotate;animation:6s linear infinite ball-spin-clockwise-fade-rotating-rotate}.la-ball-spin-clockwise-fade-rotating.la-dark{color:#333}.la-ball-spin-clockwise-fade-rotating>div{display:inline-block;float:none;background-color:currentColor;border:0 solid currentColor;position:absolute;top:50%;left:50%;width:8px;height:8px;margin-top:-4px;margin-left:-4px;border-radius:100%;-webkit-animation:1s linear infinite ball-spin-clockwise-fade-rotating;animation:1s linear infinite ball-spin-clockwise-fade-rotating}.la-ball-spin-clockwise-fade-rotating>div:nth-child(1){top:5%;left:50%;-webkit-animation-delay:-.875s;animation-delay:-.875s}.la-ball-spin-clockwise-fade-rotating>div:nth-child(2){top:18.1801948466%;left:81.8198051534%;-webkit-animation-delay:-.75s;animation-delay:-.75s}.la-ball-spin-clockwise-fade-rotating>div:nth-child(3){top:50%;left:95%;-webkit-animation-delay:-.625s;animation-delay:-.625s}.la-ball-spin-clockwise-fade-rotating>div:nth-child(4){top:81.8198051534%;left:81.8198051534%;-webkit-animation-delay:-.5s;animation-delay:-.5s}.la-ball-spin-clockwise-fade-rotating>div:nth-child(5){top:94.9999999966%;left:50.0000000005%;-webkit-animation-delay:-.375s;animation-delay:-.375s}.la-ball-spin-clockwise-fade-rotating>div:nth-child(6){top:81.8198046966%;left:18.1801949248%;-webkit-animation-delay:-.25s;animation-delay:-.25s}.la-ball-spin-clockwise-fade-rotating>div:nth-child(7){top:49.9999750815%;left:5.0000051215%;-webkit-animation-delay:-.125s;animation-delay:-.125s}.la-ball-spin-clockwise-fade-rotating>div:nth-child(8){top:18.179464974%;left:18.1803700518%;-webkit-animation-delay:0s;animation-delay:0s}.la-ball-spin-clockwise-fade-rotating.la-sm{width:16px;height:16px}.la-ball-spin-clockwise-fade-rotating.la-sm>div{width:4px;height:4px;margin-top:-2px;margin-left:-2px}.la-ball-spin-clockwise-fade-rotating.la-2x{width:64px;height:64px}.la-ball-spin-clockwise-fade-rotating.la-2x>div{width:16px;height:16px;margin-top:-8px;margin-left:-8px}.la-ball-spin-clockwise-fade-rotating.la-3x{width:96px;height:96px}.la-ball-spin-clockwise-fade-rotating.la-3x>div{width:24px;height:24px;margin-top:-12px;margin-left:-12px}@-webkit-keyframes ball-spin-clockwise-fade-rotating-rotate{100%{-webkit-transform:rotate(-360deg);transform:rotate(-360deg)}}@keyframes ball-spin-clockwise-fade-rotating-rotate{100%{-webkit-transform:rotate(-360deg);transform:rotate(-360deg)}}@-webkit-keyframes ball-spin-clockwise-fade-rotating{50%{opacity:.25;-webkit-transform:scale(.5);transform:scale(.5)}100%{opacity:1;-webkit-transform:scale(1);transform:scale(1)}}@keyframes ball-spin-clockwise-fade-rotating{50%{opacity:.25;-webkit-transform:scale(.5);transform:scale(.5)}100%{opacity:1;-webkit-transform:scale(1);transform:scale(1)}}.la-ball-spin-clockwise-fade,.la-ball-spin-clockwise-fade>div{position:relative;box-sizing:border-box}.la-ball-spin-clockwise-fade{display:block;font-size:0;color:#fff;width:32px;height:32px}.la-ball-spin-clockwise-fade.la-dark{color:#333}.la-ball-spin-clockwise-fade>div{display:inline-block;float:none;background-color:currentColor;border:0 solid currentColor;position:absolute;top:50%;left:50%;width:8px;height:8px;margin-top:-4px;margin-left:-4px;border-radius:100%;-webkit-animation:1s linear infinite ball-spin-clockwise-fade;animation:1s linear infinite ball-spin-clockwise-fade}.la-ball-spin-clockwise-fade>div:nth-child(1){top:5%;left:50%;-webkit-animation-delay:-.875s;animation-delay:-.875s}.la-ball-spin-clockwise-fade>div:nth-child(2){top:18.1801948466%;left:81.8198051534%;-webkit-animation-delay:-.75s;animation-delay:-.75s}.la-ball-spin-clockwise-fade>div:nth-child(3){top:50%;left:95%;-webkit-animation-delay:-.625s;animation-delay:-.625s}.la-ball-spin-clockwise-fade>div:nth-child(4){top:81.8198051534%;left:81.8198051534%;-webkit-animation-delay:-.5s;animation-delay:-.5s}.la-ball-spin-clockwise-fade>div:nth-child(5){top:94.9999999966%;left:50.0000000005%;-webkit-animation-delay:-.375s;animation-delay:-.375s}.la-ball-spin-clockwise-fade>div:nth-child(6){top:81.8198046966%;left:18.1801949248%;-webkit-animation-delay:-.25s;animation-delay:-.25s}.la-ball-spin-clockwise-fade>div:nth-child(7){top:49.9999750815%;left:5.0000051215%;-webkit-animation-delay:-.125s;animation-delay:-.125s}.la-ball-spin-clockwise-fade>div:nth-child(8){top:18.179464974%;left:18.1803700518%;-webkit-animation-delay:0s;animation-delay:0s}.la-ball-spin-clockwise-fade.la-sm{width:16px;height:16px}.la-ball-spin-clockwise-fade.la-sm>div{width:4px;height:4px;margin-top:-2px;margin-left:-2px}.la-ball-spin-clockwise-fade.la-2x{width:64px;height:64px}.la-ball-spin-clockwise-fade.la-2x>div{width:16px;height:16px;margin-top:-8px;margin-left:-8px}.la-ball-spin-clockwise-fade.la-3x{width:96px;height:96px}.la-ball-spin-clockwise-fade.la-3x>div{width:24px;height:24px;margin-top:-12px;margin-left:-12px}@-webkit-keyframes ball-spin-clockwise-fade{50%{opacity:.25;-webkit-transform:scale(.5);transform:scale(.5)}100%{opacity:1;-webkit-transform:scale(1);transform:scale(1)}}@keyframes ball-spin-clockwise-fade{50%{opacity:.25;-webkit-transform:scale(.5);transform:scale(.5)}100%{opacity:1;-webkit-transform:scale(1);transform:scale(1)}}.la-ball-spin-clockwise,.la-ball-spin-clockwise>div{position:relative;box-sizing:border-box}.la-ball-spin-clockwise{display:block;font-size:0;color:#fff;width:32px;height:32px}.la-ball-spin-clockwise.la-dark{color:#333}.la-ball-spin-clockwise>div{display:inline-block;float:none;background-color:currentColor;border:0 solid currentColor;position:absolute;top:50%;left:50%;width:8px;height:8px;margin-top:-4px;margin-left:-4px;border-radius:100%;-webkit-animation:1s ease-in-out infinite ball-spin-clockwise;animation:1s ease-in-out infinite ball-spin-clockwise}.la-ball-spin-clockwise>div:nth-child(1){top:5%;left:50%;-webkit-animation-delay:-.875s;animation-delay:-.875s}.la-ball-spin-clockwise>div:nth-child(2){top:18.1801948466%;left:81.8198051534%;-webkit-animation-delay:-.75s;animation-delay:-.75s}.la-ball-spin-clockwise>div:nth-child(3){top:50%;left:95%;-webkit-animation-delay:-.625s;animation-delay:-.625s}.la-ball-spin-clockwise>div:nth-child(4){top:81.8198051534%;left:81.8198051534%;-webkit-animation-delay:-.5s;animation-delay:-.5s}.la-ball-spin-clockwise>div:nth-child(5){top:94.9999999966%;left:50.0000000005%;-webkit-animation-delay:-.375s;animation-delay:-.375s}.la-ball-spin-clockwise>div:nth-child(6){top:81.8198046966%;left:18.1801949248%;-webkit-animation-delay:-.25s;animation-delay:-.25s}.la-ball-spin-clockwise>div:nth-child(7){top:49.9999750815%;left:5.0000051215%;-webkit-animation-delay:-.125s;animation-delay:-.125s}.la-ball-spin-clockwise>div:nth-child(8){top:18.179464974%;left:18.1803700518%;-webkit-animation-delay:0s;animation-delay:0s}.la-ball-spin-clockwise.la-sm{width:16px;height:16px}.la-ball-spin-clockwise.la-sm>div{width:4px;height:4px;margin-top:-2px;margin-left:-2px}.la-ball-spin-clockwise.la-2x{width:64px;height:64px}.la-ball-spin-clockwise.la-2x>div{width:16px;height:16px;margin-top:-8px;margin-left:-8px}.la-ball-spin-clockwise.la-3x{width:96px;height:96px}.la-ball-spin-clockwise.la-3x>div{width:24px;height:24px;margin-top:-12px;margin-left:-12px}@-webkit-keyframes ball-spin-clockwise{0%,100%{opacity:1;-webkit-transform:scale(1);transform:scale(1)}20%{opacity:1}80%{opacity:0;-webkit-transform:scale(0);transform:scale(0)}}@keyframes ball-spin-clockwise{0%,100%{opacity:1;-webkit-transform:scale(1);transform:scale(1)}20%{opacity:1}80%{opacity:0;-webkit-transform:scale(0);transform:scale(0)}}.la-ball-spin-fade-rotating,.la-ball-spin-fade-rotating>div{position:relative;box-sizing:border-box}.la-ball-spin-fade-rotating{display:block;font-size:0;color:#fff;width:32px;height:32px;-webkit-animation:6s linear infinite ball-spin-fade-rotate;animation:6s linear infinite ball-spin-fade-rotate}.la-ball-spin-fade-rotating.la-dark{color:#333}.la-ball-spin-fade-rotating>div{display:inline-block;float:none;background-color:currentColor;border:0 solid currentColor;position:absolute;top:50%;left:50%;width:8px;height:8px;margin-top:-4px;margin-left:-4px;border-radius:100%;-webkit-animation:1s linear infinite ball-spin-fade;animation:1s linear infinite ball-spin-fade}.la-ball-spin-fade-rotating>div:nth-child(1){top:5%;left:50%;-webkit-animation-delay:-1.125s;animation-delay:-1.125s}.la-ball-spin-fade-rotating>div:nth-child(2){top:18.1801948466%;left:81.8198051534%;-webkit-animation-delay:-1.25s;animation-delay:-1.25s}.la-ball-spin-fade-rotating>div:nth-child(3){top:50%;left:95%;-webkit-animation-delay:-1.375s;animation-delay:-1.375s}.la-ball-spin-fade-rotating>div:nth-child(4){top:81.8198051534%;left:81.8198051534%;-webkit-animation-delay:-1.5s;animation-delay:-1.5s}.la-ball-spin-fade-rotating>div:nth-child(5){top:94.9999999966%;left:50.0000000005%;-webkit-animation-delay:-1.625s;animation-delay:-1.625s}.la-ball-spin-fade-rotating>div:nth-child(6){top:81.8198046966%;left:18.1801949248%;-webkit-animation-delay:-1.75s;animation-delay:-1.75s}.la-ball-spin-fade-rotating>div:nth-child(7){top:49.9999750815%;left:5.0000051215%;-webkit-animation-delay:-1.875s;animation-delay:-1.875s}.la-ball-spin-fade-rotating>div:nth-child(8){top:18.179464974%;left:18.1803700518%;-webkit-animation-delay:-2s;animation-delay:-2s}.la-ball-spin-fade-rotating.la-sm{width:16px;height:16px}.la-ball-spin-fade-rotating.la-sm>div{width:4px;height:4px;margin-top:-2px;margin-left:-2px}.la-ball-spin-fade-rotating.la-2x{width:64px;height:64px}.la-ball-spin-fade-rotating.la-2x>div{width:16px;height:16px;margin-top:-8px;margin-left:-8px}.la-ball-spin-fade-rotating.la-3x{width:96px;height:96px}.la-ball-spin-fade-rotating.la-3x>div{width:24px;height:24px;margin-top:-12px;margin-left:-12px}@-webkit-keyframes ball-spin-fade-rotate{100%{-webkit-transform:rotate(360deg);transform:rotate(360deg)}}@keyframes ball-spin-fade-rotate{100%{-webkit-transform:rotate(360deg);transform:rotate(360deg)}}.la-ball-spin-fade,.la-ball-spin-fade>div{position:relative;box-sizing:border-box}.la-ball-spin-fade{display:block;font-size:0;color:#fff;width:32px;height:32px}.la-ball-spin-fade.la-dark{color:#333}.la-ball-spin-fade>div{display:inline-block;float:none;background-color:currentColor;border:0 solid currentColor;position:absolute;top:50%;left:50%;width:8px;height:8px;margin-top:-4px;margin-left:-4px;border-radius:100%;-webkit-animation:1s linear infinite ball-spin-fade;animation:1s linear infinite ball-spin-fade}.la-ball-spin-fade>div:nth-child(1){top:5%;left:50%;-webkit-animation-delay:-1.125s;animation-delay:-1.125s}.la-ball-spin-fade>div:nth-child(2){top:18.1801948466%;left:81.8198051534%;-webkit-animation-delay:-1.25s;animation-delay:-1.25s}.la-ball-spin-fade>div:nth-child(3){top:50%;left:95%;-webkit-animation-delay:-1.375s;animation-delay:-1.375s}.la-ball-spin-fade>div:nth-child(4){top:81.8198051534%;left:81.8198051534%;-webkit-animation-delay:-1.5s;animation-delay:-1.5s}.la-ball-spin-fade>div:nth-child(5){top:94.9999999966%;left:50.0000000005%;-webkit-animation-delay:-1.625s;animation-delay:-1.625s}.la-ball-spin-fade>div:nth-child(6){top:81.8198046966%;left:18.1801949248%;-webkit-animation-delay:-1.75s;animation-delay:-1.75s}.la-ball-spin-fade>div:nth-child(7){top:49.9999750815%;left:5.0000051215%;-webkit-animation-delay:-1.875s;animation-delay:-1.875s}.la-ball-spin-fade>div:nth-child(8){top:18.179464974%;left:18.1803700518%;-webkit-animation-delay:-2s;animation-delay:-2s}.la-ball-spin-fade.la-sm{width:16px;height:16px}.la-ball-spin-fade.la-sm>div{width:4px;height:4px;margin-top:-2px;margin-left:-2px}.la-ball-spin-fade.la-2x{width:64px;height:64px}.la-ball-spin-fade.la-2x>div{width:16px;height:16px;margin-top:-8px;margin-left:-8px}.la-ball-spin-fade.la-3x{width:96px;height:96px}.la-ball-spin-fade.la-3x>div{width:24px;height:24px;margin-top:-12px;margin-left:-12px}@-webkit-keyframes ball-spin-fade{0%,100%{opacity:1;-webkit-transform:scale(1);transform:scale(1)}50%{opacity:.25;-webkit-transform:scale(.5);transform:scale(.5)}}@keyframes ball-spin-fade{0%,100%{opacity:1;-webkit-transform:scale(1);transform:scale(1)}50%{opacity:.25;-webkit-transform:scale(.5);transform:scale(.5)}}.la-ball-spin-rotate,.la-ball-spin-rotate>div{position:relative;box-sizing:border-box}.la-ball-spin-rotate{display:block;font-size:0;color:#fff;width:32px;height:32px;-webkit-animation:2s linear infinite ball-spin-rotate;animation:2s linear infinite ball-spin-rotate}.la-ball-spin-rotate.la-dark{color:#333}.la-ball-spin-rotate>div{display:inline-block;float:none;background-color:currentColor;border:0 solid currentColor;position:absolute;top:0;width:60%;height:60%;border-radius:100%;-webkit-animation:2s ease-in-out infinite ball-spin-bounce;animation:2s ease-in-out infinite ball-spin-bounce}.la-ball-spin-rotate>div:last-child{top:auto;bottom:0;-webkit-animation-delay:-1s;animation-delay:-1s}.la-ball-spin-rotate.la-sm{width:16px;height:16px}.la-ball-spin-rotate.la-2x{width:64px;height:64px}.la-ball-spin-rotate.la-3x{width:96px;height:96px}@-webkit-keyframes ball-spin-rotate{100%{-webkit-transform:rotate(360deg);transform:rotate(360deg)}}@keyframes ball-spin-rotate{100%{-webkit-transform:rotate(360deg);transform:rotate(360deg)}}@-webkit-keyframes ball-spin-bounce{0%,100%{-webkit-transform:scale(0);transform:scale(0)}50%{-webkit-transform:scale(1);transform:scale(1)}}@keyframes ball-spin-bounce{0%,100%{-webkit-transform:scale(0);transform:scale(0)}50%{-webkit-transform:scale(1);transform:scale(1)}}.la-ball-spin,.la-ball-spin>div{position:relative;box-sizing:border-box}.la-ball-spin{display:block;font-size:0;color:#fff;width:32px;height:32px}.la-ball-spin.la-dark{color:#333}.la-ball-spin>div{display:inline-block;float:none;background-color:currentColor;border:0 solid currentColor;position:absolute;top:50%;left:50%;width:8px;height:8px;margin-top:-4px;margin-left:-4px;border-radius:100%;-webkit-animation:1s ease-in-out infinite ball-spin;animation:1s ease-in-out infinite ball-spin}.la-ball-spin>div:nth-child(1){top:5%;left:50%;-webkit-animation-delay:-1.125s;animation-delay:-1.125s}.la-ball-spin>div:nth-child(2){top:18.1801948466%;left:81.8198051534%;-webkit-animation-delay:-1.25s;animation-delay:-1.25s}.la-ball-spin>div:nth-child(3){top:50%;left:95%;-webkit-animation-delay:-1.375s;animation-delay:-1.375s}.la-ball-spin>div:nth-child(4){top:81.8198051534%;left:81.8198051534%;-webkit-animation-delay:-1.5s;animation-delay:-1.5s}.la-ball-spin>div:nth-child(5){top:94.9999999966%;left:50.0000000005%;-webkit-animation-delay:-1.625s;animation-delay:-1.625s}.la-ball-spin>div:nth-child(6){top:81.8198046966%;left:18.1801949248%;-webkit-animation-delay:-1.75s;animation-delay:-1.75s}.la-ball-spin>div:nth-child(7){top:49.9999750815%;left:5.0000051215%;-webkit-animation-delay:-1.875s;animation-delay:-1.875s}.la-ball-spin>div:nth-child(8){top:18.179464974%;left:18.1803700518%;-webkit-animation-delay:-2s;animation-delay:-2s}.la-ball-spin.la-sm{width:16px;height:16px}.la-ball-spin.la-sm>div{width:4px;height:4px;margin-top:-2px;margin-left:-2px}.la-ball-spin.la-2x{width:64px;height:64px}.la-ball-spin.la-2x>div{width:16px;height:16px;margin-top:-8px;margin-left:-8px}.la-ball-spin.la-3x{width:96px;height:96px}.la-ball-spin.la-3x>div{width:24px;height:24px;margin-top:-12px;margin-left:-12px}@-webkit-keyframes ball-spin{0%,100%{opacity:1;-webkit-transform:scale(1);transform:scale(1)}20%{opacity:1}80%{opacity:0;-webkit-transform:scale(0);transform:scale(0)}}@keyframes ball-spin{0%,100%{opacity:1;-webkit-transform:scale(1);transform:scale(1)}20%{opacity:1}80%{opacity:0;-webkit-transform:scale(0);transform:scale(0)}}.la-ball-square-clockwise-spin,.la-ball-square-clockwise-spin>div{position:relative;box-sizing:border-box}.la-ball-square-clockwise-spin{display:block;font-size:0;color:#fff;width:26px;height:26px}.la-ball-square-clockwise-spin.la-dark{color:#333}.la-ball-square-clockwise-spin>div{display:inline-block;float:none;background-color:currentColor;border:0 solid currentColor;position:absolute;top:50%;left:50%;width:12px;height:12px;margin-top:-6px;margin-left:-6px;border-radius:100%;-webkit-animation:1s ease-in-out infinite ball-square-clockwise-spin;animation:1s ease-in-out infinite ball-square-clockwise-spin}.la-ball-square-clockwise-spin>div:nth-child(1){top:0;left:0;-webkit-animation-delay:-.875s;animation-delay:-.875s}.la-ball-square-clockwise-spin>div:nth-child(2){top:0;left:50%;-webkit-animation-delay:-.75s;animation-delay:-.75s}.la-ball-square-clockwise-spin>div:nth-child(3){top:0;left:100%;-webkit-animation-delay:-.625s;animation-delay:-.625s}.la-ball-square-clockwise-spin>div:nth-child(4){top:50%;left:100%;-webkit-animation-delay:-.5s;animation-delay:-.5s}.la-ball-square-clockwise-spin>div:nth-child(5){top:100%;left:100%;-webkit-animation-delay:-.375s;animation-delay:-.375s}.la-ball-square-clockwise-spin>div:nth-child(6){top:100%;left:50%;-webkit-animation-delay:-.25s;animation-delay:-.25s}.la-ball-square-clockwise-spin>div:nth-child(7){top:100%;left:0;-webkit-animation-delay:-.125s;animation-delay:-.125s}.la-ball-square-clockwise-spin>div:nth-child(8){top:50%;left:0;-webkit-animation-delay:0s;animation-delay:0s}.la-ball-square-clockwise-spin.la-sm{width:12px;height:12px}.la-ball-square-clockwise-spin.la-sm>div{width:6px;height:6px;margin-top:-3px;margin-left:-3px}.la-ball-square-clockwise-spin.la-2x{width:52px;height:52px}.la-ball-square-clockwise-spin.la-2x>div{width:24px;height:24px;margin-top:-12px;margin-left:-12px}.la-ball-square-clockwise-spin.la-3x{width:78px;height:78px}.la-ball-square-clockwise-spin.la-3x>div{width:36px;height:36px;margin-top:-18px;margin-left:-18px}@-webkit-keyframes ball-square-clockwise-spin{0%,100%,40%{-webkit-transform:scale(.4);transform:scale(.4)}70%{-webkit-transform:scale(1);transform:scale(1)}}@keyframes ball-square-clockwise-spin{0%,100%,40%{-webkit-transform:scale(.4);transform:scale(.4)}70%{-webkit-transform:scale(1);transform:scale(1)}}.la-ball-square-spin,.la-ball-square-spin>div{position:relative;box-sizing:border-box}.la-ball-square-spin{display:block;font-size:0;color:#fff;width:26px;height:26px}.la-ball-square-spin.la-dark{color:#333}.la-ball-square-spin>div{display:inline-block;float:none;background-color:currentColor;border:0 solid currentColor;position:absolute;top:50%;left:50%;width:12px;height:12px;margin-top:-6px;margin-left:-6px;border-radius:100%;-webkit-animation:1s ease-in-out infinite ball-square-spin;animation:1s ease-in-out infinite ball-square-spin}.la-ball-square-spin>div:nth-child(1){top:0;left:0;-webkit-animation-delay:-1.125s;animation-delay:-1.125s}.la-ball-square-spin>div:nth-child(2){top:0;left:50%;-webkit-animation-delay:-1.25s;animation-delay:-1.25s}.la-ball-square-spin>div:nth-child(3){top:0;left:100%;-webkit-animation-delay:-1.375s;animation-delay:-1.375s}.la-ball-square-spin>div:nth-child(4){top:50%;left:100%;-webkit-animation-delay:-1.5s;animation-delay:-1.5s}.la-ball-square-spin>div:nth-child(5){top:100%;left:100%;-webkit-animation-delay:-1.625s;animation-delay:-1.625s}.la-ball-square-spin>div:nth-child(6){top:100%;left:50%;-webkit-animation-delay:-1.75s;animation-delay:-1.75s}.la-ball-square-spin>div:nth-child(7){top:100%;left:0;-webkit-animation-delay:-1.875s;animation-delay:-1.875s}.la-ball-square-spin>div:nth-child(8){top:50%;left:0;-webkit-animation-delay:-2s;animation-delay:-2s}.la-ball-square-spin.la-sm{width:12px;height:12px}.la-ball-square-spin.la-sm>div{width:6px;height:6px;margin-top:-3px;margin-left:-3px}.la-ball-square-spin.la-2x{width:52px;height:52px}.la-ball-square-spin.la-2x>div{width:24px;height:24px;margin-top:-12px;margin-left:-12px}.la-ball-square-spin.la-3x{width:78px;height:78px}.la-ball-square-spin.la-3x>div{width:36px;height:36px;margin-top:-18px;margin-left:-18px}@-webkit-keyframes ball-square-spin{0%,100%,40%{-webkit-transform:scale(.4);transform:scale(.4)}70%{-webkit-transform:scale(1);transform:scale(1)}}@keyframes ball-square-spin{0%,100%,40%{-webkit-transform:scale(.4);transform:scale(.4)}70%{-webkit-transform:scale(1);transform:scale(1)}}.la-ball-triangle-path,.la-ball-triangle-path>div{position:relative;box-sizing:border-box}.la-ball-triangle-path{display:block;font-size:0;color:#fff;width:32px;height:32px}.la-ball-triangle-path.la-dark{color:#333}.la-ball-triangle-path>div{display:inline-block;float:none;background-color:currentColor;border:0 solid currentColor;position:absolute;top:0;left:0;width:10px;height:10px;border-radius:100%}.la-ball-triangle-path>div:nth-child(1){-webkit-animation:2s ease-in-out infinite ball-triangle-path-ball-one;animation:2s ease-in-out infinite ball-triangle-path-ball-one}.la-ball-triangle-path>div:nth-child(2){-webkit-animation:2s ease-in-out infinite ball-triangle-path-ball-two;animation:2s ease-in-out infinite ball-triangle-path-ball-two}.la-ball-triangle-path>div:nth-child(3){-webkit-animation:2s ease-in-out infinite ball-triangle-path-ball-tree;animation:2s ease-in-out infinite ball-triangle-path-ball-tree}.la-ball-triangle-path.la-sm{width:16px;height:16px}.la-ball-triangle-path.la-sm>div{width:4px;height:4px}.la-ball-triangle-path.la-2x{width:64px;height:64px}.la-ball-triangle-path.la-2x>div{width:20px;height:20px}.la-ball-triangle-path.la-3x{width:96px;height:96px}.la-ball-triangle-path.la-3x>div{width:30px;height:30px}@-webkit-keyframes ball-triangle-path-ball-one{0%{-webkit-transform:translate(0,220%);transform:translate(0,220%)}17%,50%,83%{opacity:.25}33%{opacity:1;-webkit-transform:translate(110%,0);transform:translate(110%,0)}66%{opacity:1;-webkit-transform:translate(220%,220%);transform:translate(220%,220%)}100%{opacity:1;-webkit-transform:translate(0,220%);transform:translate(0,220%)}}@keyframes ball-triangle-path-ball-one{0%{-webkit-transform:translate(0,220%);transform:translate(0,220%)}17%,50%,83%{opacity:.25}33%{opacity:1;-webkit-transform:translate(110%,0);transform:translate(110%,0)}66%{opacity:1;-webkit-transform:translate(220%,220%);transform:translate(220%,220%)}100%{opacity:1;-webkit-transform:translate(0,220%);transform:translate(0,220%)}}@-webkit-keyframes ball-triangle-path-ball-two{0%{-webkit-transform:translate(110%,0);transform:translate(110%,0)}17%,50%,83%{opacity:.25}33%{opacity:1;-webkit-transform:translate(220%,220%);transform:translate(220%,220%)}66%{opacity:1;-webkit-transform:translate(0,220%);transform:translate(0,220%)}100%{opacity:1;-webkit-transform:translate(110%,0);transform:translate(110%,0)}}@keyframes ball-triangle-path-ball-two{0%{-webkit-transform:translate(110%,0);transform:translate(110%,0)}17%,50%,83%{opacity:.25}33%{opacity:1;-webkit-transform:translate(220%,220%);transform:translate(220%,220%)}66%{opacity:1;-webkit-transform:translate(0,220%);transform:translate(0,220%)}100%{opacity:1;-webkit-transform:translate(110%,0);transform:translate(110%,0)}}@-webkit-keyframes ball-triangle-path-ball-tree{0%{-webkit-transform:translate(220%,220%);transform:translate(220%,220%)}17%,50%,83%{opacity:.25}33%{opacity:1;-webkit-transform:translate(0,220%);transform:translate(0,220%)}66%{opacity:1;-webkit-transform:translate(110%,0);transform:translate(110%,0)}100%{opacity:1;-webkit-transform:translate(220%,220%);transform:translate(220%,220%)}}@keyframes ball-triangle-path-ball-tree{0%{-webkit-transform:translate(220%,220%);transform:translate(220%,220%)}17%,50%,83%{opacity:.25}33%{opacity:1;-webkit-transform:translate(0,220%);transform:translate(0,220%)}66%{opacity:1;-webkit-transform:translate(110%,0);transform:translate(110%,0)}100%{opacity:1;-webkit-transform:translate(220%,220%);transform:translate(220%,220%)}}.la-ball-zig-zag-deflect,.la-ball-zig-zag-deflect>div{box-sizing:border-box}.la-ball-zig-zag-deflect{display:block;font-size:0;color:#fff;position:relative;width:32px;height:32px}.la-ball-zig-zag-deflect.la-dark{color:#333}.la-ball-zig-zag-deflect>div{display:inline-block;float:none;background-color:currentColor;border:0 solid currentColor;position:absolute;top:50%;left:50%;width:10px;height:10px;margin-top:-5px;margin-left:-5px;border-radius:100%}.la-ball-zig-zag-deflect>div:first-child{-webkit-animation:1.5s linear infinite ball-zig-deflect;animation:1.5s linear infinite ball-zig-deflect}.la-ball-zig-zag-deflect>div:last-child{-webkit-animation:1.5s linear infinite ball-zag-deflect;animation:1.5s linear infinite ball-zag-deflect}.la-ball-zig-zag-deflect.la-sm{width:16px;height:16px}.la-ball-zig-zag-deflect.la-sm>div{width:4px;height:4px;margin-top:-2px;margin-left:-2px}.la-ball-zig-zag-deflect.la-2x{width:64px;height:64px}.la-ball-zig-zag-deflect.la-2x>div{width:20px;height:20px;margin-top:-10px;margin-left:-10px}.la-ball-zig-zag-deflect.la-3x{width:96px;height:96px}.la-ball-zig-zag-deflect.la-3x>div{width:30px;height:30px;margin-top:-15px;margin-left:-15px}@-webkit-keyframes ball-zig-deflect{17%,84%{-webkit-transform:translate(-80%,-160%);transform:translate(-80%,-160%)}34%,67%{-webkit-transform:translate(80%,-160%);transform:translate(80%,-160%)}100%,50%{-webkit-transform:translate(0,0);transform:translate(0,0)}}@keyframes ball-zig-deflect{17%,84%{-webkit-transform:translate(-80%,-160%);transform:translate(-80%,-160%)}34%,67%{-webkit-transform:translate(80%,-160%);transform:translate(80%,-160%)}100%,50%{-webkit-transform:translate(0,0);transform:translate(0,0)}}@-webkit-keyframes ball-zag-deflect{17%,84%{-webkit-transform:translate(80%,160%);transform:translate(80%,160%)}34%,67%{-webkit-transform:translate(-80%,160%);transform:translate(-80%,160%)}100%,50%{-webkit-transform:translate(0,0);transform:translate(0,0)}}@keyframes ball-zag-deflect{17%,84%{-webkit-transform:translate(80%,160%);transform:translate(80%,160%)}34%,67%{-webkit-transform:translate(-80%,160%);transform:translate(-80%,160%)}100%,50%{-webkit-transform:translate(0,0);transform:translate(0,0)}}.la-ball-zig-zag,.la-ball-zig-zag>div{box-sizing:border-box}.la-ball-zig-zag{display:block;font-size:0;color:#fff;position:relative;width:32px;height:32px}.la-ball-zig-zag.la-dark{color:#333}.la-ball-zig-zag>div{display:inline-block;float:none;background-color:currentColor;border:0 solid currentColor;position:absolute;top:50%;left:50%;width:10px;height:10px;margin-top:-5px;margin-left:-5px;border-radius:100%}.la-ball-zig-zag>div:first-child{-webkit-animation:.7s linear infinite ball-zig-effect;animation:.7s linear infinite ball-zig-effect}.la-ball-zig-zag>div:last-child{-webkit-animation:.7s linear infinite ball-zag-effect;animation:.7s linear infinite ball-zag-effect}.la-ball-zig-zag.la-sm{width:16px;height:16px}.la-ball-zig-zag.la-sm>div{width:4px;height:4px;margin-top:-2px;margin-left:-2px}.la-ball-zig-zag.la-2x{width:64px;height:64px}.la-ball-zig-zag.la-2x>div{width:20px;height:20px;margin-top:-10px;margin-left:-10px}.la-ball-zig-zag.la-3x{width:96px;height:96px}.la-ball-zig-zag.la-3x>div{width:30px;height:30px;margin-top:-15px;margin-left:-15px}@-webkit-keyframes ball-zig-effect{0%,100%{-webkit-transform:translate(0,0);transform:translate(0,0)}33%{-webkit-transform:translate(-75%,-150%);transform:translate(-75%,-150%)}66%{-webkit-transform:translate(75%,-150%);transform:translate(75%,-150%)}}@keyframes ball-zig-effect{0%,100%{-webkit-transform:translate(0,0);transform:translate(0,0)}33%{-webkit-transform:translate(-75%,-150%);transform:translate(-75%,-150%)}66%{-webkit-transform:translate(75%,-150%);transform:translate(75%,-150%)}}@-webkit-keyframes ball-zag-effect{0%,100%{-webkit-transform:translate(0,0);transform:translate(0,0)}33%{-webkit-transform:translate(75%,150%);transform:translate(75%,150%)}66%{-webkit-transform:translate(-75%,150%);transform:translate(-75%,150%)}}@keyframes ball-zag-effect{0%,100%{-webkit-transform:translate(0,0);transform:translate(0,0)}33%{-webkit-transform:translate(75%,150%);transform:translate(75%,150%)}66%{-webkit-transform:translate(-75%,150%);transform:translate(-75%,150%)}}.la-cog,.la-cog>div{position:relative;box-sizing:border-box}.la-cog{display:block;font-size:0;color:#fff;width:31px;height:31px}.la-cog.la-dark{color:#333}.la-cog>div{display:inline-block;float:none;border:2px dashed currentColor;width:100%;height:100%;background-color:transparent;border-radius:100%;-webkit-animation:4s linear infinite cog-rotate;animation:4s linear infinite cog-rotate}.la-cog>div:after{position:absolute;top:0;left:0;width:100%;height:100%;content:\"\";border:2px solid currentColor;border-radius:100%}.la-cog.la-sm{width:15px;height:15px}.la-cog.la-sm>div,.la-cog.la-sm>div:after{border-width:1px}.la-cog.la-2x{width:61px;height:61px}.la-cog.la-2x>div,.la-cog.la-2x>div:after{border-width:4px}.la-cog.la-3x{width:91px;height:91px}.la-cog.la-3x>div,.la-cog.la-3x>div:after{border-width:6px}@-webkit-keyframes cog-rotate{0%{-webkit-transform:rotate(0);transform:rotate(0)}100%{-webkit-transform:rotate(360deg);transform:rotate(360deg)}}@keyframes cog-rotate{0%{-webkit-transform:rotate(0);transform:rotate(0)}100%{-webkit-transform:rotate(360deg);transform:rotate(360deg)}}.la-cube-transition,.la-cube-transition>div{position:relative;box-sizing:border-box}.la-cube-transition{display:block;font-size:0;color:#fff;width:32px;height:32px}.la-cube-transition.la-dark{color:#333}.la-cube-transition>div{display:inline-block;float:none;background-color:currentColor;border:0 solid currentColor;position:absolute;top:0;left:0;width:14px;height:14px;margin-top:-7px;margin-left:-7px;border-radius:0;-webkit-animation:1.6s ease-in-out infinite cube-transition;animation:1.6s ease-in-out infinite cube-transition}.la-cube-transition>div:last-child{-webkit-animation-delay:-.8s;animation-delay:-.8s}.la-cube-transition.la-sm{width:16px;height:16px}.la-cube-transition.la-sm>div{width:6px;height:6px;margin-top:-3px;margin-left:-3px}.la-cube-transition.la-2x{width:64px;height:64px}.la-cube-transition.la-2x>div{width:28px;height:28px;margin-top:-14px;margin-left:-14px}.la-cube-transition.la-3x{width:96px;height:96px}.la-cube-transition.la-3x>div{width:42px;height:42px;margin-top:-21px;margin-left:-21px}@-webkit-keyframes cube-transition{25%{top:0;left:100%;-webkit-transform:scale(.5) rotate(-90deg);transform:scale(.5) rotate(-90deg)}50%{top:100%;left:100%;-webkit-transform:scale(1) rotate(-180deg);transform:scale(1) rotate(-180deg)}75%{top:100%;left:0;-webkit-transform:scale(.5) rotate(-270deg);transform:scale(.5) rotate(-270deg)}100%{top:0;left:0;-webkit-transform:scale(1) rotate(-360deg);transform:scale(1) rotate(-360deg)}}@keyframes cube-transition{25%{top:0;left:100%;-webkit-transform:scale(.5) rotate(-90deg);transform:scale(.5) rotate(-90deg)}50%{top:100%;left:100%;-webkit-transform:scale(1) rotate(-180deg);transform:scale(1) rotate(-180deg)}75%{top:100%;left:0;-webkit-transform:scale(.5) rotate(-270deg);transform:scale(.5) rotate(-270deg)}100%{top:0;left:0;-webkit-transform:scale(1) rotate(-360deg);transform:scale(1) rotate(-360deg)}}.la-fire,.la-fire>div{position:relative;box-sizing:border-box}.la-fire{display:block;font-size:0;color:#fff;width:32px;height:32px}.la-fire.la-dark{color:#333}.la-fire>div{display:inline-block;float:none;background-color:currentColor;border:0 solid currentColor;position:absolute;bottom:0;left:50%;width:12px;height:12px;border-radius:2px;-webkit-transform:translateY(0) translateX(-50%) rotate(45deg) scale(0);transform:translateY(0) translateX(-50%) rotate(45deg) scale(0);-webkit-animation:1.5s linear infinite fire-diamonds;animation:1.5s linear infinite fire-diamonds}.la-fire>div:nth-child(1){-webkit-animation-delay:-.85s;animation-delay:-.85s}.la-fire>div:nth-child(2){-webkit-animation-delay:-1.85s;animation-delay:-1.85s}.la-fire>div:nth-child(3){-webkit-animation-delay:-2.85s;animation-delay:-2.85s}.la-fire.la-sm{width:16px;height:16px}.la-fire.la-sm>div{width:6px;height:6px}.la-fire.la-2x{width:64px;height:64px}.la-fire.la-2x>div{width:24px;height:24px}.la-fire.la-3x{width:96px;height:96px}.la-fire.la-3x>div{width:36px;height:36px}@-webkit-keyframes fire-diamonds{0%{-webkit-transform:translateY(75%) translateX(-50%) rotate(45deg) scale(0);transform:translateY(75%) translateX(-50%) rotate(45deg) scale(0)}50%{-webkit-transform:translateY(-87.5%) translateX(-50%) rotate(45deg) scale(1);transform:translateY(-87.5%) translateX(-50%) rotate(45deg) scale(1)}100%{-webkit-transform:translateY(-212.5%) translateX(-50%) rotate(45deg) scale(0);transform:translateY(-212.5%) translateX(-50%) rotate(45deg) scale(0)}}@keyframes fire-diamonds{0%{-webkit-transform:translateY(75%) translateX(-50%) rotate(45deg) scale(0);transform:translateY(75%) translateX(-50%) rotate(45deg) scale(0)}50%{-webkit-transform:translateY(-87.5%) translateX(-50%) rotate(45deg) scale(1);transform:translateY(-87.5%) translateX(-50%) rotate(45deg) scale(1)}100%{-webkit-transform:translateY(-212.5%) translateX(-50%) rotate(45deg) scale(0);transform:translateY(-212.5%) translateX(-50%) rotate(45deg) scale(0)}}.la-line-scale-party,.la-line-scale-party>div{position:relative;box-sizing:border-box}.la-line-scale-party{display:block;font-size:0;color:#fff;width:40px;height:32px}.la-line-scale-party.la-dark{color:#333}.la-line-scale-party>div{display:inline-block;float:none;background-color:currentColor;border:0 solid currentColor;width:4px;height:32px;margin:0 2px;border-radius:0;-webkit-animation-name:line-scale-party;animation-name:line-scale-party;-webkit-animation-iteration-count:infinite;animation-iteration-count:infinite}.la-line-scale-party>div:nth-child(1){-webkit-animation-duration:.43s;animation-duration:.43s;-webkit-animation-delay:-.23s;animation-delay:-.23s}.la-line-scale-party>div:nth-child(2){-webkit-animation-duration:.62s;animation-duration:.62s;-webkit-animation-delay:-.32s;animation-delay:-.32s}.la-line-scale-party>div:nth-child(3){-webkit-animation-duration:.43s;animation-duration:.43s;-webkit-animation-delay:-.44s;animation-delay:-.44s}.la-line-scale-party>div:nth-child(4){-webkit-animation-duration:.8s;animation-duration:.8s;-webkit-animation-delay:-.31s;animation-delay:-.31s}.la-line-scale-party>div:nth-child(5){-webkit-animation-duration:.74s;animation-duration:.74s;-webkit-animation-delay:-.24s;animation-delay:-.24s}.la-line-scale-party.la-sm{width:20px;height:16px}.la-line-scale-party.la-sm>div{width:2px;height:16px;margin:0 1px}.la-line-scale-party.la-2x{width:80px;height:64px}.la-line-scale-party.la-2x>div{width:8px;height:64px;margin:0 4px}.la-line-scale-party.la-3x{width:120px;height:96px}.la-line-scale-party.la-3x>div{width:12px;height:96px;margin:0 6px}@-webkit-keyframes line-scale-party{0%,100%{-webkit-transform:scaleY(1);transform:scaleY(1)}50%{-webkit-transform:scaleY(.3);transform:scaleY(.3)}}@keyframes line-scale-party{0%,100%{-webkit-transform:scaleY(1);transform:scaleY(1)}50%{-webkit-transform:scaleY(.3);transform:scaleY(.3)}}.la-line-scale-pulse-out-rapid,.la-line-scale-pulse-out-rapid>div{position:relative;box-sizing:border-box}.la-line-scale-pulse-out-rapid{display:block;font-size:0;color:#fff;width:40px;height:32px}.la-line-scale-pulse-out-rapid.la-dark{color:#333}.la-line-scale-pulse-out-rapid>div{display:inline-block;float:none;background-color:currentColor;border:0 solid currentColor;width:4px;height:32px;margin:0 2px;border-radius:0;-webkit-animation:.9s cubic-bezier(.11,.49,.38,.78) infinite line-scale-pulse-out-rapid;animation:.9s cubic-bezier(.11,.49,.38,.78) infinite line-scale-pulse-out-rapid}.la-line-scale-pulse-out-rapid>div:nth-child(3){-webkit-animation-delay:-.9s;animation-delay:-.9s}.la-line-scale-pulse-out-rapid>div:nth-child(2),.la-line-scale-pulse-out-rapid>div:nth-child(4){-webkit-animation-delay:-.65s;animation-delay:-.65s}.la-line-scale-pulse-out-rapid>div:nth-child(1),.la-line-scale-pulse-out-rapid>div:nth-child(5){-webkit-animation-delay:-.4s;animation-delay:-.4s}.la-line-scale-pulse-out-rapid.la-sm{width:20px;height:16px}.la-line-scale-pulse-out-rapid.la-sm>div{width:2px;height:16px;margin:0 1px}.la-line-scale-pulse-out-rapid.la-2x{width:80px;height:64px}.la-line-scale-pulse-out-rapid.la-2x>div{width:8px;height:64px;margin:0 4px}.la-line-scale-pulse-out-rapid.la-3x{width:120px;height:96px}.la-line-scale-pulse-out-rapid.la-3x>div{width:12px;height:96px;margin:0 6px}@-webkit-keyframes line-scale-pulse-out-rapid{0%,90%{-webkit-transform:scaley(1);transform:scaley(1)}80%{-webkit-transform:scaley(.3);transform:scaley(.3)}}@keyframes line-scale-pulse-out-rapid{0%,90%{-webkit-transform:scaley(1);transform:scaley(1)}80%{-webkit-transform:scaley(.3);transform:scaley(.3)}}.la-line-scale-pulse-out,.la-line-scale-pulse-out>div{position:relative;box-sizing:border-box}.la-line-scale-pulse-out{display:block;font-size:0;color:#fff;width:40px;height:32px}.la-line-scale-pulse-out.la-dark{color:#333}.la-line-scale-pulse-out>div{display:inline-block;float:none;background-color:currentColor;border:0 solid currentColor;width:4px;height:32px;margin:0 2px;border-radius:0;-webkit-animation:.9s cubic-bezier(.85,.25,.37,.85) infinite line-scale-pulse-out;animation:.9s cubic-bezier(.85,.25,.37,.85) infinite line-scale-pulse-out}.la-line-scale-pulse-out>div:nth-child(3){-webkit-animation-delay:-.9s;animation-delay:-.9s}.la-line-scale-pulse-out>div:nth-child(2),.la-line-scale-pulse-out>div:nth-child(4){-webkit-animation-delay:-.7s;animation-delay:-.7s}.la-line-scale-pulse-out>div:nth-child(1),.la-line-scale-pulse-out>div:nth-child(5){-webkit-animation-delay:-.5s;animation-delay:-.5s}.la-line-scale-pulse-out.la-sm{width:20px;height:16px}.la-line-scale-pulse-out.la-sm>div{width:2px;height:16px;margin:0 1px}.la-line-scale-pulse-out.la-2x{width:80px;height:64px}.la-line-scale-pulse-out.la-2x>div{width:8px;height:64px;margin:0 4px}.la-line-scale-pulse-out.la-3x{width:120px;height:96px}.la-line-scale-pulse-out.la-3x>div{width:12px;height:96px;margin:0 6px}@-webkit-keyframes line-scale-pulse-out{0%,100%{-webkit-transform:scaley(1);transform:scaley(1)}50%{-webkit-transform:scaley(.3);transform:scaley(.3)}}@keyframes line-scale-pulse-out{0%,100%{-webkit-transform:scaley(1);transform:scaley(1)}50%{-webkit-transform:scaley(.3);transform:scaley(.3)}}.la-line-scale,.la-line-scale>div{position:relative;box-sizing:border-box}.la-line-scale{display:block;font-size:0;color:#fff;width:40px;height:32px}.la-line-scale.la-dark{color:#333}.la-line-scale>div{display:inline-block;float:none;background-color:currentColor;border:0 solid currentColor;width:4px;height:32px;margin:0 2px;border-radius:0;-webkit-animation:1.2s infinite line-scale;animation:1.2s infinite line-scale}.la-line-scale>div:nth-child(1){-webkit-animation-delay:-1.2s;animation-delay:-1.2s}.la-line-scale>div:nth-child(2){-webkit-animation-delay:-1.1s;animation-delay:-1.1s}.la-line-scale>div:nth-child(3){-webkit-animation-delay:-1s;animation-delay:-1s}.la-line-scale>div:nth-child(4){-webkit-animation-delay:-.9s;animation-delay:-.9s}.la-line-scale>div:nth-child(5){-webkit-animation-delay:-.8s;animation-delay:-.8s}.la-line-scale.la-sm{width:20px;height:16px}.la-line-scale.la-sm>div{width:2px;height:16px;margin:0 1px}.la-line-scale.la-2x{width:80px;height:64px}.la-line-scale.la-2x>div{width:8px;height:64px;margin:0 4px}.la-line-scale.la-3x{width:120px;height:96px}.la-line-scale.la-3x>div{width:12px;height:96px;margin:0 6px}@-webkit-keyframes line-scale{0%,100%,40%{-webkit-transform:scaleY(.4);transform:scaleY(.4)}20%{-webkit-transform:scaleY(1);transform:scaleY(1)}}@keyframes line-scale{0%,100%,40%{-webkit-transform:scaleY(.4);transform:scaleY(.4)}20%{-webkit-transform:scaleY(1);transform:scaleY(1)}}.la-line-spin-clockwise-fade-rotating,.la-line-spin-clockwise-fade-rotating>div{position:relative;box-sizing:border-box}.la-line-spin-clockwise-fade-rotating{display:block;font-size:0;color:#fff;width:32px;height:32px;-webkit-animation:6s linear infinite line-spin-clockwise-fade-rotating-rotate;animation:6s linear infinite line-spin-clockwise-fade-rotating-rotate}.la-line-spin-clockwise-fade-rotating.la-dark{color:#333}.la-line-spin-clockwise-fade-rotating>div{display:inline-block;float:none;background-color:currentColor;border:0 solid currentColor;position:absolute;width:2px;height:10px;margin:-5px 2px 2px -1px;border-radius:0;-webkit-animation:1s ease-in-out infinite line-spin-clockwise-fade-rotating;animation:1s ease-in-out infinite line-spin-clockwise-fade-rotating}.la-line-spin-clockwise-fade-rotating>div:nth-child(1){top:15%;left:50%;-webkit-transform:rotate(0);transform:rotate(0);-webkit-animation-delay:-.875s;animation-delay:-.875s}.la-line-spin-clockwise-fade-rotating>div:nth-child(2){top:25.2512626585%;left:74.7487373415%;-webkit-transform:rotate(45deg);transform:rotate(45deg);-webkit-animation-delay:-.75s;animation-delay:-.75s}.la-line-spin-clockwise-fade-rotating>div:nth-child(3){top:50%;left:85%;-webkit-transform:rotate(90deg);transform:rotate(90deg);-webkit-animation-delay:-.625s;animation-delay:-.625s}.la-line-spin-clockwise-fade-rotating>div:nth-child(4){top:74.7487373415%;left:74.7487373415%;-webkit-transform:rotate(135deg);transform:rotate(135deg);-webkit-animation-delay:-.5s;animation-delay:-.5s}.la-line-spin-clockwise-fade-rotating>div:nth-child(5){top:84.9999999974%;left:50.0000000004%;-webkit-transform:rotate(180deg);transform:rotate(180deg);-webkit-animation-delay:-.375s;animation-delay:-.375s}.la-line-spin-clockwise-fade-rotating>div:nth-child(6){top:74.7487369862%;left:25.2512627193%;-webkit-transform:rotate(225deg);transform:rotate(225deg);-webkit-animation-delay:-.25s;animation-delay:-.25s}.la-line-spin-clockwise-fade-rotating>div:nth-child(7){top:49.9999806189%;left:15.0000039834%;-webkit-transform:rotate(270deg);transform:rotate(270deg);-webkit-animation-delay:-.125s;animation-delay:-.125s}.la-line-spin-clockwise-fade-rotating>div:nth-child(8){top:25.2506949798%;left:25.2513989292%;-webkit-transform:rotate(315deg);transform:rotate(315deg);-webkit-animation-delay:0s;animation-delay:0s}.la-line-spin-clockwise-fade-rotating.la-sm{width:16px;height:16px}.la-line-spin-clockwise-fade-rotating.la-sm>div{width:1px;height:4px;margin-top:-2px;margin-left:0}.la-line-spin-clockwise-fade-rotating.la-2x{width:64px;height:64px}.la-line-spin-clockwise-fade-rotating.la-2x>div{width:4px;height:20px;margin-top:-10px;margin-left:-2px}.la-line-spin-clockwise-fade-rotating.la-3x{width:96px;height:96px}.la-line-spin-clockwise-fade-rotating.la-3x>div{width:6px;height:30px;margin-top:-15px;margin-left:-3px}@-webkit-keyframes line-spin-clockwise-fade-rotating-rotate{100%{-webkit-transform:rotate(-360deg);transform:rotate(-360deg)}}@keyframes line-spin-clockwise-fade-rotating-rotate{100%{-webkit-transform:rotate(-360deg);transform:rotate(-360deg)}}@-webkit-keyframes line-spin-clockwise-fade-rotating{50%{opacity:.2}100%{opacity:1}}@keyframes line-spin-clockwise-fade-rotating{50%{opacity:.2}100%{opacity:1}}.la-line-spin-clockwise-fade,.la-line-spin-clockwise-fade>div{position:relative;box-sizing:border-box}.la-line-spin-clockwise-fade{display:block;font-size:0;color:#fff;width:32px;height:32px}.la-line-spin-clockwise-fade.la-dark{color:#333}.la-line-spin-clockwise-fade>div{display:inline-block;float:none;background-color:currentColor;border:0 solid currentColor;position:absolute;width:2px;height:10px;margin:-5px 2px 2px -1px;border-radius:0;-webkit-animation:1s ease-in-out infinite line-spin-clockwise-fade;animation:1s ease-in-out infinite line-spin-clockwise-fade}.la-line-spin-clockwise-fade>div:nth-child(1){top:15%;left:50%;-webkit-transform:rotate(0);transform:rotate(0);-webkit-animation-delay:-.875s;animation-delay:-.875s}.la-line-spin-clockwise-fade>div:nth-child(2){top:25.2512626585%;left:74.7487373415%;-webkit-transform:rotate(45deg);transform:rotate(45deg);-webkit-animation-delay:-.75s;animation-delay:-.75s}.la-line-spin-clockwise-fade>div:nth-child(3){top:50%;left:85%;-webkit-transform:rotate(90deg);transform:rotate(90deg);-webkit-animation-delay:-.625s;animation-delay:-.625s}.la-line-spin-clockwise-fade>div:nth-child(4){top:74.7487373415%;left:74.7487373415%;-webkit-transform:rotate(135deg);transform:rotate(135deg);-webkit-animation-delay:-.5s;animation-delay:-.5s}.la-line-spin-clockwise-fade>div:nth-child(5){top:84.9999999974%;left:50.0000000004%;-webkit-transform:rotate(180deg);transform:rotate(180deg);-webkit-animation-delay:-.375s;animation-delay:-.375s}.la-line-spin-clockwise-fade>div:nth-child(6){top:74.7487369862%;left:25.2512627193%;-webkit-transform:rotate(225deg);transform:rotate(225deg);-webkit-animation-delay:-.25s;animation-delay:-.25s}.la-line-spin-clockwise-fade>div:nth-child(7){top:49.9999806189%;left:15.0000039834%;-webkit-transform:rotate(270deg);transform:rotate(270deg);-webkit-animation-delay:-.125s;animation-delay:-.125s}.la-line-spin-clockwise-fade>div:nth-child(8){top:25.2506949798%;left:25.2513989292%;-webkit-transform:rotate(315deg);transform:rotate(315deg);-webkit-animation-delay:0s;animation-delay:0s}.la-line-spin-clockwise-fade.la-sm{width:16px;height:16px}.la-line-spin-clockwise-fade.la-sm>div{width:1px;height:4px;margin-top:-2px;margin-left:0}.la-line-spin-clockwise-fade.la-2x{width:64px;height:64px}.la-line-spin-clockwise-fade.la-2x>div{width:4px;height:20px;margin-top:-10px;margin-left:-2px}.la-line-spin-clockwise-fade.la-3x{width:96px;height:96px}.la-line-spin-clockwise-fade.la-3x>div{width:6px;height:30px;margin-top:-15px;margin-left:-3px}@-webkit-keyframes line-spin-clockwise-fade{50%{opacity:.2}100%{opacity:1}}@keyframes line-spin-clockwise-fade{50%{opacity:.2}100%{opacity:1}}.la-line-spin-fade-rotating,.la-line-spin-fade-rotating>div{position:relative;box-sizing:border-box}.la-line-spin-fade-rotating{display:block;font-size:0;color:#fff;width:32px;height:32px;-webkit-animation:6s linear infinite ball-spin-fade-rotating-rotate;animation:6s linear infinite ball-spin-fade-rotating-rotate}.la-line-spin-fade-rotating.la-dark{color:#333}.la-line-spin-fade-rotating>div{display:inline-block;float:none;background-color:currentColor;border:0 solid currentColor;position:absolute;width:2px;height:10px;margin:-5px 2px 2px -1px;border-radius:0;-webkit-animation:1s ease-in-out infinite line-spin-fade-rotating;animation:1s ease-in-out infinite line-spin-fade-rotating}.la-line-spin-fade-rotating>div:nth-child(1){top:15%;left:50%;-webkit-transform:rotate(0);transform:rotate(0);-webkit-animation-delay:-1.125s;animation-delay:-1.125s}.la-line-spin-fade-rotating>div:nth-child(2){top:25.2512626585%;left:74.7487373415%;-webkit-transform:rotate(45deg);transform:rotate(45deg);-webkit-animation-delay:-1.25s;animation-delay:-1.25s}.la-line-spin-fade-rotating>div:nth-child(3){top:50%;left:85%;-webkit-transform:rotate(90deg);transform:rotate(90deg);-webkit-animation-delay:-1.375s;animation-delay:-1.375s}.la-line-spin-fade-rotating>div:nth-child(4){top:74.7487373415%;left:74.7487373415%;-webkit-transform:rotate(135deg);transform:rotate(135deg);-webkit-animation-delay:-1.5s;animation-delay:-1.5s}.la-line-spin-fade-rotating>div:nth-child(5){top:84.9999999974%;left:50.0000000004%;-webkit-transform:rotate(180deg);transform:rotate(180deg);-webkit-animation-delay:-1.625s;animation-delay:-1.625s}.la-line-spin-fade-rotating>div:nth-child(6){top:74.7487369862%;left:25.2512627193%;-webkit-transform:rotate(225deg);transform:rotate(225deg);-webkit-animation-delay:-1.75s;animation-delay:-1.75s}.la-line-spin-fade-rotating>div:nth-child(7){top:49.9999806189%;left:15.0000039834%;-webkit-transform:rotate(270deg);transform:rotate(270deg);-webkit-animation-delay:-1.875s;animation-delay:-1.875s}.la-line-spin-fade-rotating>div:nth-child(8){top:25.2506949798%;left:25.2513989292%;-webkit-transform:rotate(315deg);transform:rotate(315deg);-webkit-animation-delay:-2s;animation-delay:-2s}.la-line-spin-fade-rotating.la-sm{width:16px;height:16px}.la-line-spin-fade-rotating.la-sm>div{width:1px;height:4px;margin-top:-2px;margin-left:0}.la-line-spin-fade-rotating.la-2x{width:64px;height:64px}.la-line-spin-fade-rotating.la-2x>div{width:4px;height:20px;margin-top:-10px;margin-left:-2px}.la-line-spin-fade-rotating.la-3x{width:96px;height:96px}.la-line-spin-fade-rotating.la-3x>div{width:6px;height:30px;margin-top:-15px;margin-left:-3px}@-webkit-keyframes ball-spin-fade-rotating-rotate{100%{-webkit-transform:rotate(360deg);transform:rotate(360deg)}}@keyframes ball-spin-fade-rotating-rotate{100%{-webkit-transform:rotate(360deg);transform:rotate(360deg)}}@-webkit-keyframes line-spin-fade-rotating{50%{opacity:.2}100%{opacity:1}}@keyframes line-spin-fade-rotating{50%{opacity:.2}100%{opacity:1}}.la-line-spin-fade,.la-line-spin-fade>div{position:relative;box-sizing:border-box}.la-line-spin-fade{display:block;font-size:0;color:#fff;width:32px;height:32px}.la-line-spin-fade.la-dark{color:#333}.la-line-spin-fade>div{display:inline-block;float:none;background-color:currentColor;border:0 solid currentColor;position:absolute;width:2px;height:10px;margin:-5px 2px 2px -1px;border-radius:0;-webkit-animation:1s ease-in-out infinite line-spin-fade;animation:1s ease-in-out infinite line-spin-fade}.la-line-spin-fade>div:nth-child(1){top:15%;left:50%;-webkit-transform:rotate(0);transform:rotate(0);-webkit-animation-delay:-1.125s;animation-delay:-1.125s}.la-line-spin-fade>div:nth-child(2){top:25.2512626585%;left:74.7487373415%;-webkit-transform:rotate(45deg);transform:rotate(45deg);-webkit-animation-delay:-1.25s;animation-delay:-1.25s}.la-line-spin-fade>div:nth-child(3){top:50%;left:85%;-webkit-transform:rotate(90deg);transform:rotate(90deg);-webkit-animation-delay:-1.375s;animation-delay:-1.375s}.la-line-spin-fade>div:nth-child(4){top:74.7487373415%;left:74.7487373415%;-webkit-transform:rotate(135deg);transform:rotate(135deg);-webkit-animation-delay:-1.5s;animation-delay:-1.5s}.la-line-spin-fade>div:nth-child(5){top:84.9999999974%;left:50.0000000004%;-webkit-transform:rotate(180deg);transform:rotate(180deg);-webkit-animation-delay:-1.625s;animation-delay:-1.625s}.la-line-spin-fade>div:nth-child(6){top:74.7487369862%;left:25.2512627193%;-webkit-transform:rotate(225deg);transform:rotate(225deg);-webkit-animation-delay:-1.75s;animation-delay:-1.75s}.la-line-spin-fade>div:nth-child(7){top:49.9999806189%;left:15.0000039834%;-webkit-transform:rotate(270deg);transform:rotate(270deg);-webkit-animation-delay:-1.875s;animation-delay:-1.875s}.la-line-spin-fade>div:nth-child(8){top:25.2506949798%;left:25.2513989292%;-webkit-transform:rotate(315deg);transform:rotate(315deg);-webkit-animation-delay:-2s;animation-delay:-2s}.la-line-spin-fade.la-sm{width:16px;height:16px}.la-line-spin-fade.la-sm>div{width:1px;height:4px;margin-top:-2px;margin-left:0}.la-line-spin-fade.la-2x{width:64px;height:64px}.la-line-spin-fade.la-2x>div{width:4px;height:20px;margin-top:-10px;margin-left:-2px}.la-line-spin-fade.la-3x{width:96px;height:96px}.la-line-spin-fade.la-3x>div{width:6px;height:30px;margin-top:-15px;margin-left:-3px}@-webkit-keyframes line-spin-fade{50%{opacity:.2}100%{opacity:1}}@keyframes line-spin-fade{50%{opacity:.2}100%{opacity:1}}.la-pacman,.la-pacman>div{position:relative;box-sizing:border-box}.la-pacman{display:block;font-size:0;color:#fff;width:32px;height:32px}.la-pacman.la-dark{color:#333}.la-pacman>div{display:inline-block;float:none;background-color:currentColor;border:0 solid currentColor}.la-pacman>div:nth-child(1),.la-pacman>div:nth-child(2){width:0;height:0;background:0 0;border-style:solid;border-width:16px;border-right-color:transparent;border-radius:100%;-webkit-animation:.5s infinite pacman-rotate-half-up;animation:.5s infinite pacman-rotate-half-up}.la-pacman>div:nth-child(2){margin-top:-32px;-webkit-animation-name:pacman-rotate-half-down;animation-name:pacman-rotate-half-down}.la-pacman>div:nth-child(3),.la-pacman>div:nth-child(4),.la-pacman>div:nth-child(5),.la-pacman>div:nth-child(6){position:absolute;top:50%;left:200%;width:8px;height:8px;border-radius:100%;opacity:0;-webkit-animation:2s linear infinite pacman-balls;animation:2s linear infinite pacman-balls}.la-pacman>div:nth-child(3){-webkit-animation-delay:-1.44s;animation-delay:-1.44s}.la-pacman>div:nth-child(4){-webkit-animation-delay:-1.94s;animation-delay:-1.94s}.la-pacman>div:nth-child(5){-webkit-animation-delay:-2.44s;animation-delay:-2.44s}.la-pacman>div:nth-child(6){-webkit-animation-delay:-2.94s;animation-delay:-2.94s}.la-pacman.la-sm{width:16px;height:16px}.la-pacman.la-sm>div:nth-child(1),.la-pacman.la-sm>div:nth-child(2){border-width:8px}.la-pacman.la-sm>div:nth-child(2){margin-top:-16px}.la-pacman.la-sm>div:nth-child(3),.la-pacman.la-sm>div:nth-child(4),.la-pacman.la-sm>div:nth-child(5),.la-pacman.la-sm>div:nth-child(6){width:4px;height:4px}.la-pacman.la-2x{width:64px;height:64px}.la-pacman.la-2x>div:nth-child(1),.la-pacman.la-2x>div:nth-child(2){border-width:32px}.la-pacman.la-2x>div:nth-child(2){margin-top:-64px}.la-pacman.la-2x>div:nth-child(3),.la-pacman.la-2x>div:nth-child(4),.la-pacman.la-2x>div:nth-child(5),.la-pacman.la-2x>div:nth-child(6){width:16px;height:16px}.la-pacman.la-3x{width:96px;height:96px}.la-pacman.la-3x>div:nth-child(1),.la-pacman.la-3x>div:nth-child(2){border-width:48px}.la-pacman.la-3x>div:nth-child(2){margin-top:-96px}.la-pacman.la-3x>div:nth-child(3),.la-pacman.la-3x>div:nth-child(4),.la-pacman.la-3x>div:nth-child(5),.la-pacman.la-3x>div:nth-child(6){width:24px;height:24px}@-webkit-keyframes pacman-rotate-half-up{0%,100%{-webkit-transform:rotate(270deg);transform:rotate(270deg)}50%{-webkit-transform:rotate(360deg);transform:rotate(360deg)}}@keyframes pacman-rotate-half-up{0%,100%{-webkit-transform:rotate(270deg);transform:rotate(270deg)}50%{-webkit-transform:rotate(360deg);transform:rotate(360deg)}}@-webkit-keyframes pacman-rotate-half-down{0%,100%{-webkit-transform:rotate(90deg);transform:rotate(90deg)}50%{-webkit-transform:rotate(0);transform:rotate(0)}}@keyframes pacman-rotate-half-down{0%,100%{-webkit-transform:rotate(90deg);transform:rotate(90deg)}50%{-webkit-transform:rotate(0);transform:rotate(0)}}@-webkit-keyframes pacman-balls{0%{left:200%;opacity:0;-webkit-transform:translateY(-50%);transform:translateY(-50%)}5%{opacity:.5}66%{opacity:1}67%{opacity:0}100%{left:0;-webkit-transform:translateY(-50%);transform:translateY(-50%)}}@keyframes pacman-balls{0%{left:200%;opacity:0;-webkit-transform:translateY(-50%);transform:translateY(-50%)}5%{opacity:.5}66%{opacity:1}67%{opacity:0}100%{left:0;-webkit-transform:translateY(-50%);transform:translateY(-50%)}}.la-square-jelly-box,.la-square-jelly-box>div{position:relative;box-sizing:border-box}.la-square-jelly-box{display:block;font-size:0;color:#fff;width:32px;height:32px}.la-square-jelly-box.la-dark{color:#333}.la-square-jelly-box>div{display:inline-block;float:none;background-color:currentColor;border:0 solid currentColor}.la-square-jelly-box>div:nth-child(1),.la-square-jelly-box>div:nth-child(2){position:absolute;left:0;width:100%}.la-square-jelly-box>div:nth-child(1){top:-25%;z-index:1;height:100%;border-radius:10%;-webkit-animation:.6s linear -.1s infinite square-jelly-box-animate;animation:.6s linear -.1s infinite square-jelly-box-animate}.la-square-jelly-box>div:nth-child(2){bottom:-9%;height:10%;background:#000;border-radius:50%;opacity:.2;-webkit-animation:.6s linear -.1s infinite square-jelly-box-shadow;animation:.6s linear -.1s infinite square-jelly-box-shadow}.la-square-jelly-box.la-sm{width:16px;height:16px}.la-square-jelly-box.la-2x{width:64px;height:64px}.la-square-jelly-box.la-3x{width:96px;height:96px}@-webkit-keyframes square-jelly-box-animate{17%{border-bottom-right-radius:10%}25%{-webkit-transform:translateY(25%) rotate(22.5deg);transform:translateY(25%) rotate(22.5deg)}50%{border-bottom-right-radius:100%;-webkit-transform:translateY(50%) scale(1,.9) rotate(45deg);transform:translateY(50%) scale(1,.9) rotate(45deg)}75%{-webkit-transform:translateY(25%) rotate(67.5deg);transform:translateY(25%) rotate(67.5deg)}100%{-webkit-transform:translateY(0) rotate(90deg);transform:translateY(0) rotate(90deg)}}@keyframes square-jelly-box-animate{17%{border-bottom-right-radius:10%}25%{-webkit-transform:translateY(25%) rotate(22.5deg);transform:translateY(25%) rotate(22.5deg)}50%{border-bottom-right-radius:100%;-webkit-transform:translateY(50%) scale(1,.9) rotate(45deg);transform:translateY(50%) scale(1,.9) rotate(45deg)}75%{-webkit-transform:translateY(25%) rotate(67.5deg);transform:translateY(25%) rotate(67.5deg)}100%{-webkit-transform:translateY(0) rotate(90deg);transform:translateY(0) rotate(90deg)}}@-webkit-keyframes square-jelly-box-shadow{50%{-webkit-transform:scale(1.25,1);transform:scale(1.25,1)}}@keyframes square-jelly-box-shadow{50%{-webkit-transform:scale(1.25,1);transform:scale(1.25,1)}}.la-square-loader,.la-square-loader>div{position:relative;box-sizing:border-box}.la-square-loader{display:block;font-size:0;color:#fff;width:32px;height:32px}.la-square-loader.la-dark{color:#333}.la-square-loader>div{display:inline-block;float:none;border:2px solid currentColor;width:100%;height:100%;background:0 0;border-radius:0;-webkit-animation:2s infinite square-loader;animation:2s infinite square-loader}.la-square-loader>div:after{display:inline-block;width:100%;vertical-align:top;content:\"\";background-color:currentColor;-webkit-animation:2s ease-in infinite square-loader-inner;animation:2s ease-in infinite square-loader-inner}.la-square-loader.la-sm{width:16px;height:16px}.la-square-loader.la-sm>div{border-width:1px}.la-square-loader.la-2x{width:64px;height:64px}.la-square-loader.la-2x>div{border-width:4px}.la-square-loader.la-3x{width:96px;height:96px}.la-square-loader.la-3x>div{border-width:6px}@-webkit-keyframes square-loader{0%{-webkit-transform:rotate(0);transform:rotate(0)}25%,50%{-webkit-transform:rotate(180deg);transform:rotate(180deg)}100%,75%{-webkit-transform:rotate(360deg);transform:rotate(360deg)}}@keyframes square-loader{0%{-webkit-transform:rotate(0);transform:rotate(0)}25%,50%{-webkit-transform:rotate(180deg);transform:rotate(180deg)}100%,75%{-webkit-transform:rotate(360deg);transform:rotate(360deg)}}@-webkit-keyframes square-loader-inner{0%,100%,25%{height:0}50%,75%{height:100%}}@keyframes square-loader-inner{0%,100%,25%{height:0}50%,75%{height:100%}}.la-square-spin,.la-square-spin>div{position:relative;box-sizing:border-box}.la-square-spin{display:block;font-size:0;color:#fff;width:32px;height:32px}.la-square-spin.la-dark{color:#333}.la-square-spin>div{display:inline-block;float:none;background-color:currentColor;border:0 solid currentColor;width:100%;height:100%;border-radius:0;-webkit-animation:3s cubic-bezier(.09,.57,.49,.9) infinite square-spin;animation:3s cubic-bezier(.09,.57,.49,.9) infinite square-spin}.la-square-spin.la-sm{width:16px;height:16px}.la-square-spin.la-2x{width:64px;height:64px}.la-square-spin.la-3x{width:96px;height:96px}@-webkit-keyframes square-spin{0%{-webkit-transform:perspective(100px) rotateX(0) rotateY(0);transform:perspective(100px) rotateX(0) rotateY(0)}25%{-webkit-transform:perspective(100px) rotateX(180deg) rotateY(0);transform:perspective(100px) rotateX(180deg) rotateY(0)}50%{-webkit-transform:perspective(100px) rotateX(180deg) rotateY(180deg);transform:perspective(100px) rotateX(180deg) rotateY(180deg)}75%{-webkit-transform:perspective(100px) rotateX(0) rotateY(180deg);transform:perspective(100px) rotateX(0) rotateY(180deg)}100%{-webkit-transform:perspective(100px) rotateX(0) rotateY(360deg);transform:perspective(100px) rotateX(0) rotateY(360deg)}}@keyframes square-spin{0%{-webkit-transform:perspective(100px) rotateX(0) rotateY(0);transform:perspective(100px) rotateX(0) rotateY(0)}25%{-webkit-transform:perspective(100px) rotateX(180deg) rotateY(0);transform:perspective(100px) rotateX(180deg) rotateY(0)}50%{-webkit-transform:perspective(100px) rotateX(180deg) rotateY(180deg);transform:perspective(100px) rotateX(180deg) rotateY(180deg)}75%{-webkit-transform:perspective(100px) rotateX(0) rotateY(180deg);transform:perspective(100px) rotateX(0) rotateY(180deg)}100%{-webkit-transform:perspective(100px) rotateX(0) rotateY(360deg);transform:perspective(100px) rotateX(0) rotateY(360deg)}}.la-timer,.la-timer>div{position:relative;box-sizing:border-box}.la-timer{display:block;font-size:0;color:#fff;width:32px;height:32px}.la-timer.la-dark{color:#333}.la-timer>div{display:inline-block;float:none;border:2px solid currentColor;width:32px;height:32px;background:0 0;border-radius:100%}.la-timer>div:after,.la-timer>div:before{position:absolute;top:14px;left:14px;display:block;width:2px;margin-top:-1px;margin-left:-1px;content:\"\";background:currentColor;border-radius:2px;-webkit-transform-origin:1px 1px 0;transform-origin:1px 1px 0;-webkit-animation:1.25s linear -625ms infinite timer-loader;animation:1.25s linear -625ms infinite timer-loader}.la-timer>div:before{height:12px}.la-timer>div:after{height:8px;-webkit-animation-duration:15s;animation-duration:15s;-webkit-animation-delay:-7.5s;animation-delay:-7.5s}.la-timer.la-sm{width:16px;height:16px}.la-timer.la-sm>div{width:16px;height:16px;border-width:1px}.la-timer.la-sm>div:after,.la-timer.la-sm>div:before{top:7px;left:7px;width:1px;margin-top:-.5px;margin-left:-.5px;border-radius:1px;-webkit-transform-origin:.5px .5px 0;transform-origin:.5px .5px 0}.la-timer.la-sm>div:before{height:6px}.la-timer.la-sm>div:after{height:4px}.la-timer.la-2x{width:64px;height:64px}.la-timer.la-2x>div{width:64px;height:64px;border-width:4px}.la-timer.la-2x>div:after,.la-timer.la-2x>div:before{top:28px;left:28px;width:4px;margin-top:-2px;margin-left:-2px;border-radius:4px;-webkit-transform-origin:2px 2px 0;transform-origin:2px 2px 0}.la-timer.la-2x>div:before{height:24px}.la-timer.la-2x>div:after{height:16px}.la-timer.la-3x{width:96px;height:96px}.la-timer.la-3x>div{width:96px;height:96px;border-width:6px}.la-timer.la-3x>div:after,.la-timer.la-3x>div:before{top:42px;left:42px;width:6px;margin-top:-3px;margin-left:-3px;border-radius:6px;-webkit-transform-origin:3px 3px 0;transform-origin:3px 3px 0}.la-timer.la-3x>div:before{height:36px}.la-timer.la-3x>div:after{height:24px}@-webkit-keyframes timer-loader{0%{-webkit-transform:rotate(0);transform:rotate(0)}100%{-webkit-transform:rotate(360deg);transform:rotate(360deg)}}@keyframes timer-loader{0%{-webkit-transform:rotate(0);transform:rotate(0)}100%{-webkit-transform:rotate(360deg);transform:rotate(360deg)}}.la-triangle-skew-spin,.la-triangle-skew-spin>div{position:relative;box-sizing:border-box}.la-triangle-skew-spin{display:block;font-size:0;color:#fff;width:32px;height:16px}.la-triangle-skew-spin.la-dark{color:#333}.la-triangle-skew-spin>div{display:inline-block;float:none;border:0 solid currentColor;width:0;height:0;background:0 0;border:solid;border-width:0 16px 16px;border-right-color:transparent;border-left-color:transparent;-webkit-animation:3s cubic-bezier(.09,.57,.49,.9) infinite triangle-skew-spin;animation:3s cubic-bezier(.09,.57,.49,.9) infinite triangle-skew-spin}.la-triangle-skew-spin.la-sm{width:16px;height:8px}.la-triangle-skew-spin.la-sm>div{border-width:0 8px 8px}.la-triangle-skew-spin.la-2x{width:64px;height:32px}.la-triangle-skew-spin.la-2x>div{border-width:0 32px 32px}.la-triangle-skew-spin.la-3x{width:96px;height:48px}.la-triangle-skew-spin.la-3x>div{border-width:0 48px 48px}@-webkit-keyframes triangle-skew-spin{0%{-webkit-transform:perspective(100px) rotateX(0) rotateY(0);transform:perspective(100px) rotateX(0) rotateY(0)}25%{-webkit-transform:perspective(100px) rotateX(180deg) rotateY(0);transform:perspective(100px) rotateX(180deg) rotateY(0)}50%{-webkit-transform:perspective(100px) rotateX(180deg) rotateY(180deg);transform:perspective(100px) rotateX(180deg) rotateY(180deg)}75%{-webkit-transform:perspective(100px) rotateX(0) rotateY(180deg);transform:perspective(100px) rotateX(0) rotateY(180deg)}100%{-webkit-transform:perspective(100px) rotateX(0) rotateY(360deg);transform:perspective(100px) rotateX(0) rotateY(360deg)}}@keyframes triangle-skew-spin{0%{-webkit-transform:perspective(100px) rotateX(0) rotateY(0);transform:perspective(100px) rotateX(0) rotateY(0)}25%{-webkit-transform:perspective(100px) rotateX(180deg) rotateY(0);transform:perspective(100px) rotateX(180deg) rotateY(0)}50%{-webkit-transform:perspective(100px) rotateX(180deg) rotateY(180deg);transform:perspective(100px) rotateX(180deg) rotateY(180deg)}75%{-webkit-transform:perspective(100px) rotateX(0) rotateY(180deg);transform:perspective(100px) rotateX(0) rotateY(180deg)}100%{-webkit-transform:perspective(100px) rotateX(0) rotateY(360deg);transform:perspective(100px) rotateX(0) rotateY(360deg)}}.black-overlay{position:fixed;top:0;left:0;width:100%;height:100%;z-index:99999!important}.black-overlay>div{top:50%;left:50%;margin:0;position:absolute;-webkit-transform:translate(-50%,-50%);transform:translate(-50%,-50%)}.loading-text{top:60%!important;z-index:99999!important}"]
                }] }
    ];
    /** @nocollapse */
    SocLoadingComponent.ctorParameters = function () { return [
        { type: SocLoadingService }
    ]; };
    SocLoadingComponent.propDecorators = {
        bdColor: [{ type: Input }],
        size: [{ type: Input }],
        color: [{ type: Input }],
        type: [{ type: Input }],
        fullScreen: [{ type: Input }]
    };
    return SocLoadingComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var SocLoadingModule = /** @class */ (function () {
    function SocLoadingModule() {
    }
    SocLoadingModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule
                    ],
                    declarations: [SocLoadingComponent],
                    exports: [SocLoadingComponent]
                },] }
    ];
    return SocLoadingModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */

export { SocAppLibraryService, SocAppLibraryComponent, SocAppLibraryModule, UploadAttachmentComponent, UploadAttachmentModule, StepListComponent, StepListModule, SentListComponent, SentListModule, AttachmentListModule, AttachmentListComponent, ModalStepComponent, ModalStepModule, ModalStepViewComponent, ModalStepViewModule, ModalAttachmentComponent, ModalAttachmentModule, ModalAttachmentViewComponent, ModalAttachmentViewModule, ModalImageUploadComponent, ModalImageUploadModule, ModalSpellCheckComponent, ModalSpellCheckModule, CreateAlertComponent, CreateAlertModule, AppConfigService, Common, DateService, Request, B2bService, B2bModule, PermissionGuard, SocAutoCompleteComponent, SharedAutoCompleteModule, CALENDAR_VALUE_ACCESSOR, Calendar, SharedCalendarModule, SocDateBoxComponent, SharedDateBoxModule, CanShowDirective, CanShowDirectiveModule, SocLoadingComponent, SocLoadingModule, SocLoadingService, DisableControlDirective as ɵa, DisableControlDirectiveModule as ɵb, SharedAutoComplete2Module as ɵd, SocAutoComplete2Component as ɵc };

//# sourceMappingURL=soc-app-library.js.map